(function(window,undefined){"use strict";var TraceKit={remoteFetching:false,collectWindowErrors:true,linesOfContext:7};var _slice=[].slice;var UNKNOWN_FUNCTION="?";TraceKit.wrap=function traceKitWrapper(func){function wrapped(){try{return func.apply(this,arguments)}catch(e){TraceKit.report(e);throw e}}return wrapped};TraceKit.report=function reportModuleWrapper(){var handlers=[],lastArgs=null,lastException=null,lastExceptionStack=null;function subscribe(handler){installGlobalHandler();handlers.push(handler)}function unsubscribe(handler){for(var i=handlers.length-1;i>=0;--i){if(handlers[i]===handler){handlers.splice(i,1)}}}function unsubscribeAll(){uninstallGlobalHandler();handlers=[]}function notifyHandlers(stack,isWindowError){var exception=null;if(isWindowError&&!TraceKit.collectWindowErrors){return}for(var i in handlers){if(hasKey(handlers,i)){try{handlers[i].apply(null,[stack].concat(_slice.call(arguments,2)))}catch(inner){exception=inner}}}if(exception){throw exception}}var _oldOnerrorHandler,_onErrorHandlerInstalled;function traceKitWindowOnError(message,url,lineNo,colNo,ex){var stack=null;if(lastExceptionStack){TraceKit.computeStackTrace.augmentStackTraceWithInitialElement(lastExceptionStack,url,lineNo,message);processLastException()}else if(ex){stack=TraceKit.computeStackTrace(ex);notifyHandlers(stack,true)}else{var location={url:url,line:lineNo,column:colNo};location.func=TraceKit.computeStackTrace.guessFunctionName(location.url,location.line);location.context=TraceKit.computeStackTrace.gatherContext(location.url,location.line);stack={message:message,url:document.location.href,stack:[location]};notifyHandlers(stack,true)}if(_oldOnerrorHandler){return _oldOnerrorHandler.apply(this,arguments)}return false}function installGlobalHandler(){if(_onErrorHandlerInstalled){return}_oldOnerrorHandler=window.onerror;window.onerror=traceKitWindowOnError;_onErrorHandlerInstalled=true}function uninstallGlobalHandler(){if(!_onErrorHandlerInstalled){return}window.onerror=_oldOnerrorHandler;_onErrorHandlerInstalled=false;_oldOnerrorHandler=undefined}function processLastException(){var _lastExceptionStack=lastExceptionStack,_lastArgs=lastArgs;lastArgs=null;lastExceptionStack=null;lastException=null;notifyHandlers.apply(null,[_lastExceptionStack,false].concat(_lastArgs))}function report(ex,rethrow){var args=_slice.call(arguments,1);if(lastExceptionStack){if(lastException===ex){return}else{processLastException()}}var stack=TraceKit.computeStackTrace(ex);lastExceptionStack=stack;lastException=ex;lastArgs=args;window.setTimeout(function(){if(lastException===ex){processLastException()}},stack.incomplete?2e3:0);if(rethrow!==false){throw ex}}report.subscribe=subscribe;report.unsubscribe=unsubscribe;report.uninstall=unsubscribeAll;return report}();TraceKit.computeStackTrace=function computeStackTraceWrapper(){var debug=false,sourceCache={};function loadSource(url){if(!TraceKit.remoteFetching){return""}try{var getXHR=function(){try{return new window.XMLHttpRequest}catch(e){return new window.ActiveXObject("Microsoft.XMLHTTP")}};var request=getXHR();request.open("GET",url,false);request.send("");return request.responseText}catch(e){return""}}function getSource(url){if(!isString(url))return[];if(!hasKey(sourceCache,url)){var source="";if(url.indexOf(document.domain)!==-1){source=loadSource(url)}sourceCache[url]=source?source.split("\n"):[]}return sourceCache[url]}function guessFunctionName(url,lineNo){var reFunctionArgNames=/function ([^(]*)\(([^)]*)\)/,reGuessFunction=/['"]?([0-9A-Za-z$_]+)['"]?\s*[:=]\s*(function|eval|new Function)/,line="",maxLines=10,source=getSource(url),m;if(!source.length){return UNKNOWN_FUNCTION}for(var i=0;i<maxLines;++i){line=source[lineNo-i]+line;if(!isUndefined(line)){if(m=reGuessFunction.exec(line)){return m[1]}else if(m=reFunctionArgNames.exec(line)){return m[1]}}}return UNKNOWN_FUNCTION}function gatherContext(url,line){var source=getSource(url);if(!source.length){return null}var context=[],linesBefore=Math.floor(TraceKit.linesOfContext/2),linesAfter=linesBefore+TraceKit.linesOfContext%2,start=Math.max(0,line-linesBefore-1),end=Math.min(source.length,line+linesAfter-1);line-=1;for(var i=start;i<end;++i){if(!isUndefined(source[i])){context.push(source[i])}}return context.length>0?context:null}function escapeRegExp(text){return text.replace(/[\-\[\]{}()*+?.,\\\^$|#]/g,"\\$&")}function escapeCodeAsRegExpForMatchingInsideHTML(body){return escapeRegExp(body).replace("<","(?:<|&lt;)").replace(">","(?:>|&gt;)").replace("&","(?:&|&amp;)").replace('"','(?:"|&quot;)').replace(/\s+/g,"\\s+")}function findSourceInUrls(re,urls){var source,m;for(var i=0,j=urls.length;i<j;++i){if((source=getSource(urls[i])).length){source=source.join("\n");if(m=re.exec(source)){return{url:urls[i],line:source.substring(0,m.index).split("\n").length,column:m.index-source.lastIndexOf("\n",m.index)-1}}}}return null}function findSourceInLine(fragment,url,line){var source=getSource(url),re=new RegExp("\\b"+escapeRegExp(fragment)+"\\b"),m;line-=1;if(source&&source.length>line&&(m=re.exec(source[line]))){return m.index}return null}function findSourceByFunctionBody(func){var urls=[window.location.href],scripts=document.getElementsByTagName("script"),body,code=""+func,codeRE=/^function(?:\s+([\w$]+))?\s*\(([\w\s,]*)\)\s*\{\s*(\S[\s\S]*\S)\s*\}\s*$/,eventRE=/^function on([\w$]+)\s*\(event\)\s*\{\s*(\S[\s\S]*\S)\s*\}\s*$/,re,parts,result;for(var i=0;i<scripts.length;++i){var script=scripts[i];if(script.src){urls.push(script.src)}}if(!(parts=codeRE.exec(code))){re=new RegExp(escapeRegExp(code).replace(/\s+/g,"\\s+"))}else{var name=parts[1]?"\\s+"+parts[1]:"",args=parts[2].split(",").join("\\s*,\\s*");body=escapeRegExp(parts[3]).replace(/;$/,";?");re=new RegExp("function"+name+"\\s*\\(\\s*"+args+"\\s*\\)\\s*{\\s*"+body+"\\s*}")}if(result=findSourceInUrls(re,urls)){return result}if(parts=eventRE.exec(code)){var event=parts[1];body=escapeCodeAsRegExpForMatchingInsideHTML(parts[2]);re=new RegExp("on"+event+"=[\\'\"]\\s*"+body+"\\s*[\\'\"]","i");if(result=findSourceInUrls(re,urls[0])){return result}re=new RegExp(body);if(result=findSourceInUrls(re,urls)){return result}}return null}function computeStackTraceFromStackProp(ex){if(!ex.stack){return null}var chrome=/^\s*at (?:((?:\[object object\])?\S+(?: \[as \S+\])?) )?\(?((?:file|https?|chrome-extension):.*?):(\d+)(?::(\d+))?\)?\s*$/i,gecko=/^\s*(\S*)(?:\((.*?)\))?@((?:file|https?|chrome).*?):(\d+)(?::(\d+))?\s*$/i,lines=ex.stack.split("\n"),stack=[],parts,element,reference=/^(.*) is undefined$/.exec(ex.message);for(var i=0,j=lines.length;i<j;++i){if(parts=gecko.exec(lines[i])){element={url:parts[3],func:parts[1]||UNKNOWN_FUNCTION,args:parts[2]?parts[2].split(","):"",line:+parts[4],column:parts[5]?+parts[5]:null}}else if(parts=chrome.exec(lines[i])){element={url:parts[2],func:parts[1]||UNKNOWN_FUNCTION,line:+parts[3],column:parts[4]?+parts[4]:null}}else{continue}if(!element.func&&element.line){element.func=guessFunctionName(element.url,element.line)}if(element.line){element.context=gatherContext(element.url,element.line)}stack.push(element)}if(!stack.length){return null}if(stack[0].line&&!stack[0].column&&reference){stack[0].column=findSourceInLine(reference[1],stack[0].url,stack[0].line)}else if(!stack[0].column&&!isUndefined(ex.columnNumber)){stack[0].column=ex.columnNumber+1}return{name:ex.name,message:ex.message,url:document.location.href,stack:stack}}function computeStackTraceFromStacktraceProp(ex){var stacktrace=ex.stacktrace;var testRE=/ line (\d+), column (\d+) in (?:<anonymous function: ([^>]+)>|([^\)]+))\((.*)\) in (.*):\s*$/i,lines=stacktrace.split("\n"),stack=[],parts;for(var i=0,j=lines.length;i<j;i+=2){if(parts=testRE.exec(lines[i])){var element={line:+parts[1],column:+parts[2],func:parts[3]||parts[4],args:parts[5]?parts[5].split(","):[],url:parts[6]};if(!element.func&&element.line){element.func=guessFunctionName(element.url,element.line)}if(element.line){try{element.context=gatherContext(element.url,element.line)}catch(exc){}}if(!element.context){element.context=[lines[i+1]]}stack.push(element)}}if(!stack.length){return null}return{name:ex.name,message:ex.message,url:document.location.href,stack:stack}}function computeStackTraceFromOperaMultiLineMessage(ex){var lines=ex.message.split("\n");if(lines.length<4){return null}var lineRE1=/^\s*Line (\d+) of linked script ((?:file|https?)\S+)(?:: in function (\S+))?\s*$/i,lineRE2=/^\s*Line (\d+) of inline#(\d+) script in ((?:file|https?)\S+)(?:: in function (\S+))?\s*$/i,lineRE3=/^\s*Line (\d+) of function script\s*$/i,stack=[],scripts=document.getElementsByTagName("script"),inlineScriptBlocks=[],parts,i,len,source;for(i in scripts){if(hasKey(scripts,i)&&!scripts[i].src){inlineScriptBlocks.push(scripts[i])}}for(i=2,len=lines.length;i<len;i+=2){var item=null;if(parts=lineRE1.exec(lines[i])){item={url:parts[2],func:parts[3],line:+parts[1]}}else if(parts=lineRE2.exec(lines[i])){item={url:parts[3],func:parts[4]};var relativeLine=+parts[1];var script=inlineScriptBlocks[parts[2]-1];if(script){source=getSource(item.url);if(source){source=source.join("\n");var pos=source.indexOf(script.innerText);if(pos>=0){item.line=relativeLine+source.substring(0,pos).split("\n").length}}}}else if(parts=lineRE3.exec(lines[i])){var url=window.location.href.replace(/#.*$/,""),line=parts[1];var re=new RegExp(escapeCodeAsRegExpForMatchingInsideHTML(lines[i+1]));source=findSourceInUrls(re,[url]);item={url:url,line:source?source.line:line,func:""}}if(item){if(!item.func){item.func=guessFunctionName(item.url,item.line)}var context=gatherContext(item.url,item.line);var midline=context?context[Math.floor(context.length/2)]:null;if(context&&midline.replace(/^\s*/,"")===lines[i+1].replace(/^\s*/,"")){item.context=context}else{item.context=[lines[i+1]]}stack.push(item)}}if(!stack.length){return null}return{name:ex.name,message:lines[0],url:document.location.href,stack:stack}}function augmentStackTraceWithInitialElement(stackInfo,url,lineNo,message){var initial={url:url,line:lineNo};if(initial.url&&initial.line){stackInfo.incomplete=false;if(!initial.func){initial.func=guessFunctionName(initial.url,initial.line)}if(!initial.context){initial.context=gatherContext(initial.url,initial.line)}var reference=/ '([^']+)' /.exec(message);if(reference){initial.column=findSourceInLine(reference[1],initial.url,initial.line)}if(stackInfo.stack.length>0){if(stackInfo.stack[0].url===initial.url){if(stackInfo.stack[0].line===initial.line){return false}else if(!stackInfo.stack[0].line&&stackInfo.stack[0].func===initial.func){stackInfo.stack[0].line=initial.line;stackInfo.stack[0].context=initial.context;return false}}}stackInfo.stack.unshift(initial);stackInfo.partial=true;return true}else{stackInfo.incomplete=true}return false}function computeStackTraceByWalkingCallerChain(ex,depth){var functionName=/function\s+([_$a-zA-Z\xA0-\uFFFF][_$a-zA-Z0-9\xA0-\uFFFF]*)?\s*\(/i,stack=[],funcs={},recursion=false,parts,item,source;for(var curr=computeStackTraceByWalkingCallerChain.caller;curr&&!recursion;curr=curr.caller){if(curr===computeStackTrace||curr===TraceKit.report){continue}item={url:null,func:UNKNOWN_FUNCTION,line:null,column:null};if(curr.name){item.func=curr.name}else if(parts=functionName.exec(curr.toString())){item.func=parts[1]}if(source=findSourceByFunctionBody(curr)){item.url=source.url;item.line=source.line;if(item.func===UNKNOWN_FUNCTION){item.func=guessFunctionName(item.url,item.line)}var reference=/ '([^']+)' /.exec(ex.message||ex.description);if(reference){item.column=findSourceInLine(reference[1],source.url,source.line)}}if(funcs[""+curr]){recursion=true}else{funcs[""+curr]=true}stack.push(item)}if(depth){stack.splice(0,depth)}var result={name:ex.name,message:ex.message,url:document.location.href,stack:stack};augmentStackTraceWithInitialElement(result,ex.sourceURL||ex.fileName,ex.line||ex.lineNumber,ex.message||ex.description);return result}function computeStackTrace(ex,depth){var stack=null;depth=depth==null?0:+depth;try{stack=computeStackTraceFromStacktraceProp(ex);if(stack){return stack}}catch(e){if(debug){throw e}}try{stack=computeStackTraceFromStackProp(ex);if(stack){return stack}}catch(e){if(debug){throw e}}try{stack=computeStackTraceFromOperaMultiLineMessage(ex);if(stack){return stack}}catch(e){if(debug){throw e}}try{stack=computeStackTraceByWalkingCallerChain(ex,depth+1);if(stack){return stack}}catch(e){if(debug){throw e}}return{}}function computeStackTraceOfCaller(depth){depth=(depth==null?0:+depth)+1;try{throw new Error}catch(ex){return computeStackTrace(ex,depth+1)}}computeStackTrace.augmentStackTraceWithInitialElement=augmentStackTraceWithInitialElement;computeStackTrace.guessFunctionName=guessFunctionName;computeStackTrace.gatherContext=gatherContext;computeStackTrace.ofCaller=computeStackTraceOfCaller;return computeStackTrace}();"use strict";var _Raven=window.Raven,hasJSON=!!(window.JSON&&window.JSON.stringify),lastCapturedException,lastEventId,globalServer,globalUser,globalKey,globalProject,globalOptions={logger:"javascript",ignoreErrors:[],ignoreUrls:[],whitelistUrls:[],includePaths:[],collectWindowErrors:true,tags:{},extra:{}},authQueryString,isRavenInstalled=false;var Raven={VERSION:"1.1.16",debug:true,noConflict:function(){window.Raven=_Raven;return Raven},config:function(dsn,options){if(globalServer){logDebug("error","Error: Raven has already been configured");return Raven}if(!dsn)return Raven;var uri=parseDSN(dsn),lastSlash=uri.path.lastIndexOf("/"),path=uri.path.substr(1,lastSlash);if(options){each(options,function(key,value){globalOptions[key]=value})}globalOptions.ignoreErrors.push("Script error.");globalOptions.ignoreErrors.push("Script error");globalOptions.ignoreErrors.push("Javascript error: Script error on line 0");globalOptions.ignoreErrors.push("Javascript error: Script error. on line 0");globalOptions.ignoreErrors=joinRegExp(globalOptions.ignoreErrors);globalOptions.ignoreUrls=globalOptions.ignoreUrls.length?joinRegExp(globalOptions.ignoreUrls):false;globalOptions.whitelistUrls=globalOptions.whitelistUrls.length?joinRegExp(globalOptions.whitelistUrls):false;globalOptions.includePaths=joinRegExp(globalOptions.includePaths);globalKey=uri.user;globalProject=uri.path.substr(lastSlash+1);globalServer="//"+uri.host+(uri.port?":"+uri.port:"")+"/"+path+"api/"+globalProject+"/store/";if(uri.protocol){globalServer=uri.protocol+":"+globalServer}if(globalOptions.fetchContext){TraceKit.remoteFetching=true}if(globalOptions.linesOfContext){TraceKit.linesOfContext=globalOptions.linesOfContext}TraceKit.collectWindowErrors=!!globalOptions.collectWindowErrors;setAuthQueryString();return Raven},install:function(){if(isSetup()&&!isRavenInstalled){TraceKit.report.subscribe(handleStackInfo);isRavenInstalled=true}return Raven},context:function(options,func,args){if(isFunction(options)){args=func||[];func=options;options=undefined}return Raven.wrap(options,func).apply(this,args)},wrap:function(options,func){if(isUndefined(func)&&!isFunction(options)){return options}if(isFunction(options)){func=options;options=undefined}if(!isFunction(func)){return func}if(func.__raven__){return func}function wrapped(){var args=[],i=arguments.length,deep=!options||options&&options.deep!==false;while(i--)args[i]=deep?Raven.wrap(options,arguments[i]):arguments[i];try{return func.apply(this,args)}catch(e){Raven.captureException(e,options);throw e}}for(var property in func){if(hasKey(func,property)){wrapped[property]=func[property]}}wrapped.__raven__=true;wrapped.__inner__=func;return wrapped},uninstall:function(){TraceKit.report.uninstall();isRavenInstalled=false;return Raven},captureException:function(ex,options){if(!(ex instanceof Error))return Raven.captureMessage(ex,options);lastCapturedException=ex;try{TraceKit.report(ex,options)}catch(ex1){if(ex!==ex1){throw ex1}}return Raven},captureMessage:function(msg,options){send(objectMerge({message:msg+""},options));return Raven},setUserContext:function(user){globalUser=user;return Raven},setExtraContext:function(extra){globalOptions.extra=extra||{};return Raven},setTagsContext:function(tags){globalOptions.tags=tags||{};return Raven},lastException:function(){return lastCapturedException},lastEventId:function(){return lastEventId}};Raven.setUser=Raven.setUserContext;function triggerEvent(eventType,options){var event,key;options=options||{};eventType="raven"+eventType.substr(0,1).toUpperCase()+eventType.substr(1);if(document.createEvent){event=document.createEvent("HTMLEvents");event.initEvent(eventType,true,true)}else{event=document.createEventObject();event.eventType=eventType}for(key in options)if(hasKey(options,key)){event[key]=options[key]}if(document.createEvent){document.dispatchEvent(event)}else{try{document.fireEvent("on"+event.eventType.toLowerCase(),event)}catch(e){}}}var dsnKeys="source protocol user pass host port path".split(" "),dsnPattern=/^(?:(\w+):)?\/\/(\w+)(:\w+)?@([\w\.-]+)(?::(\d+))?(\/.*)/;function RavenConfigError(message){this.name="RavenConfigError";this.message=message}RavenConfigError.prototype=new Error;RavenConfigError.prototype.constructor=RavenConfigError;function parseDSN(str){var m=dsnPattern.exec(str),dsn={},i=7;try{while(i--)dsn[dsnKeys[i]]=m[i]||""}catch(e){throw new RavenConfigError("Invalid DSN: "+str)}if(dsn.pass)throw new RavenConfigError("Do not specify your private key in the DSN!");return dsn}function isUndefined(what){return typeof what==="undefined"}function isFunction(what){return typeof what==="function"}function isString(what){return typeof what==="string"}function isEmptyObject(what){for(var k in what)return false;return true}function hasKey(object,key){return Object.prototype.hasOwnProperty.call(object,key)}function each(obj,callback){var i,j;if(isUndefined(obj.length)){for(i in obj){if(hasKey(obj,i)){callback.call(null,i,obj[i])}}}else{j=obj.length;if(j){for(i=0;i<j;i++){callback.call(null,i,obj[i])}}}}function setAuthQueryString(){authQueryString="?sentry_version=4"+"&sentry_client=raven-js/"+Raven.VERSION+"&sentry_key="+globalKey}function handleStackInfo(stackInfo,options){var frames=[];if(stackInfo.stack&&stackInfo.stack.length){each(stackInfo.stack,function(i,stack){var frame=normalizeFrame(stack);if(frame){frames.push(frame)}})}triggerEvent("handle",{stackInfo:stackInfo,options:options});processException(stackInfo.name,stackInfo.message,stackInfo.url,stackInfo.lineno,frames,options)}function normalizeFrame(frame){if(!frame.url)return;var normalized={filename:frame.url,lineno:frame.line,colno:frame.column,"function":frame.func||"?"},context=extractContextFromFrame(frame),i;if(context){var keys=["pre_context","context_line","post_context"];i=3;while(i--)normalized[keys[i]]=context[i]}normalized.in_app=!(!globalOptions.includePaths.test(normalized.filename)||/(Raven|TraceKit)\./.test(normalized["function"])||/raven\.(min\.)?js$/.test(normalized.filename));return normalized}function extractContextFromFrame(frame){if(!frame.context||!globalOptions.fetchContext)return;var context=frame.context,pivot=~~(context.length/2),i=context.length,isMinified=false;while(i--){if(context[i].length>300){isMinified=true;break}}if(isMinified){if(isUndefined(frame.column))return;return[[],context[pivot].substr(frame.column,50),[]]}return[context.slice(0,pivot),context[pivot],context.slice(pivot+1)]}function processException(type,message,fileurl,lineno,frames,options){var stacktrace,label,i;message+="";if(type==="Error"&&!message)return;if(globalOptions.ignoreErrors.test(message))return;if(frames&&frames.length){fileurl=frames[0].filename||fileurl;frames.reverse();stacktrace={frames:frames}}else if(fileurl){stacktrace={frames:[{filename:fileurl,lineno:lineno,in_app:true}]}}message=truncate(message,100);if(globalOptions.ignoreUrls&&globalOptions.ignoreUrls.test(fileurl))return;if(globalOptions.whitelistUrls&&!globalOptions.whitelistUrls.test(fileurl))return;label=lineno?message+" at "+lineno:message;send(objectMerge({exception:{type:type,value:message},stacktrace:stacktrace,culprit:fileurl,message:label},options))}function objectMerge(obj1,obj2){if(!obj2){return obj1}each(obj2,function(key,value){obj1[key]=value});return obj1}function truncate(str,max){return str.length<=max?str:str.substr(0,max)+"…"}function getHttpData(){var http={url:document.location.href,headers:{"User-Agent":navigator.userAgent}};if(document.referrer){http.headers.Referer=document.referrer}return http}function send(data){if(!isSetup())return;data=objectMerge({project:globalProject,logger:globalOptions.logger,site:globalOptions.site,platform:"javascript",request:getHttpData()},data);data.tags=objectMerge(globalOptions.tags,data.tags);data.extra=objectMerge(globalOptions.extra,data.extra);if(isEmptyObject(data.tags))delete data.tags;if(isEmptyObject(data.extra))delete data.extra;if(globalUser){data.user=globalUser}if(isFunction(globalOptions.dataCallback)){data=globalOptions.dataCallback(data)}if(isFunction(globalOptions.shouldSendCallback)&&!globalOptions.shouldSendCallback(data)){return}lastEventId=data.event_id||(data.event_id=uuid4());makeRequest(data)}function makeRequest(data){var img=new Image,src=globalServer+authQueryString+"&sentry_data="+encodeURIComponent(JSON.stringify(data));img.onload=function success(){triggerEvent("success",{data:data,src:src})};img.onerror=img.onabort=function failure(){triggerEvent("failure",{data:data,src:src})};img.src=src}function isSetup(){if(!hasJSON)return false;if(!globalServer){return false}return true}function joinRegExp(patterns){var sources=[],i=0,len=patterns.length,pattern;for(;i<len;i++){pattern=patterns[i];if(isString(pattern)){sources.push(pattern.replace(/([.*+?^=!:${}()|\[\]\/\\])/g,"\\$1"))}else if(pattern&&pattern.source){sources.push(pattern.source)}}return new RegExp(sources.join("|"),"i")}function uuid4(){return"xxxxxxxxxxxx4xxxyxxxxxxxxxxxxxxx".replace(/[xy]/g,function(c){var r=Math.random()*16|0,v=c=="x"?r:r&3|8;return v.toString(16)})}function logDebug(level,message){if(window.console&&console[level]&&Raven.debug){console[level](message)}}function afterLoad(){var RavenConfig=window.RavenConfig;if(RavenConfig){Raven.config(RavenConfig.dsn,RavenConfig.config).install()}}afterLoad();window.Raven=Raven;if(typeof define==="function"&&define.amd){define("raven",[],function(){return Raven})}})(this);(function(window,Raven,Backbone){"use strict";if(!Backbone){return}function makeBackboneEventsOn(oldOn){return function BackboneEventsOn(name,callback,context){var _callback=callback._callback||callback;callback=Raven.wrap(callback);callback._callback=_callback;return oldOn.call(this,name,callback,context)}}var affectedObjects=[Backbone.Events,Backbone,Backbone.Model.prototype,Backbone.Collection.prototype,Backbone.View.prototype,Backbone.Router.prototype,Backbone.History.prototype],i=0,l=affectedObjects.length;for(;i<l;i++){var affected=affectedObjects[i];affected.on=makeBackboneEventsOn(affected.on);affected.bind=affected.on}})(this,Raven,window.Backbone);(function(window,Raven,console){"use strict";var originalConsole=console,logLevels=["debug","info","warn","error"],level;var logForGivenLevel=function(level){var originalConsoleLevel=console[level];return function(){var args=[].slice.call(arguments);Raven.captureMessage(""+args,{level:level,logger:"console"});if(originalConsoleLevel){Function.prototype.bind.call(originalConsoleLevel,originalConsole).apply(originalConsole,args)}}};level=logLevels.pop();while(level){console[level]=logForGivenLevel(level);level=logLevels.pop()}window.console=console})(this,Raven,window.console||{});(function(window,Raven,$){"use strict";if(!$){return}var _oldEventAdd=$.event.add;$.event.add=function ravenEventAdd(elem,types,handler,data,selector){var _handler;if(handler&&handler.handler){_handler=handler.handler;handler.handler=Raven.wrap(handler.handler)}else{_handler=handler;handler=Raven.wrap(handler)}if(_handler.guid){handler.guid=_handler.guid}else{handler.guid=_handler.guid=$.guid++}return _oldEventAdd.call(this,elem,types,handler,data,selector)};var _oldReady=$.fn.ready;$.fn.ready=function ravenjQueryReadyWrapper(fn){return _oldReady.call(this,Raven.wrap(fn))};var _oldAjax=$.ajax;$.ajax=function ravenAjaxWrapper(url,options){var keys=["complete","error","success"],key;if(typeof url==="object"){options=url;url=undefined}options=options||{};while(key=keys.pop()){if($.isFunction(options[key])){options[key]=Raven.wrap(options[key])}}try{return _oldAjax.call(this,url,options)}catch(e){Raven.captureException(e);throw e}}})(this,Raven,window.jQuery);(function extendToAsynchronousCallbacks(window,Raven){"use strict";var _helper=function _helper(fnName){var originalFn=window[fnName];window[fnName]=function ravenAsyncExtension(){var args=[].slice.call(arguments);var originalCallback=args[0];if(typeof originalCallback==="function"){args[0]=Raven.wrap(originalCallback)}if(originalFn.apply){return originalFn.apply(this,args)}else{return originalFn(args[0],args[1])}}};_helper("setTimeout");_helper("setInterval")})(this,Raven);var MARVELAPP=MARVELAPP||{};MARVELAPP.models={};MARVELAPP.models.teams={};MARVELAPP.models.projects=undefined;MARVELAPP.models.my_projects={};MARVELAPP.models.current_user={};MARVELAPP.models.current_team={};MARVELAPP.models.selected_team_tab=undefined;MARVELAPP.models.poll_project=undefined;MARVELAPP.models.required_fonts=[];MARVELAPP.pollers={};MARVELAPP.pollers.team_first_run=false;MARVELAPP.pollers.team_poller=undefined;MARVELAPP.pollers.project_poller=undefined;MARVELAPP.pollers.project_delta_poller=undefined;MARVELAPP.utils={};MARVELAPP.utils.validator=undefined;MARVELAPP.utils.getEmbedCode=undefined;MARVELAPP.constants={VERSION_NO:"0.9.30",VERSION_NUM_COMPARE:930,user:{ALL_USER_PROPS:{ui_new_feature:"ui-new-feature",ui_pro_notify:"ui-pro-notify"}},modal:{TOP_HEADER:"Modal header",CONTENT_HEADER:"Content header",BUTTON_TEXT:"button action",BUTTON_COLOR:"green",SIZE:""},profile:{delete_profile:{REMOVE_ACCOUNT:"Delete account?",NEXT_STEP:"Yes, delete my account"},delete_subscription:{REMOVE_SUBSCRIPTION:"Cancel Pro?",NEXT_SUBSCRIPTION:"Yes, cancel my subscription"},current_tab:""},projects:{POLL_TIMING:1e4,POLL_DELTA_TIMING:6e3,ALL_PROJECTS_TEAM_ID:-1,MY_PROJECTS_TEAM_ID:-2,delete_modal:{DELETE_MODAL_HEADER:"Delete project?",DELETE_PROJECT_SUBMIT:"Yes, delete this project",DELETE_MODAL_SECOND_HEADER:"Are you sure you want to delete this project?"},create_project:{CREATE_NEW_PROJECT:"Create new project",NEXT_STEP:"Create project"}},content:{POLL_IMAGE_STATUS:15e3,SOURCE_TYPES:{SOURCE_DROPBOX:"1",SOURCE_GDRIVE:"2",SOURCE_CC:"3",SOURCE_DESKTOP:"4"}},team:{POLL_TIMING:4e4,DEFAULT_TEAM_NAME:"Team name",DEFAULT_TEAM_ICON_URL:"../../../static/assets/images/team-demo-logo.png",PEOPLE:"People",PERSON:"Person",categories:{HEADER_INVITED:"Teams you&apos;ve been invited to",HEADER_STARTED:"Teams you&apos;ve started",HEADER_JOINED:"Teams you&apos;ve joined",EMPTY_CATEGORY:"There are no teams in the category"},invite:{TEAM_MEMBER_INVITE:"Invite team member",TEAM_MEMBER_REMOVE:"Remove team member",NEXT_STEP:"Send Invite",REMOVE_MEMBER:"Remove from team",REMOVE_TEAM:"Remove team?",REMOVE_TEAM_BUTTON:"Yes, remove this team"},create_team:{CREATE_NEW_TEAM:"Create new team",NEXT_STEP:"Create team &rarr;"}},invite:{TEAM_MEMBER_STATE_INVITED:"Invited",TEAM_MEMBER_STATE_ACCEPTED:"Accepted",TEAM_MEMBER_STATE_DECLINED:"Declined",TEAM_MEMBER_STATE_REMOVED:"Removed"},role:{ROLE_OWNER:"Owner",ROLE_ADMIN:"Administrator",ROLE_CLIENT:"Client",ROLE_TEAM_MEMBER:"Team Member"},subscription:{SUBSCRIPTION_ACTIVE:1,SUBSCRIPTION_INACTIVE:0,SUBSCRIPTION_CANCELLED:2,SUBSCRIPTION_IS_TRIAL:3,BILLING_CYCLE_MONTHLY:"monthly",BILLING_CYCLE_YEARLY:"yearly",SUB_TYPE_MONTHLY_EARLY:1,SUB_TYPE_MONTHLY_FULL:2,SUB_TYPE_YEARLY_EARLY:3,SUB_TYPE_YEARLY_FULL:4,PRICE_SUB_EARLY_MONTH:1e3,PRICE_SUB_EARLY_YEARLY:9600,PRICE_SUB_MONTHLY_FULL:1e3,PRICE_SUB_YEARLY_FULL:9600,PAYMENT_TYPE_NONE:0,PAYMENT_TYPE_PROCESSING:1,PAYMENT_TYPE_INVALIDATED:2,SOURCE_PAYPAL:1,SOURCE_STRIPE:2},allowance:{ALLOWANCE_APP_BUILD:"app_build",ALLOWANCE_ZIP_DOWNLOAD:"download prototypes",ALLOWANCE_TEAM_MEMBER:"team_member",ALLOWANCE_CREATE_TEAM:"create_team",ALLOWANCE_PASSWORD_PROTECT:"password_protect",ALLOWANCE_IOS_APP_BUILDS:"ios_app_builds"},hotspot:{HOTSPOT_ACTIVE:1,HOTSPOT_DELETED:3,HOTSPOT_DETACHED:2},prototype:{ARCHIVE_STATUS_READY:0,ARCHIVE_STATUS_WORKING:1,ARCHIVE_STATUS_APP_BUILDING:2,ARCHIVE_STATUS_APP_QUEUED:3,ARCHIVE_STATUS_APP_COMPILING:4,ARCHIVE_STATUS_APP_UPLOADING:5,ARCHIVE_STATUS_FAILED:-1,ARCHIVE_TYPE_DOWNLOAD:1,ARCHIVE_TYPE_APP_IOS:2,ARCHIVE_TYPE_APP_ANDROID:3,ARCHIVE_TYPE_APP_PDF:4},pusher:{EVENT_MESSAGE:"notify_info",EVENT_IMAGE:"event_image",EVENT_ARCHIVE:"event_archive",EVENT_HOTSPOT:"event_hotspot",EVENT_PROJECT:"event_project",EVENT_SEQUENCE:"event_sequence",EVENT_TEAM:"event_team",EVENT_TEAM_PROJECT:"event_team_project",EVENT_TEAM_REMOVAL:"event_team_removal",EVENT_SKETCH:"event_sketch",STATE_CONNECTED:"connected"},image_urls:{SKETCH_PREVIEW:"../../../static/assets/images/defaults/sketch.gif"}};MARVELAPP.messages={MEMBER_DELETE_FORBIDDEN:"You cannot remove your own user from a team",MEMBER_DELETE_SUCCESS:"User successfully removed",INVITE_SEND_ERROR:"There was a problem sending your invitation",INVITE_SEND_SUCCESS:"Your invite has been sent",INVITE_ACCEPT_ERROR:"There was a problem sending your invitation reply",INVITE_ACCEPT_SUCCESS:"Your reply has been sent",TEAM_NOT_FOUND:"Team not found",TEAM_CREATE_SUCCESS:"We have successfully created your team",TEAM_CREATE_ERROR:"We were unable to create your team",PROJECT_NOT_FOUND:"Project not found",PROJECT_DUPLICATE_ERROR:"Project could not be duplicated",PROJECT_DELETE_ERROR:"Project could not be deleted",PROJECT_ALREADY_EXISTS:"A project with this name already exists",HOTSPOT_SYNC_ERROR:"There was a problem syncing the hotspot",ACCOUNT_DELETION_ERROR:"There was a problem deleting your account, please contact hello@marvelapp.com"};(function(){var n=this,t=n._,r={},e=Array.prototype,u=Object.prototype,i=Function.prototype,a=e.push,o=e.slice,c=e.concat,l=u.toString,f=u.hasOwnProperty,s=e.forEach,p=e.map,h=e.reduce,v=e.reduceRight,g=e.filter,d=e.every,m=e.some,y=e.indexOf,b=e.lastIndexOf,x=Array.isArray,w=Object.keys,_=i.bind,j=function(n){return n instanceof j?n:this instanceof j?(this._wrapped=n,void 0):new j(n)};"undefined"!=typeof exports?("undefined"!=typeof module&&module.exports&&(exports=module.exports=j),exports._=j):n._=j,j.VERSION="1.5.2";var A=j.each=j.forEach=function(n,t,e){if(null!=n)if(s&&n.forEach===s)n.forEach(t,e);else if(n.length===+n.length){for(var u=0,i=n.length;i>u;u++)if(t.call(e,n[u],u,n)===r)return}else for(var a=j.keys(n),u=0,i=a.length;i>u;u++)if(t.call(e,n[a[u]],a[u],n)===r)return};j.map=j.collect=function(n,t,r){var e=[];return null==n?e:p&&n.map===p?n.map(t,r):(A(n,function(n,u,i){e.push(t.call(r,n,u,i))}),e)};var E="Reduce of empty array with no initial value";j.reduce=j.foldl=j.inject=function(n,t,r,e){var u=arguments.length>2;if(null==n&&(n=[]),h&&n.reduce===h)return e&&(t=j.bind(t,e)),u?n.reduce(t,r):n.reduce(t);if(A(n,function(n,i,a){u?r=t.call(e,r,n,i,a):(r=n,u=!0)}),!u)throw new TypeError(E);return r},j.reduceRight=j.foldr=function(n,t,r,e){var u=arguments.length>2;if(null==n&&(n=[]),v&&n.reduceRight===v)return e&&(t=j.bind(t,e)),u?n.reduceRight(t,r):n.reduceRight(t);var i=n.length;if(i!==+i){var a=j.keys(n);i=a.length}if(A(n,function(o,c,l){c=a?a[--i]:--i,u?r=t.call(e,r,n[c],c,l):(r=n[c],u=!0)}),!u)throw new TypeError(E);return r},j.find=j.detect=function(n,t,r){var e;return O(n,function(n,u,i){return t.call(r,n,u,i)?(e=n,!0):void 0}),e},j.filter=j.select=function(n,t,r){var e=[];return null==n?e:g&&n.filter===g?n.filter(t,r):(A(n,function(n,u,i){t.call(r,n,u,i)&&e.push(n)}),e)},j.reject=function(n,t,r){return j.filter(n,function(n,e,u){return!t.call(r,n,e,u)},r)},j.every=j.all=function(n,t,e){t||(t=j.identity);var u=!0;return null==n?u:d&&n.every===d?n.every(t,e):(A(n,function(n,i,a){return(u=u&&t.call(e,n,i,a))?void 0:r}),!!u)};var O=j.some=j.any=function(n,t,e){t||(t=j.identity);var u=!1;return null==n?u:m&&n.some===m?n.some(t,e):(A(n,function(n,i,a){return u||(u=t.call(e,n,i,a))?r:void 0
}),!!u)};j.contains=j.include=function(n,t){return null==n?!1:y&&n.indexOf===y?n.indexOf(t)!=-1:O(n,function(n){return n===t})},j.invoke=function(n,t){var r=o.call(arguments,2),e=j.isFunction(t);return j.map(n,function(n){return(e?t:n[t]).apply(n,r)})},j.pluck=function(n,t){return j.map(n,function(n){return n[t]})},j.where=function(n,t,r){return j.isEmpty(t)?r?void 0:[]:j[r?"find":"filter"](n,function(n){for(var r in t)if(t[r]!==n[r])return!1;return!0})},j.findWhere=function(n,t){return j.where(n,t,!0)},j.max=function(n,t,r){if(!t&&j.isArray(n)&&n[0]===+n[0]&&n.length<65535)return Math.max.apply(Math,n);if(!t&&j.isEmpty(n))return-1/0;var e={computed:-1/0,value:-1/0};return A(n,function(n,u,i){var a=t?t.call(r,n,u,i):n;a>e.computed&&(e={value:n,computed:a})}),e.value},j.min=function(n,t,r){if(!t&&j.isArray(n)&&n[0]===+n[0]&&n.length<65535)return Math.min.apply(Math,n);if(!t&&j.isEmpty(n))return 1/0;var e={computed:1/0,value:1/0};return A(n,function(n,u,i){var a=t?t.call(r,n,u,i):n;a<e.computed&&(e={value:n,computed:a})}),e.value},j.shuffle=function(n){var t,r=0,e=[];return A(n,function(n){t=j.random(r++),e[r-1]=e[t],e[t]=n}),e},j.sample=function(n,t,r){return arguments.length<2||r?n[j.random(n.length-1)]:j.shuffle(n).slice(0,Math.max(0,t))};var k=function(n){return j.isFunction(n)?n:function(t){return t[n]}};j.sortBy=function(n,t,r){var e=k(t);return j.pluck(j.map(n,function(n,t,u){return{value:n,index:t,criteria:e.call(r,n,t,u)}}).sort(function(n,t){var r=n.criteria,e=t.criteria;if(r!==e){if(r>e||r===void 0)return 1;if(e>r||e===void 0)return-1}return n.index-t.index}),"value")};var F=function(n){return function(t,r,e){var u={},i=null==r?j.identity:k(r);return A(t,function(r,a){var o=i.call(e,r,a,t);n(u,o,r)}),u}};j.groupBy=F(function(n,t,r){(j.has(n,t)?n[t]:n[t]=[]).push(r)}),j.indexBy=F(function(n,t,r){n[t]=r}),j.countBy=F(function(n,t){j.has(n,t)?n[t]++:n[t]=1}),j.sortedIndex=function(n,t,r,e){r=null==r?j.identity:k(r);for(var u=r.call(e,t),i=0,a=n.length;a>i;){var o=i+a>>>1;r.call(e,n[o])<u?i=o+1:a=o}return i},j.toArray=function(n){return n?j.isArray(n)?o.call(n):n.length===+n.length?j.map(n,j.identity):j.values(n):[]},j.size=function(n){return null==n?0:n.length===+n.length?n.length:j.keys(n).length},j.first=j.head=j.take=function(n,t,r){return null==n?void 0:null==t||r?n[0]:o.call(n,0,t)},j.initial=function(n,t,r){return o.call(n,0,n.length-(null==t||r?1:t))},j.last=function(n,t,r){return null==n?void 0:null==t||r?n[n.length-1]:o.call(n,Math.max(n.length-t,0))},j.rest=j.tail=j.drop=function(n,t,r){return o.call(n,null==t||r?1:t)},j.compact=function(n){return j.filter(n,j.identity)};var M=function(n,t,r){return t&&j.every(n,j.isArray)?c.apply(r,n):(A(n,function(n){j.isArray(n)||j.isArguments(n)?t?a.apply(r,n):M(n,t,r):r.push(n)}),r)};j.flatten=function(n,t){return M(n,t,[])},j.without=function(n){return j.difference(n,o.call(arguments,1))},j.uniq=j.unique=function(n,t,r,e){j.isFunction(t)&&(e=r,r=t,t=!1);var u=r?j.map(n,r,e):n,i=[],a=[];return A(u,function(r,e){(t?e&&a[a.length-1]===r:j.contains(a,r))||(a.push(r),i.push(n[e]))}),i},j.union=function(){return j.uniq(j.flatten(arguments,!0))},j.intersection=function(n){var t=o.call(arguments,1);return j.filter(j.uniq(n),function(n){return j.every(t,function(t){return j.indexOf(t,n)>=0})})},j.difference=function(n){var t=c.apply(e,o.call(arguments,1));return j.filter(n,function(n){return!j.contains(t,n)})},j.zip=function(){for(var n=j.max(j.pluck(arguments,"length").concat(0)),t=new Array(n),r=0;n>r;r++)t[r]=j.pluck(arguments,""+r);return t},j.object=function(n,t){if(null==n)return{};for(var r={},e=0,u=n.length;u>e;e++)t?r[n[e]]=t[e]:r[n[e][0]]=n[e][1];return r},j.indexOf=function(n,t,r){if(null==n)return-1;var e=0,u=n.length;if(r){if("number"!=typeof r)return e=j.sortedIndex(n,t),n[e]===t?e:-1;e=0>r?Math.max(0,u+r):r}if(y&&n.indexOf===y)return n.indexOf(t,r);for(;u>e;e++)if(n[e]===t)return e;return-1},j.lastIndexOf=function(n,t,r){if(null==n)return-1;var e=null!=r;if(b&&n.lastIndexOf===b)return e?n.lastIndexOf(t,r):n.lastIndexOf(t);for(var u=e?r:n.length;u--;)if(n[u]===t)return u;return-1},j.range=function(n,t,r){arguments.length<=1&&(t=n||0,n=0),r=arguments[2]||1;for(var e=Math.max(Math.ceil((t-n)/r),0),u=0,i=new Array(e);e>u;)i[u++]=n,n+=r;return i};var R=function(){};j.bind=function(n,t){var r,e;if(_&&n.bind===_)return _.apply(n,o.call(arguments,1));if(!j.isFunction(n))throw new TypeError;return r=o.call(arguments,2),e=function(){if(!(this instanceof e))return n.apply(t,r.concat(o.call(arguments)));R.prototype=n.prototype;var u=new R;R.prototype=null;var i=n.apply(u,r.concat(o.call(arguments)));return Object(i)===i?i:u}},j.partial=function(n){var t=o.call(arguments,1);return function(){return n.apply(this,t.concat(o.call(arguments)))}},j.bindAll=function(n){var t=o.call(arguments,1);if(0===t.length)throw new Error("bindAll must be passed function names");return A(t,function(t){n[t]=j.bind(n[t],n)}),n},j.memoize=function(n,t){var r={};return t||(t=j.identity),function(){var e=t.apply(this,arguments);return j.has(r,e)?r[e]:r[e]=n.apply(this,arguments)}},j.delay=function(n,t){var r=o.call(arguments,2);return setTimeout(function(){return n.apply(null,r)},t)},j.defer=function(n){return j.delay.apply(j,[n,1].concat(o.call(arguments,1)))},j.throttle=function(n,t,r){var e,u,i,a=null,o=0;r||(r={});var c=function(){o=r.leading===!1?0:new Date,a=null,i=n.apply(e,u)};return function(){var l=new Date;o||r.leading!==!1||(o=l);var f=t-(l-o);return e=this,u=arguments,0>=f?(clearTimeout(a),a=null,o=l,i=n.apply(e,u)):a||r.trailing===!1||(a=setTimeout(c,f)),i}},j.debounce=function(n,t,r){var e,u,i,a,o;return function(){i=this,u=arguments,a=new Date;var c=function(){var l=new Date-a;t>l?e=setTimeout(c,t-l):(e=null,r||(o=n.apply(i,u)))},l=r&&!e;return e||(e=setTimeout(c,t)),l&&(o=n.apply(i,u)),o}},j.once=function(n){var t,r=!1;return function(){return r?t:(r=!0,t=n.apply(this,arguments),n=null,t)}},j.wrap=function(n,t){return function(){var r=[n];return a.apply(r,arguments),t.apply(this,r)}},j.compose=function(){var n=arguments;return function(){for(var t=arguments,r=n.length-1;r>=0;r--)t=[n[r].apply(this,t)];return t[0]}},j.after=function(n,t){return function(){return--n<1?t.apply(this,arguments):void 0}},j.keys=w||function(n){if(n!==Object(n))throw new TypeError("Invalid object");var t=[];for(var r in n)j.has(n,r)&&t.push(r);return t},j.values=function(n){for(var t=j.keys(n),r=t.length,e=new Array(r),u=0;r>u;u++)e[u]=n[t[u]];return e},j.pairs=function(n){for(var t=j.keys(n),r=t.length,e=new Array(r),u=0;r>u;u++)e[u]=[t[u],n[t[u]]];return e},j.invert=function(n){for(var t={},r=j.keys(n),e=0,u=r.length;u>e;e++)t[n[r[e]]]=r[e];return t},j.functions=j.methods=function(n){var t=[];for(var r in n)j.isFunction(n[r])&&t.push(r);return t.sort()},j.extend=function(n){return A(o.call(arguments,1),function(t){if(t)for(var r in t)n[r]=t[r]}),n},j.pick=function(n){var t={},r=c.apply(e,o.call(arguments,1));return A(r,function(r){r in n&&(t[r]=n[r])}),t},j.omit=function(n){var t={},r=c.apply(e,o.call(arguments,1));for(var u in n)j.contains(r,u)||(t[u]=n[u]);return t},j.defaults=function(n){return A(o.call(arguments,1),function(t){if(t)for(var r in t)n[r]===void 0&&(n[r]=t[r])}),n},j.clone=function(n){return j.isObject(n)?j.isArray(n)?n.slice():j.extend({},n):n},j.tap=function(n,t){return t(n),n};var S=function(n,t,r,e){if(n===t)return 0!==n||1/n==1/t;if(null==n||null==t)return n===t;n instanceof j&&(n=n._wrapped),t instanceof j&&(t=t._wrapped);var u=l.call(n);if(u!=l.call(t))return!1;switch(u){case"[object String]":return n==String(t);case"[object Number]":return n!=+n?t!=+t:0==n?1/n==1/t:n==+t;case"[object Date]":case"[object Boolean]":return+n==+t;case"[object RegExp]":return n.source==t.source&&n.global==t.global&&n.multiline==t.multiline&&n.ignoreCase==t.ignoreCase}if("object"!=typeof n||"object"!=typeof t)return!1;for(var i=r.length;i--;)if(r[i]==n)return e[i]==t;var a=n.constructor,o=t.constructor;if(a!==o&&!(j.isFunction(a)&&a instanceof a&&j.isFunction(o)&&o instanceof o))return!1;r.push(n),e.push(t);var c=0,f=!0;if("[object Array]"==u){if(c=n.length,f=c==t.length)for(;c--&&(f=S(n[c],t[c],r,e)););}else{for(var s in n)if(j.has(n,s)&&(c++,!(f=j.has(t,s)&&S(n[s],t[s],r,e))))break;if(f){for(s in t)if(j.has(t,s)&&!c--)break;f=!c}}return r.pop(),e.pop(),f};j.isEqual=function(n,t){return S(n,t,[],[])},j.isEmpty=function(n){if(null==n)return!0;if(j.isArray(n)||j.isString(n))return 0===n.length;for(var t in n)if(j.has(n,t))return!1;return!0},j.isElement=function(n){return!(!n||1!==n.nodeType)},j.isArray=x||function(n){return"[object Array]"==l.call(n)},j.isObject=function(n){return n===Object(n)},A(["Arguments","Function","String","Number","Date","RegExp"],function(n){j["is"+n]=function(t){return l.call(t)=="[object "+n+"]"}}),j.isArguments(arguments)||(j.isArguments=function(n){return!(!n||!j.has(n,"callee"))}),"function"!=typeof/./&&(j.isFunction=function(n){return"function"==typeof n}),j.isFinite=function(n){return isFinite(n)&&!isNaN(parseFloat(n))},j.isNaN=function(n){return j.isNumber(n)&&n!=+n},j.isBoolean=function(n){return n===!0||n===!1||"[object Boolean]"==l.call(n)},j.isNull=function(n){return null===n},j.isUndefined=function(n){return n===void 0},j.has=function(n,t){return f.call(n,t)},j.noConflict=function(){return n._=t,this},j.identity=function(n){return n},j.times=function(n,t,r){for(var e=Array(Math.max(0,n)),u=0;n>u;u++)e[u]=t.call(r,u);return e},j.random=function(n,t){return null==t&&(t=n,n=0),n+Math.floor(Math.random()*(t-n+1))};var I={escape:{"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#x27;"}};I.unescape=j.invert(I.escape);var T={escape:new RegExp("["+j.keys(I.escape).join("")+"]","g"),unescape:new RegExp("("+j.keys(I.unescape).join("|")+")","g")};j.each(["escape","unescape"],function(n){j[n]=function(t){return null==t?"":(""+t).replace(T[n],function(t){return I[n][t]})}}),j.result=function(n,t){if(null==n)return void 0;var r=n[t];return j.isFunction(r)?r.call(n):r},j.mixin=function(n){A(j.functions(n),function(t){var r=j[t]=n[t];j.prototype[t]=function(){var n=[this._wrapped];return a.apply(n,arguments),z.call(this,r.apply(j,n))}})};var N=0;j.uniqueId=function(n){var t=++N+"";return n?n+t:t},j.templateSettings={evaluate:/<%([\s\S]+?)%>/g,interpolate:/<%=([\s\S]+?)%>/g,escape:/<%-([\s\S]+?)%>/g};var q=/(.)^/,B={"'":"'","\\":"\\","\r":"r","\n":"n","	":"t","\u2028":"u2028","\u2029":"u2029"},D=/\\|'|\r|\n|\t|\u2028|\u2029/g;j.template=function(n,t,r){var e;r=j.defaults({},r,j.templateSettings);var u=new RegExp([(r.escape||q).source,(r.interpolate||q).source,(r.evaluate||q).source].join("|")+"|$","g"),i=0,a="__p+='";n.replace(u,function(t,r,e,u,o){return a+=n.slice(i,o).replace(D,function(n){return"\\"+B[n]}),r&&(a+="'+\n((__t=("+r+"))==null?'':_.escape(__t))+\n'"),e&&(a+="'+\n((__t=("+e+"))==null?'':__t)+\n'"),u&&(a+="';\n"+u+"\n__p+='"),i=o+t.length,t}),a+="';\n",r.variable||(a="with(obj||{}){\n"+a+"}\n"),a="var __t,__p='',__j=Array.prototype.join,"+"print=function(){__p+=__j.call(arguments,'');};\n"+a+"return __p;\n";try{e=new Function(r.variable||"obj","_",a)}catch(o){throw o.source=a,o}if(t)return e(t,j);var c=function(n){return e.call(this,n,j)};return c.source="function("+(r.variable||"obj")+"){\n"+a+"}",c},j.chain=function(n){return j(n).chain()};var z=function(n){return this._chain?j(n).chain():n};j.mixin(j),A(["pop","push","reverse","shift","sort","splice","unshift"],function(n){var t=e[n];j.prototype[n]=function(){var r=this._wrapped;return t.apply(r,arguments),"shift"!=n&&"splice"!=n||0!==r.length||delete r[0],z.call(this,r)}}),A(["concat","join","slice"],function(n){var t=e[n];j.prototype[n]=function(){return z.call(this,t.apply(this._wrapped,arguments))}}),j.extend(j.prototype,{chain:function(){return this._chain=!0,this},value:function(){return this._wrapped}})}).call(this);(function(window,undefined){var readyList,rootjQuery,core_strundefined=typeof undefined,location=window.location,document=window.document,docElem=document.documentElement,_jQuery=window.jQuery,_$=window.$,class2type={},core_deletedIds=[],core_version="1.10.2",core_concat=core_deletedIds.concat,core_push=core_deletedIds.push,core_slice=core_deletedIds.slice,core_indexOf=core_deletedIds.indexOf,core_toString=class2type.toString,core_hasOwn=class2type.hasOwnProperty,core_trim=core_version.trim,jQuery=function(selector,context){return new jQuery.fn.init(selector,context,rootjQuery)},core_pnum=/[+-]?(?:\d*\.|)\d+(?:[eE][+-]?\d+|)/.source,core_rnotwhite=/\S+/g,rtrim=/^[\s\uFEFF\xA0]+|[\s\uFEFF\xA0]+$/g,rquickExpr=/^(?:\s*(<[\w\W]+>)[^>]*|#([\w-]*))$/,rsingleTag=/^<(\w+)\s*\/?>(?:<\/\1>|)$/,rvalidchars=/^[\],:{}\s]*$/,rvalidbraces=/(?:^|:|,)(?:\s*\[)+/g,rvalidescape=/\\(?:["\\\/bfnrt]|u[\da-fA-F]{4})/g,rvalidtokens=/"[^"\\\r\n]*"|true|false|null|-?(?:\d+\.|)\d+(?:[eE][+-]?\d+|)/g,rmsPrefix=/^-ms-/,rdashAlpha=/-([\da-z])/gi,fcamelCase=function(all,letter){return letter.toUpperCase()},completed=function(event){if(document.addEventListener||event.type==="load"||document.readyState==="complete"){detach();jQuery.ready()}},detach=function(){if(document.addEventListener){document.removeEventListener("DOMContentLoaded",completed,false);window.removeEventListener("load",completed,false)}else{document.detachEvent("onreadystatechange",completed);window.detachEvent("onload",completed)}};jQuery.fn=jQuery.prototype={jquery:core_version,constructor:jQuery,init:function(selector,context,rootjQuery){var match,elem;if(!selector){return this}if(typeof selector==="string"){if(selector.charAt(0)==="<"&&selector.charAt(selector.length-1)===">"&&selector.length>=3){match=[null,selector,null]}else{match=rquickExpr.exec(selector)}if(match&&(match[1]||!context)){if(match[1]){context=context instanceof jQuery?context[0]:context;jQuery.merge(this,jQuery.parseHTML(match[1],context&&context.nodeType?context.ownerDocument||context:document,true));if(rsingleTag.test(match[1])&&jQuery.isPlainObject(context)){for(match in context){if(jQuery.isFunction(this[match])){this[match](context[match])}else{this.attr(match,context[match])}}}return this}else{elem=document.getElementById(match[2]);if(elem&&elem.parentNode){if(elem.id!==match[2]){return rootjQuery.find(selector)}this.length=1;this[0]=elem}this.context=document;this.selector=selector;return this}}else if(!context||context.jquery){return(context||rootjQuery).find(selector)}else{return this.constructor(context).find(selector)}}else if(selector.nodeType){this.context=this[0]=selector;this.length=1;return this}else if(jQuery.isFunction(selector)){return rootjQuery.ready(selector)}if(selector.selector!==undefined){this.selector=selector.selector;this.context=selector.context}return jQuery.makeArray(selector,this)},selector:"",length:0,toArray:function(){return core_slice.call(this)},get:function(num){return num==null?this.toArray():num<0?this[this.length+num]:this[num]},pushStack:function(elems){var ret=jQuery.merge(this.constructor(),elems);ret.prevObject=this;ret.context=this.context;return ret},each:function(callback,args){return jQuery.each(this,callback,args)},ready:function(fn){jQuery.ready.promise().done(fn);return this},slice:function(){return this.pushStack(core_slice.apply(this,arguments))},first:function(){return this.eq(0)},last:function(){return this.eq(-1)},eq:function(i){var len=this.length,j=+i+(i<0?len:0);return this.pushStack(j>=0&&j<len?[this[j]]:[])},map:function(callback){return this.pushStack(jQuery.map(this,function(elem,i){return callback.call(elem,i,elem)}))},end:function(){return this.prevObject||this.constructor(null)},push:core_push,sort:[].sort,splice:[].splice};jQuery.fn.init.prototype=jQuery.fn;jQuery.extend=jQuery.fn.extend=function(){var src,copyIsArray,copy,name,options,clone,target=arguments[0]||{},i=1,length=arguments.length,deep=false;if(typeof target==="boolean"){deep=target;target=arguments[1]||{};i=2}if(typeof target!=="object"&&!jQuery.isFunction(target)){target={}}if(length===i){target=this;--i}for(;i<length;i++){if((options=arguments[i])!=null){for(name in options){src=target[name];copy=options[name];if(target===copy){continue}if(deep&&copy&&(jQuery.isPlainObject(copy)||(copyIsArray=jQuery.isArray(copy)))){if(copyIsArray){copyIsArray=false;clone=src&&jQuery.isArray(src)?src:[]}else{clone=src&&jQuery.isPlainObject(src)?src:{}}target[name]=jQuery.extend(deep,clone,copy)}else if(copy!==undefined){target[name]=copy}}}}return target};jQuery.extend({expando:"jQuery"+(core_version+Math.random()).replace(/\D/g,""),noConflict:function(deep){if(window.$===jQuery){window.$=_$}if(deep&&window.jQuery===jQuery){window.jQuery=_jQuery}return jQuery},isReady:false,readyWait:1,holdReady:function(hold){if(hold){jQuery.readyWait++}else{jQuery.ready(true)}},ready:function(wait){if(wait===true?--jQuery.readyWait:jQuery.isReady){return}if(!document.body){return setTimeout(jQuery.ready)}jQuery.isReady=true;if(wait!==true&&--jQuery.readyWait>0){return}readyList.resolveWith(document,[jQuery]);if(jQuery.fn.trigger){jQuery(document).trigger("ready").off("ready")}},isFunction:function(obj){return jQuery.type(obj)==="function"},isArray:Array.isArray||function(obj){return jQuery.type(obj)==="array"},isWindow:function(obj){return obj!=null&&obj==obj.window},isNumeric:function(obj){return!isNaN(parseFloat(obj))&&isFinite(obj)},type:function(obj){if(obj==null){return String(obj)}return typeof obj==="object"||typeof obj==="function"?class2type[core_toString.call(obj)]||"object":typeof obj},isPlainObject:function(obj){var key;if(!obj||jQuery.type(obj)!=="object"||obj.nodeType||jQuery.isWindow(obj)){return false}try{if(obj.constructor&&!core_hasOwn.call(obj,"constructor")&&!core_hasOwn.call(obj.constructor.prototype,"isPrototypeOf")){return false}}catch(e){return false}if(jQuery.support.ownLast){for(key in obj){return core_hasOwn.call(obj,key)}}for(key in obj){}return key===undefined||core_hasOwn.call(obj,key)},isEmptyObject:function(obj){var name;for(name in obj){return false}return true},error:function(msg){throw new Error(msg)},parseHTML:function(data,context,keepScripts){if(!data||typeof data!=="string"){return null}if(typeof context==="boolean"){keepScripts=context;context=false}context=context||document;var parsed=rsingleTag.exec(data),scripts=!keepScripts&&[];if(parsed){return[context.createElement(parsed[1])]}parsed=jQuery.buildFragment([data],context,scripts);if(scripts){jQuery(scripts).remove()}return jQuery.merge([],parsed.childNodes)},parseJSON:function(data){if(window.JSON&&window.JSON.parse){return window.JSON.parse(data)}if(data===null){return data}if(typeof data==="string"){data=jQuery.trim(data);if(data){if(rvalidchars.test(data.replace(rvalidescape,"@").replace(rvalidtokens,"]").replace(rvalidbraces,""))){return new Function("return "+data)()}}}jQuery.error("Invalid JSON: "+data)},parseXML:function(data){var xml,tmp;if(!data||typeof data!=="string"){return null}try{if(window.DOMParser){tmp=new DOMParser;xml=tmp.parseFromString(data,"text/xml")}else{xml=new ActiveXObject("Microsoft.XMLDOM");xml.async="false";xml.loadXML(data)}}catch(e){xml=undefined}if(!xml||!xml.documentElement||xml.getElementsByTagName("parsererror").length){jQuery.error("Invalid XML: "+data)}return xml},noop:function(){},globalEval:function(data){if(data&&jQuery.trim(data)){(window.execScript||function(data){window["eval"].call(window,data)})(data)}},camelCase:function(string){return string.replace(rmsPrefix,"ms-").replace(rdashAlpha,fcamelCase)},nodeName:function(elem,name){return elem.nodeName&&elem.nodeName.toLowerCase()===name.toLowerCase()},each:function(obj,callback,args){var value,i=0,length=obj.length,isArray=isArraylike(obj);if(args){if(isArray){for(;i<length;i++){value=callback.apply(obj[i],args);if(value===false){break}}}else{for(i in obj){value=callback.apply(obj[i],args);if(value===false){break}}}}else{if(isArray){for(;i<length;i++){value=callback.call(obj[i],i,obj[i]);if(value===false){break}}}else{for(i in obj){value=callback.call(obj[i],i,obj[i]);if(value===false){break}}}}return obj},trim:core_trim&&!core_trim.call("﻿ ")?function(text){return text==null?"":core_trim.call(text)}:function(text){return text==null?"":(text+"").replace(rtrim,"")},makeArray:function(arr,results){var ret=results||[];if(arr!=null){if(isArraylike(Object(arr))){jQuery.merge(ret,typeof arr==="string"?[arr]:arr)}else{core_push.call(ret,arr)}}return ret},inArray:function(elem,arr,i){var len;if(arr){if(core_indexOf){return core_indexOf.call(arr,elem,i)}len=arr.length;i=i?i<0?Math.max(0,len+i):i:0;for(;i<len;i++){if(i in arr&&arr[i]===elem){return i}}}return-1},merge:function(first,second){var l=second.length,i=first.length,j=0;if(typeof l==="number"){for(;j<l;j++){first[i++]=second[j]}}else{while(second[j]!==undefined){first[i++]=second[j++]}}first.length=i;return first},grep:function(elems,callback,inv){var retVal,ret=[],i=0,length=elems.length;inv=!!inv;for(;i<length;i++){retVal=!!callback(elems[i],i);if(inv!==retVal){ret.push(elems[i])}}return ret},map:function(elems,callback,arg){var value,i=0,length=elems.length,isArray=isArraylike(elems),ret=[];if(isArray){for(;i<length;i++){value=callback(elems[i],i,arg);if(value!=null){ret[ret.length]=value}}}else{for(i in elems){value=callback(elems[i],i,arg);if(value!=null){ret[ret.length]=value}}}return core_concat.apply([],ret)},guid:1,proxy:function(fn,context){var args,proxy,tmp;if(typeof context==="string"){tmp=fn[context];context=fn;fn=tmp}if(!jQuery.isFunction(fn)){return undefined}args=core_slice.call(arguments,2);proxy=function(){return fn.apply(context||this,args.concat(core_slice.call(arguments)))};proxy.guid=fn.guid=fn.guid||jQuery.guid++;return proxy},access:function(elems,fn,key,value,chainable,emptyGet,raw){var i=0,length=elems.length,bulk=key==null;if(jQuery.type(key)==="object"){chainable=true;for(i in key){jQuery.access(elems,fn,i,key[i],true,emptyGet,raw)}}else if(value!==undefined){chainable=true;if(!jQuery.isFunction(value)){raw=true}if(bulk){if(raw){fn.call(elems,value);fn=null}else{bulk=fn;fn=function(elem,key,value){return bulk.call(jQuery(elem),value)}}}if(fn){for(;i<length;i++){fn(elems[i],key,raw?value:value.call(elems[i],i,fn(elems[i],key)))}}}return chainable?elems:bulk?fn.call(elems):length?fn(elems[0],key):emptyGet},now:function(){return(new Date).getTime()},swap:function(elem,options,callback,args){var ret,name,old={};for(name in options){old[name]=elem.style[name];elem.style[name]=options[name]}ret=callback.apply(elem,args||[]);for(name in options){elem.style[name]=old[name]}return ret}});jQuery.ready.promise=function(obj){if(!readyList){readyList=jQuery.Deferred();if(document.readyState==="complete"){setTimeout(jQuery.ready)}else if(document.addEventListener){document.addEventListener("DOMContentLoaded",completed,false);window.addEventListener("load",completed,false)}else{document.attachEvent("onreadystatechange",completed);window.attachEvent("onload",completed);var top=false;try{top=window.frameElement==null&&document.documentElement}catch(e){}if(top&&top.doScroll){(function doScrollCheck(){if(!jQuery.isReady){try{top.doScroll("left")}catch(e){return setTimeout(doScrollCheck,50)}detach();jQuery.ready()}})()}}}return readyList.promise(obj)};jQuery.each("Boolean Number String Function Array Date RegExp Object Error".split(" "),function(i,name){class2type["[object "+name+"]"]=name.toLowerCase()});function isArraylike(obj){var length=obj.length,type=jQuery.type(obj);if(jQuery.isWindow(obj)){return false}if(obj.nodeType===1&&length){return true}return type==="array"||type!=="function"&&(length===0||typeof length==="number"&&length>0&&length-1 in obj)}rootjQuery=jQuery(document);(function(window,undefined){var i,support,cachedruns,Expr,getText,isXML,compile,outermostContext,sortInput,setDocument,document,docElem,documentIsHTML,rbuggyQSA,rbuggyMatches,matches,contains,expando="sizzle"+-new Date,preferredDoc=window.document,dirruns=0,done=0,classCache=createCache(),tokenCache=createCache(),compilerCache=createCache(),hasDuplicate=false,sortOrder=function(a,b){if(a===b){hasDuplicate=true;return 0}return 0},strundefined=typeof undefined,MAX_NEGATIVE=1<<31,hasOwn={}.hasOwnProperty,arr=[],pop=arr.pop,push_native=arr.push,push=arr.push,slice=arr.slice,indexOf=arr.indexOf||function(elem){var i=0,len=this.length;for(;i<len;i++){if(this[i]===elem){return i}}return-1},booleans="checked|selected|async|autofocus|autoplay|controls|defer|disabled|hidden|ismap|loop|multiple|open|readonly|required|scoped",whitespace="[\\x20\\t\\r\\n\\f]",characterEncoding="(?:\\\\.|[\\w-]|[^\\x00-\\xa0])+",identifier=characterEncoding.replace("w","w#"),attributes="\\["+whitespace+"*("+characterEncoding+")"+whitespace+"*(?:([*^$|!~]?=)"+whitespace+"*(?:(['\"])((?:\\\\.|[^\\\\])*?)\\3|("+identifier+")|)|)"+whitespace+"*\\]",pseudos=":("+characterEncoding+")(?:\\(((['\"])((?:\\\\.|[^\\\\])*?)\\3|((?:\\\\.|[^\\\\()[\\]]|"+attributes.replace(3,8)+")*)|.*)\\)|)",rtrim=new RegExp("^"+whitespace+"+|((?:^|[^\\\\])(?:\\\\.)*)"+whitespace+"+$","g"),rcomma=new RegExp("^"+whitespace+"*,"+whitespace+"*"),rcombinators=new RegExp("^"+whitespace+"*([>+~]|"+whitespace+")"+whitespace+"*"),rsibling=new RegExp(whitespace+"*[+~]"),rattributeQuotes=new RegExp("="+whitespace+"*([^\\]'\"]*)"+whitespace+"*\\]","g"),rpseudo=new RegExp(pseudos),ridentifier=new RegExp("^"+identifier+"$"),matchExpr={ID:new RegExp("^#("+characterEncoding+")"),CLASS:new RegExp("^\\.("+characterEncoding+")"),TAG:new RegExp("^("+characterEncoding.replace("w","w*")+")"),ATTR:new RegExp("^"+attributes),PSEUDO:new RegExp("^"+pseudos),CHILD:new RegExp("^:(only|first|last|nth|nth-last)-(child|of-type)(?:\\("+whitespace+"*(even|odd|(([+-]|)(\\d*)n|)"+whitespace+"*(?:([+-]|)"+whitespace+"*(\\d+)|))"+whitespace+"*\\)|)","i"),bool:new RegExp("^(?:"+booleans+")$","i"),needsContext:new RegExp("^"+whitespace+"*[>+~]|:(even|odd|eq|gt|lt|nth|first|last)(?:\\("+whitespace+"*((?:-\\d)?\\d*)"+whitespace+"*\\)|)(?=[^-]|$)","i")},rnative=/^[^{]+\{\s*\[native \w/,rquickExpr=/^(?:#([\w-]+)|(\w+)|\.([\w-]+))$/,rinputs=/^(?:input|select|textarea|button)$/i,rheader=/^h\d$/i,rescape=/'|\\/g,runescape=new RegExp("\\\\([\\da-f]{1,6}"+whitespace+"?|("+whitespace+")|.)","ig"),funescape=function(_,escaped,escapedWhitespace){var high="0x"+escaped-65536;return high!==high||escapedWhitespace?escaped:high<0?String.fromCharCode(high+65536):String.fromCharCode(high>>10|55296,high&1023|56320)};try{push.apply(arr=slice.call(preferredDoc.childNodes),preferredDoc.childNodes);arr[preferredDoc.childNodes.length].nodeType}catch(e){push={apply:arr.length?function(target,els){push_native.apply(target,slice.call(els))}:function(target,els){var j=target.length,i=0;while(target[j++]=els[i++]){}target.length=j-1}}}function Sizzle(selector,context,results,seed){var match,elem,m,nodeType,i,groups,old,nid,newContext,newSelector;if((context?context.ownerDocument||context:preferredDoc)!==document){setDocument(context)}context=context||document;results=results||[];if(!selector||typeof selector!=="string"){return results}if((nodeType=context.nodeType)!==1&&nodeType!==9){return[]}if(documentIsHTML&&!seed){if(match=rquickExpr.exec(selector)){if(m=match[1]){if(nodeType===9){elem=context.getElementById(m);if(elem&&elem.parentNode){if(elem.id===m){results.push(elem);return results}}else{return results}}else{if(context.ownerDocument&&(elem=context.ownerDocument.getElementById(m))&&contains(context,elem)&&elem.id===m){results.push(elem);return results}}}else if(match[2]){push.apply(results,context.getElementsByTagName(selector));return results}else if((m=match[3])&&support.getElementsByClassName&&context.getElementsByClassName){push.apply(results,context.getElementsByClassName(m));return results}}if(support.qsa&&(!rbuggyQSA||!rbuggyQSA.test(selector))){nid=old=expando;newContext=context;newSelector=nodeType===9&&selector;if(nodeType===1&&context.nodeName.toLowerCase()!=="object"){groups=tokenize(selector);if(old=context.getAttribute("id")){nid=old.replace(rescape,"\\$&")}else{context.setAttribute("id",nid)}nid="[id='"+nid+"'] ";i=groups.length;while(i--){groups[i]=nid+toSelector(groups[i])}newContext=rsibling.test(selector)&&context.parentNode||context;newSelector=groups.join(",")}if(newSelector){try{push.apply(results,newContext.querySelectorAll(newSelector));return results}catch(qsaError){}finally{if(!old){context.removeAttribute("id")}}}}}return select(selector.replace(rtrim,"$1"),context,results,seed)}function createCache(){var keys=[];function cache(key,value){if(keys.push(key+=" ")>Expr.cacheLength){delete cache[keys.shift()]}return cache[key]=value}return cache}function markFunction(fn){fn[expando]=true;return fn}function assert(fn){var div=document.createElement("div");try{return!!fn(div)}catch(e){return false}finally{if(div.parentNode){div.parentNode.removeChild(div)}div=null}}function addHandle(attrs,handler){var arr=attrs.split("|"),i=attrs.length;while(i--){Expr.attrHandle[arr[i]]=handler}}function siblingCheck(a,b){var cur=b&&a,diff=cur&&a.nodeType===1&&b.nodeType===1&&(~b.sourceIndex||MAX_NEGATIVE)-(~a.sourceIndex||MAX_NEGATIVE);if(diff){return diff}if(cur){while(cur=cur.nextSibling){if(cur===b){return-1}}}return a?1:-1}function createInputPseudo(type){return function(elem){var name=elem.nodeName.toLowerCase();return name==="input"&&elem.type===type}}function createButtonPseudo(type){return function(elem){var name=elem.nodeName.toLowerCase();return(name==="input"||name==="button")&&elem.type===type}}function createPositionalPseudo(fn){return markFunction(function(argument){argument=+argument;return markFunction(function(seed,matches){var j,matchIndexes=fn([],seed.length,argument),i=matchIndexes.length;while(i--){if(seed[j=matchIndexes[i]]){seed[j]=!(matches[j]=seed[j])}}})})}isXML=Sizzle.isXML=function(elem){var documentElement=elem&&(elem.ownerDocument||elem).documentElement;return documentElement?documentElement.nodeName!=="HTML":false};support=Sizzle.support={};setDocument=Sizzle.setDocument=function(node){var doc=node?node.ownerDocument||node:preferredDoc,parent=doc.defaultView;if(doc===document||doc.nodeType!==9||!doc.documentElement){return document}document=doc;docElem=doc.documentElement;documentIsHTML=!isXML(doc);if(parent&&parent.attachEvent&&parent!==parent.top){parent.attachEvent("onbeforeunload",function(){setDocument()})}support.attributes=assert(function(div){div.className="i";return!div.getAttribute("className")});support.getElementsByTagName=assert(function(div){div.appendChild(doc.createComment(""));return!div.getElementsByTagName("*").length});support.getElementsByClassName=assert(function(div){div.innerHTML="<div class='a'></div><div class='a i'></div>";div.firstChild.className="i";return div.getElementsByClassName("i").length===2});support.getById=assert(function(div){docElem.appendChild(div).id=expando;return!doc.getElementsByName||!doc.getElementsByName(expando).length});if(support.getById){Expr.find["ID"]=function(id,context){if(typeof context.getElementById!==strundefined&&documentIsHTML){var m=context.getElementById(id);return m&&m.parentNode?[m]:[]}};Expr.filter["ID"]=function(id){var attrId=id.replace(runescape,funescape);return function(elem){return elem.getAttribute("id")===attrId}}}else{delete Expr.find["ID"];Expr.filter["ID"]=function(id){var attrId=id.replace(runescape,funescape);return function(elem){var node=typeof elem.getAttributeNode!==strundefined&&elem.getAttributeNode("id");return node&&node.value===attrId}}}Expr.find["TAG"]=support.getElementsByTagName?function(tag,context){if(typeof context.getElementsByTagName!==strundefined){return context.getElementsByTagName(tag)}}:function(tag,context){var elem,tmp=[],i=0,results=context.getElementsByTagName(tag);if(tag==="*"){while(elem=results[i++]){if(elem.nodeType===1){tmp.push(elem)}}return tmp}return results};Expr.find["CLASS"]=support.getElementsByClassName&&function(className,context){if(typeof context.getElementsByClassName!==strundefined&&documentIsHTML){return context.getElementsByClassName(className)}};rbuggyMatches=[];rbuggyQSA=[];
if(support.qsa=rnative.test(doc.querySelectorAll)){assert(function(div){div.innerHTML="<select><option selected=''></option></select>";if(!div.querySelectorAll("[selected]").length){rbuggyQSA.push("\\["+whitespace+"*(?:value|"+booleans+")")}if(!div.querySelectorAll(":checked").length){rbuggyQSA.push(":checked")}});assert(function(div){var input=doc.createElement("input");input.setAttribute("type","hidden");div.appendChild(input).setAttribute("t","");if(div.querySelectorAll("[t^='']").length){rbuggyQSA.push("[*^$]="+whitespace+"*(?:''|\"\")")}if(!div.querySelectorAll(":enabled").length){rbuggyQSA.push(":enabled",":disabled")}div.querySelectorAll("*,:x");rbuggyQSA.push(",.*:")})}if(support.matchesSelector=rnative.test(matches=docElem.webkitMatchesSelector||docElem.mozMatchesSelector||docElem.oMatchesSelector||docElem.msMatchesSelector)){assert(function(div){support.disconnectedMatch=matches.call(div,"div");matches.call(div,"[s!='']:x");rbuggyMatches.push("!=",pseudos)})}rbuggyQSA=rbuggyQSA.length&&new RegExp(rbuggyQSA.join("|"));rbuggyMatches=rbuggyMatches.length&&new RegExp(rbuggyMatches.join("|"));contains=rnative.test(docElem.contains)||docElem.compareDocumentPosition?function(a,b){var adown=a.nodeType===9?a.documentElement:a,bup=b&&b.parentNode;return a===bup||!!(bup&&bup.nodeType===1&&(adown.contains?adown.contains(bup):a.compareDocumentPosition&&a.compareDocumentPosition(bup)&16))}:function(a,b){if(b){while(b=b.parentNode){if(b===a){return true}}}return false};sortOrder=docElem.compareDocumentPosition?function(a,b){if(a===b){hasDuplicate=true;return 0}var compare=b.compareDocumentPosition&&a.compareDocumentPosition&&a.compareDocumentPosition(b);if(compare){if(compare&1||!support.sortDetached&&b.compareDocumentPosition(a)===compare){if(a===doc||contains(preferredDoc,a)){return-1}if(b===doc||contains(preferredDoc,b)){return 1}return sortInput?indexOf.call(sortInput,a)-indexOf.call(sortInput,b):0}return compare&4?-1:1}return a.compareDocumentPosition?-1:1}:function(a,b){var cur,i=0,aup=a.parentNode,bup=b.parentNode,ap=[a],bp=[b];if(a===b){hasDuplicate=true;return 0}else if(!aup||!bup){return a===doc?-1:b===doc?1:aup?-1:bup?1:sortInput?indexOf.call(sortInput,a)-indexOf.call(sortInput,b):0}else if(aup===bup){return siblingCheck(a,b)}cur=a;while(cur=cur.parentNode){ap.unshift(cur)}cur=b;while(cur=cur.parentNode){bp.unshift(cur)}while(ap[i]===bp[i]){i++}return i?siblingCheck(ap[i],bp[i]):ap[i]===preferredDoc?-1:bp[i]===preferredDoc?1:0};return doc};Sizzle.matches=function(expr,elements){return Sizzle(expr,null,null,elements)};Sizzle.matchesSelector=function(elem,expr){if((elem.ownerDocument||elem)!==document){setDocument(elem)}expr=expr.replace(rattributeQuotes,"='$1']");if(support.matchesSelector&&documentIsHTML&&(!rbuggyMatches||!rbuggyMatches.test(expr))&&(!rbuggyQSA||!rbuggyQSA.test(expr))){try{var ret=matches.call(elem,expr);if(ret||support.disconnectedMatch||elem.document&&elem.document.nodeType!==11){return ret}}catch(e){}}return Sizzle(expr,document,null,[elem]).length>0};Sizzle.contains=function(context,elem){if((context.ownerDocument||context)!==document){setDocument(context)}return contains(context,elem)};Sizzle.attr=function(elem,name){if((elem.ownerDocument||elem)!==document){setDocument(elem)}var fn=Expr.attrHandle[name.toLowerCase()],val=fn&&hasOwn.call(Expr.attrHandle,name.toLowerCase())?fn(elem,name,!documentIsHTML):undefined;return val===undefined?support.attributes||!documentIsHTML?elem.getAttribute(name):(val=elem.getAttributeNode(name))&&val.specified?val.value:null:val};Sizzle.error=function(msg){throw new Error("Syntax error, unrecognized expression: "+msg)};Sizzle.uniqueSort=function(results){var elem,duplicates=[],j=0,i=0;hasDuplicate=!support.detectDuplicates;sortInput=!support.sortStable&&results.slice(0);results.sort(sortOrder);if(hasDuplicate){while(elem=results[i++]){if(elem===results[i]){j=duplicates.push(i)}}while(j--){results.splice(duplicates[j],1)}}return results};getText=Sizzle.getText=function(elem){var node,ret="",i=0,nodeType=elem.nodeType;if(!nodeType){for(;node=elem[i];i++){ret+=getText(node)}}else if(nodeType===1||nodeType===9||nodeType===11){if(typeof elem.textContent==="string"){return elem.textContent}else{for(elem=elem.firstChild;elem;elem=elem.nextSibling){ret+=getText(elem)}}}else if(nodeType===3||nodeType===4){return elem.nodeValue}return ret};Expr=Sizzle.selectors={cacheLength:50,createPseudo:markFunction,match:matchExpr,attrHandle:{},find:{},relative:{">":{dir:"parentNode",first:true}," ":{dir:"parentNode"},"+":{dir:"previousSibling",first:true},"~":{dir:"previousSibling"}},preFilter:{ATTR:function(match){match[1]=match[1].replace(runescape,funescape);match[3]=(match[4]||match[5]||"").replace(runescape,funescape);if(match[2]==="~="){match[3]=" "+match[3]+" "}return match.slice(0,4)},CHILD:function(match){match[1]=match[1].toLowerCase();if(match[1].slice(0,3)==="nth"){if(!match[3]){Sizzle.error(match[0])}match[4]=+(match[4]?match[5]+(match[6]||1):2*(match[3]==="even"||match[3]==="odd"));match[5]=+(match[7]+match[8]||match[3]==="odd")}else if(match[3]){Sizzle.error(match[0])}return match},PSEUDO:function(match){var excess,unquoted=!match[5]&&match[2];if(matchExpr["CHILD"].test(match[0])){return null}if(match[3]&&match[4]!==undefined){match[2]=match[4]}else if(unquoted&&rpseudo.test(unquoted)&&(excess=tokenize(unquoted,true))&&(excess=unquoted.indexOf(")",unquoted.length-excess)-unquoted.length)){match[0]=match[0].slice(0,excess);match[2]=unquoted.slice(0,excess)}return match.slice(0,3)}},filter:{TAG:function(nodeNameSelector){var nodeName=nodeNameSelector.replace(runescape,funescape).toLowerCase();return nodeNameSelector==="*"?function(){return true}:function(elem){return elem.nodeName&&elem.nodeName.toLowerCase()===nodeName}},CLASS:function(className){var pattern=classCache[className+" "];return pattern||(pattern=new RegExp("(^|"+whitespace+")"+className+"("+whitespace+"|$)"))&&classCache(className,function(elem){return pattern.test(typeof elem.className==="string"&&elem.className||typeof elem.getAttribute!==strundefined&&elem.getAttribute("class")||"")})},ATTR:function(name,operator,check){return function(elem){var result=Sizzle.attr(elem,name);if(result==null){return operator==="!="}if(!operator){return true}result+="";return operator==="="?result===check:operator==="!="?result!==check:operator==="^="?check&&result.indexOf(check)===0:operator==="*="?check&&result.indexOf(check)>-1:operator==="$="?check&&result.slice(-check.length)===check:operator==="~="?(" "+result+" ").indexOf(check)>-1:operator==="|="?result===check||result.slice(0,check.length+1)===check+"-":false}},CHILD:function(type,what,argument,first,last){var simple=type.slice(0,3)!=="nth",forward=type.slice(-4)!=="last",ofType=what==="of-type";return first===1&&last===0?function(elem){return!!elem.parentNode}:function(elem,context,xml){var cache,outerCache,node,diff,nodeIndex,start,dir=simple!==forward?"nextSibling":"previousSibling",parent=elem.parentNode,name=ofType&&elem.nodeName.toLowerCase(),useCache=!xml&&!ofType;if(parent){if(simple){while(dir){node=elem;while(node=node[dir]){if(ofType?node.nodeName.toLowerCase()===name:node.nodeType===1){return false}}start=dir=type==="only"&&!start&&"nextSibling"}return true}start=[forward?parent.firstChild:parent.lastChild];if(forward&&useCache){outerCache=parent[expando]||(parent[expando]={});cache=outerCache[type]||[];nodeIndex=cache[0]===dirruns&&cache[1];diff=cache[0]===dirruns&&cache[2];node=nodeIndex&&parent.childNodes[nodeIndex];while(node=++nodeIndex&&node&&node[dir]||(diff=nodeIndex=0)||start.pop()){if(node.nodeType===1&&++diff&&node===elem){outerCache[type]=[dirruns,nodeIndex,diff];break}}}else if(useCache&&(cache=(elem[expando]||(elem[expando]={}))[type])&&cache[0]===dirruns){diff=cache[1]}else{while(node=++nodeIndex&&node&&node[dir]||(diff=nodeIndex=0)||start.pop()){if((ofType?node.nodeName.toLowerCase()===name:node.nodeType===1)&&++diff){if(useCache){(node[expando]||(node[expando]={}))[type]=[dirruns,diff]}if(node===elem){break}}}}diff-=last;return diff===first||diff%first===0&&diff/first>=0}}},PSEUDO:function(pseudo,argument){var args,fn=Expr.pseudos[pseudo]||Expr.setFilters[pseudo.toLowerCase()]||Sizzle.error("unsupported pseudo: "+pseudo);if(fn[expando]){return fn(argument)}if(fn.length>1){args=[pseudo,pseudo,"",argument];return Expr.setFilters.hasOwnProperty(pseudo.toLowerCase())?markFunction(function(seed,matches){var idx,matched=fn(seed,argument),i=matched.length;while(i--){idx=indexOf.call(seed,matched[i]);seed[idx]=!(matches[idx]=matched[i])}}):function(elem){return fn(elem,0,args)}}return fn}},pseudos:{not:markFunction(function(selector){var input=[],results=[],matcher=compile(selector.replace(rtrim,"$1"));return matcher[expando]?markFunction(function(seed,matches,context,xml){var elem,unmatched=matcher(seed,null,xml,[]),i=seed.length;while(i--){if(elem=unmatched[i]){seed[i]=!(matches[i]=elem)}}}):function(elem,context,xml){input[0]=elem;matcher(input,null,xml,results);return!results.pop()}}),has:markFunction(function(selector){return function(elem){return Sizzle(selector,elem).length>0}}),contains:markFunction(function(text){return function(elem){return(elem.textContent||elem.innerText||getText(elem)).indexOf(text)>-1}}),lang:markFunction(function(lang){if(!ridentifier.test(lang||"")){Sizzle.error("unsupported lang: "+lang)}lang=lang.replace(runescape,funescape).toLowerCase();return function(elem){var elemLang;do{if(elemLang=documentIsHTML?elem.lang:elem.getAttribute("xml:lang")||elem.getAttribute("lang")){elemLang=elemLang.toLowerCase();return elemLang===lang||elemLang.indexOf(lang+"-")===0}}while((elem=elem.parentNode)&&elem.nodeType===1);return false}}),target:function(elem){var hash=window.location&&window.location.hash;return hash&&hash.slice(1)===elem.id},root:function(elem){return elem===docElem},focus:function(elem){return elem===document.activeElement&&(!document.hasFocus||document.hasFocus())&&!!(elem.type||elem.href||~elem.tabIndex)},enabled:function(elem){return elem.disabled===false},disabled:function(elem){return elem.disabled===true},checked:function(elem){var nodeName=elem.nodeName.toLowerCase();return nodeName==="input"&&!!elem.checked||nodeName==="option"&&!!elem.selected},selected:function(elem){if(elem.parentNode){elem.parentNode.selectedIndex}return elem.selected===true},empty:function(elem){for(elem=elem.firstChild;elem;elem=elem.nextSibling){if(elem.nodeName>"@"||elem.nodeType===3||elem.nodeType===4){return false}}return true},parent:function(elem){return!Expr.pseudos["empty"](elem)},header:function(elem){return rheader.test(elem.nodeName)},input:function(elem){return rinputs.test(elem.nodeName)},button:function(elem){var name=elem.nodeName.toLowerCase();return name==="input"&&elem.type==="button"||name==="button"},text:function(elem){var attr;return elem.nodeName.toLowerCase()==="input"&&elem.type==="text"&&((attr=elem.getAttribute("type"))==null||attr.toLowerCase()===elem.type)},first:createPositionalPseudo(function(){return[0]}),last:createPositionalPseudo(function(matchIndexes,length){return[length-1]}),eq:createPositionalPseudo(function(matchIndexes,length,argument){return[argument<0?argument+length:argument]}),even:createPositionalPseudo(function(matchIndexes,length){var i=0;for(;i<length;i+=2){matchIndexes.push(i)}return matchIndexes}),odd:createPositionalPseudo(function(matchIndexes,length){var i=1;for(;i<length;i+=2){matchIndexes.push(i)}return matchIndexes}),lt:createPositionalPseudo(function(matchIndexes,length,argument){var i=argument<0?argument+length:argument;for(;--i>=0;){matchIndexes.push(i)}return matchIndexes}),gt:createPositionalPseudo(function(matchIndexes,length,argument){var i=argument<0?argument+length:argument;for(;++i<length;){matchIndexes.push(i)}return matchIndexes})}};Expr.pseudos["nth"]=Expr.pseudos["eq"];for(i in{radio:true,checkbox:true,file:true,password:true,image:true}){Expr.pseudos[i]=createInputPseudo(i)}for(i in{submit:true,reset:true}){Expr.pseudos[i]=createButtonPseudo(i)}function setFilters(){}setFilters.prototype=Expr.filters=Expr.pseudos;Expr.setFilters=new setFilters;function tokenize(selector,parseOnly){var matched,match,tokens,type,soFar,groups,preFilters,cached=tokenCache[selector+" "];if(cached){return parseOnly?0:cached.slice(0)}soFar=selector;groups=[];preFilters=Expr.preFilter;while(soFar){if(!matched||(match=rcomma.exec(soFar))){if(match){soFar=soFar.slice(match[0].length)||soFar}groups.push(tokens=[])}matched=false;if(match=rcombinators.exec(soFar)){matched=match.shift();tokens.push({value:matched,type:match[0].replace(rtrim," ")});soFar=soFar.slice(matched.length)}for(type in Expr.filter){if((match=matchExpr[type].exec(soFar))&&(!preFilters[type]||(match=preFilters[type](match)))){matched=match.shift();tokens.push({value:matched,type:type,matches:match});soFar=soFar.slice(matched.length)}}if(!matched){break}}return parseOnly?soFar.length:soFar?Sizzle.error(selector):tokenCache(selector,groups).slice(0)}function toSelector(tokens){var i=0,len=tokens.length,selector="";for(;i<len;i++){selector+=tokens[i].value}return selector}function addCombinator(matcher,combinator,base){var dir=combinator.dir,checkNonElements=base&&dir==="parentNode",doneName=done++;return combinator.first?function(elem,context,xml){while(elem=elem[dir]){if(elem.nodeType===1||checkNonElements){return matcher(elem,context,xml)}}}:function(elem,context,xml){var data,cache,outerCache,dirkey=dirruns+" "+doneName;if(xml){while(elem=elem[dir]){if(elem.nodeType===1||checkNonElements){if(matcher(elem,context,xml)){return true}}}}else{while(elem=elem[dir]){if(elem.nodeType===1||checkNonElements){outerCache=elem[expando]||(elem[expando]={});if((cache=outerCache[dir])&&cache[0]===dirkey){if((data=cache[1])===true||data===cachedruns){return data===true}}else{cache=outerCache[dir]=[dirkey];cache[1]=matcher(elem,context,xml)||cachedruns;if(cache[1]===true){return true}}}}}}}function elementMatcher(matchers){return matchers.length>1?function(elem,context,xml){var i=matchers.length;while(i--){if(!matchers[i](elem,context,xml)){return false}}return true}:matchers[0]}function condense(unmatched,map,filter,context,xml){var elem,newUnmatched=[],i=0,len=unmatched.length,mapped=map!=null;for(;i<len;i++){if(elem=unmatched[i]){if(!filter||filter(elem,context,xml)){newUnmatched.push(elem);if(mapped){map.push(i)}}}}return newUnmatched}function setMatcher(preFilter,selector,matcher,postFilter,postFinder,postSelector){if(postFilter&&!postFilter[expando]){postFilter=setMatcher(postFilter)}if(postFinder&&!postFinder[expando]){postFinder=setMatcher(postFinder,postSelector)}return markFunction(function(seed,results,context,xml){var temp,i,elem,preMap=[],postMap=[],preexisting=results.length,elems=seed||multipleContexts(selector||"*",context.nodeType?[context]:context,[]),matcherIn=preFilter&&(seed||!selector)?condense(elems,preMap,preFilter,context,xml):elems,matcherOut=matcher?postFinder||(seed?preFilter:preexisting||postFilter)?[]:results:matcherIn;if(matcher){matcher(matcherIn,matcherOut,context,xml)}if(postFilter){temp=condense(matcherOut,postMap);postFilter(temp,[],context,xml);i=temp.length;while(i--){if(elem=temp[i]){matcherOut[postMap[i]]=!(matcherIn[postMap[i]]=elem)}}}if(seed){if(postFinder||preFilter){if(postFinder){temp=[];i=matcherOut.length;while(i--){if(elem=matcherOut[i]){temp.push(matcherIn[i]=elem)}}postFinder(null,matcherOut=[],temp,xml)}i=matcherOut.length;while(i--){if((elem=matcherOut[i])&&(temp=postFinder?indexOf.call(seed,elem):preMap[i])>-1){seed[temp]=!(results[temp]=elem)}}}}else{matcherOut=condense(matcherOut===results?matcherOut.splice(preexisting,matcherOut.length):matcherOut);if(postFinder){postFinder(null,results,matcherOut,xml)}else{push.apply(results,matcherOut)}}})}function matcherFromTokens(tokens){var checkContext,matcher,j,len=tokens.length,leadingRelative=Expr.relative[tokens[0].type],implicitRelative=leadingRelative||Expr.relative[" "],i=leadingRelative?1:0,matchContext=addCombinator(function(elem){return elem===checkContext},implicitRelative,true),matchAnyContext=addCombinator(function(elem){return indexOf.call(checkContext,elem)>-1},implicitRelative,true),matchers=[function(elem,context,xml){return!leadingRelative&&(xml||context!==outermostContext)||((checkContext=context).nodeType?matchContext(elem,context,xml):matchAnyContext(elem,context,xml))}];for(;i<len;i++){if(matcher=Expr.relative[tokens[i].type]){matchers=[addCombinator(elementMatcher(matchers),matcher)]}else{matcher=Expr.filter[tokens[i].type].apply(null,tokens[i].matches);if(matcher[expando]){j=++i;for(;j<len;j++){if(Expr.relative[tokens[j].type]){break}}return setMatcher(i>1&&elementMatcher(matchers),i>1&&toSelector(tokens.slice(0,i-1).concat({value:tokens[i-2].type===" "?"*":""})).replace(rtrim,"$1"),matcher,i<j&&matcherFromTokens(tokens.slice(i,j)),j<len&&matcherFromTokens(tokens=tokens.slice(j)),j<len&&toSelector(tokens))}matchers.push(matcher)}}return elementMatcher(matchers)}function matcherFromGroupMatchers(elementMatchers,setMatchers){var matcherCachedRuns=0,bySet=setMatchers.length>0,byElement=elementMatchers.length>0,superMatcher=function(seed,context,xml,results,expandContext){var elem,j,matcher,setMatched=[],matchedCount=0,i="0",unmatched=seed&&[],outermost=expandContext!=null,contextBackup=outermostContext,elems=seed||byElement&&Expr.find["TAG"]("*",expandContext&&context.parentNode||context),dirrunsUnique=dirruns+=contextBackup==null?1:Math.random()||.1;if(outermost){outermostContext=context!==document&&context;cachedruns=matcherCachedRuns}for(;(elem=elems[i])!=null;i++){if(byElement&&elem){j=0;while(matcher=elementMatchers[j++]){if(matcher(elem,context,xml)){results.push(elem);break}}if(outermost){dirruns=dirrunsUnique;cachedruns=++matcherCachedRuns}}if(bySet){if(elem=!matcher&&elem){matchedCount--}if(seed){unmatched.push(elem)}}}matchedCount+=i;if(bySet&&i!==matchedCount){j=0;while(matcher=setMatchers[j++]){matcher(unmatched,setMatched,context,xml)}if(seed){if(matchedCount>0){while(i--){if(!(unmatched[i]||setMatched[i])){setMatched[i]=pop.call(results)}}}setMatched=condense(setMatched)}push.apply(results,setMatched);if(outermost&&!seed&&setMatched.length>0&&matchedCount+setMatchers.length>1){Sizzle.uniqueSort(results)}}if(outermost){dirruns=dirrunsUnique;outermostContext=contextBackup}return unmatched};return bySet?markFunction(superMatcher):superMatcher}compile=Sizzle.compile=function(selector,group){var i,setMatchers=[],elementMatchers=[],cached=compilerCache[selector+" "];if(!cached){if(!group){group=tokenize(selector)}i=group.length;while(i--){cached=matcherFromTokens(group[i]);if(cached[expando]){setMatchers.push(cached)}else{elementMatchers.push(cached)}}cached=compilerCache(selector,matcherFromGroupMatchers(elementMatchers,setMatchers))}return cached};function multipleContexts(selector,contexts,results){var i=0,len=contexts.length;for(;i<len;i++){Sizzle(selector,contexts[i],results)}return results}function select(selector,context,results,seed){var i,tokens,token,type,find,match=tokenize(selector);if(!seed){if(match.length===1){tokens=match[0]=match[0].slice(0);if(tokens.length>2&&(token=tokens[0]).type==="ID"&&support.getById&&context.nodeType===9&&documentIsHTML&&Expr.relative[tokens[1].type]){context=(Expr.find["ID"](token.matches[0].replace(runescape,funescape),context)||[])[0];if(!context){return results}selector=selector.slice(tokens.shift().value.length)}i=matchExpr["needsContext"].test(selector)?0:tokens.length;while(i--){token=tokens[i];if(Expr.relative[type=token.type]){break}if(find=Expr.find[type]){if(seed=find(token.matches[0].replace(runescape,funescape),rsibling.test(tokens[0].type)&&context.parentNode||context)){tokens.splice(i,1);selector=seed.length&&toSelector(tokens);if(!selector){push.apply(results,seed);return results}break}}}}}compile(selector,match)(seed,context,!documentIsHTML,results,rsibling.test(selector));return results}support.sortStable=expando.split("").sort(sortOrder).join("")===expando;support.detectDuplicates=hasDuplicate;setDocument();support.sortDetached=assert(function(div1){return div1.compareDocumentPosition(document.createElement("div"))&1});if(!assert(function(div){div.innerHTML="<a href='#'></a>";return div.firstChild.getAttribute("href")==="#"})){addHandle("type|href|height|width",function(elem,name,isXML){if(!isXML){return elem.getAttribute(name,name.toLowerCase()==="type"?1:2)}})}if(!support.attributes||!assert(function(div){div.innerHTML="<input/>";div.firstChild.setAttribute("value","");return div.firstChild.getAttribute("value")===""})){addHandle("value",function(elem,name,isXML){if(!isXML&&elem.nodeName.toLowerCase()==="input"){return elem.defaultValue}})}if(!assert(function(div){return div.getAttribute("disabled")==null})){addHandle(booleans,function(elem,name,isXML){var val;if(!isXML){return(val=elem.getAttributeNode(name))&&val.specified?val.value:elem[name]===true?name.toLowerCase():null}})}jQuery.find=Sizzle;jQuery.expr=Sizzle.selectors;jQuery.expr[":"]=jQuery.expr.pseudos;jQuery.unique=Sizzle.uniqueSort;jQuery.text=Sizzle.getText;jQuery.isXMLDoc=Sizzle.isXML;jQuery.contains=Sizzle.contains})(window);var optionsCache={};function createOptions(options){var object=optionsCache[options]={};jQuery.each(options.match(core_rnotwhite)||[],function(_,flag){object[flag]=true});return object}jQuery.Callbacks=function(options){options=typeof options==="string"?optionsCache[options]||createOptions(options):jQuery.extend({},options);var firing,memory,fired,firingLength,firingIndex,firingStart,list=[],stack=!options.once&&[],fire=function(data){memory=options.memory&&data;fired=true;firingIndex=firingStart||0;firingStart=0;firingLength=list.length;firing=true;for(;list&&firingIndex<firingLength;firingIndex++){if(list[firingIndex].apply(data[0],data[1])===false&&options.stopOnFalse){memory=false;break}}firing=false;if(list){if(stack){if(stack.length){fire(stack.shift())}}else if(memory){list=[]}else{self.disable()}}},self={add:function(){if(list){var start=list.length;(function add(args){jQuery.each(args,function(_,arg){var type=jQuery.type(arg);if(type==="function"){if(!options.unique||!self.has(arg)){list.push(arg)}}else if(arg&&arg.length&&type!=="string"){add(arg)}})})(arguments);if(firing){firingLength=list.length}else if(memory){firingStart=start;fire(memory)}}return this},remove:function(){if(list){jQuery.each(arguments,function(_,arg){var index;while((index=jQuery.inArray(arg,list,index))>-1){list.splice(index,1);if(firing){if(index<=firingLength){firingLength--}if(index<=firingIndex){firingIndex--}}}})}return this},has:function(fn){return fn?jQuery.inArray(fn,list)>-1:!!(list&&list.length)},empty:function(){list=[];firingLength=0;return this},disable:function(){list=stack=memory=undefined;return this},disabled:function(){return!list},lock:function(){stack=undefined;if(!memory){self.disable()}return this},locked:function(){return!stack},fireWith:function(context,args){if(list&&(!fired||stack)){args=args||[];args=[context,args.slice?args.slice():args];if(firing){stack.push(args)}else{fire(args)}}return this},fire:function(){self.fireWith(this,arguments);return this},fired:function(){return!!fired}};return self};jQuery.extend({Deferred:function(func){var tuples=[["resolve","done",jQuery.Callbacks("once memory"),"resolved"],["reject","fail",jQuery.Callbacks("once memory"),"rejected"],["notify","progress",jQuery.Callbacks("memory")]],state="pending",promise={state:function(){return state},always:function(){deferred.done(arguments).fail(arguments);return this},then:function(){var fns=arguments;return jQuery.Deferred(function(newDefer){jQuery.each(tuples,function(i,tuple){var action=tuple[0],fn=jQuery.isFunction(fns[i])&&fns[i];deferred[tuple[1]](function(){var returned=fn&&fn.apply(this,arguments);if(returned&&jQuery.isFunction(returned.promise)){returned.promise().done(newDefer.resolve).fail(newDefer.reject).progress(newDefer.notify)}else{newDefer[action+"With"](this===promise?newDefer.promise():this,fn?[returned]:arguments)}})});fns=null}).promise()},promise:function(obj){return obj!=null?jQuery.extend(obj,promise):promise}},deferred={};promise.pipe=promise.then;jQuery.each(tuples,function(i,tuple){var list=tuple[2],stateString=tuple[3];promise[tuple[1]]=list.add;if(stateString){list.add(function(){state=stateString},tuples[i^1][2].disable,tuples[2][2].lock)}deferred[tuple[0]]=function(){deferred[tuple[0]+"With"](this===deferred?promise:this,arguments);return this};deferred[tuple[0]+"With"]=list.fireWith});promise.promise(deferred);if(func){func.call(deferred,deferred)}return deferred},when:function(subordinate){var i=0,resolveValues=core_slice.call(arguments),length=resolveValues.length,remaining=length!==1||subordinate&&jQuery.isFunction(subordinate.promise)?length:0,deferred=remaining===1?subordinate:jQuery.Deferred(),updateFunc=function(i,contexts,values){return function(value){contexts[i]=this;values[i]=arguments.length>1?core_slice.call(arguments):value;if(values===progressValues){deferred.notifyWith(contexts,values)}else if(!--remaining){deferred.resolveWith(contexts,values)}}},progressValues,progressContexts,resolveContexts;if(length>1){progressValues=new Array(length);progressContexts=new Array(length);resolveContexts=new Array(length);for(;i<length;i++){if(resolveValues[i]&&jQuery.isFunction(resolveValues[i].promise)){resolveValues[i].promise().done(updateFunc(i,resolveContexts,resolveValues)).fail(deferred.reject).progress(updateFunc(i,progressContexts,progressValues))}else{--remaining}}}if(!remaining){deferred.resolveWith(resolveContexts,resolveValues)}return deferred.promise()}});jQuery.support=function(support){var all,a,input,select,fragment,opt,eventName,isSupported,i,div=document.createElement("div");div.setAttribute("className","t");div.innerHTML="  <link/><table></table><a href='/a'>a</a><input type='checkbox'/>";all=div.getElementsByTagName("*")||[];a=div.getElementsByTagName("a")[0];if(!a||!a.style||!all.length){return support}select=document.createElement("select");opt=select.appendChild(document.createElement("option"));input=div.getElementsByTagName("input")[0];a.style.cssText="top:1px;float:left;opacity:.5";support.getSetAttribute=div.className!=="t";support.leadingWhitespace=div.firstChild.nodeType===3;support.tbody=!div.getElementsByTagName("tbody").length;support.htmlSerialize=!!div.getElementsByTagName("link").length;support.style=/top/.test(a.getAttribute("style"));support.hrefNormalized=a.getAttribute("href")==="/a";support.opacity=/^0.5/.test(a.style.opacity);support.cssFloat=!!a.style.cssFloat;support.checkOn=!!input.value;support.optSelected=opt.selected;support.enctype=!!document.createElement("form").enctype;support.html5Clone=document.createElement("nav").cloneNode(true).outerHTML!=="<:nav></:nav>";support.inlineBlockNeedsLayout=false;support.shrinkWrapBlocks=false;support.pixelPosition=false;support.deleteExpando=true;support.noCloneEvent=true;support.reliableMarginRight=true;support.boxSizingReliable=true;input.checked=true;support.noCloneChecked=input.cloneNode(true).checked;select.disabled=true;support.optDisabled=!opt.disabled;try{delete div.test}catch(e){support.deleteExpando=false}input=document.createElement("input");input.setAttribute("value","");support.input=input.getAttribute("value")==="";input.value="t";input.setAttribute("type","radio");support.radioValue=input.value==="t";input.setAttribute("checked","t");input.setAttribute("name","t");fragment=document.createDocumentFragment();fragment.appendChild(input);support.appendChecked=input.checked;support.checkClone=fragment.cloneNode(true).cloneNode(true).lastChild.checked;if(div.attachEvent){div.attachEvent("onclick",function(){support.noCloneEvent=false});div.cloneNode(true).click()}for(i in{submit:true,change:true,focusin:true}){div.setAttribute(eventName="on"+i,"t");support[i+"Bubbles"]=eventName in window||div.attributes[eventName].expando===false}div.style.backgroundClip="content-box";div.cloneNode(true).style.backgroundClip="";support.clearCloneStyle=div.style.backgroundClip==="content-box";for(i in jQuery(support)){break}support.ownLast=i!=="0";jQuery(function(){var container,marginDiv,tds,divReset="padding:0;margin:0;border:0;display:block;box-sizing:content-box;-moz-box-sizing:content-box;-webkit-box-sizing:content-box;",body=document.getElementsByTagName("body")[0];if(!body){return}container=document.createElement("div");container.style.cssText="border:0;width:0;height:0;position:absolute;top:0;left:-9999px;margin-top:1px";body.appendChild(container).appendChild(div);div.innerHTML="<table><tr><td></td><td>t</td></tr></table>";tds=div.getElementsByTagName("td");tds[0].style.cssText="padding:0;margin:0;border:0;display:none";isSupported=tds[0].offsetHeight===0;tds[0].style.display="";tds[1].style.display="none";support.reliableHiddenOffsets=isSupported&&tds[0].offsetHeight===0;div.innerHTML="";div.style.cssText="box-sizing:border-box;-moz-box-sizing:border-box;-webkit-box-sizing:border-box;padding:1px;border:1px;display:block;width:4px;margin-top:1%;position:absolute;top:1%;";jQuery.swap(body,body.style.zoom!=null?{zoom:1}:{},function(){support.boxSizing=div.offsetWidth===4});if(window.getComputedStyle){support.pixelPosition=(window.getComputedStyle(div,null)||{}).top!=="1%";support.boxSizingReliable=(window.getComputedStyle(div,null)||{width:"4px"}).width==="4px";marginDiv=div.appendChild(document.createElement("div"));marginDiv.style.cssText=div.style.cssText=divReset;marginDiv.style.marginRight=marginDiv.style.width="0";div.style.width="1px";support.reliableMarginRight=!parseFloat((window.getComputedStyle(marginDiv,null)||{}).marginRight)}if(typeof div.style.zoom!==core_strundefined){div.innerHTML="";div.style.cssText=divReset+"width:1px;padding:1px;display:inline;zoom:1";support.inlineBlockNeedsLayout=div.offsetWidth===3;div.style.display="block";div.innerHTML="<div></div>";div.firstChild.style.width="5px";support.shrinkWrapBlocks=div.offsetWidth!==3;if(support.inlineBlockNeedsLayout){body.style.zoom=1}}body.removeChild(container);container=div=tds=marginDiv=null});all=select=fragment=opt=a=input=null;return support}({});var rbrace=/(?:\{[\s\S]*\}|\[[\s\S]*\])$/,rmultiDash=/([A-Z])/g;function internalData(elem,name,data,pvt){if(!jQuery.acceptData(elem)){return}var ret,thisCache,internalKey=jQuery.expando,isNode=elem.nodeType,cache=isNode?jQuery.cache:elem,id=isNode?elem[internalKey]:elem[internalKey]&&internalKey;if((!id||!cache[id]||!pvt&&!cache[id].data)&&data===undefined&&typeof name==="string"){return}if(!id){if(isNode){id=elem[internalKey]=core_deletedIds.pop()||jQuery.guid++}else{id=internalKey}}if(!cache[id]){cache[id]=isNode?{}:{toJSON:jQuery.noop}}if(typeof name==="object"||typeof name==="function"){if(pvt){cache[id]=jQuery.extend(cache[id],name)}else{cache[id].data=jQuery.extend(cache[id].data,name)}}thisCache=cache[id];if(!pvt){if(!thisCache.data){thisCache.data={}}thisCache=thisCache.data}if(data!==undefined){thisCache[jQuery.camelCase(name)]=data}if(typeof name==="string"){ret=thisCache[name];if(ret==null){ret=thisCache[jQuery.camelCase(name)]}}else{ret=thisCache}return ret}function internalRemoveData(elem,name,pvt){if(!jQuery.acceptData(elem)){return}var thisCache,i,isNode=elem.nodeType,cache=isNode?jQuery.cache:elem,id=isNode?elem[jQuery.expando]:jQuery.expando;if(!cache[id]){return}if(name){thisCache=pvt?cache[id]:cache[id].data;if(thisCache){if(!jQuery.isArray(name)){if(name in thisCache){name=[name]}else{name=jQuery.camelCase(name);if(name in thisCache){name=[name]}else{name=name.split(" ")}}}else{name=name.concat(jQuery.map(name,jQuery.camelCase))}i=name.length;while(i--){delete thisCache[name[i]]}if(pvt?!isEmptyDataObject(thisCache):!jQuery.isEmptyObject(thisCache)){return}}}if(!pvt){delete cache[id].data;if(!isEmptyDataObject(cache[id])){return}}if(isNode){jQuery.cleanData([elem],true)}else if(jQuery.support.deleteExpando||cache!=cache.window){delete cache[id]}else{cache[id]=null}}jQuery.extend({cache:{},noData:{applet:true,embed:true,object:"clsid:D27CDB6E-AE6D-11cf-96B8-444553540000"},hasData:function(elem){elem=elem.nodeType?jQuery.cache[elem[jQuery.expando]]:elem[jQuery.expando];
return!!elem&&!isEmptyDataObject(elem)},data:function(elem,name,data){return internalData(elem,name,data)},removeData:function(elem,name){return internalRemoveData(elem,name)},_data:function(elem,name,data){return internalData(elem,name,data,true)},_removeData:function(elem,name){return internalRemoveData(elem,name,true)},acceptData:function(elem){if(elem.nodeType&&elem.nodeType!==1&&elem.nodeType!==9){return false}var noData=elem.nodeName&&jQuery.noData[elem.nodeName.toLowerCase()];return!noData||noData!==true&&elem.getAttribute("classid")===noData}});jQuery.fn.extend({data:function(key,value){var attrs,name,data=null,i=0,elem=this[0];if(key===undefined){if(this.length){data=jQuery.data(elem);if(elem.nodeType===1&&!jQuery._data(elem,"parsedAttrs")){attrs=elem.attributes;for(;i<attrs.length;i++){name=attrs[i].name;if(name.indexOf("data-")===0){name=jQuery.camelCase(name.slice(5));dataAttr(elem,name,data[name])}}jQuery._data(elem,"parsedAttrs",true)}}return data}if(typeof key==="object"){return this.each(function(){jQuery.data(this,key)})}return arguments.length>1?this.each(function(){jQuery.data(this,key,value)}):elem?dataAttr(elem,key,jQuery.data(elem,key)):null},removeData:function(key){return this.each(function(){jQuery.removeData(this,key)})}});function dataAttr(elem,key,data){if(data===undefined&&elem.nodeType===1){var name="data-"+key.replace(rmultiDash,"-$1").toLowerCase();data=elem.getAttribute(name);if(typeof data==="string"){try{data=data==="true"?true:data==="false"?false:data==="null"?null:+data+""===data?+data:rbrace.test(data)?jQuery.parseJSON(data):data}catch(e){}jQuery.data(elem,key,data)}else{data=undefined}}return data}function isEmptyDataObject(obj){var name;for(name in obj){if(name==="data"&&jQuery.isEmptyObject(obj[name])){continue}if(name!=="toJSON"){return false}}return true}jQuery.extend({queue:function(elem,type,data){var queue;if(elem){type=(type||"fx")+"queue";queue=jQuery._data(elem,type);if(data){if(!queue||jQuery.isArray(data)){queue=jQuery._data(elem,type,jQuery.makeArray(data))}else{queue.push(data)}}return queue||[]}},dequeue:function(elem,type){type=type||"fx";var queue=jQuery.queue(elem,type),startLength=queue.length,fn=queue.shift(),hooks=jQuery._queueHooks(elem,type),next=function(){jQuery.dequeue(elem,type)};if(fn==="inprogress"){fn=queue.shift();startLength--}if(fn){if(type==="fx"){queue.unshift("inprogress")}delete hooks.stop;fn.call(elem,next,hooks)}if(!startLength&&hooks){hooks.empty.fire()}},_queueHooks:function(elem,type){var key=type+"queueHooks";return jQuery._data(elem,key)||jQuery._data(elem,key,{empty:jQuery.Callbacks("once memory").add(function(){jQuery._removeData(elem,type+"queue");jQuery._removeData(elem,key)})})}});jQuery.fn.extend({queue:function(type,data){var setter=2;if(typeof type!=="string"){data=type;type="fx";setter--}if(arguments.length<setter){return jQuery.queue(this[0],type)}return data===undefined?this:this.each(function(){var queue=jQuery.queue(this,type,data);jQuery._queueHooks(this,type);if(type==="fx"&&queue[0]!=="inprogress"){jQuery.dequeue(this,type)}})},dequeue:function(type){return this.each(function(){jQuery.dequeue(this,type)})},delay:function(time,type){time=jQuery.fx?jQuery.fx.speeds[time]||time:time;type=type||"fx";return this.queue(type,function(next,hooks){var timeout=setTimeout(next,time);hooks.stop=function(){clearTimeout(timeout)}})},clearQueue:function(type){return this.queue(type||"fx",[])},promise:function(type,obj){var tmp,count=1,defer=jQuery.Deferred(),elements=this,i=this.length,resolve=function(){if(!--count){defer.resolveWith(elements,[elements])}};if(typeof type!=="string"){obj=type;type=undefined}type=type||"fx";while(i--){tmp=jQuery._data(elements[i],type+"queueHooks");if(tmp&&tmp.empty){count++;tmp.empty.add(resolve)}}resolve();return defer.promise(obj)}});var nodeHook,boolHook,rclass=/[\t\r\n\f]/g,rreturn=/\r/g,rfocusable=/^(?:input|select|textarea|button|object)$/i,rclickable=/^(?:a|area)$/i,ruseDefault=/^(?:checked|selected)$/i,getSetAttribute=jQuery.support.getSetAttribute,getSetInput=jQuery.support.input;jQuery.fn.extend({attr:function(name,value){return jQuery.access(this,jQuery.attr,name,value,arguments.length>1)},removeAttr:function(name){return this.each(function(){jQuery.removeAttr(this,name)})},prop:function(name,value){return jQuery.access(this,jQuery.prop,name,value,arguments.length>1)},removeProp:function(name){name=jQuery.propFix[name]||name;return this.each(function(){try{this[name]=undefined;delete this[name]}catch(e){}})},addClass:function(value){var classes,elem,cur,clazz,j,i=0,len=this.length,proceed=typeof value==="string"&&value;if(jQuery.isFunction(value)){return this.each(function(j){jQuery(this).addClass(value.call(this,j,this.className))})}if(proceed){classes=(value||"").match(core_rnotwhite)||[];for(;i<len;i++){elem=this[i];cur=elem.nodeType===1&&(elem.className?(" "+elem.className+" ").replace(rclass," "):" ");if(cur){j=0;while(clazz=classes[j++]){if(cur.indexOf(" "+clazz+" ")<0){cur+=clazz+" "}}elem.className=jQuery.trim(cur)}}}return this},removeClass:function(value){var classes,elem,cur,clazz,j,i=0,len=this.length,proceed=arguments.length===0||typeof value==="string"&&value;if(jQuery.isFunction(value)){return this.each(function(j){jQuery(this).removeClass(value.call(this,j,this.className))})}if(proceed){classes=(value||"").match(core_rnotwhite)||[];for(;i<len;i++){elem=this[i];cur=elem.nodeType===1&&(elem.className?(" "+elem.className+" ").replace(rclass," "):"");if(cur){j=0;while(clazz=classes[j++]){while(cur.indexOf(" "+clazz+" ")>=0){cur=cur.replace(" "+clazz+" "," ")}}elem.className=value?jQuery.trim(cur):""}}}return this},toggleClass:function(value,stateVal){var type=typeof value;if(typeof stateVal==="boolean"&&type==="string"){return stateVal?this.addClass(value):this.removeClass(value)}if(jQuery.isFunction(value)){return this.each(function(i){jQuery(this).toggleClass(value.call(this,i,this.className,stateVal),stateVal)})}return this.each(function(){if(type==="string"){var className,i=0,self=jQuery(this),classNames=value.match(core_rnotwhite)||[];while(className=classNames[i++]){if(self.hasClass(className)){self.removeClass(className)}else{self.addClass(className)}}}else if(type===core_strundefined||type==="boolean"){if(this.className){jQuery._data(this,"__className__",this.className)}this.className=this.className||value===false?"":jQuery._data(this,"__className__")||""}})},hasClass:function(selector){var className=" "+selector+" ",i=0,l=this.length;for(;i<l;i++){if(this[i].nodeType===1&&(" "+this[i].className+" ").replace(rclass," ").indexOf(className)>=0){return true}}return false},val:function(value){var ret,hooks,isFunction,elem=this[0];if(!arguments.length){if(elem){hooks=jQuery.valHooks[elem.type]||jQuery.valHooks[elem.nodeName.toLowerCase()];if(hooks&&"get"in hooks&&(ret=hooks.get(elem,"value"))!==undefined){return ret}ret=elem.value;return typeof ret==="string"?ret.replace(rreturn,""):ret==null?"":ret}return}isFunction=jQuery.isFunction(value);return this.each(function(i){var val;if(this.nodeType!==1){return}if(isFunction){val=value.call(this,i,jQuery(this).val())}else{val=value}if(val==null){val=""}else if(typeof val==="number"){val+=""}else if(jQuery.isArray(val)){val=jQuery.map(val,function(value){return value==null?"":value+""})}hooks=jQuery.valHooks[this.type]||jQuery.valHooks[this.nodeName.toLowerCase()];if(!hooks||!("set"in hooks)||hooks.set(this,val,"value")===undefined){this.value=val}})}});jQuery.extend({valHooks:{option:{get:function(elem){var val=jQuery.find.attr(elem,"value");return val!=null?val:elem.text}},select:{get:function(elem){var value,option,options=elem.options,index=elem.selectedIndex,one=elem.type==="select-one"||index<0,values=one?null:[],max=one?index+1:options.length,i=index<0?max:one?index:0;for(;i<max;i++){option=options[i];if((option.selected||i===index)&&(jQuery.support.optDisabled?!option.disabled:option.getAttribute("disabled")===null)&&(!option.parentNode.disabled||!jQuery.nodeName(option.parentNode,"optgroup"))){value=jQuery(option).val();if(one){return value}values.push(value)}}return values},set:function(elem,value){var optionSet,option,options=elem.options,values=jQuery.makeArray(value),i=options.length;while(i--){option=options[i];if(option.selected=jQuery.inArray(jQuery(option).val(),values)>=0){optionSet=true}}if(!optionSet){elem.selectedIndex=-1}return values}}},attr:function(elem,name,value){var hooks,ret,nType=elem.nodeType;if(!elem||nType===3||nType===8||nType===2){return}if(typeof elem.getAttribute===core_strundefined){return jQuery.prop(elem,name,value)}if(nType!==1||!jQuery.isXMLDoc(elem)){name=name.toLowerCase();hooks=jQuery.attrHooks[name]||(jQuery.expr.match.bool.test(name)?boolHook:nodeHook)}if(value!==undefined){if(value===null){jQuery.removeAttr(elem,name)}else if(hooks&&"set"in hooks&&(ret=hooks.set(elem,value,name))!==undefined){return ret}else{elem.setAttribute(name,value+"");return value}}else if(hooks&&"get"in hooks&&(ret=hooks.get(elem,name))!==null){return ret}else{ret=jQuery.find.attr(elem,name);return ret==null?undefined:ret}},removeAttr:function(elem,value){var name,propName,i=0,attrNames=value&&value.match(core_rnotwhite);if(attrNames&&elem.nodeType===1){while(name=attrNames[i++]){propName=jQuery.propFix[name]||name;if(jQuery.expr.match.bool.test(name)){if(getSetInput&&getSetAttribute||!ruseDefault.test(name)){elem[propName]=false}else{elem[jQuery.camelCase("default-"+name)]=elem[propName]=false}}else{jQuery.attr(elem,name,"")}elem.removeAttribute(getSetAttribute?name:propName)}}},attrHooks:{type:{set:function(elem,value){if(!jQuery.support.radioValue&&value==="radio"&&jQuery.nodeName(elem,"input")){var val=elem.value;elem.setAttribute("type",value);if(val){elem.value=val}return value}}}},propFix:{"for":"htmlFor","class":"className"},prop:function(elem,name,value){var ret,hooks,notxml,nType=elem.nodeType;if(!elem||nType===3||nType===8||nType===2){return}notxml=nType!==1||!jQuery.isXMLDoc(elem);if(notxml){name=jQuery.propFix[name]||name;hooks=jQuery.propHooks[name]}if(value!==undefined){return hooks&&"set"in hooks&&(ret=hooks.set(elem,value,name))!==undefined?ret:elem[name]=value}else{return hooks&&"get"in hooks&&(ret=hooks.get(elem,name))!==null?ret:elem[name]}},propHooks:{tabIndex:{get:function(elem){var tabindex=jQuery.find.attr(elem,"tabindex");return tabindex?parseInt(tabindex,10):rfocusable.test(elem.nodeName)||rclickable.test(elem.nodeName)&&elem.href?0:-1}}}});boolHook={set:function(elem,value,name){if(value===false){jQuery.removeAttr(elem,name)}else if(getSetInput&&getSetAttribute||!ruseDefault.test(name)){elem.setAttribute(!getSetAttribute&&jQuery.propFix[name]||name,name)}else{elem[jQuery.camelCase("default-"+name)]=elem[name]=true}return name}};jQuery.each(jQuery.expr.match.bool.source.match(/\w+/g),function(i,name){var getter=jQuery.expr.attrHandle[name]||jQuery.find.attr;jQuery.expr.attrHandle[name]=getSetInput&&getSetAttribute||!ruseDefault.test(name)?function(elem,name,isXML){var fn=jQuery.expr.attrHandle[name],ret=isXML?undefined:(jQuery.expr.attrHandle[name]=undefined)!=getter(elem,name,isXML)?name.toLowerCase():null;jQuery.expr.attrHandle[name]=fn;return ret}:function(elem,name,isXML){return isXML?undefined:elem[jQuery.camelCase("default-"+name)]?name.toLowerCase():null}});if(!getSetInput||!getSetAttribute){jQuery.attrHooks.value={set:function(elem,value,name){if(jQuery.nodeName(elem,"input")){elem.defaultValue=value}else{return nodeHook&&nodeHook.set(elem,value,name)}}}}if(!getSetAttribute){nodeHook={set:function(elem,value,name){var ret=elem.getAttributeNode(name);if(!ret){elem.setAttributeNode(ret=elem.ownerDocument.createAttribute(name))}ret.value=value+="";return name==="value"||value===elem.getAttribute(name)?value:undefined}};jQuery.expr.attrHandle.id=jQuery.expr.attrHandle.name=jQuery.expr.attrHandle.coords=function(elem,name,isXML){var ret;return isXML?undefined:(ret=elem.getAttributeNode(name))&&ret.value!==""?ret.value:null};jQuery.valHooks.button={get:function(elem,name){var ret=elem.getAttributeNode(name);return ret&&ret.specified?ret.value:undefined},set:nodeHook.set};jQuery.attrHooks.contenteditable={set:function(elem,value,name){nodeHook.set(elem,value===""?false:value,name)}};jQuery.each(["width","height"],function(i,name){jQuery.attrHooks[name]={set:function(elem,value){if(value===""){elem.setAttribute(name,"auto");return value}}}})}if(!jQuery.support.hrefNormalized){jQuery.each(["href","src"],function(i,name){jQuery.propHooks[name]={get:function(elem){return elem.getAttribute(name,4)}}})}if(!jQuery.support.style){jQuery.attrHooks.style={get:function(elem){return elem.style.cssText||undefined},set:function(elem,value){return elem.style.cssText=value+""}}}if(!jQuery.support.optSelected){jQuery.propHooks.selected={get:function(elem){var parent=elem.parentNode;if(parent){parent.selectedIndex;if(parent.parentNode){parent.parentNode.selectedIndex}}return null}}}jQuery.each(["tabIndex","readOnly","maxLength","cellSpacing","cellPadding","rowSpan","colSpan","useMap","frameBorder","contentEditable"],function(){jQuery.propFix[this.toLowerCase()]=this});if(!jQuery.support.enctype){jQuery.propFix.enctype="encoding"}jQuery.each(["radio","checkbox"],function(){jQuery.valHooks[this]={set:function(elem,value){if(jQuery.isArray(value)){return elem.checked=jQuery.inArray(jQuery(elem).val(),value)>=0}}};if(!jQuery.support.checkOn){jQuery.valHooks[this].get=function(elem){return elem.getAttribute("value")===null?"on":elem.value}}});var rformElems=/^(?:input|select|textarea)$/i,rkeyEvent=/^key/,rmouseEvent=/^(?:mouse|contextmenu)|click/,rfocusMorph=/^(?:focusinfocus|focusoutblur)$/,rtypenamespace=/^([^.]*)(?:\.(.+)|)$/;function returnTrue(){return true}function returnFalse(){return false}function safeActiveElement(){try{return document.activeElement}catch(err){}}jQuery.event={global:{},add:function(elem,types,handler,data,selector){var tmp,events,t,handleObjIn,special,eventHandle,handleObj,handlers,type,namespaces,origType,elemData=jQuery._data(elem);if(!elemData){return}if(handler.handler){handleObjIn=handler;handler=handleObjIn.handler;selector=handleObjIn.selector}if(!handler.guid){handler.guid=jQuery.guid++}if(!(events=elemData.events)){events=elemData.events={}}if(!(eventHandle=elemData.handle)){eventHandle=elemData.handle=function(e){return typeof jQuery!==core_strundefined&&(!e||jQuery.event.triggered!==e.type)?jQuery.event.dispatch.apply(eventHandle.elem,arguments):undefined};eventHandle.elem=elem}types=(types||"").match(core_rnotwhite)||[""];t=types.length;while(t--){tmp=rtypenamespace.exec(types[t])||[];type=origType=tmp[1];namespaces=(tmp[2]||"").split(".").sort();if(!type){continue}special=jQuery.event.special[type]||{};type=(selector?special.delegateType:special.bindType)||type;special=jQuery.event.special[type]||{};handleObj=jQuery.extend({type:type,origType:origType,data:data,handler:handler,guid:handler.guid,selector:selector,needsContext:selector&&jQuery.expr.match.needsContext.test(selector),namespace:namespaces.join(".")},handleObjIn);if(!(handlers=events[type])){handlers=events[type]=[];handlers.delegateCount=0;if(!special.setup||special.setup.call(elem,data,namespaces,eventHandle)===false){if(elem.addEventListener){elem.addEventListener(type,eventHandle,false)}else if(elem.attachEvent){elem.attachEvent("on"+type,eventHandle)}}}if(special.add){special.add.call(elem,handleObj);if(!handleObj.handler.guid){handleObj.handler.guid=handler.guid}}if(selector){handlers.splice(handlers.delegateCount++,0,handleObj)}else{handlers.push(handleObj)}jQuery.event.global[type]=true}elem=null},remove:function(elem,types,handler,selector,mappedTypes){var j,handleObj,tmp,origCount,t,events,special,handlers,type,namespaces,origType,elemData=jQuery.hasData(elem)&&jQuery._data(elem);if(!elemData||!(events=elemData.events)){return}types=(types||"").match(core_rnotwhite)||[""];t=types.length;while(t--){tmp=rtypenamespace.exec(types[t])||[];type=origType=tmp[1];namespaces=(tmp[2]||"").split(".").sort();if(!type){for(type in events){jQuery.event.remove(elem,type+types[t],handler,selector,true)}continue}special=jQuery.event.special[type]||{};type=(selector?special.delegateType:special.bindType)||type;handlers=events[type]||[];tmp=tmp[2]&&new RegExp("(^|\\.)"+namespaces.join("\\.(?:.*\\.|)")+"(\\.|$)");origCount=j=handlers.length;while(j--){handleObj=handlers[j];if((mappedTypes||origType===handleObj.origType)&&(!handler||handler.guid===handleObj.guid)&&(!tmp||tmp.test(handleObj.namespace))&&(!selector||selector===handleObj.selector||selector==="**"&&handleObj.selector)){handlers.splice(j,1);if(handleObj.selector){handlers.delegateCount--}if(special.remove){special.remove.call(elem,handleObj)}}}if(origCount&&!handlers.length){if(!special.teardown||special.teardown.call(elem,namespaces,elemData.handle)===false){jQuery.removeEvent(elem,type,elemData.handle)}delete events[type]}}if(jQuery.isEmptyObject(events)){delete elemData.handle;jQuery._removeData(elem,"events")}},trigger:function(event,data,elem,onlyHandlers){var handle,ontype,cur,bubbleType,special,tmp,i,eventPath=[elem||document],type=core_hasOwn.call(event,"type")?event.type:event,namespaces=core_hasOwn.call(event,"namespace")?event.namespace.split("."):[];cur=tmp=elem=elem||document;if(elem.nodeType===3||elem.nodeType===8){return}if(rfocusMorph.test(type+jQuery.event.triggered)){return}if(type.indexOf(".")>=0){namespaces=type.split(".");type=namespaces.shift();namespaces.sort()}ontype=type.indexOf(":")<0&&"on"+type;event=event[jQuery.expando]?event:new jQuery.Event(type,typeof event==="object"&&event);event.isTrigger=onlyHandlers?2:3;event.namespace=namespaces.join(".");event.namespace_re=event.namespace?new RegExp("(^|\\.)"+namespaces.join("\\.(?:.*\\.|)")+"(\\.|$)"):null;event.result=undefined;if(!event.target){event.target=elem}data=data==null?[event]:jQuery.makeArray(data,[event]);special=jQuery.event.special[type]||{};if(!onlyHandlers&&special.trigger&&special.trigger.apply(elem,data)===false){return}if(!onlyHandlers&&!special.noBubble&&!jQuery.isWindow(elem)){bubbleType=special.delegateType||type;if(!rfocusMorph.test(bubbleType+type)){cur=cur.parentNode}for(;cur;cur=cur.parentNode){eventPath.push(cur);tmp=cur}if(tmp===(elem.ownerDocument||document)){eventPath.push(tmp.defaultView||tmp.parentWindow||window)}}i=0;while((cur=eventPath[i++])&&!event.isPropagationStopped()){event.type=i>1?bubbleType:special.bindType||type;handle=(jQuery._data(cur,"events")||{})[event.type]&&jQuery._data(cur,"handle");if(handle){handle.apply(cur,data)}handle=ontype&&cur[ontype];if(handle&&jQuery.acceptData(cur)&&handle.apply&&handle.apply(cur,data)===false){event.preventDefault()}}event.type=type;if(!onlyHandlers&&!event.isDefaultPrevented()){if((!special._default||special._default.apply(eventPath.pop(),data)===false)&&jQuery.acceptData(elem)){if(ontype&&elem[type]&&!jQuery.isWindow(elem)){tmp=elem[ontype];if(tmp){elem[ontype]=null}jQuery.event.triggered=type;try{elem[type]()}catch(e){}jQuery.event.triggered=undefined;if(tmp){elem[ontype]=tmp}}}}return event.result},dispatch:function(event){event=jQuery.event.fix(event);var i,ret,handleObj,matched,j,handlerQueue=[],args=core_slice.call(arguments),handlers=(jQuery._data(this,"events")||{})[event.type]||[],special=jQuery.event.special[event.type]||{};args[0]=event;event.delegateTarget=this;if(special.preDispatch&&special.preDispatch.call(this,event)===false){return}handlerQueue=jQuery.event.handlers.call(this,event,handlers);i=0;while((matched=handlerQueue[i++])&&!event.isPropagationStopped()){event.currentTarget=matched.elem;j=0;while((handleObj=matched.handlers[j++])&&!event.isImmediatePropagationStopped()){if(!event.namespace_re||event.namespace_re.test(handleObj.namespace)){event.handleObj=handleObj;event.data=handleObj.data;ret=((jQuery.event.special[handleObj.origType]||{}).handle||handleObj.handler).apply(matched.elem,args);if(ret!==undefined){if((event.result=ret)===false){event.preventDefault();event.stopPropagation()}}}}}if(special.postDispatch){special.postDispatch.call(this,event)}return event.result},handlers:function(event,handlers){var sel,handleObj,matches,i,handlerQueue=[],delegateCount=handlers.delegateCount,cur=event.target;if(delegateCount&&cur.nodeType&&(!event.button||event.type!=="click")){for(;cur!=this;cur=cur.parentNode||this){if(cur.nodeType===1&&(cur.disabled!==true||event.type!=="click")){matches=[];for(i=0;i<delegateCount;i++){handleObj=handlers[i];sel=handleObj.selector+" ";if(matches[sel]===undefined){matches[sel]=handleObj.needsContext?jQuery(sel,this).index(cur)>=0:jQuery.find(sel,this,null,[cur]).length}if(matches[sel]){matches.push(handleObj)}}if(matches.length){handlerQueue.push({elem:cur,handlers:matches})}}}}if(delegateCount<handlers.length){handlerQueue.push({elem:this,handlers:handlers.slice(delegateCount)})}return handlerQueue},fix:function(event){if(event[jQuery.expando]){return event}var i,prop,copy,type=event.type,originalEvent=event,fixHook=this.fixHooks[type];if(!fixHook){this.fixHooks[type]=fixHook=rmouseEvent.test(type)?this.mouseHooks:rkeyEvent.test(type)?this.keyHooks:{}}copy=fixHook.props?this.props.concat(fixHook.props):this.props;event=new jQuery.Event(originalEvent);i=copy.length;while(i--){prop=copy[i];event[prop]=originalEvent[prop]}if(!event.target){event.target=originalEvent.srcElement||document}if(event.target.nodeType===3){event.target=event.target.parentNode}event.metaKey=!!event.metaKey;return fixHook.filter?fixHook.filter(event,originalEvent):event},props:"altKey bubbles cancelable ctrlKey currentTarget eventPhase metaKey relatedTarget shiftKey target timeStamp view which".split(" "),fixHooks:{},keyHooks:{props:"char charCode key keyCode".split(" "),filter:function(event,original){if(event.which==null){event.which=original.charCode!=null?original.charCode:original.keyCode}return event}},mouseHooks:{props:"button buttons clientX clientY fromElement offsetX offsetY pageX pageY screenX screenY toElement".split(" "),filter:function(event,original){var body,eventDoc,doc,button=original.button,fromElement=original.fromElement;if(event.pageX==null&&original.clientX!=null){eventDoc=event.target.ownerDocument||document;doc=eventDoc.documentElement;body=eventDoc.body;event.pageX=original.clientX+(doc&&doc.scrollLeft||body&&body.scrollLeft||0)-(doc&&doc.clientLeft||body&&body.clientLeft||0);event.pageY=original.clientY+(doc&&doc.scrollTop||body&&body.scrollTop||0)-(doc&&doc.clientTop||body&&body.clientTop||0)}if(!event.relatedTarget&&fromElement){event.relatedTarget=fromElement===event.target?original.toElement:fromElement}if(!event.which&&button!==undefined){event.which=button&1?1:button&2?3:button&4?2:0}return event}},special:{load:{noBubble:true},focus:{trigger:function(){if(this!==safeActiveElement()&&this.focus){try{this.focus();return false}catch(e){}}},delegateType:"focusin"},blur:{trigger:function(){if(this===safeActiveElement()&&this.blur){this.blur();return false}},delegateType:"focusout"},click:{trigger:function(){if(jQuery.nodeName(this,"input")&&this.type==="checkbox"&&this.click){this.click();return false}},_default:function(event){return jQuery.nodeName(event.target,"a")}},beforeunload:{postDispatch:function(event){if(event.result!==undefined){event.originalEvent.returnValue=event.result}}}},simulate:function(type,elem,event,bubble){var e=jQuery.extend(new jQuery.Event,event,{type:type,isSimulated:true,originalEvent:{}});if(bubble){jQuery.event.trigger(e,null,elem)}else{jQuery.event.dispatch.call(elem,e)}if(e.isDefaultPrevented()){event.preventDefault()}}};jQuery.removeEvent=document.removeEventListener?function(elem,type,handle){if(elem.removeEventListener){elem.removeEventListener(type,handle,false)}}:function(elem,type,handle){var name="on"+type;if(elem.detachEvent){if(typeof elem[name]===core_strundefined){elem[name]=null}elem.detachEvent(name,handle)}};jQuery.Event=function(src,props){if(!(this instanceof jQuery.Event)){return new jQuery.Event(src,props)}if(src&&src.type){this.originalEvent=src;this.type=src.type;this.isDefaultPrevented=src.defaultPrevented||src.returnValue===false||src.getPreventDefault&&src.getPreventDefault()?returnTrue:returnFalse}else{this.type=src}if(props){jQuery.extend(this,props)}this.timeStamp=src&&src.timeStamp||jQuery.now();this[jQuery.expando]=true};jQuery.Event.prototype={isDefaultPrevented:returnFalse,isPropagationStopped:returnFalse,isImmediatePropagationStopped:returnFalse,preventDefault:function(){var e=this.originalEvent;this.isDefaultPrevented=returnTrue;if(!e){return}if(e.preventDefault){e.preventDefault()}else{e.returnValue=false}},stopPropagation:function(){var e=this.originalEvent;this.isPropagationStopped=returnTrue;if(!e){return}if(e.stopPropagation){e.stopPropagation()}e.cancelBubble=true},stopImmediatePropagation:function(){this.isImmediatePropagationStopped=returnTrue;this.stopPropagation()}};jQuery.each({mouseenter:"mouseover",mouseleave:"mouseout"},function(orig,fix){jQuery.event.special[orig]={delegateType:fix,bindType:fix,handle:function(event){var ret,target=this,related=event.relatedTarget,handleObj=event.handleObj;if(!related||related!==target&&!jQuery.contains(target,related)){event.type=handleObj.origType;ret=handleObj.handler.apply(this,arguments);event.type=fix}return ret}}});if(!jQuery.support.submitBubbles){jQuery.event.special.submit={setup:function(){if(jQuery.nodeName(this,"form")){return false}jQuery.event.add(this,"click._submit keypress._submit",function(e){var elem=e.target,form=jQuery.nodeName(elem,"input")||jQuery.nodeName(elem,"button")?elem.form:undefined;if(form&&!jQuery._data(form,"submitBubbles")){jQuery.event.add(form,"submit._submit",function(event){event._submit_bubble=true});jQuery._data(form,"submitBubbles",true)}})},postDispatch:function(event){if(event._submit_bubble){delete event._submit_bubble;if(this.parentNode&&!event.isTrigger){jQuery.event.simulate("submit",this.parentNode,event,true)}}},teardown:function(){if(jQuery.nodeName(this,"form")){return false}jQuery.event.remove(this,"._submit")}}}if(!jQuery.support.changeBubbles){jQuery.event.special.change={setup:function(){if(rformElems.test(this.nodeName)){if(this.type==="checkbox"||this.type==="radio"){jQuery.event.add(this,"propertychange._change",function(event){if(event.originalEvent.propertyName==="checked"){this._just_changed=true}});jQuery.event.add(this,"click._change",function(event){if(this._just_changed&&!event.isTrigger){this._just_changed=false}jQuery.event.simulate("change",this,event,true)})}return false}jQuery.event.add(this,"beforeactivate._change",function(e){var elem=e.target;if(rformElems.test(elem.nodeName)&&!jQuery._data(elem,"changeBubbles")){jQuery.event.add(elem,"change._change",function(event){if(this.parentNode&&!event.isSimulated&&!event.isTrigger){jQuery.event.simulate("change",this.parentNode,event,true)}});jQuery._data(elem,"changeBubbles",true)}})},handle:function(event){var elem=event.target;if(this!==elem||event.isSimulated||event.isTrigger||elem.type!=="radio"&&elem.type!=="checkbox"){return event.handleObj.handler.apply(this,arguments)}},teardown:function(){jQuery.event.remove(this,"._change");return!rformElems.test(this.nodeName)}}}if(!jQuery.support.focusinBubbles){jQuery.each({focus:"focusin",blur:"focusout"},function(orig,fix){var attaches=0,handler=function(event){jQuery.event.simulate(fix,event.target,jQuery.event.fix(event),true)};jQuery.event.special[fix]={setup:function(){if(attaches++===0){document.addEventListener(orig,handler,true)}},teardown:function(){if(--attaches===0){document.removeEventListener(orig,handler,true)}}}})}jQuery.fn.extend({on:function(types,selector,data,fn,one){var type,origFn;if(typeof types==="object"){if(typeof selector!=="string"){data=data||selector;selector=undefined}for(type in types){this.on(type,selector,data,types[type],one)}return this}if(data==null&&fn==null){fn=selector;data=selector=undefined}else if(fn==null){if(typeof selector==="string"){fn=data;data=undefined}else{fn=data;data=selector;selector=undefined}}if(fn===false){fn=returnFalse}else if(!fn){return this}if(one===1){origFn=fn;fn=function(event){jQuery().off(event);return origFn.apply(this,arguments)};fn.guid=origFn.guid||(origFn.guid=jQuery.guid++)}return this.each(function(){jQuery.event.add(this,types,fn,data,selector)})},one:function(types,selector,data,fn){return this.on(types,selector,data,fn,1)},off:function(types,selector,fn){var handleObj,type;if(types&&types.preventDefault&&types.handleObj){handleObj=types.handleObj;jQuery(types.delegateTarget).off(handleObj.namespace?handleObj.origType+"."+handleObj.namespace:handleObj.origType,handleObj.selector,handleObj.handler);return this}if(typeof types==="object"){for(type in types){this.off(type,selector,types[type])}return this}if(selector===false||typeof selector==="function"){fn=selector;selector=undefined}if(fn===false){fn=returnFalse}return this.each(function(){jQuery.event.remove(this,types,fn,selector)})},trigger:function(type,data){return this.each(function(){jQuery.event.trigger(type,data,this)})},triggerHandler:function(type,data){var elem=this[0];if(elem){return jQuery.event.trigger(type,data,elem,true)}}});var isSimple=/^.[^:#\[\.,]*$/,rparentsprev=/^(?:parents|prev(?:Until|All))/,rneedsContext=jQuery.expr.match.needsContext,guaranteedUnique={children:true,contents:true,next:true,prev:true};jQuery.fn.extend({find:function(selector){var i,ret=[],self=this,len=self.length;if(typeof selector!=="string"){return this.pushStack(jQuery(selector).filter(function(){for(i=0;i<len;i++){if(jQuery.contains(self[i],this)){return true}}}))}for(i=0;i<len;i++){jQuery.find(selector,self[i],ret)}ret=this.pushStack(len>1?jQuery.unique(ret):ret);ret.selector=this.selector?this.selector+" "+selector:selector;return ret},has:function(target){var i,targets=jQuery(target,this),len=targets.length;return this.filter(function(){for(i=0;i<len;i++){if(jQuery.contains(this,targets[i])){return true}}})},not:function(selector){return this.pushStack(winnow(this,selector||[],true))},filter:function(selector){return this.pushStack(winnow(this,selector||[],false))},is:function(selector){return!!winnow(this,typeof selector==="string"&&rneedsContext.test(selector)?jQuery(selector):selector||[],false).length},closest:function(selectors,context){var cur,i=0,l=this.length,ret=[],pos=rneedsContext.test(selectors)||typeof selectors!=="string"?jQuery(selectors,context||this.context):0;for(;i<l;i++){for(cur=this[i];cur&&cur!==context;cur=cur.parentNode){if(cur.nodeType<11&&(pos?pos.index(cur)>-1:cur.nodeType===1&&jQuery.find.matchesSelector(cur,selectors))){cur=ret.push(cur);break}}}return this.pushStack(ret.length>1?jQuery.unique(ret):ret)},index:function(elem){if(!elem){return this[0]&&this[0].parentNode?this.first().prevAll().length:-1}if(typeof elem==="string"){return jQuery.inArray(this[0],jQuery(elem))}return jQuery.inArray(elem.jquery?elem[0]:elem,this)},add:function(selector,context){var set=typeof selector==="string"?jQuery(selector,context):jQuery.makeArray(selector&&selector.nodeType?[selector]:selector),all=jQuery.merge(this.get(),set);return this.pushStack(jQuery.unique(all))},addBack:function(selector){return this.add(selector==null?this.prevObject:this.prevObject.filter(selector))}});function sibling(cur,dir){do{cur=cur[dir]}while(cur&&cur.nodeType!==1);return cur}jQuery.each({parent:function(elem){var parent=elem.parentNode;return parent&&parent.nodeType!==11?parent:null},parents:function(elem){return jQuery.dir(elem,"parentNode")},parentsUntil:function(elem,i,until){return jQuery.dir(elem,"parentNode",until)},next:function(elem){return sibling(elem,"nextSibling")},prev:function(elem){return sibling(elem,"previousSibling")},nextAll:function(elem){return jQuery.dir(elem,"nextSibling")},prevAll:function(elem){return jQuery.dir(elem,"previousSibling")},nextUntil:function(elem,i,until){return jQuery.dir(elem,"nextSibling",until)},prevUntil:function(elem,i,until){return jQuery.dir(elem,"previousSibling",until)
},siblings:function(elem){return jQuery.sibling((elem.parentNode||{}).firstChild,elem)},children:function(elem){return jQuery.sibling(elem.firstChild)},contents:function(elem){return jQuery.nodeName(elem,"iframe")?elem.contentDocument||elem.contentWindow.document:jQuery.merge([],elem.childNodes)}},function(name,fn){jQuery.fn[name]=function(until,selector){var ret=jQuery.map(this,fn,until);if(name.slice(-5)!=="Until"){selector=until}if(selector&&typeof selector==="string"){ret=jQuery.filter(selector,ret)}if(this.length>1){if(!guaranteedUnique[name]){ret=jQuery.unique(ret)}if(rparentsprev.test(name)){ret=ret.reverse()}}return this.pushStack(ret)}});jQuery.extend({filter:function(expr,elems,not){var elem=elems[0];if(not){expr=":not("+expr+")"}return elems.length===1&&elem.nodeType===1?jQuery.find.matchesSelector(elem,expr)?[elem]:[]:jQuery.find.matches(expr,jQuery.grep(elems,function(elem){return elem.nodeType===1}))},dir:function(elem,dir,until){var matched=[],cur=elem[dir];while(cur&&cur.nodeType!==9&&(until===undefined||cur.nodeType!==1||!jQuery(cur).is(until))){if(cur.nodeType===1){matched.push(cur)}cur=cur[dir]}return matched},sibling:function(n,elem){var r=[];for(;n;n=n.nextSibling){if(n.nodeType===1&&n!==elem){r.push(n)}}return r}});function winnow(elements,qualifier,not){if(jQuery.isFunction(qualifier)){return jQuery.grep(elements,function(elem,i){return!!qualifier.call(elem,i,elem)!==not})}if(qualifier.nodeType){return jQuery.grep(elements,function(elem){return elem===qualifier!==not})}if(typeof qualifier==="string"){if(isSimple.test(qualifier)){return jQuery.filter(qualifier,elements,not)}qualifier=jQuery.filter(qualifier,elements)}return jQuery.grep(elements,function(elem){return jQuery.inArray(elem,qualifier)>=0!==not})}function createSafeFragment(document){var list=nodeNames.split("|"),safeFrag=document.createDocumentFragment();if(safeFrag.createElement){while(list.length){safeFrag.createElement(list.pop())}}return safeFrag}var nodeNames="abbr|article|aside|audio|bdi|canvas|data|datalist|details|figcaption|figure|footer|"+"header|hgroup|mark|meter|nav|output|progress|section|summary|time|video",rinlinejQuery=/ jQuery\d+="(?:null|\d+)"/g,rnoshimcache=new RegExp("<(?:"+nodeNames+")[\\s/>]","i"),rleadingWhitespace=/^\s+/,rxhtmlTag=/<(?!area|br|col|embed|hr|img|input|link|meta|param)(([\w:]+)[^>]*)\/>/gi,rtagName=/<([\w:]+)/,rtbody=/<tbody/i,rhtml=/<|&#?\w+;/,rnoInnerhtml=/<(?:script|style|link)/i,manipulation_rcheckableType=/^(?:checkbox|radio)$/i,rchecked=/checked\s*(?:[^=]|=\s*.checked.)/i,rscriptType=/^$|\/(?:java|ecma)script/i,rscriptTypeMasked=/^true\/(.*)/,rcleanScript=/^\s*<!(?:\[CDATA\[|--)|(?:\]\]|--)>\s*$/g,wrapMap={option:[1,"<select multiple='multiple'>","</select>"],legend:[1,"<fieldset>","</fieldset>"],area:[1,"<map>","</map>"],param:[1,"<object>","</object>"],thead:[1,"<table>","</table>"],tr:[2,"<table><tbody>","</tbody></table>"],col:[2,"<table><tbody></tbody><colgroup>","</colgroup></table>"],td:[3,"<table><tbody><tr>","</tr></tbody></table>"],_default:jQuery.support.htmlSerialize?[0,"",""]:[1,"X<div>","</div>"]},safeFragment=createSafeFragment(document),fragmentDiv=safeFragment.appendChild(document.createElement("div"));wrapMap.optgroup=wrapMap.option;wrapMap.tbody=wrapMap.tfoot=wrapMap.colgroup=wrapMap.caption=wrapMap.thead;wrapMap.th=wrapMap.td;jQuery.fn.extend({text:function(value){return jQuery.access(this,function(value){return value===undefined?jQuery.text(this):this.empty().append((this[0]&&this[0].ownerDocument||document).createTextNode(value))},null,value,arguments.length)},append:function(){return this.domManip(arguments,function(elem){if(this.nodeType===1||this.nodeType===11||this.nodeType===9){var target=manipulationTarget(this,elem);target.appendChild(elem)}})},prepend:function(){return this.domManip(arguments,function(elem){if(this.nodeType===1||this.nodeType===11||this.nodeType===9){var target=manipulationTarget(this,elem);target.insertBefore(elem,target.firstChild)}})},before:function(){return this.domManip(arguments,function(elem){if(this.parentNode){this.parentNode.insertBefore(elem,this)}})},after:function(){return this.domManip(arguments,function(elem){if(this.parentNode){this.parentNode.insertBefore(elem,this.nextSibling)}})},remove:function(selector,keepData){var elem,elems=selector?jQuery.filter(selector,this):this,i=0;for(;(elem=elems[i])!=null;i++){if(!keepData&&elem.nodeType===1){jQuery.cleanData(getAll(elem))}if(elem.parentNode){if(keepData&&jQuery.contains(elem.ownerDocument,elem)){setGlobalEval(getAll(elem,"script"))}elem.parentNode.removeChild(elem)}}return this},empty:function(){var elem,i=0;for(;(elem=this[i])!=null;i++){if(elem.nodeType===1){jQuery.cleanData(getAll(elem,false))}while(elem.firstChild){elem.removeChild(elem.firstChild)}if(elem.options&&jQuery.nodeName(elem,"select")){elem.options.length=0}}return this},clone:function(dataAndEvents,deepDataAndEvents){dataAndEvents=dataAndEvents==null?false:dataAndEvents;deepDataAndEvents=deepDataAndEvents==null?dataAndEvents:deepDataAndEvents;return this.map(function(){return jQuery.clone(this,dataAndEvents,deepDataAndEvents)})},html:function(value){return jQuery.access(this,function(value){var elem=this[0]||{},i=0,l=this.length;if(value===undefined){return elem.nodeType===1?elem.innerHTML.replace(rinlinejQuery,""):undefined}if(typeof value==="string"&&!rnoInnerhtml.test(value)&&(jQuery.support.htmlSerialize||!rnoshimcache.test(value))&&(jQuery.support.leadingWhitespace||!rleadingWhitespace.test(value))&&!wrapMap[(rtagName.exec(value)||["",""])[1].toLowerCase()]){value=value.replace(rxhtmlTag,"<$1></$2>");try{for(;i<l;i++){elem=this[i]||{};if(elem.nodeType===1){jQuery.cleanData(getAll(elem,false));elem.innerHTML=value}}elem=0}catch(e){}}if(elem){this.empty().append(value)}},null,value,arguments.length)},replaceWith:function(){var args=jQuery.map(this,function(elem){return[elem.nextSibling,elem.parentNode]}),i=0;this.domManip(arguments,function(elem){var next=args[i++],parent=args[i++];if(parent){if(next&&next.parentNode!==parent){next=this.nextSibling}jQuery(this).remove();parent.insertBefore(elem,next)}},true);return i?this:this.remove()},detach:function(selector){return this.remove(selector,true)},domManip:function(args,callback,allowIntersection){args=core_concat.apply([],args);var first,node,hasScripts,scripts,doc,fragment,i=0,l=this.length,set=this,iNoClone=l-1,value=args[0],isFunction=jQuery.isFunction(value);if(isFunction||!(l<=1||typeof value!=="string"||jQuery.support.checkClone||!rchecked.test(value))){return this.each(function(index){var self=set.eq(index);if(isFunction){args[0]=value.call(this,index,self.html())}self.domManip(args,callback,allowIntersection)})}if(l){fragment=jQuery.buildFragment(args,this[0].ownerDocument,false,!allowIntersection&&this);first=fragment.firstChild;if(fragment.childNodes.length===1){fragment=first}if(first){scripts=jQuery.map(getAll(fragment,"script"),disableScript);hasScripts=scripts.length;for(;i<l;i++){node=fragment;if(i!==iNoClone){node=jQuery.clone(node,true,true);if(hasScripts){jQuery.merge(scripts,getAll(node,"script"))}}callback.call(this[i],node,i)}if(hasScripts){doc=scripts[scripts.length-1].ownerDocument;jQuery.map(scripts,restoreScript);for(i=0;i<hasScripts;i++){node=scripts[i];if(rscriptType.test(node.type||"")&&!jQuery._data(node,"globalEval")&&jQuery.contains(doc,node)){if(node.src){jQuery._evalUrl(node.src)}else{jQuery.globalEval((node.text||node.textContent||node.innerHTML||"").replace(rcleanScript,""))}}}}fragment=first=null}}return this}});function manipulationTarget(elem,content){return jQuery.nodeName(elem,"table")&&jQuery.nodeName(content.nodeType===1?content:content.firstChild,"tr")?elem.getElementsByTagName("tbody")[0]||elem.appendChild(elem.ownerDocument.createElement("tbody")):elem}function disableScript(elem){elem.type=(jQuery.find.attr(elem,"type")!==null)+"/"+elem.type;return elem}function restoreScript(elem){var match=rscriptTypeMasked.exec(elem.type);if(match){elem.type=match[1]}else{elem.removeAttribute("type")}return elem}function setGlobalEval(elems,refElements){var elem,i=0;for(;(elem=elems[i])!=null;i++){jQuery._data(elem,"globalEval",!refElements||jQuery._data(refElements[i],"globalEval"))}}function cloneCopyEvent(src,dest){if(dest.nodeType!==1||!jQuery.hasData(src)){return}var type,i,l,oldData=jQuery._data(src),curData=jQuery._data(dest,oldData),events=oldData.events;if(events){delete curData.handle;curData.events={};for(type in events){for(i=0,l=events[type].length;i<l;i++){jQuery.event.add(dest,type,events[type][i])}}}if(curData.data){curData.data=jQuery.extend({},curData.data)}}function fixCloneNodeIssues(src,dest){var nodeName,e,data;if(dest.nodeType!==1){return}nodeName=dest.nodeName.toLowerCase();if(!jQuery.support.noCloneEvent&&dest[jQuery.expando]){data=jQuery._data(dest);for(e in data.events){jQuery.removeEvent(dest,e,data.handle)}dest.removeAttribute(jQuery.expando)}if(nodeName==="script"&&dest.text!==src.text){disableScript(dest).text=src.text;restoreScript(dest)}else if(nodeName==="object"){if(dest.parentNode){dest.outerHTML=src.outerHTML}if(jQuery.support.html5Clone&&(src.innerHTML&&!jQuery.trim(dest.innerHTML))){dest.innerHTML=src.innerHTML}}else if(nodeName==="input"&&manipulation_rcheckableType.test(src.type)){dest.defaultChecked=dest.checked=src.checked;if(dest.value!==src.value){dest.value=src.value}}else if(nodeName==="option"){dest.defaultSelected=dest.selected=src.defaultSelected}else if(nodeName==="input"||nodeName==="textarea"){dest.defaultValue=src.defaultValue}}jQuery.each({appendTo:"append",prependTo:"prepend",insertBefore:"before",insertAfter:"after",replaceAll:"replaceWith"},function(name,original){jQuery.fn[name]=function(selector){var elems,i=0,ret=[],insert=jQuery(selector),last=insert.length-1;for(;i<=last;i++){elems=i===last?this:this.clone(true);jQuery(insert[i])[original](elems);core_push.apply(ret,elems.get())}return this.pushStack(ret)}});function getAll(context,tag){var elems,elem,i=0,found=typeof context.getElementsByTagName!==core_strundefined?context.getElementsByTagName(tag||"*"):typeof context.querySelectorAll!==core_strundefined?context.querySelectorAll(tag||"*"):undefined;if(!found){for(found=[],elems=context.childNodes||context;(elem=elems[i])!=null;i++){if(!tag||jQuery.nodeName(elem,tag)){found.push(elem)}else{jQuery.merge(found,getAll(elem,tag))}}}return tag===undefined||tag&&jQuery.nodeName(context,tag)?jQuery.merge([context],found):found}function fixDefaultChecked(elem){if(manipulation_rcheckableType.test(elem.type)){elem.defaultChecked=elem.checked}}jQuery.extend({clone:function(elem,dataAndEvents,deepDataAndEvents){var destElements,node,clone,i,srcElements,inPage=jQuery.contains(elem.ownerDocument,elem);if(jQuery.support.html5Clone||jQuery.isXMLDoc(elem)||!rnoshimcache.test("<"+elem.nodeName+">")){clone=elem.cloneNode(true)}else{fragmentDiv.innerHTML=elem.outerHTML;fragmentDiv.removeChild(clone=fragmentDiv.firstChild)}if((!jQuery.support.noCloneEvent||!jQuery.support.noCloneChecked)&&(elem.nodeType===1||elem.nodeType===11)&&!jQuery.isXMLDoc(elem)){destElements=getAll(clone);srcElements=getAll(elem);for(i=0;(node=srcElements[i])!=null;++i){if(destElements[i]){fixCloneNodeIssues(node,destElements[i])}}}if(dataAndEvents){if(deepDataAndEvents){srcElements=srcElements||getAll(elem);destElements=destElements||getAll(clone);for(i=0;(node=srcElements[i])!=null;i++){cloneCopyEvent(node,destElements[i])}}else{cloneCopyEvent(elem,clone)}}destElements=getAll(clone,"script");if(destElements.length>0){setGlobalEval(destElements,!inPage&&getAll(elem,"script"))}destElements=srcElements=node=null;return clone},buildFragment:function(elems,context,scripts,selection){var j,elem,contains,tmp,tag,tbody,wrap,l=elems.length,safe=createSafeFragment(context),nodes=[],i=0;for(;i<l;i++){elem=elems[i];if(elem||elem===0){if(jQuery.type(elem)==="object"){jQuery.merge(nodes,elem.nodeType?[elem]:elem)}else if(!rhtml.test(elem)){nodes.push(context.createTextNode(elem))}else{tmp=tmp||safe.appendChild(context.createElement("div"));tag=(rtagName.exec(elem)||["",""])[1].toLowerCase();wrap=wrapMap[tag]||wrapMap._default;tmp.innerHTML=wrap[1]+elem.replace(rxhtmlTag,"<$1></$2>")+wrap[2];j=wrap[0];while(j--){tmp=tmp.lastChild}if(!jQuery.support.leadingWhitespace&&rleadingWhitespace.test(elem)){nodes.push(context.createTextNode(rleadingWhitespace.exec(elem)[0]))}if(!jQuery.support.tbody){elem=tag==="table"&&!rtbody.test(elem)?tmp.firstChild:wrap[1]==="<table>"&&!rtbody.test(elem)?tmp:0;j=elem&&elem.childNodes.length;while(j--){if(jQuery.nodeName(tbody=elem.childNodes[j],"tbody")&&!tbody.childNodes.length){elem.removeChild(tbody)}}}jQuery.merge(nodes,tmp.childNodes);tmp.textContent="";while(tmp.firstChild){tmp.removeChild(tmp.firstChild)}tmp=safe.lastChild}}}if(tmp){safe.removeChild(tmp)}if(!jQuery.support.appendChecked){jQuery.grep(getAll(nodes,"input"),fixDefaultChecked)}i=0;while(elem=nodes[i++]){if(selection&&jQuery.inArray(elem,selection)!==-1){continue}contains=jQuery.contains(elem.ownerDocument,elem);tmp=getAll(safe.appendChild(elem),"script");if(contains){setGlobalEval(tmp)}if(scripts){j=0;while(elem=tmp[j++]){if(rscriptType.test(elem.type||"")){scripts.push(elem)}}}}tmp=null;return safe},cleanData:function(elems,acceptData){var elem,type,id,data,i=0,internalKey=jQuery.expando,cache=jQuery.cache,deleteExpando=jQuery.support.deleteExpando,special=jQuery.event.special;for(;(elem=elems[i])!=null;i++){if(acceptData||jQuery.acceptData(elem)){id=elem[internalKey];data=id&&cache[id];if(data){if(data.events){for(type in data.events){if(special[type]){jQuery.event.remove(elem,type)}else{jQuery.removeEvent(elem,type,data.handle)}}}if(cache[id]){delete cache[id];if(deleteExpando){delete elem[internalKey]}else if(typeof elem.removeAttribute!==core_strundefined){elem.removeAttribute(internalKey)}else{elem[internalKey]=null}core_deletedIds.push(id)}}}}},_evalUrl:function(url){return jQuery.ajax({url:url,type:"GET",dataType:"script",async:false,global:false,"throws":true})}});jQuery.fn.extend({wrapAll:function(html){if(jQuery.isFunction(html)){return this.each(function(i){jQuery(this).wrapAll(html.call(this,i))})}if(this[0]){var wrap=jQuery(html,this[0].ownerDocument).eq(0).clone(true);if(this[0].parentNode){wrap.insertBefore(this[0])}wrap.map(function(){var elem=this;while(elem.firstChild&&elem.firstChild.nodeType===1){elem=elem.firstChild}return elem}).append(this)}return this},wrapInner:function(html){if(jQuery.isFunction(html)){return this.each(function(i){jQuery(this).wrapInner(html.call(this,i))})}return this.each(function(){var self=jQuery(this),contents=self.contents();if(contents.length){contents.wrapAll(html)}else{self.append(html)}})},wrap:function(html){var isFunction=jQuery.isFunction(html);return this.each(function(i){jQuery(this).wrapAll(isFunction?html.call(this,i):html)})},unwrap:function(){return this.parent().each(function(){if(!jQuery.nodeName(this,"body")){jQuery(this).replaceWith(this.childNodes)}}).end()}});var iframe,getStyles,curCSS,ralpha=/alpha\([^)]*\)/i,ropacity=/opacity\s*=\s*([^)]*)/,rposition=/^(top|right|bottom|left)$/,rdisplayswap=/^(none|table(?!-c[ea]).+)/,rmargin=/^margin/,rnumsplit=new RegExp("^("+core_pnum+")(.*)$","i"),rnumnonpx=new RegExp("^("+core_pnum+")(?!px)[a-z%]+$","i"),rrelNum=new RegExp("^([+-])=("+core_pnum+")","i"),elemdisplay={BODY:"block"},cssShow={position:"absolute",visibility:"hidden",display:"block"},cssNormalTransform={letterSpacing:0,fontWeight:400},cssExpand=["Top","Right","Bottom","Left"],cssPrefixes=["Webkit","O","Moz","ms"];function vendorPropName(style,name){if(name in style){return name}var capName=name.charAt(0).toUpperCase()+name.slice(1),origName=name,i=cssPrefixes.length;while(i--){name=cssPrefixes[i]+capName;if(name in style){return name}}return origName}function isHidden(elem,el){elem=el||elem;return jQuery.css(elem,"display")==="none"||!jQuery.contains(elem.ownerDocument,elem)}function showHide(elements,show){var display,elem,hidden,values=[],index=0,length=elements.length;for(;index<length;index++){elem=elements[index];if(!elem.style){continue}values[index]=jQuery._data(elem,"olddisplay");display=elem.style.display;if(show){if(!values[index]&&display==="none"){elem.style.display=""}if(elem.style.display===""&&isHidden(elem)){values[index]=jQuery._data(elem,"olddisplay",css_defaultDisplay(elem.nodeName))}}else{if(!values[index]){hidden=isHidden(elem);if(display&&display!=="none"||!hidden){jQuery._data(elem,"olddisplay",hidden?display:jQuery.css(elem,"display"))}}}}for(index=0;index<length;index++){elem=elements[index];if(!elem.style){continue}if(!show||elem.style.display==="none"||elem.style.display===""){elem.style.display=show?values[index]||"":"none"}}return elements}jQuery.fn.extend({css:function(name,value){return jQuery.access(this,function(elem,name,value){var len,styles,map={},i=0;if(jQuery.isArray(name)){styles=getStyles(elem);len=name.length;for(;i<len;i++){map[name[i]]=jQuery.css(elem,name[i],false,styles)}return map}return value!==undefined?jQuery.style(elem,name,value):jQuery.css(elem,name)},name,value,arguments.length>1)},show:function(){return showHide(this,true)},hide:function(){return showHide(this)},toggle:function(state){if(typeof state==="boolean"){return state?this.show():this.hide()}return this.each(function(){if(isHidden(this)){jQuery(this).show()}else{jQuery(this).hide()}})}});jQuery.extend({cssHooks:{opacity:{get:function(elem,computed){if(computed){var ret=curCSS(elem,"opacity");return ret===""?"1":ret}}}},cssNumber:{columnCount:true,fillOpacity:true,fontWeight:true,lineHeight:true,opacity:true,order:true,orphans:true,widows:true,zIndex:true,zoom:true},cssProps:{"float":jQuery.support.cssFloat?"cssFloat":"styleFloat"},style:function(elem,name,value,extra){if(!elem||elem.nodeType===3||elem.nodeType===8||!elem.style){return}var ret,type,hooks,origName=jQuery.camelCase(name),style=elem.style;name=jQuery.cssProps[origName]||(jQuery.cssProps[origName]=vendorPropName(style,origName));hooks=jQuery.cssHooks[name]||jQuery.cssHooks[origName];if(value!==undefined){type=typeof value;if(type==="string"&&(ret=rrelNum.exec(value))){value=(ret[1]+1)*ret[2]+parseFloat(jQuery.css(elem,name));type="number"}if(value==null||type==="number"&&isNaN(value)){return}if(type==="number"&&!jQuery.cssNumber[origName]){value+="px"}if(!jQuery.support.clearCloneStyle&&value===""&&name.indexOf("background")===0){style[name]="inherit"}if(!hooks||!("set"in hooks)||(value=hooks.set(elem,value,extra))!==undefined){try{style[name]=value}catch(e){}}}else{if(hooks&&"get"in hooks&&(ret=hooks.get(elem,false,extra))!==undefined){return ret}return style[name]}},css:function(elem,name,extra,styles){var num,val,hooks,origName=jQuery.camelCase(name);name=jQuery.cssProps[origName]||(jQuery.cssProps[origName]=vendorPropName(elem.style,origName));hooks=jQuery.cssHooks[name]||jQuery.cssHooks[origName];if(hooks&&"get"in hooks){val=hooks.get(elem,true,extra)}if(val===undefined){val=curCSS(elem,name,styles)}if(val==="normal"&&name in cssNormalTransform){val=cssNormalTransform[name]}if(extra===""||extra){num=parseFloat(val);return extra===true||jQuery.isNumeric(num)?num||0:val}return val}});if(window.getComputedStyle){getStyles=function(elem){return window.getComputedStyle(elem,null)};curCSS=function(elem,name,_computed){var width,minWidth,maxWidth,computed=_computed||getStyles(elem),ret=computed?computed.getPropertyValue(name)||computed[name]:undefined,style=elem.style;if(computed){if(ret===""&&!jQuery.contains(elem.ownerDocument,elem)){ret=jQuery.style(elem,name)}if(rnumnonpx.test(ret)&&rmargin.test(name)){width=style.width;minWidth=style.minWidth;maxWidth=style.maxWidth;style.minWidth=style.maxWidth=style.width=ret;ret=computed.width;style.width=width;style.minWidth=minWidth;style.maxWidth=maxWidth}}return ret}}else if(document.documentElement.currentStyle){getStyles=function(elem){return elem.currentStyle};curCSS=function(elem,name,_computed){var left,rs,rsLeft,computed=_computed||getStyles(elem),ret=computed?computed[name]:undefined,style=elem.style;if(ret==null&&style&&style[name]){ret=style[name]}if(rnumnonpx.test(ret)&&!rposition.test(name)){left=style.left;rs=elem.runtimeStyle;rsLeft=rs&&rs.left;if(rsLeft){rs.left=elem.currentStyle.left}style.left=name==="fontSize"?"1em":ret;ret=style.pixelLeft+"px";style.left=left;if(rsLeft){rs.left=rsLeft}}return ret===""?"auto":ret}}function setPositiveNumber(elem,value,subtract){var matches=rnumsplit.exec(value);return matches?Math.max(0,matches[1]-(subtract||0))+(matches[2]||"px"):value}function augmentWidthOrHeight(elem,name,extra,isBorderBox,styles){var i=extra===(isBorderBox?"border":"content")?4:name==="width"?1:0,val=0;for(;i<4;i+=2){if(extra==="margin"){val+=jQuery.css(elem,extra+cssExpand[i],true,styles)}if(isBorderBox){if(extra==="content"){val-=jQuery.css(elem,"padding"+cssExpand[i],true,styles)}if(extra!=="margin"){val-=jQuery.css(elem,"border"+cssExpand[i]+"Width",true,styles)}}else{val+=jQuery.css(elem,"padding"+cssExpand[i],true,styles);if(extra!=="padding"){val+=jQuery.css(elem,"border"+cssExpand[i]+"Width",true,styles)}}}return val}function getWidthOrHeight(elem,name,extra){var valueIsBorderBox=true,val=name==="width"?elem.offsetWidth:elem.offsetHeight,styles=getStyles(elem),isBorderBox=jQuery.support.boxSizing&&jQuery.css(elem,"boxSizing",false,styles)==="border-box";if(val<=0||val==null){val=curCSS(elem,name,styles);if(val<0||val==null){val=elem.style[name]}if(rnumnonpx.test(val)){return val}valueIsBorderBox=isBorderBox&&(jQuery.support.boxSizingReliable||val===elem.style[name]);val=parseFloat(val)||0}return val+augmentWidthOrHeight(elem,name,extra||(isBorderBox?"border":"content"),valueIsBorderBox,styles)+"px"}function css_defaultDisplay(nodeName){var doc=document,display=elemdisplay[nodeName];if(!display){display=actualDisplay(nodeName,doc);if(display==="none"||!display){iframe=(iframe||jQuery("<iframe frameborder='0' width='0' height='0'/>").css("cssText","display:block !important")).appendTo(doc.documentElement);doc=(iframe[0].contentWindow||iframe[0].contentDocument).document;doc.write("<!doctype html><html><body>");doc.close();display=actualDisplay(nodeName,doc);iframe.detach()}elemdisplay[nodeName]=display}return display}function actualDisplay(name,doc){var elem=jQuery(doc.createElement(name)).appendTo(doc.body),display=jQuery.css(elem[0],"display");elem.remove();return display}jQuery.each(["height","width"],function(i,name){jQuery.cssHooks[name]={get:function(elem,computed,extra){if(computed){return elem.offsetWidth===0&&rdisplayswap.test(jQuery.css(elem,"display"))?jQuery.swap(elem,cssShow,function(){return getWidthOrHeight(elem,name,extra)}):getWidthOrHeight(elem,name,extra)}},set:function(elem,value,extra){var styles=extra&&getStyles(elem);return setPositiveNumber(elem,value,extra?augmentWidthOrHeight(elem,name,extra,jQuery.support.boxSizing&&jQuery.css(elem,"boxSizing",false,styles)==="border-box",styles):0)}}});if(!jQuery.support.opacity){jQuery.cssHooks.opacity={get:function(elem,computed){return ropacity.test((computed&&elem.currentStyle?elem.currentStyle.filter:elem.style.filter)||"")?.01*parseFloat(RegExp.$1)+"":computed?"1":""},set:function(elem,value){var style=elem.style,currentStyle=elem.currentStyle,opacity=jQuery.isNumeric(value)?"alpha(opacity="+value*100+")":"",filter=currentStyle&&currentStyle.filter||style.filter||"";style.zoom=1;if((value>=1||value==="")&&jQuery.trim(filter.replace(ralpha,""))===""&&style.removeAttribute){style.removeAttribute("filter");if(value===""||currentStyle&&!currentStyle.filter){return}}style.filter=ralpha.test(filter)?filter.replace(ralpha,opacity):filter+" "+opacity}}}jQuery(function(){if(!jQuery.support.reliableMarginRight){jQuery.cssHooks.marginRight={get:function(elem,computed){if(computed){return jQuery.swap(elem,{display:"inline-block"},curCSS,[elem,"marginRight"])}}}}if(!jQuery.support.pixelPosition&&jQuery.fn.position){jQuery.each(["top","left"],function(i,prop){jQuery.cssHooks[prop]={get:function(elem,computed){if(computed){computed=curCSS(elem,prop);return rnumnonpx.test(computed)?jQuery(elem).position()[prop]+"px":computed}}}})}});if(jQuery.expr&&jQuery.expr.filters){jQuery.expr.filters.hidden=function(elem){return elem.offsetWidth<=0&&elem.offsetHeight<=0||!jQuery.support.reliableHiddenOffsets&&(elem.style&&elem.style.display||jQuery.css(elem,"display"))==="none"};jQuery.expr.filters.visible=function(elem){return!jQuery.expr.filters.hidden(elem)}}jQuery.each({margin:"",padding:"",border:"Width"},function(prefix,suffix){jQuery.cssHooks[prefix+suffix]={expand:function(value){var i=0,expanded={},parts=typeof value==="string"?value.split(" "):[value];for(;i<4;i++){expanded[prefix+cssExpand[i]+suffix]=parts[i]||parts[i-2]||parts[0]}return expanded}};if(!rmargin.test(prefix)){jQuery.cssHooks[prefix+suffix].set=setPositiveNumber}});var r20=/%20/g,rbracket=/\[\]$/,rCRLF=/\r?\n/g,rsubmitterTypes=/^(?:submit|button|image|reset|file)$/i,rsubmittable=/^(?:input|select|textarea|keygen)/i;jQuery.fn.extend({serialize:function(){return jQuery.param(this.serializeArray())},serializeArray:function(){return this.map(function(){var elements=jQuery.prop(this,"elements");return elements?jQuery.makeArray(elements):this}).filter(function(){var type=this.type;return this.name&&!jQuery(this).is(":disabled")&&rsubmittable.test(this.nodeName)&&!rsubmitterTypes.test(type)&&(this.checked||!manipulation_rcheckableType.test(type))}).map(function(i,elem){var val=jQuery(this).val();return val==null?null:jQuery.isArray(val)?jQuery.map(val,function(val){return{name:elem.name,value:val.replace(rCRLF,"\r\n")}}):{name:elem.name,value:val.replace(rCRLF,"\r\n")}}).get()}});jQuery.param=function(a,traditional){var prefix,s=[],add=function(key,value){value=jQuery.isFunction(value)?value():value==null?"":value;s[s.length]=encodeURIComponent(key)+"="+encodeURIComponent(value)};if(traditional===undefined){traditional=jQuery.ajaxSettings&&jQuery.ajaxSettings.traditional}if(jQuery.isArray(a)||a.jquery&&!jQuery.isPlainObject(a)){jQuery.each(a,function(){add(this.name,this.value)})}else{for(prefix in a){buildParams(prefix,a[prefix],traditional,add)}}return s.join("&").replace(r20,"+")};function buildParams(prefix,obj,traditional,add){var name;if(jQuery.isArray(obj)){jQuery.each(obj,function(i,v){if(traditional||rbracket.test(prefix)){add(prefix,v)}else{buildParams(prefix+"["+(typeof v==="object"?i:"")+"]",v,traditional,add)}})}else if(!traditional&&jQuery.type(obj)==="object"){for(name in obj){buildParams(prefix+"["+name+"]",obj[name],traditional,add)}}else{add(prefix,obj)}}jQuery.each(("blur focus focusin focusout load resize scroll unload click dblclick "+"mousedown mouseup mousemove mouseover mouseout mouseenter mouseleave "+"change select submit keydown keypress keyup error contextmenu").split(" "),function(i,name){jQuery.fn[name]=function(data,fn){return arguments.length>0?this.on(name,null,data,fn):this.trigger(name)}});jQuery.fn.extend({hover:function(fnOver,fnOut){return this.mouseenter(fnOver).mouseleave(fnOut||fnOver)},bind:function(types,data,fn){return this.on(types,null,data,fn)},unbind:function(types,fn){return this.off(types,null,fn)},delegate:function(selector,types,data,fn){return this.on(types,selector,data,fn)},undelegate:function(selector,types,fn){return arguments.length===1?this.off(selector,"**"):this.off(types,selector||"**",fn)}});var ajaxLocParts,ajaxLocation,ajax_nonce=jQuery.now(),ajax_rquery=/\?/,rhash=/#.*$/,rts=/([?&])_=[^&]*/,rheaders=/^(.*?):[ \t]*([^\r\n]*)\r?$/gm,rlocalProtocol=/^(?:about|app|app-storage|.+-extension|file|res|widget):$/,rnoContent=/^(?:GET|HEAD)$/,rprotocol=/^\/\//,rurl=/^([\w.+-]+:)(?:\/\/([^\/?#:]*)(?::(\d+)|)|)/,_load=jQuery.fn.load,prefilters={},transports={},allTypes="*/".concat("*");try{ajaxLocation=location.href}catch(e){ajaxLocation=document.createElement("a");ajaxLocation.href="";ajaxLocation=ajaxLocation.href}ajaxLocParts=rurl.exec(ajaxLocation.toLowerCase())||[];function addToPrefiltersOrTransports(structure){return function(dataTypeExpression,func){if(typeof dataTypeExpression!=="string"){func=dataTypeExpression;dataTypeExpression="*"}var dataType,i=0,dataTypes=dataTypeExpression.toLowerCase().match(core_rnotwhite)||[];if(jQuery.isFunction(func)){while(dataType=dataTypes[i++]){if(dataType[0]==="+"){dataType=dataType.slice(1)||"*";(structure[dataType]=structure[dataType]||[]).unshift(func)}else{(structure[dataType]=structure[dataType]||[]).push(func)}}}}}function inspectPrefiltersOrTransports(structure,options,originalOptions,jqXHR){var inspected={},seekingTransport=structure===transports;function inspect(dataType){var selected;inspected[dataType]=true;jQuery.each(structure[dataType]||[],function(_,prefilterOrFactory){var dataTypeOrTransport=prefilterOrFactory(options,originalOptions,jqXHR);if(typeof dataTypeOrTransport==="string"&&!seekingTransport&&!inspected[dataTypeOrTransport]){options.dataTypes.unshift(dataTypeOrTransport);inspect(dataTypeOrTransport);return false}else if(seekingTransport){return!(selected=dataTypeOrTransport)}});return selected}return inspect(options.dataTypes[0])||!inspected["*"]&&inspect("*")}function ajaxExtend(target,src){var deep,key,flatOptions=jQuery.ajaxSettings.flatOptions||{};for(key in src){if(src[key]!==undefined){(flatOptions[key]?target:deep||(deep={}))[key]=src[key]}}if(deep){jQuery.extend(true,target,deep)}return target}jQuery.fn.load=function(url,params,callback){if(typeof url!=="string"&&_load){return _load.apply(this,arguments)}var selector,response,type,self=this,off=url.indexOf(" ");if(off>=0){selector=url.slice(off,url.length);url=url.slice(0,off)}if(jQuery.isFunction(params)){callback=params;params=undefined}else if(params&&typeof params==="object"){type="POST"}if(self.length>0){jQuery.ajax({url:url,type:type,dataType:"html",data:params}).done(function(responseText){response=arguments;self.html(selector?jQuery("<div>").append(jQuery.parseHTML(responseText)).find(selector):responseText)}).complete(callback&&function(jqXHR,status){self.each(callback,response||[jqXHR.responseText,status,jqXHR])})}return this};jQuery.each(["ajaxStart","ajaxStop","ajaxComplete","ajaxError","ajaxSuccess","ajaxSend"],function(i,type){jQuery.fn[type]=function(fn){return this.on(type,fn)}});jQuery.extend({active:0,lastModified:{},etag:{},ajaxSettings:{url:ajaxLocation,type:"GET",isLocal:rlocalProtocol.test(ajaxLocParts[1]),global:true,processData:true,async:true,contentType:"application/x-www-form-urlencoded; charset=UTF-8",accepts:{"*":allTypes,text:"text/plain",html:"text/html",xml:"application/xml, text/xml",json:"application/json, text/javascript"},contents:{xml:/xml/,html:/html/,json:/json/},responseFields:{xml:"responseXML",text:"responseText",json:"responseJSON"},converters:{"* text":String,"text html":true,"text json":jQuery.parseJSON,"text xml":jQuery.parseXML},flatOptions:{url:true,context:true}},ajaxSetup:function(target,settings){return settings?ajaxExtend(ajaxExtend(target,jQuery.ajaxSettings),settings):ajaxExtend(jQuery.ajaxSettings,target)},ajaxPrefilter:addToPrefiltersOrTransports(prefilters),ajaxTransport:addToPrefiltersOrTransports(transports),ajax:function(url,options){if(typeof url==="object"){options=url;url=undefined}options=options||{};var parts,i,cacheURL,responseHeadersString,timeoutTimer,fireGlobals,transport,responseHeaders,s=jQuery.ajaxSetup({},options),callbackContext=s.context||s,globalEventContext=s.context&&(callbackContext.nodeType||callbackContext.jquery)?jQuery(callbackContext):jQuery.event,deferred=jQuery.Deferred(),completeDeferred=jQuery.Callbacks("once memory"),statusCode=s.statusCode||{},requestHeaders={},requestHeadersNames={},state=0,strAbort="canceled",jqXHR={readyState:0,getResponseHeader:function(key){var match;if(state===2){if(!responseHeaders){responseHeaders={};while(match=rheaders.exec(responseHeadersString)){responseHeaders[match[1].toLowerCase()]=match[2]}}match=responseHeaders[key.toLowerCase()]}return match==null?null:match},getAllResponseHeaders:function(){return state===2?responseHeadersString:null
},setRequestHeader:function(name,value){var lname=name.toLowerCase();if(!state){name=requestHeadersNames[lname]=requestHeadersNames[lname]||name;requestHeaders[name]=value}return this},overrideMimeType:function(type){if(!state){s.mimeType=type}return this},statusCode:function(map){var code;if(map){if(state<2){for(code in map){statusCode[code]=[statusCode[code],map[code]]}}else{jqXHR.always(map[jqXHR.status])}}return this},abort:function(statusText){var finalText=statusText||strAbort;if(transport){transport.abort(finalText)}done(0,finalText);return this}};deferred.promise(jqXHR).complete=completeDeferred.add;jqXHR.success=jqXHR.done;jqXHR.error=jqXHR.fail;s.url=((url||s.url||ajaxLocation)+"").replace(rhash,"").replace(rprotocol,ajaxLocParts[1]+"//");s.type=options.method||options.type||s.method||s.type;s.dataTypes=jQuery.trim(s.dataType||"*").toLowerCase().match(core_rnotwhite)||[""];if(s.crossDomain==null){parts=rurl.exec(s.url.toLowerCase());s.crossDomain=!!(parts&&(parts[1]!==ajaxLocParts[1]||parts[2]!==ajaxLocParts[2]||(parts[3]||(parts[1]==="http:"?"80":"443"))!==(ajaxLocParts[3]||(ajaxLocParts[1]==="http:"?"80":"443"))))}if(s.data&&s.processData&&typeof s.data!=="string"){s.data=jQuery.param(s.data,s.traditional)}inspectPrefiltersOrTransports(prefilters,s,options,jqXHR);if(state===2){return jqXHR}fireGlobals=s.global;if(fireGlobals&&jQuery.active++===0){jQuery.event.trigger("ajaxStart")}s.type=s.type.toUpperCase();s.hasContent=!rnoContent.test(s.type);cacheURL=s.url;if(!s.hasContent){if(s.data){cacheURL=s.url+=(ajax_rquery.test(cacheURL)?"&":"?")+s.data;delete s.data}if(s.cache===false){s.url=rts.test(cacheURL)?cacheURL.replace(rts,"$1_="+ajax_nonce++):cacheURL+(ajax_rquery.test(cacheURL)?"&":"?")+"_="+ajax_nonce++}}if(s.ifModified){if(jQuery.lastModified[cacheURL]){jqXHR.setRequestHeader("If-Modified-Since",jQuery.lastModified[cacheURL])}if(jQuery.etag[cacheURL]){jqXHR.setRequestHeader("If-None-Match",jQuery.etag[cacheURL])}}if(s.data&&s.hasContent&&s.contentType!==false||options.contentType){jqXHR.setRequestHeader("Content-Type",s.contentType)}jqXHR.setRequestHeader("Accept",s.dataTypes[0]&&s.accepts[s.dataTypes[0]]?s.accepts[s.dataTypes[0]]+(s.dataTypes[0]!=="*"?", "+allTypes+"; q=0.01":""):s.accepts["*"]);for(i in s.headers){jqXHR.setRequestHeader(i,s.headers[i])}if(s.beforeSend&&(s.beforeSend.call(callbackContext,jqXHR,s)===false||state===2)){return jqXHR.abort()}strAbort="abort";for(i in{success:1,error:1,complete:1}){jqXHR[i](s[i])}transport=inspectPrefiltersOrTransports(transports,s,options,jqXHR);if(!transport){done(-1,"No Transport")}else{jqXHR.readyState=1;if(fireGlobals){globalEventContext.trigger("ajaxSend",[jqXHR,s])}if(s.async&&s.timeout>0){timeoutTimer=setTimeout(function(){jqXHR.abort("timeout")},s.timeout)}try{state=1;transport.send(requestHeaders,done)}catch(e){if(state<2){done(-1,e)}else{throw e}}}function done(status,nativeStatusText,responses,headers){var isSuccess,success,error,response,modified,statusText=nativeStatusText;if(state===2){return}state=2;if(timeoutTimer){clearTimeout(timeoutTimer)}transport=undefined;responseHeadersString=headers||"";jqXHR.readyState=status>0?4:0;isSuccess=status>=200&&status<300||status===304;if(responses){response=ajaxHandleResponses(s,jqXHR,responses)}response=ajaxConvert(s,response,jqXHR,isSuccess);if(isSuccess){if(s.ifModified){modified=jqXHR.getResponseHeader("Last-Modified");if(modified){jQuery.lastModified[cacheURL]=modified}modified=jqXHR.getResponseHeader("etag");if(modified){jQuery.etag[cacheURL]=modified}}if(status===204||s.type==="HEAD"){statusText="nocontent"}else if(status===304){statusText="notmodified"}else{statusText=response.state;success=response.data;error=response.error;isSuccess=!error}}else{error=statusText;if(status||!statusText){statusText="error";if(status<0){status=0}}}jqXHR.status=status;jqXHR.statusText=(nativeStatusText||statusText)+"";if(isSuccess){deferred.resolveWith(callbackContext,[success,statusText,jqXHR])}else{deferred.rejectWith(callbackContext,[jqXHR,statusText,error])}jqXHR.statusCode(statusCode);statusCode=undefined;if(fireGlobals){globalEventContext.trigger(isSuccess?"ajaxSuccess":"ajaxError",[jqXHR,s,isSuccess?success:error])}completeDeferred.fireWith(callbackContext,[jqXHR,statusText]);if(fireGlobals){globalEventContext.trigger("ajaxComplete",[jqXHR,s]);if(!--jQuery.active){jQuery.event.trigger("ajaxStop")}}}return jqXHR},getJSON:function(url,data,callback){return jQuery.get(url,data,callback,"json")},getScript:function(url,callback){return jQuery.get(url,undefined,callback,"script")}});jQuery.each(["get","post"],function(i,method){jQuery[method]=function(url,data,callback,type){if(jQuery.isFunction(data)){type=type||callback;callback=data;data=undefined}return jQuery.ajax({url:url,type:method,dataType:type,data:data,success:callback})}});function ajaxHandleResponses(s,jqXHR,responses){var firstDataType,ct,finalDataType,type,contents=s.contents,dataTypes=s.dataTypes;while(dataTypes[0]==="*"){dataTypes.shift();if(ct===undefined){ct=s.mimeType||jqXHR.getResponseHeader("Content-Type")}}if(ct){for(type in contents){if(contents[type]&&contents[type].test(ct)){dataTypes.unshift(type);break}}}if(dataTypes[0]in responses){finalDataType=dataTypes[0]}else{for(type in responses){if(!dataTypes[0]||s.converters[type+" "+dataTypes[0]]){finalDataType=type;break}if(!firstDataType){firstDataType=type}}finalDataType=finalDataType||firstDataType}if(finalDataType){if(finalDataType!==dataTypes[0]){dataTypes.unshift(finalDataType)}return responses[finalDataType]}}function ajaxConvert(s,response,jqXHR,isSuccess){var conv2,current,conv,tmp,prev,converters={},dataTypes=s.dataTypes.slice();if(dataTypes[1]){for(conv in s.converters){converters[conv.toLowerCase()]=s.converters[conv]}}current=dataTypes.shift();while(current){if(s.responseFields[current]){jqXHR[s.responseFields[current]]=response}if(!prev&&isSuccess&&s.dataFilter){response=s.dataFilter(response,s.dataType)}prev=current;current=dataTypes.shift();if(current){if(current==="*"){current=prev}else if(prev!=="*"&&prev!==current){conv=converters[prev+" "+current]||converters["* "+current];if(!conv){for(conv2 in converters){tmp=conv2.split(" ");if(tmp[1]===current){conv=converters[prev+" "+tmp[0]]||converters["* "+tmp[0]];if(conv){if(conv===true){conv=converters[conv2]}else if(converters[conv2]!==true){current=tmp[0];dataTypes.unshift(tmp[1])}break}}}}if(conv!==true){if(conv&&s["throws"]){response=conv(response)}else{try{response=conv(response)}catch(e){return{state:"parsererror",error:conv?e:"No conversion from "+prev+" to "+current}}}}}}}return{state:"success",data:response}}jQuery.ajaxSetup({accepts:{script:"text/javascript, application/javascript, application/ecmascript, application/x-ecmascript"},contents:{script:/(?:java|ecma)script/},converters:{"text script":function(text){jQuery.globalEval(text);return text}}});jQuery.ajaxPrefilter("script",function(s){if(s.cache===undefined){s.cache=false}if(s.crossDomain){s.type="GET";s.global=false}});jQuery.ajaxTransport("script",function(s){if(s.crossDomain){var script,head=document.head||jQuery("head")[0]||document.documentElement;return{send:function(_,callback){script=document.createElement("script");script.async=true;if(s.scriptCharset){script.charset=s.scriptCharset}script.src=s.url;script.onload=script.onreadystatechange=function(_,isAbort){if(isAbort||!script.readyState||/loaded|complete/.test(script.readyState)){script.onload=script.onreadystatechange=null;if(script.parentNode){script.parentNode.removeChild(script)}script=null;if(!isAbort){callback(200,"success")}}};head.insertBefore(script,head.firstChild)},abort:function(){if(script){script.onload(undefined,true)}}}}});var oldCallbacks=[],rjsonp=/(=)\?(?=&|$)|\?\?/;jQuery.ajaxSetup({jsonp:"callback",jsonpCallback:function(){var callback=oldCallbacks.pop()||jQuery.expando+"_"+ajax_nonce++;this[callback]=true;return callback}});jQuery.ajaxPrefilter("json jsonp",function(s,originalSettings,jqXHR){var callbackName,overwritten,responseContainer,jsonProp=s.jsonp!==false&&(rjsonp.test(s.url)?"url":typeof s.data==="string"&&!(s.contentType||"").indexOf("application/x-www-form-urlencoded")&&rjsonp.test(s.data)&&"data");if(jsonProp||s.dataTypes[0]==="jsonp"){callbackName=s.jsonpCallback=jQuery.isFunction(s.jsonpCallback)?s.jsonpCallback():s.jsonpCallback;if(jsonProp){s[jsonProp]=s[jsonProp].replace(rjsonp,"$1"+callbackName)}else if(s.jsonp!==false){s.url+=(ajax_rquery.test(s.url)?"&":"?")+s.jsonp+"="+callbackName}s.converters["script json"]=function(){if(!responseContainer){jQuery.error(callbackName+" was not called")}return responseContainer[0]};s.dataTypes[0]="json";overwritten=window[callbackName];window[callbackName]=function(){responseContainer=arguments};jqXHR.always(function(){window[callbackName]=overwritten;if(s[callbackName]){s.jsonpCallback=originalSettings.jsonpCallback;oldCallbacks.push(callbackName)}if(responseContainer&&jQuery.isFunction(overwritten)){overwritten(responseContainer[0])}responseContainer=overwritten=undefined});return"script"}});var xhrCallbacks,xhrSupported,xhrId=0,xhrOnUnloadAbort=window.ActiveXObject&&function(){var key;for(key in xhrCallbacks){xhrCallbacks[key](undefined,true)}};function createStandardXHR(){try{return new window.XMLHttpRequest}catch(e){}}function createActiveXHR(){try{return new window.ActiveXObject("Microsoft.XMLHTTP")}catch(e){}}jQuery.ajaxSettings.xhr=window.ActiveXObject?function(){return!this.isLocal&&createStandardXHR()||createActiveXHR()}:createStandardXHR;xhrSupported=jQuery.ajaxSettings.xhr();jQuery.support.cors=!!xhrSupported&&"withCredentials"in xhrSupported;xhrSupported=jQuery.support.ajax=!!xhrSupported;if(xhrSupported){jQuery.ajaxTransport(function(s){if(!s.crossDomain||jQuery.support.cors){var callback;return{send:function(headers,complete){var handle,i,xhr=s.xhr();if(s.username){xhr.open(s.type,s.url,s.async,s.username,s.password)}else{xhr.open(s.type,s.url,s.async)}if(s.xhrFields){for(i in s.xhrFields){xhr[i]=s.xhrFields[i]}}if(s.mimeType&&xhr.overrideMimeType){xhr.overrideMimeType(s.mimeType)}if(!s.crossDomain&&!headers["X-Requested-With"]){headers["X-Requested-With"]="XMLHttpRequest"}try{for(i in headers){xhr.setRequestHeader(i,headers[i])}}catch(err){}xhr.send(s.hasContent&&s.data||null);callback=function(_,isAbort){var status,responseHeaders,statusText,responses;try{if(callback&&(isAbort||xhr.readyState===4)){callback=undefined;if(handle){xhr.onreadystatechange=jQuery.noop;if(xhrOnUnloadAbort){delete xhrCallbacks[handle]}}if(isAbort){if(xhr.readyState!==4){xhr.abort()}}else{responses={};status=xhr.status;responseHeaders=xhr.getAllResponseHeaders();if(typeof xhr.responseText==="string"){responses.text=xhr.responseText}try{statusText=xhr.statusText}catch(e){statusText=""}if(!status&&s.isLocal&&!s.crossDomain){status=responses.text?200:404}else if(status===1223){status=204}}}}catch(firefoxAccessException){if(!isAbort){complete(-1,firefoxAccessException)}}if(responses){complete(status,statusText,responses,responseHeaders)}};if(!s.async){callback()}else if(xhr.readyState===4){setTimeout(callback)}else{handle=++xhrId;if(xhrOnUnloadAbort){if(!xhrCallbacks){xhrCallbacks={};jQuery(window).unload(xhrOnUnloadAbort)}xhrCallbacks[handle]=callback}xhr.onreadystatechange=callback}},abort:function(){if(callback){callback(undefined,true)}}}}})}var fxNow,timerId,rfxtypes=/^(?:toggle|show|hide)$/,rfxnum=new RegExp("^(?:([+-])=|)("+core_pnum+")([a-z%]*)$","i"),rrun=/queueHooks$/,animationPrefilters=[defaultPrefilter],tweeners={"*":[function(prop,value){var tween=this.createTween(prop,value),target=tween.cur(),parts=rfxnum.exec(value),unit=parts&&parts[3]||(jQuery.cssNumber[prop]?"":"px"),start=(jQuery.cssNumber[prop]||unit!=="px"&&+target)&&rfxnum.exec(jQuery.css(tween.elem,prop)),scale=1,maxIterations=20;if(start&&start[3]!==unit){unit=unit||start[3];parts=parts||[];start=+target||1;do{scale=scale||".5";start=start/scale;jQuery.style(tween.elem,prop,start+unit)}while(scale!==(scale=tween.cur()/target)&&scale!==1&&--maxIterations)}if(parts){start=tween.start=+start||+target||0;tween.unit=unit;tween.end=parts[1]?start+(parts[1]+1)*parts[2]:+parts[2]}return tween}]};function createFxNow(){setTimeout(function(){fxNow=undefined});return fxNow=jQuery.now()}function createTween(value,prop,animation){var tween,collection=(tweeners[prop]||[]).concat(tweeners["*"]),index=0,length=collection.length;for(;index<length;index++){if(tween=collection[index].call(animation,prop,value)){return tween}}}function Animation(elem,properties,options){var result,stopped,index=0,length=animationPrefilters.length,deferred=jQuery.Deferred().always(function(){delete tick.elem}),tick=function(){if(stopped){return false}var currentTime=fxNow||createFxNow(),remaining=Math.max(0,animation.startTime+animation.duration-currentTime),temp=remaining/animation.duration||0,percent=1-temp,index=0,length=animation.tweens.length;for(;index<length;index++){animation.tweens[index].run(percent)}deferred.notifyWith(elem,[animation,percent,remaining]);if(percent<1&&length){return remaining}else{deferred.resolveWith(elem,[animation]);return false}},animation=deferred.promise({elem:elem,props:jQuery.extend({},properties),opts:jQuery.extend(true,{specialEasing:{}},options),originalProperties:properties,originalOptions:options,startTime:fxNow||createFxNow(),duration:options.duration,tweens:[],createTween:function(prop,end){var tween=jQuery.Tween(elem,animation.opts,prop,end,animation.opts.specialEasing[prop]||animation.opts.easing);animation.tweens.push(tween);return tween},stop:function(gotoEnd){var index=0,length=gotoEnd?animation.tweens.length:0;if(stopped){return this}stopped=true;for(;index<length;index++){animation.tweens[index].run(1)}if(gotoEnd){deferred.resolveWith(elem,[animation,gotoEnd])}else{deferred.rejectWith(elem,[animation,gotoEnd])}return this}}),props=animation.props;propFilter(props,animation.opts.specialEasing);for(;index<length;index++){result=animationPrefilters[index].call(animation,elem,props,animation.opts);if(result){return result}}jQuery.map(props,createTween,animation);if(jQuery.isFunction(animation.opts.start)){animation.opts.start.call(elem,animation)}jQuery.fx.timer(jQuery.extend(tick,{elem:elem,anim:animation,queue:animation.opts.queue}));return animation.progress(animation.opts.progress).done(animation.opts.done,animation.opts.complete).fail(animation.opts.fail).always(animation.opts.always)}function propFilter(props,specialEasing){var index,name,easing,value,hooks;for(index in props){name=jQuery.camelCase(index);easing=specialEasing[name];value=props[index];if(jQuery.isArray(value)){easing=value[1];value=props[index]=value[0]}if(index!==name){props[name]=value;delete props[index]}hooks=jQuery.cssHooks[name];if(hooks&&"expand"in hooks){value=hooks.expand(value);delete props[name];for(index in value){if(!(index in props)){props[index]=value[index];specialEasing[index]=easing}}}else{specialEasing[name]=easing}}}jQuery.Animation=jQuery.extend(Animation,{tweener:function(props,callback){if(jQuery.isFunction(props)){callback=props;props=["*"]}else{props=props.split(" ")}var prop,index=0,length=props.length;for(;index<length;index++){prop=props[index];tweeners[prop]=tweeners[prop]||[];tweeners[prop].unshift(callback)}},prefilter:function(callback,prepend){if(prepend){animationPrefilters.unshift(callback)}else{animationPrefilters.push(callback)}}});function defaultPrefilter(elem,props,opts){var prop,value,toggle,tween,hooks,oldfire,anim=this,orig={},style=elem.style,hidden=elem.nodeType&&isHidden(elem),dataShow=jQuery._data(elem,"fxshow");if(!opts.queue){hooks=jQuery._queueHooks(elem,"fx");if(hooks.unqueued==null){hooks.unqueued=0;oldfire=hooks.empty.fire;hooks.empty.fire=function(){if(!hooks.unqueued){oldfire()}}}hooks.unqueued++;anim.always(function(){anim.always(function(){hooks.unqueued--;if(!jQuery.queue(elem,"fx").length){hooks.empty.fire()}})})}if(elem.nodeType===1&&("height"in props||"width"in props)){opts.overflow=[style.overflow,style.overflowX,style.overflowY];if(jQuery.css(elem,"display")==="inline"&&jQuery.css(elem,"float")==="none"){if(!jQuery.support.inlineBlockNeedsLayout||css_defaultDisplay(elem.nodeName)==="inline"){style.display="inline-block"}else{style.zoom=1}}}if(opts.overflow){style.overflow="hidden";if(!jQuery.support.shrinkWrapBlocks){anim.always(function(){style.overflow=opts.overflow[0];style.overflowX=opts.overflow[1];style.overflowY=opts.overflow[2]})}}for(prop in props){value=props[prop];if(rfxtypes.exec(value)){delete props[prop];toggle=toggle||value==="toggle";if(value===(hidden?"hide":"show")){continue}orig[prop]=dataShow&&dataShow[prop]||jQuery.style(elem,prop)}}if(!jQuery.isEmptyObject(orig)){if(dataShow){if("hidden"in dataShow){hidden=dataShow.hidden}}else{dataShow=jQuery._data(elem,"fxshow",{})}if(toggle){dataShow.hidden=!hidden}if(hidden){jQuery(elem).show()}else{anim.done(function(){jQuery(elem).hide()})}anim.done(function(){var prop;jQuery._removeData(elem,"fxshow");for(prop in orig){jQuery.style(elem,prop,orig[prop])}});for(prop in orig){tween=createTween(hidden?dataShow[prop]:0,prop,anim);if(!(prop in dataShow)){dataShow[prop]=tween.start;if(hidden){tween.end=tween.start;tween.start=prop==="width"||prop==="height"?1:0}}}}}function Tween(elem,options,prop,end,easing){return new Tween.prototype.init(elem,options,prop,end,easing)}jQuery.Tween=Tween;Tween.prototype={constructor:Tween,init:function(elem,options,prop,end,easing,unit){this.elem=elem;this.prop=prop;this.easing=easing||"swing";this.options=options;this.start=this.now=this.cur();this.end=end;this.unit=unit||(jQuery.cssNumber[prop]?"":"px")},cur:function(){var hooks=Tween.propHooks[this.prop];return hooks&&hooks.get?hooks.get(this):Tween.propHooks._default.get(this)},run:function(percent){var eased,hooks=Tween.propHooks[this.prop];if(this.options.duration){this.pos=eased=jQuery.easing[this.easing](percent,this.options.duration*percent,0,1,this.options.duration)}else{this.pos=eased=percent}this.now=(this.end-this.start)*eased+this.start;if(this.options.step){this.options.step.call(this.elem,this.now,this)}if(hooks&&hooks.set){hooks.set(this)}else{Tween.propHooks._default.set(this)}return this}};Tween.prototype.init.prototype=Tween.prototype;Tween.propHooks={_default:{get:function(tween){var result;if(tween.elem[tween.prop]!=null&&(!tween.elem.style||tween.elem.style[tween.prop]==null)){return tween.elem[tween.prop]}result=jQuery.css(tween.elem,tween.prop,"");return!result||result==="auto"?0:result},set:function(tween){if(jQuery.fx.step[tween.prop]){jQuery.fx.step[tween.prop](tween)}else if(tween.elem.style&&(tween.elem.style[jQuery.cssProps[tween.prop]]!=null||jQuery.cssHooks[tween.prop])){jQuery.style(tween.elem,tween.prop,tween.now+tween.unit)}else{tween.elem[tween.prop]=tween.now}}}};Tween.propHooks.scrollTop=Tween.propHooks.scrollLeft={set:function(tween){if(tween.elem.nodeType&&tween.elem.parentNode){tween.elem[tween.prop]=tween.now}}};jQuery.each(["toggle","show","hide"],function(i,name){var cssFn=jQuery.fn[name];jQuery.fn[name]=function(speed,easing,callback){return speed==null||typeof speed==="boolean"?cssFn.apply(this,arguments):this.animate(genFx(name,true),speed,easing,callback)}});jQuery.fn.extend({fadeTo:function(speed,to,easing,callback){return this.filter(isHidden).css("opacity",0).show().end().animate({opacity:to},speed,easing,callback)},animate:function(prop,speed,easing,callback){var empty=jQuery.isEmptyObject(prop),optall=jQuery.speed(speed,easing,callback),doAnimation=function(){var anim=Animation(this,jQuery.extend({},prop),optall);if(empty||jQuery._data(this,"finish")){anim.stop(true)}};doAnimation.finish=doAnimation;return empty||optall.queue===false?this.each(doAnimation):this.queue(optall.queue,doAnimation)},stop:function(type,clearQueue,gotoEnd){var stopQueue=function(hooks){var stop=hooks.stop;delete hooks.stop;stop(gotoEnd)};if(typeof type!=="string"){gotoEnd=clearQueue;clearQueue=type;type=undefined}if(clearQueue&&type!==false){this.queue(type||"fx",[])}return this.each(function(){var dequeue=true,index=type!=null&&type+"queueHooks",timers=jQuery.timers,data=jQuery._data(this);if(index){if(data[index]&&data[index].stop){stopQueue(data[index])}}else{for(index in data){if(data[index]&&data[index].stop&&rrun.test(index)){stopQueue(data[index])}}}for(index=timers.length;index--;){if(timers[index].elem===this&&(type==null||timers[index].queue===type)){timers[index].anim.stop(gotoEnd);dequeue=false;timers.splice(index,1)}}if(dequeue||!gotoEnd){jQuery.dequeue(this,type)}})},finish:function(type){if(type!==false){type=type||"fx"}return this.each(function(){var index,data=jQuery._data(this),queue=data[type+"queue"],hooks=data[type+"queueHooks"],timers=jQuery.timers,length=queue?queue.length:0;data.finish=true;jQuery.queue(this,type,[]);if(hooks&&hooks.stop){hooks.stop.call(this,true)}for(index=timers.length;index--;){if(timers[index].elem===this&&timers[index].queue===type){timers[index].anim.stop(true);timers.splice(index,1)}}for(index=0;index<length;index++){if(queue[index]&&queue[index].finish){queue[index].finish.call(this)}}delete data.finish})}});function genFx(type,includeWidth){var which,attrs={height:type},i=0;includeWidth=includeWidth?1:0;for(;i<4;i+=2-includeWidth){which=cssExpand[i];attrs["margin"+which]=attrs["padding"+which]=type}if(includeWidth){attrs.opacity=attrs.width=type}return attrs}jQuery.each({slideDown:genFx("show"),slideUp:genFx("hide"),slideToggle:genFx("toggle"),fadeIn:{opacity:"show"},fadeOut:{opacity:"hide"},fadeToggle:{opacity:"toggle"}},function(name,props){jQuery.fn[name]=function(speed,easing,callback){return this.animate(props,speed,easing,callback)}});jQuery.speed=function(speed,easing,fn){var opt=speed&&typeof speed==="object"?jQuery.extend({},speed):{complete:fn||!fn&&easing||jQuery.isFunction(speed)&&speed,duration:speed,easing:fn&&easing||easing&&!jQuery.isFunction(easing)&&easing};opt.duration=jQuery.fx.off?0:typeof opt.duration==="number"?opt.duration:opt.duration in jQuery.fx.speeds?jQuery.fx.speeds[opt.duration]:jQuery.fx.speeds._default;if(opt.queue==null||opt.queue===true){opt.queue="fx"}opt.old=opt.complete;opt.complete=function(){if(jQuery.isFunction(opt.old)){opt.old.call(this)}if(opt.queue){jQuery.dequeue(this,opt.queue)}};return opt};jQuery.easing={linear:function(p){return p},swing:function(p){return.5-Math.cos(p*Math.PI)/2}};jQuery.timers=[];jQuery.fx=Tween.prototype.init;jQuery.fx.tick=function(){var timer,timers=jQuery.timers,i=0;fxNow=jQuery.now();for(;i<timers.length;i++){timer=timers[i];if(!timer()&&timers[i]===timer){timers.splice(i--,1)}}if(!timers.length){jQuery.fx.stop()}fxNow=undefined};jQuery.fx.timer=function(timer){if(timer()&&jQuery.timers.push(timer)){jQuery.fx.start()}};jQuery.fx.interval=13;jQuery.fx.start=function(){if(!timerId){timerId=setInterval(jQuery.fx.tick,jQuery.fx.interval)}};jQuery.fx.stop=function(){clearInterval(timerId);timerId=null};jQuery.fx.speeds={slow:600,fast:200,_default:400};jQuery.fx.step={};if(jQuery.expr&&jQuery.expr.filters){jQuery.expr.filters.animated=function(elem){return jQuery.grep(jQuery.timers,function(fn){return elem===fn.elem}).length}}jQuery.fn.offset=function(options){if(arguments.length){return options===undefined?this:this.each(function(i){jQuery.offset.setOffset(this,options,i)})}var docElem,win,box={top:0,left:0},elem=this[0],doc=elem&&elem.ownerDocument;if(!doc){return}docElem=doc.documentElement;if(!jQuery.contains(docElem,elem)){return box}if(typeof elem.getBoundingClientRect!==core_strundefined){box=elem.getBoundingClientRect()}win=getWindow(doc);return{top:box.top+(win.pageYOffset||docElem.scrollTop)-(docElem.clientTop||0),left:box.left+(win.pageXOffset||docElem.scrollLeft)-(docElem.clientLeft||0)}};jQuery.offset={setOffset:function(elem,options,i){var position=jQuery.css(elem,"position");if(position==="static"){elem.style.position="relative"}var curElem=jQuery(elem),curOffset=curElem.offset(),curCSSTop=jQuery.css(elem,"top"),curCSSLeft=jQuery.css(elem,"left"),calculatePosition=(position==="absolute"||position==="fixed")&&jQuery.inArray("auto",[curCSSTop,curCSSLeft])>-1,props={},curPosition={},curTop,curLeft;if(calculatePosition){curPosition=curElem.position();curTop=curPosition.top;curLeft=curPosition.left}else{curTop=parseFloat(curCSSTop)||0;curLeft=parseFloat(curCSSLeft)||0}if(jQuery.isFunction(options)){options=options.call(elem,i,curOffset)}if(options.top!=null){props.top=options.top-curOffset.top+curTop}if(options.left!=null){props.left=options.left-curOffset.left+curLeft}if("using"in options){options.using.call(elem,props)}else{curElem.css(props)}}};jQuery.fn.extend({position:function(){if(!this[0]){return}var offsetParent,offset,parentOffset={top:0,left:0},elem=this[0];if(jQuery.css(elem,"position")==="fixed"){offset=elem.getBoundingClientRect()}else{offsetParent=this.offsetParent();offset=this.offset();if(!jQuery.nodeName(offsetParent[0],"html")){parentOffset=offsetParent.offset()}parentOffset.top+=jQuery.css(offsetParent[0],"borderTopWidth",true);parentOffset.left+=jQuery.css(offsetParent[0],"borderLeftWidth",true)}return{top:offset.top-parentOffset.top-jQuery.css(elem,"marginTop",true),left:offset.left-parentOffset.left-jQuery.css(elem,"marginLeft",true)}},offsetParent:function(){return this.map(function(){var offsetParent=this.offsetParent||docElem;while(offsetParent&&(!jQuery.nodeName(offsetParent,"html")&&jQuery.css(offsetParent,"position")==="static")){offsetParent=offsetParent.offsetParent}return offsetParent||docElem})}});jQuery.each({scrollLeft:"pageXOffset",scrollTop:"pageYOffset"},function(method,prop){var top=/Y/.test(prop);jQuery.fn[method]=function(val){return jQuery.access(this,function(elem,method,val){var win=getWindow(elem);if(val===undefined){return win?prop in win?win[prop]:win.document.documentElement[method]:elem[method]}if(win){win.scrollTo(!top?val:jQuery(win).scrollLeft(),top?val:jQuery(win).scrollTop())}else{elem[method]=val}},method,val,arguments.length,null)}});function getWindow(elem){return jQuery.isWindow(elem)?elem:elem.nodeType===9?elem.defaultView||elem.parentWindow:false}jQuery.each({Height:"height",Width:"width"},function(name,type){jQuery.each({padding:"inner"+name,content:type,"":"outer"+name},function(defaultExtra,funcName){jQuery.fn[funcName]=function(margin,value){var chainable=arguments.length&&(defaultExtra||typeof margin!=="boolean"),extra=defaultExtra||(margin===true||value===true?"margin":"border");return jQuery.access(this,function(elem,type,value){var doc;if(jQuery.isWindow(elem)){return elem.document.documentElement["client"+name]}if(elem.nodeType===9){doc=elem.documentElement;return Math.max(elem.body["scroll"+name],doc["scroll"+name],elem.body["offset"+name],doc["offset"+name],doc["client"+name])}return value===undefined?jQuery.css(elem,type,extra):jQuery.style(elem,type,value,extra)},type,chainable?margin:undefined,chainable,null)}})});jQuery.fn.size=function(){return this.length};jQuery.fn.andSelf=jQuery.fn.addBack;if(typeof module==="object"&&module&&typeof module.exports==="object"){module.exports=jQuery}else{window.jQuery=window.$=jQuery;if(typeof define==="function"&&define.amd){define("jquery",[],function(){return jQuery})}}})(window);(function(root,factory){if(typeof define==="function"&&define.amd){define(["underscore","jquery","exports"],function(_,$,exports){root.Backbone=factory(root,exports,_,$)})}else if(typeof exports!=="undefined"){var _=require("underscore"),$;try{$=require("jquery")}catch(e){}factory(root,exports,_,$)}else{root.Backbone=factory(root,{},root._,root.jQuery||root.Zepto||root.ender||root.$)}})(this,function(root,Backbone,_,$){var previousBackbone=root.Backbone;var array=[];var push=array.push;var slice=array.slice;var splice=array.splice;Backbone.VERSION="1.1.0";Backbone.$=$;Backbone.noConflict=function(){root.Backbone=previousBackbone;return this};Backbone.emulateHTTP=false;Backbone.emulateJSON=false;var Events=Backbone.Events={on:function(name,callback,context){if(!eventsApi(this,"on",name,[callback,context])||!callback)return this;this._events||(this._events={});var events=this._events[name]||(this._events[name]=[]);events.push({callback:callback,context:context,ctx:context||this});return this},once:function(name,callback,context){if(!eventsApi(this,"once",name,[callback,context])||!callback)return this;var self=this;var once=_.once(function(){self.off(name,once);callback.apply(this,arguments)});once._callback=callback;return this.on(name,once,context)},off:function(name,callback,context){var retain,ev,events,names,i,l,j,k;if(!this._events||!eventsApi(this,"off",name,[callback,context]))return this;if(!name&&!callback&&!context){this._events=void 0;return this}names=name?[name]:_.keys(this._events);for(i=0,l=names.length;i<l;i++){name=names[i];if(events=this._events[name]){this._events[name]=retain=[];if(callback||context){for(j=0,k=events.length;j<k;j++){ev=events[j];if(callback&&callback!==ev.callback&&callback!==ev.callback._callback||context&&context!==ev.context){retain.push(ev)}}}if(!retain.length)delete this._events[name]}}return this},trigger:function(name){if(!this._events)return this;var args=slice.call(arguments,1);if(!eventsApi(this,"trigger",name,args))return this;var events=this._events[name];var allEvents=this._events.all;if(events)triggerEvents(events,args);if(allEvents)triggerEvents(allEvents,arguments);return this},stopListening:function(obj,name,callback){var listeningTo=this._listeningTo;if(!listeningTo)return this;var remove=!name&&!callback;if(!callback&&typeof name==="object")callback=this;if(obj)(listeningTo={})[obj._listenId]=obj;for(var id in listeningTo){obj=listeningTo[id];obj.off(name,callback,this);if(remove||_.isEmpty(obj._events))delete this._listeningTo[id]}return this}};var eventSplitter=/\s+/;var eventsApi=function(obj,action,name,rest){if(!name)return true;if(typeof name==="object"){for(var key in name){obj[action].apply(obj,[key,name[key]].concat(rest))}return false}if(eventSplitter.test(name)){var names=name.split(eventSplitter);for(var i=0,l=names.length;i<l;i++){obj[action].apply(obj,[names[i]].concat(rest))}return false}return true};var triggerEvents=function(events,args){var ev,i=-1,l=events.length,a1=args[0],a2=args[1],a3=args[2];switch(args.length){case 0:while(++i<l)(ev=events[i]).callback.call(ev.ctx);return;case 1:while(++i<l)(ev=events[i]).callback.call(ev.ctx,a1);return;case 2:while(++i<l)(ev=events[i]).callback.call(ev.ctx,a1,a2);return;case 3:while(++i<l)(ev=events[i]).callback.call(ev.ctx,a1,a2,a3);return;default:while(++i<l)(ev=events[i]).callback.apply(ev.ctx,args);return}};var listenMethods={listenTo:"on",listenToOnce:"once"};_.each(listenMethods,function(implementation,method){Events[method]=function(obj,name,callback){var listeningTo=this._listeningTo||(this._listeningTo={});var id=obj._listenId||(obj._listenId=_.uniqueId("l"));listeningTo[id]=obj;if(!callback&&typeof name==="object")callback=this;obj[implementation](name,callback,this);return this}});Events.bind=Events.on;Events.unbind=Events.off;_.extend(Backbone,Events);var Model=Backbone.Model=function(attributes,options){var attrs=attributes||{};options||(options={});this.cid=_.uniqueId("c");this.attributes={};if(options.collection)this.collection=options.collection;if(options.parse)attrs=this.parse(attrs,options)||{};attrs=_.defaults({},attrs,_.result(this,"defaults"));this.set(attrs,options);this.changed={};this.initialize.apply(this,arguments)};_.extend(Model.prototype,Events,{changed:null,validationError:null,idAttribute:"id",initialize:function(){},toJSON:function(options){return _.clone(this.attributes)},sync:function(){return Backbone.sync.apply(this,arguments)},get:function(attr){return this.attributes[attr]},escape:function(attr){return _.escape(this.get(attr))},has:function(attr){return this.get(attr)!=null},set:function(key,val,options){var attr,attrs,unset,changes,silent,changing,prev,current;if(key==null)return this;if(typeof key==="object"){attrs=key;options=val}else{(attrs={})[key]=val
}options||(options={});if(!this._validate(attrs,options))return false;unset=options.unset;silent=options.silent;changes=[];changing=this._changing;this._changing=true;if(!changing){this._previousAttributes=_.clone(this.attributes);this.changed={}}current=this.attributes,prev=this._previousAttributes;if(this.idAttribute in attrs)this.id=attrs[this.idAttribute];for(attr in attrs){val=attrs[attr];if(!_.isEqual(current[attr],val))changes.push(attr);if(!_.isEqual(prev[attr],val)){this.changed[attr]=val}else{delete this.changed[attr]}unset?delete current[attr]:current[attr]=val}if(!silent){if(changes.length)this._pending=options;for(var i=0,l=changes.length;i<l;i++){this.trigger("change:"+changes[i],this,current[changes[i]],options)}}if(changing)return this;if(!silent){while(this._pending){options=this._pending;this._pending=false;this.trigger("change",this,options)}}this._pending=false;this._changing=false;return this},unset:function(attr,options){return this.set(attr,void 0,_.extend({},options,{unset:true}))},clear:function(options){var attrs={};for(var key in this.attributes)attrs[key]=void 0;return this.set(attrs,_.extend({},options,{unset:true}))},hasChanged:function(attr){if(attr==null)return!_.isEmpty(this.changed);return _.has(this.changed,attr)},changedAttributes:function(diff){if(!diff)return this.hasChanged()?_.clone(this.changed):false;var val,changed=false;var old=this._changing?this._previousAttributes:this.attributes;for(var attr in diff){if(_.isEqual(old[attr],val=diff[attr]))continue;(changed||(changed={}))[attr]=val}return changed},previous:function(attr){if(attr==null||!this._previousAttributes)return null;return this._previousAttributes[attr]},previousAttributes:function(){return _.clone(this._previousAttributes)},fetch:function(options){options=options?_.clone(options):{};if(options.parse===void 0)options.parse=true;var model=this;var success=options.success;options.success=function(resp){if(!model.set(model.parse(resp,options),options))return false;if(success)success(model,resp,options);model.trigger("sync",model,resp,options)};wrapError(this,options);return this.sync("read",this,options)},save:function(key,val,options){var attrs,method,xhr,attributes=this.attributes;if(key==null||typeof key==="object"){attrs=key;options=val}else{(attrs={})[key]=val}options=_.extend({validate:true},options);if(attrs&&!options.wait){if(!this.set(attrs,options))return false}else{if(!this._validate(attrs,options))return false}if(attrs&&options.wait){this.attributes=_.extend({},attributes,attrs)}if(options.parse===void 0)options.parse=true;var model=this;var success=options.success;options.success=function(resp){model.attributes=attributes;var serverAttrs=model.parse(resp,options);if(options.wait)serverAttrs=_.extend(attrs||{},serverAttrs);if(_.isObject(serverAttrs)&&!model.set(serverAttrs,options)){return false}if(success)success(model,resp,options);model.trigger("sync",model,resp,options)};wrapError(this,options);method=this.isNew()?"create":options.patch?"patch":"update";if(method==="patch")options.attrs=attrs;xhr=this.sync(method,this,options);if(attrs&&options.wait)this.attributes=attributes;return xhr},destroy:function(options){options=options?_.clone(options):{};var model=this;var success=options.success;var destroy=function(){model.trigger("destroy",model,model.collection,options)};options.success=function(resp){if(options.wait||model.isNew())destroy();if(success)success(model,resp,options);if(!model.isNew())model.trigger("sync",model,resp,options)};if(this.isNew()){options.success();return false}wrapError(this,options);var xhr=this.sync("delete",this,options);if(!options.wait)destroy();return xhr},url:function(){var base=_.result(this,"urlRoot")||_.result(this.collection,"url")||urlError();if(this.isNew())return base;return base.replace(/([^\/])$/,"$1/")+encodeURIComponent(this.id)},parse:function(resp,options){return resp},clone:function(){return new this.constructor(this.attributes)},isNew:function(){return!this.has(this.idAttribute)},isValid:function(options){return this._validate({},_.extend(options||{},{validate:true}))},_validate:function(attrs,options){if(!options.validate||!this.validate)return true;attrs=_.extend({},this.attributes,attrs);var error=this.validationError=this.validate(attrs,options)||null;if(!error)return true;this.trigger("invalid",this,error,_.extend(options,{validationError:error}));return false}});var modelMethods=["keys","values","pairs","invert","pick","omit"];_.each(modelMethods,function(method){Model.prototype[method]=function(){var args=slice.call(arguments);args.unshift(this.attributes);return _[method].apply(_,args)}});var Collection=Backbone.Collection=function(models,options){options||(options={});if(options.model)this.model=options.model;if(options.comparator!==void 0)this.comparator=options.comparator;this._reset();this.initialize.apply(this,arguments);if(models)this.reset(models,_.extend({silent:true},options))};var setOptions={add:true,remove:true,merge:true};var addOptions={add:true,remove:false};_.extend(Collection.prototype,Events,{model:Model,initialize:function(){},toJSON:function(options){return this.map(function(model){return model.toJSON(options)})},sync:function(){return Backbone.sync.apply(this,arguments)},add:function(models,options){return this.set(models,_.extend({merge:false},options,addOptions))},remove:function(models,options){var singular=!_.isArray(models);models=singular?[models]:_.clone(models);options||(options={});var i,l,index,model;for(i=0,l=models.length;i<l;i++){model=models[i]=this.get(models[i]);if(!model)continue;delete this._byId[model.id];delete this._byId[model.cid];index=this.indexOf(model);this.models.splice(index,1);this.length--;if(!options.silent){options.index=index;model.trigger("remove",model,this,options)}this._removeReference(model,options)}return singular?models[0]:models},set:function(models,options){options=_.defaults({},options,setOptions);if(options.parse)models=this.parse(models,options);var singular=!_.isArray(models);models=singular?models?[models]:[]:_.clone(models);var i,l,id,model,attrs,existing,sort;var at=options.at;var targetModel=this.model;var sortable=this.comparator&&at==null&&options.sort!==false;var sortAttr=_.isString(this.comparator)?this.comparator:null;var toAdd=[],toRemove=[],modelMap={};var add=options.add,merge=options.merge,remove=options.remove;var order=!sortable&&add&&remove?[]:false;for(i=0,l=models.length;i<l;i++){attrs=models[i]||{};if(attrs instanceof Model){id=model=attrs}else{id=attrs[targetModel.prototype.idAttribute||"id"]}if(existing=this.get(id)){if(remove)modelMap[existing.cid]=true;if(merge){attrs=attrs===model?model.attributes:attrs;if(options.parse)attrs=existing.parse(attrs,options);existing.set(attrs,options);if(sortable&&!sort&&existing.hasChanged(sortAttr))sort=true}models[i]=existing}else if(add){model=models[i]=this._prepareModel(attrs,options);if(!model)continue;toAdd.push(model);this._addReference(model,options)}if(order)order.push(existing||model)}if(remove){for(i=0,l=this.length;i<l;++i){if(!modelMap[(model=this.models[i]).cid])toRemove.push(model)}if(toRemove.length)this.remove(toRemove,options)}if(toAdd.length||order&&order.length){if(sortable)sort=true;this.length+=toAdd.length;if(at!=null){for(i=0,l=toAdd.length;i<l;i++){this.models.splice(at+i,0,toAdd[i])}}else{if(order)this.models.length=0;var orderedModels=order||toAdd;for(i=0,l=orderedModels.length;i<l;i++){this.models.push(orderedModels[i])}}}if(sort)this.sort({silent:true});if(!options.silent){for(i=0,l=toAdd.length;i<l;i++){(model=toAdd[i]).trigger("add",model,this,options)}if(sort||order&&order.length)this.trigger("sort",this,options)}return singular?models[0]:models},reset:function(models,options){options||(options={});for(var i=0,l=this.models.length;i<l;i++){this._removeReference(this.models[i],options)}options.previousModels=this.models;this._reset();models=this.add(models,_.extend({silent:true},options));if(!options.silent)this.trigger("reset",this,options);return models},push:function(model,options){return this.add(model,_.extend({at:this.length},options))},pop:function(options){var model=this.at(this.length-1);this.remove(model,options);return model},unshift:function(model,options){return this.add(model,_.extend({at:0},options))},shift:function(options){var model=this.at(0);this.remove(model,options);return model},slice:function(){return slice.apply(this.models,arguments)},get:function(obj){if(obj==null)return void 0;return this._byId[obj]||this._byId[obj.id]||this._byId[obj.cid]},at:function(index){return this.models[index]},where:function(attrs,first){if(_.isEmpty(attrs))return first?void 0:[];return this[first?"find":"filter"](function(model){for(var key in attrs){if(attrs[key]!==model.get(key))return false}return true})},findWhere:function(attrs){return this.where(attrs,true)},sort:function(options){if(!this.comparator)throw new Error("Cannot sort a set without a comparator");options||(options={});if(_.isString(this.comparator)||this.comparator.length===1){this.models=this.sortBy(this.comparator,this)}else{this.models.sort(_.bind(this.comparator,this))}if(!options.silent)this.trigger("sort",this,options);return this},pluck:function(attr){return _.invoke(this.models,"get",attr)},fetch:function(options){options=options?_.clone(options):{};if(options.parse===void 0)options.parse=true;var success=options.success;var collection=this;options.success=function(resp){var method=options.reset?"reset":"set";collection[method](resp,options);if(success)success(collection,resp,options);collection.trigger("sync",collection,resp,options)};wrapError(this,options);return this.sync("read",this,options)},create:function(model,options){options=options?_.clone(options):{};if(!(model=this._prepareModel(model,options)))return false;if(!options.wait)this.add(model,options);var collection=this;var success=options.success;options.success=function(model,resp){if(options.wait)collection.add(model,options);if(success)success(model,resp,options)};model.save(null,options);return model},parse:function(resp,options){return resp},clone:function(){return new this.constructor(this.models)},_reset:function(){this.length=0;this.models=[];this._byId={}},_prepareModel:function(attrs,options){if(attrs instanceof Model)return attrs;options=options?_.clone(options):{};options.collection=this;var model=new this.model(attrs,options);if(!model.validationError)return model;this.trigger("invalid",this,model.validationError,options);return false},_addReference:function(model,options){this._byId[model.cid]=model;if(model.id!=null)this._byId[model.id]=model;if(!model.collection)model.collection=this;model.on("all",this._onModelEvent,this)},_removeReference:function(model,options){if(this===model.collection)delete model.collection;model.off("all",this._onModelEvent,this)},_onModelEvent:function(event,model,collection,options){if((event==="add"||event==="remove")&&collection!==this)return;if(event==="destroy")this.remove(model,options);if(model&&event==="change:"+model.idAttribute){delete this._byId[model.previous(model.idAttribute)];if(model.id!=null)this._byId[model.id]=model}this.trigger.apply(this,arguments)}});var methods=["forEach","each","map","collect","reduce","foldl","inject","reduceRight","foldr","find","detect","filter","select","reject","every","all","some","any","include","contains","invoke","max","min","toArray","size","first","head","take","initial","rest","tail","drop","last","without","difference","indexOf","shuffle","lastIndexOf","isEmpty","chain","sample"];_.each(methods,function(method){Collection.prototype[method]=function(){var args=slice.call(arguments);args.unshift(this.models);return _[method].apply(_,args)}});var attributeMethods=["groupBy","countBy","sortBy","indexBy"];_.each(attributeMethods,function(method){Collection.prototype[method]=function(value,context){var iterator=_.isFunction(value)?value:function(model){return model.get(value)};return _[method](this.models,iterator,context)}});var View=Backbone.View=function(options){this.cid=_.uniqueId("view");options||(options={});_.extend(this,_.pick(options,viewOptions));this._ensureElement();this.initialize.apply(this,arguments);this.delegateEvents()};var delegateEventSplitter=/^(\S+)\s*(.*)$/;var viewOptions=["model","collection","el","id","attributes","className","tagName","events"];_.extend(View.prototype,Events,{tagName:"div",$:function(selector){return this.$el.find(selector)},initialize:function(){},render:function(){return this},remove:function(){this.$el.remove();this.stopListening();return this},setElement:function(element,delegate){if(this.$el)this.undelegateEvents();this.$el=element instanceof Backbone.$?element:Backbone.$(element);this.el=this.$el[0];if(delegate!==false)this.delegateEvents();return this},delegateEvents:function(events){if(!(events||(events=_.result(this,"events"))))return this;this.undelegateEvents();for(var key in events){var method=events[key];if(!_.isFunction(method))method=this[events[key]];if(!method)continue;var match=key.match(delegateEventSplitter);var eventName=match[1],selector=match[2];method=_.bind(method,this);eventName+=".delegateEvents"+this.cid;if(selector===""){this.$el.on(eventName,method)}else{this.$el.on(eventName,selector,method)}}return this},undelegateEvents:function(){this.$el.off(".delegateEvents"+this.cid);return this},_ensureElement:function(){if(!this.el){var attrs=_.extend({},_.result(this,"attributes"));if(this.id)attrs.id=_.result(this,"id");if(this.className)attrs["class"]=_.result(this,"className");var $el=Backbone.$("<"+_.result(this,"tagName")+">").attr(attrs);this.setElement($el,false)}else{this.setElement(_.result(this,"el"),false)}}});Backbone.sync=function(method,model,options){var type=methodMap[method];_.defaults(options||(options={}),{emulateHTTP:Backbone.emulateHTTP,emulateJSON:Backbone.emulateJSON});var params={type:type,dataType:"json"};if(!options.url){params.url=_.result(model,"url")||urlError()}if(options.data==null&&model&&(method==="create"||method==="update"||method==="patch")){params.contentType="application/json";params.data=JSON.stringify(options.attrs||model.toJSON(options))}if(options.emulateJSON){params.contentType="application/x-www-form-urlencoded";params.data=params.data?{model:params.data}:{}}if(options.emulateHTTP&&(type==="PUT"||type==="DELETE"||type==="PATCH")){params.type="POST";if(options.emulateJSON)params.data._method=type;var beforeSend=options.beforeSend;options.beforeSend=function(xhr){xhr.setRequestHeader("X-HTTP-Method-Override",type);if(beforeSend)return beforeSend.apply(this,arguments)}}if(params.type!=="GET"&&!options.emulateJSON){params.processData=false}if(params.type==="PATCH"&&noXhrPatch){params.xhr=function(){return new ActiveXObject("Microsoft.XMLHTTP")}}var xhr=options.xhr=Backbone.ajax(_.extend(params,options));model.trigger("request",model,xhr,options);return xhr};var noXhrPatch=typeof window!=="undefined"&&!!window.ActiveXObject&&!(window.XMLHttpRequest&&(new XMLHttpRequest).dispatchEvent);var methodMap={create:"POST",update:"PUT",patch:"PATCH","delete":"DELETE",read:"GET"};Backbone.ajax=function(){return Backbone.$.ajax.apply(Backbone.$,arguments)};var Router=Backbone.Router=function(options){options||(options={});if(options.routes)this.routes=options.routes;this._bindRoutes();this.initialize.apply(this,arguments)};var optionalParam=/\((.*?)\)/g;var namedParam=/(\(\?)?:\w+/g;var splatParam=/\*\w+/g;var escapeRegExp=/[\-{}\[\]+?.,\\\^$|#\s]/g;_.extend(Router.prototype,Events,{initialize:function(){},route:function(route,name,callback){if(!_.isRegExp(route))route=this._routeToRegExp(route);if(_.isFunction(name)){callback=name;name=""}if(!callback)callback=this[name];var router=this;Backbone.history.route(route,function(fragment){var args=router._extractParameters(route,fragment);router.execute(callback,args);router.trigger.apply(router,["route:"+name].concat(args));router.trigger("route",name,args);Backbone.history.trigger("route",router,name,args)});return this},execute:function(callback,args){if(callback)callback.apply(this,args)},navigate:function(fragment,options){Backbone.history.navigate(fragment,options);return this},_bindRoutes:function(){if(!this.routes)return;this.routes=_.result(this,"routes");var route,routes=_.keys(this.routes);while((route=routes.pop())!=null){this.route(route,this.routes[route])}},_routeToRegExp:function(route){route=route.replace(escapeRegExp,"\\$&").replace(optionalParam,"(?:$1)?").replace(namedParam,function(match,optional){return optional?match:"([^/?]+)"}).replace(splatParam,"([^?]*?)");return new RegExp("^"+route+"(?:\\?(.*))?$")},_extractParameters:function(route,fragment){var params=route.exec(fragment).slice(1);return _.map(params,function(param,i){if(i===params.length-1)return param||null;return param?decodeURIComponent(param):null})}});var History=Backbone.History=function(){this.handlers=[];_.bindAll(this,"checkUrl");if(typeof window!=="undefined"){this.location=window.location;this.history=window.history}};var routeStripper=/^[#\/]|\s+$/g;var rootStripper=/^\/+|\/+$/g;var isExplorer=/msie [\w.]+/;var trailingSlash=/\/$/;var pathStripper=/#.*$/;History.started=false;_.extend(History.prototype,Events,{interval:50,atRoot:function(){return this.location.pathname.replace(/[^\/]$/,"$&/")===this.root},getHash:function(window){var match=(window||this).location.href.match(/#(.*)$/);return match?match[1]:""},getFragment:function(fragment,forcePushState){if(fragment==null){if(this._hasPushState||!this._wantsHashChange||forcePushState){fragment=decodeURI(this.location.pathname+this.location.search);var root=this.root.replace(trailingSlash,"");if(!fragment.indexOf(root))fragment=fragment.slice(root.length)}else{fragment=this.getHash()}}return fragment.replace(routeStripper,"")},start:function(options){if(History.started)throw new Error("Backbone.history has already been started");History.started=true;this.options=_.extend({root:"/"},this.options,options);this.root=this.options.root;this._wantsHashChange=this.options.hashChange!==false;this._wantsPushState=!!this.options.pushState;this._hasPushState=!!(this.options.pushState&&this.history&&this.history.pushState);var fragment=this.getFragment();var docMode=document.documentMode;var oldIE=isExplorer.exec(navigator.userAgent.toLowerCase())&&(!docMode||docMode<=7);this.root=("/"+this.root+"/").replace(rootStripper,"/");if(oldIE&&this._wantsHashChange){var frame=Backbone.$('<iframe src="javascript:0" tabindex="-1">');this.iframe=frame.hide().appendTo("body")[0].contentWindow;this.navigate(fragment)}if(this._hasPushState){Backbone.$(window).on("popstate",this.checkUrl)}else if(this._wantsHashChange&&"onhashchange"in window&&!oldIE){Backbone.$(window).on("hashchange",this.checkUrl)}else if(this._wantsHashChange){this._checkUrlInterval=setInterval(this.checkUrl,this.interval)}this.fragment=fragment;var loc=this.location;if(this._wantsHashChange&&this._wantsPushState){if(!this._hasPushState&&!this.atRoot()){this.fragment=this.getFragment(null,true);this.location.replace(this.root+"#"+this.fragment);return true}else if(this._hasPushState&&this.atRoot()&&loc.hash){this.fragment=this.getHash().replace(routeStripper,"");this.history.replaceState({},document.title,this.root+this.fragment)}}if(!this.options.silent)return this.loadUrl()},stop:function(){Backbone.$(window).off("popstate",this.checkUrl).off("hashchange",this.checkUrl);clearInterval(this._checkUrlInterval);History.started=false},route:function(route,callback){this.handlers.unshift({route:route,callback:callback})},checkUrl:function(e){var current=this.getFragment();if(current===this.fragment&&this.iframe){current=this.getFragment(this.getHash(this.iframe))}if(current===this.fragment)return false;if(this.iframe)this.navigate(current);this.loadUrl()},loadUrl:function(fragment){fragment=this.fragment=this.getFragment(fragment);return _.any(this.handlers,function(handler){if(handler.route.test(fragment)){handler.callback(fragment);return true}})},navigate:function(fragment,options){if(!History.started)return false;if(!options||options===true)options={trigger:!!options};var url=this.root+(fragment=this.getFragment(fragment||""));fragment=fragment.replace(pathStripper,"");if(this.fragment===fragment)return;this.fragment=fragment;if(fragment===""&&url!=="/")url=url.slice(0,-1);if(this._hasPushState){this.history[options.replace?"replaceState":"pushState"]({},document.title,url)}else if(this._wantsHashChange){this._updateHash(this.location,fragment,options.replace);if(this.iframe&&fragment!==this.getFragment(this.getHash(this.iframe))){if(!options.replace)this.iframe.document.open().close();this._updateHash(this.iframe.location,fragment,options.replace)}}else{return this.location.assign(url)}if(options.trigger)return this.loadUrl(fragment)},_updateHash:function(location,fragment,replace){if(replace){var href=location.href.replace(/(javascript:|#).*$/,"");location.replace(href+"#"+fragment)}else{location.hash="#"+fragment}}});Backbone.history=new History;var extend=function(protoProps,staticProps){var parent=this;var child;if(protoProps&&_.has(protoProps,"constructor")){child=protoProps.constructor}else{child=function(){return parent.apply(this,arguments)}}_.extend(child,parent,staticProps);var Surrogate=function(){this.constructor=child};Surrogate.prototype=parent.prototype;child.prototype=new Surrogate;if(protoProps)_.extend(child.prototype,protoProps);child.__super__=parent.prototype;return child};Model.extend=Collection.extend=Router.extend=View.extend=History.extend=extend;var urlError=function(){throw new Error('A "url" property or function must be specified')};var wrapError=function(model,options){var error=options.error;options.error=function(resp){if(error)error(model,resp,options);model.trigger("error",model,resp,options)}};return Backbone});function ord(string){var str=string+"",code=str.charCodeAt(0);if(55296<=code&&code<=56319){var hi=code;if(str.length===1){return code}var low=str.charCodeAt(1);return(hi-55296)*1024+(low-56320)+65536}if(56320<=code&&code<=57343){return code}return code}function UrlExists(url){var http=new XMLHttpRequest;http.open("HEAD",url,false);http.send();return http.status!=404}function showBlockMessage(blockElement){$.blockUI({message:$("#"+blockElement)})}function checkEmail(email){var regex=/^([a-zA-Z0-9_\.\-\+])+\@(([a-zA-Z0-9\-])+\.)+([a-zA-Z0-9]{2,4})+$/;return regex.test(email)}var STRENGTH_TOO_SHORT=1;var STRENGTH_WEAK=2;var STRENGTH_GOOD=3;var STRENGTH_STRONG=4;function checkStrength(password){var strength=0;if(password.length<6){return STRENGTH_TOO_SHORT}if(password.length>7)strength+=1;if(password.match(/([a-z].*[A-Z])|([A-Z].*[a-z])/))strength+=1;if(password.match(/([a-zA-Z])/)&&password.match(/([0-9])/))strength+=1;if(password.match(/([!,%,&,@,#,$,^,*,?,_,~])/))strength+=1;if(password.match(/(.*[!,%,&,@,#,$,^,*,?,_,~].*[!,",%,&,@,#,$,^,*,?,_,~])/))strength+=1;if(strength<2){$("#result").removeClass();$("#result").addClass("weak");return STRENGTH_WEAK}else if(strength==2){$("#result").removeClass();$("#result").addClass("good");return STRENGTH_GOOD}else{$("#result").removeClass();$("#result").addClass("strong");return STRENGTH_STRONG}}function showErrorMessage(message){$(".error-message").html(message);$(".error-message").fadeIn(10)}function hideErrorMessage(){}function hideNotificationMessage(){$(".notification").addClass("hidden")}function showNotificationMessage(notify_type,message){try{noty({text:message,layout:"topCenter",type:notify_type,killer:true,animation:{open:{opacity:"toggle"},close:{opacity:"toggle"},easing:"swing",speed:500},timeout:2e4,closeWith:["click"],template:'<div class="noty_message"><span class="noty_text"></span><div class="notyClose"></div></div>'})}catch(e){}}function showMessage(type,message,animate){if(type==null){var notificationClass="default"}else{var notificationClass=type}var notificationCount=$(".message-notification").length+1;if(animate){var animateClass=""}else{var animateClass="static active"}$("body").prepend('<div id="message-'+notificationCount+'" class="message-notification '+notificationClass+" "+animateClass+'">'+message+'<div class="close"></div></div>');if(animate){setTimeout(function(){$("#message-"+notificationCount).addClass("active")},5e3)}}Object.size=function(obj){var size=0,key;for(key in obj){if(obj.hasOwnProperty(key))size++}return size};function md5cycle(x,k){var a=x[0],b=x[1],c=x[2],d=x[3];a=ff(a,b,c,d,k[0],7,-680876936);d=ff(d,a,b,c,k[1],12,-389564586);c=ff(c,d,a,b,k[2],17,606105819);b=ff(b,c,d,a,k[3],22,-1044525330);a=ff(a,b,c,d,k[4],7,-176418897);d=ff(d,a,b,c,k[5],12,1200080426);c=ff(c,d,a,b,k[6],17,-1473231341);b=ff(b,c,d,a,k[7],22,-45705983);a=ff(a,b,c,d,k[8],7,1770035416);d=ff(d,a,b,c,k[9],12,-1958414417);c=ff(c,d,a,b,k[10],17,-42063);b=ff(b,c,d,a,k[11],22,-1990404162);a=ff(a,b,c,d,k[12],7,1804603682);d=ff(d,a,b,c,k[13],12,-40341101);c=ff(c,d,a,b,k[14],17,-1502002290);b=ff(b,c,d,a,k[15],22,1236535329);a=gg(a,b,c,d,k[1],5,-165796510);d=gg(d,a,b,c,k[6],9,-1069501632);c=gg(c,d,a,b,k[11],14,643717713);b=gg(b,c,d,a,k[0],20,-373897302);a=gg(a,b,c,d,k[5],5,-701558691);d=gg(d,a,b,c,k[10],9,38016083);c=gg(c,d,a,b,k[15],14,-660478335);b=gg(b,c,d,a,k[4],20,-405537848);a=gg(a,b,c,d,k[9],5,568446438);d=gg(d,a,b,c,k[14],9,-1019803690);c=gg(c,d,a,b,k[3],14,-187363961);b=gg(b,c,d,a,k[8],20,1163531501);a=gg(a,b,c,d,k[13],5,-1444681467);d=gg(d,a,b,c,k[2],9,-51403784);c=gg(c,d,a,b,k[7],14,1735328473);b=gg(b,c,d,a,k[12],20,-1926607734);a=hh(a,b,c,d,k[5],4,-378558);d=hh(d,a,b,c,k[8],11,-2022574463);c=hh(c,d,a,b,k[11],16,1839030562);b=hh(b,c,d,a,k[14],23,-35309556);a=hh(a,b,c,d,k[1],4,-1530992060);d=hh(d,a,b,c,k[4],11,1272893353);c=hh(c,d,a,b,k[7],16,-155497632);b=hh(b,c,d,a,k[10],23,-1094730640);a=hh(a,b,c,d,k[13],4,681279174);d=hh(d,a,b,c,k[0],11,-358537222);c=hh(c,d,a,b,k[3],16,-722521979);b=hh(b,c,d,a,k[6],23,76029189);a=hh(a,b,c,d,k[9],4,-640364487);d=hh(d,a,b,c,k[12],11,-421815835);c=hh(c,d,a,b,k[15],16,530742520);b=hh(b,c,d,a,k[2],23,-995338651);a=ii(a,b,c,d,k[0],6,-198630844);d=ii(d,a,b,c,k[7],10,1126891415);c=ii(c,d,a,b,k[14],15,-1416354905);b=ii(b,c,d,a,k[5],21,-57434055);a=ii(a,b,c,d,k[12],6,1700485571);d=ii(d,a,b,c,k[3],10,-1894986606);c=ii(c,d,a,b,k[10],15,-1051523);b=ii(b,c,d,a,k[1],21,-2054922799);a=ii(a,b,c,d,k[8],6,1873313359);d=ii(d,a,b,c,k[15],10,-30611744);c=ii(c,d,a,b,k[6],15,-1560198380);b=ii(b,c,d,a,k[13],21,1309151649);a=ii(a,b,c,d,k[4],6,-145523070);d=ii(d,a,b,c,k[11],10,-1120210379);c=ii(c,d,a,b,k[2],15,718787259);b=ii(b,c,d,a,k[9],21,-343485551);x[0]=add32(a,x[0]);x[1]=add32(b,x[1]);x[2]=add32(c,x[2]);x[3]=add32(d,x[3])}function cmn(q,a,b,x,s,t){a=add32(add32(a,q),add32(x,t));return add32(a<<s|a>>>32-s,b)}function ff(a,b,c,d,x,s,t){return cmn(b&c|~b&d,a,b,x,s,t)}function gg(a,b,c,d,x,s,t){return cmn(b&d|c&~d,a,b,x,s,t)}function hh(a,b,c,d,x,s,t){return cmn(b^c^d,a,b,x,s,t)}function ii(a,b,c,d,x,s,t){return cmn(c^(b|~d),a,b,x,s,t)}function md51(s){txt="";var n=s.length,state=[1732584193,-271733879,-1732584194,271733878],i;for(i=64;i<=s.length;i+=64){md5cycle(state,md5blk(s.substring(i-64,i)))}s=s.substring(i-64);var tail=[0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0];for(i=0;i<s.length;i++)tail[i>>2]|=s.charCodeAt(i)<<(i%4<<3);tail[i>>2]|=128<<(i%4<<3);if(i>55){md5cycle(state,tail);for(i=0;i<16;i++)tail[i]=0}tail[14]=n*8;md5cycle(state,tail);return state}function md5blk(s){var md5blks=[],i;for(i=0;i<64;i+=4){md5blks[i>>2]=s.charCodeAt(i)+(s.charCodeAt(i+1)<<8)+(s.charCodeAt(i+2)<<16)+(s.charCodeAt(i+3)<<24)}return md5blks}var hex_chr="0123456789abcdef".split("");function rhex(n){var s="",j=0;for(;j<4;j++)s+=hex_chr[n>>j*8+4&15]+hex_chr[n>>j*8&15];return s}function hex(x){for(var i=0;i<x.length;i++)x[i]=rhex(x[i]);return x.join("")}function md5(s){return hex(md51(s))}function add32(a,b){return a+b&4294967295}if(md5("hello")!="5d41402abc4b2a76b9719d911017c592"){function add32(x,y){var lsw=(x&65535)+(y&65535),msw=(x>>16)+(y>>16)+(lsw>>16);return msw<<16|lsw&65535}}function getElementPosition(param){var x=0,y=0;var obj=typeof param=="string"?document.getElementById(param):param;if(obj){x=obj.offsetLeft;y=obj.offsetTop;var body=document.getElementsByTagName("body")[0];while(obj.offsetParent&&obj!=body){x+=obj.offsetParent.offsetLeft;y+=obj.offsetParent.offsetTop;obj=obj.offsetParent}}return[x,y]}function sleep(ms){var dt=new Date;dt.setTime(dt.getTime()+ms);while((new Date).getTime()<dt.getTime());}function getURLParameter(name){var pid=undefined;var pathArray=window.location.pathname.split("/");try{pid=pathArray[pathArray.length-2];if(pid=="project"){pid=pathArray[2]}}catch(ex){}if(pid==undefined||pid==""||pid=="project"){pid=decodeURI((RegExp(name+"="+"(.+?)(&|$)").exec(location.search)||[,null])[1])}return pid}function copyToClipBoard(s){if(window.clipboardData&&clipboardData.setData){clipboardData.setData("Text",s)}else{netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");var clip=Components.classes["@mozilla.org/widget/clipboard;1"].createInstance(Components.interfaces.nsIClipboard);if(!clip)return;var trans=Components.classes["@mozilla.org/widget/transferable;1"].createInstance(Components.interfaces.nsITransferable);if(!trans)return;trans.addDataFlavor("text/unicode");var str=new Object;var len=new Object;var str=Components.classes["@mozilla.org/supports-string;1"].createInstance(Components.interfaces.nsISupportsString);str.data=s;trans.setTransferData("text/unicode",str,str.data.length*2);var clipid=Components.interfaces.nsIClipboard;if(!clip)return false;clip.setData(trans,null,clipid.kGlobalClipboard)}}function validateEmail(email){var email_test=/^([a-z0-9_\.-]+)@([\da-z\.-]+)\.([a-z\.]{2,6})$/;if(email==""||email==" "){$("input[name=email]").focus().before('<div class="error">Empty!</div>');$("input[name=email]").addClass("highlight");return false}else if(!email_test.test(email)){$("input[name=email]").select().before('<div class="error">Incorrect!</div>');$("input[name=email]").addClass("highlight");return false}else{return true}}function capitalise(string){if(string!=undefined){return string.charAt(0).toUpperCase()+string.slice(1).toLowerCase()}else{return""}}function strip(html){var tmp=document.createElement("DIV");tmp.innerHTML=html;return tmp.textContent||tmp.innerText||""}function encodeHTML(s){return s.replace(/&/g,"&amp;").replace(/</g,"&lt;").replace(/"/g,"&quot;")}Date.createFromMysql=function(mysql_string){if(typeof mysql_string==="string"){var t=mysql_string.split(/[- :]/);return new Date(t[0],t[1]-1,t[2],t[3]||0,t[4]||0,t[5]||0)}return null};function get_display_date(date_obj,m_format,is_year){var tm_format="M";var year="";if(m_format!=undefined){tm_format=m_format;if(is_year==true){year="yy"}}date_obj=date_obj.replace("T"," ");date_obj=date_obj.replace("Z","");var d1=Date.createFromMysql(date_obj);var date_is=parseInt($.datepicker.formatDate("d",d1));var dayFormat="th";if(date_is==1||date_is==21||date_is==31){dayFormat="st"}if(date_is==2||date_is==22){dayFormat="nd"}else if(date_is==3||date_is==23){dayFormat="rd"}var date_is=$.datepicker.formatDate("dd'"+dayFormat+"' "+tm_format+" "+year,d1);return date_is}function setEndOfContenteditable(contentEditableElement){var range,selection;if(document.createRange){range=document.createRange();range.selectNodeContents(contentEditableElement);range.collapse(false);selection=window.getSelection();selection.removeAllRanges();selection.addRange(range)}else if(document.selection){range=document.body.createTextRange();range.moveToElementText(contentEditableElement);range.collapse(false);range.select()}}function getGravatar(email,id){email=typeof email!=="undefined"?email:"murat@marvelapp.com";default_image=typeof default_image!=="undefined"?default_image:"https://secure.gravatar.com/avatar/a1e908deeac1ac1412168b63638be7e5?s=300";var gravatar="https://secure.gravatar.com/avatar/"+md5(email.toLowerCase().trim())+"?s=300&default="+encodeURIComponent(default_image);var randomColour=ord(email+id)%8;var colour="blanchedalmond";switch(randomColour){case 0:colour="lightcoral";
break;case 1:colour="peachpuff";break;case 2:colour="mediumslateblue";break;case 3:colour="navajowhite";break;case 4:colour="thistle";break;case 5:colour="dodgerblue";break;case 6:colour="tomato";break;case 7:colour="mediumspringgreen";break;case 8:colour="palegreen";break;case 9:colour="mediumseagreen";break;case 10:colour="lightblue";break}return{url:gravatar,colour:colour}}function getCookie(name){var cookieValue=null;try{if(document.cookie&&document.cookie!=""){var cookies=document.cookie.split(";");for(var i=0;i<cookies.length;i++){var cookie=jQuery.trim(cookies[i]);if(cookie.substring(0,name.length+1)==name+"="){cookieValue=decodeURIComponent(cookie.substring(name.length+1));break}}}}catch(except){}return cookieValue}var csrftoken=getCookie("csrftoken");function csrfSafeMethod(method){return/^(GET|HEAD|OPTIONS|TRACE)$/.test(method)}$.ajaxSetup({crossDomain:false,beforeSend:function(xhr,settings){if(!csrfSafeMethod(settings.type)){xhr.setRequestHeader("X-CSRFToken",csrftoken)}}});function encode_utf8(s){return unescape(encodeURIComponent(s))}function generateUUID(){var d=(new Date).getTime();var uuid="xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx".replace(/[xy]/g,function(c){var r=(d+Math.random()*16)%16|0;d=Math.floor(d/16);return(c=="x"?r:r&7|8).toString(16)});return uuid}(function($){$.fn.extend({limiter:function(limit,elem){$(this).on("keyup focus",function(){setCount(this,elem)});function setCount(src,elem){var chars=src.value.length;if(chars>limit){src.value=src.value.substr(0,limit);chars=limit}elem.html(limit-chars)}setCount($(this)[0],elem)}})})(jQuery);(function(factory){if(typeof define==="function"&&define.amd){define(["jquery"],factory)}else{factory(jQuery)}})(function($){var pluses=/\+/g;function encode(s){return config.raw?s:encodeURIComponent(s)}function decode(s){return config.raw?s:decodeURIComponent(s)}function stringifyCookieValue(value){return encode(config.json?JSON.stringify(value):String(value))}function parseCookieValue(s){if(s.indexOf('"')===0){s=s.slice(1,-1).replace(/\\"/g,'"').replace(/\\\\/g,"\\")}try{s=decodeURIComponent(s.replace(pluses," "));return config.json?JSON.parse(s):s}catch(e){}}function read(s,converter){var value=config.raw?s:parseCookieValue(s);return $.isFunction(converter)?converter(value):value}var config=$.cookie=function(key,value,options){if(value!==undefined&&!$.isFunction(value)){options=$.extend({},config.defaults,options);if(typeof options.expires==="number"){var days=options.expires,t=options.expires=new Date;t.setTime(+t+days*864e5)}return document.cookie=[encode(key),"=",stringifyCookieValue(value),options.expires?"; expires="+options.expires.toUTCString():"",options.path?"; path="+options.path:"",options.domain?"; domain="+options.domain:"",options.secure?"; secure":""].join("")}var result=key?undefined:{};var cookies=document.cookie?document.cookie.split("; "):[];for(var i=0,l=cookies.length;i<l;i++){var parts=cookies[i].split("=");var name=decode(parts.shift());var cookie=parts.join("=");if(key&&key===name){result=read(cookie,value);break}if(!key&&(cookie=read(cookie))!==undefined){result[name]=cookie}}return result};config.defaults={};$.removeCookie=function(key,options){if($.cookie(key)===undefined){return false}$.cookie(key,"",$.extend({},options,{expires:-1}));return!$.cookie(key)}});(function(c){var a=["DOMMouseScroll","mousewheel"];c.event.special.mousewheel={setup:function(){if(this.addEventListener){for(var d=a.length;d;){this.addEventListener(a[--d],b,false)}}else{this.onmousewheel=b}},teardown:function(){if(this.removeEventListener){for(var d=a.length;d;){this.removeEventListener(a[--d],b,false)}}else{this.onmousewheel=null}}};c.fn.extend({mousewheel:function(d){return d?this.bind("mousewheel",d):this.trigger("mousewheel")},unmousewheel:function(d){return this.unbind("mousewheel",d)}});function b(f){var d=[].slice.call(arguments,1),g=0,e=true;f=c.event.fix(f||window.event);f.type="mousewheel";if(f.wheelDelta){g=f.wheelDelta/120}if(f.detail){g=-f.detail/3}d.unshift(f,g);if(c.event.handle!=undefined){return c.event.handle.apply(this,d)}else{return undefined}}})(jQuery);function FastClick(layer){"use strict";var oldOnClick;this.trackingClick=false;this.trackingClickStart=0;this.targetElement=null;this.touchStartX=0;this.touchStartY=0;this.lastTouchIdentifier=0;this.touchBoundary=10;this.layer=layer;if(FastClick.notNeeded(layer)){return}function bind(method,context){return function(){return method.apply(context,arguments)}}if(deviceIsAndroid){layer.addEventListener("mouseover",bind(this.onMouse,this),true);layer.addEventListener("mousedown",bind(this.onMouse,this),true);layer.addEventListener("mouseup",bind(this.onMouse,this),true)}layer.addEventListener("click",bind(this.onClick,this),true);layer.addEventListener("touchstart",bind(this.onTouchStart,this),false);layer.addEventListener("touchmove",bind(this.onTouchMove,this),false);layer.addEventListener("touchend",bind(this.onTouchEnd,this),false);layer.addEventListener("touchcancel",bind(this.onTouchCancel,this),false);if(!Event.prototype.stopImmediatePropagation){layer.removeEventListener=function(type,callback,capture){var rmv=Node.prototype.removeEventListener;if(type==="click"){rmv.call(layer,type,callback.hijacked||callback,capture)}else{rmv.call(layer,type,callback,capture)}};layer.addEventListener=function(type,callback,capture){var adv=Node.prototype.addEventListener;if(type==="click"){adv.call(layer,type,callback.hijacked||(callback.hijacked=function(event){if(!event.propagationStopped){callback(event)}}),capture)}else{adv.call(layer,type,callback,capture)}}}if(typeof layer.onclick==="function"){oldOnClick=layer.onclick;layer.addEventListener("click",function(event){oldOnClick(event)},false);layer.onclick=null}}var deviceIsAndroid=navigator.userAgent.indexOf("Android")>0;var deviceIsIOS=/iP(ad|hone|od)/.test(navigator.userAgent);var deviceIsIOS4=deviceIsIOS&&/OS 4_\d(_\d)?/.test(navigator.userAgent);var deviceIsIOSWithBadTarget=deviceIsIOS&&/OS ([6-9]|\d{2})_\d/.test(navigator.userAgent);FastClick.prototype.needsClick=function(target){"use strict";switch(target.nodeName.toLowerCase()){case"button":case"select":case"textarea":if(target.disabled){return true}break;case"input":if(deviceIsIOS&&target.type==="file"||target.disabled){return true}break;case"label":case"video":return true}return/\bneedsclick\b/.test(target.className)};FastClick.prototype.needsFocus=function(target){"use strict";switch(target.nodeName.toLowerCase()){case"textarea":return true;case"select":return!deviceIsAndroid;case"input":switch(target.type){case"button":case"checkbox":case"file":case"image":case"radio":case"submit":return false}return!target.disabled&&!target.readOnly;default:return/\bneedsfocus\b/.test(target.className)}};FastClick.prototype.sendClick=function(targetElement,event){"use strict";var clickEvent,touch;if(document.activeElement&&document.activeElement!==targetElement){document.activeElement.blur()}touch=event.changedTouches[0];clickEvent=document.createEvent("MouseEvents");clickEvent.initMouseEvent(this.determineEventType(targetElement),true,true,window,1,touch.screenX,touch.screenY,touch.clientX,touch.clientY,false,false,false,false,0,null);clickEvent.forwardedTouchEvent=true;targetElement.dispatchEvent(clickEvent)};FastClick.prototype.determineEventType=function(targetElement){"use strict";if(deviceIsAndroid&&targetElement.tagName.toLowerCase()==="select"){return"mousedown"}return"click"};FastClick.prototype.focus=function(targetElement){"use strict";var length;if(deviceIsIOS&&targetElement.setSelectionRange&&targetElement.type.indexOf("date")!==0&&targetElement.type!=="time"){length=targetElement.value.length;targetElement.setSelectionRange(length,length)}else{targetElement.focus()}};FastClick.prototype.updateScrollParent=function(targetElement){"use strict";var scrollParent,parentElement;scrollParent=targetElement.fastClickScrollParent;if(!scrollParent||!scrollParent.contains(targetElement)){parentElement=targetElement;do{if(parentElement.scrollHeight>parentElement.offsetHeight){scrollParent=parentElement;targetElement.fastClickScrollParent=parentElement;break}parentElement=parentElement.parentElement}while(parentElement)}if(scrollParent){scrollParent.fastClickLastScrollTop=scrollParent.scrollTop}};FastClick.prototype.getTargetElementFromEventTarget=function(eventTarget){"use strict";if(eventTarget.nodeType===Node.TEXT_NODE){return eventTarget.parentNode}return eventTarget};FastClick.prototype.onTouchStart=function(event){"use strict";var targetElement,touch,selection;if(event.targetTouches.length>1){return true}targetElement=this.getTargetElementFromEventTarget(event.target);touch=event.targetTouches[0];if(deviceIsIOS){selection=window.getSelection();if(selection.rangeCount&&!selection.isCollapsed){return true}if(!deviceIsIOS4){if(touch.identifier===this.lastTouchIdentifier){event.preventDefault();return false}this.lastTouchIdentifier=touch.identifier;this.updateScrollParent(targetElement)}}this.trackingClick=true;this.trackingClickStart=event.timeStamp;this.targetElement=targetElement;this.touchStartX=touch.pageX;this.touchStartY=touch.pageY;if(event.timeStamp-this.lastClickTime<200){event.preventDefault()}return true};FastClick.prototype.touchHasMoved=function(event){"use strict";var touch=event.changedTouches[0],boundary=this.touchBoundary;if(Math.abs(touch.pageX-this.touchStartX)>boundary||Math.abs(touch.pageY-this.touchStartY)>boundary){return true}return false};FastClick.prototype.onTouchMove=function(event){"use strict";if(!this.trackingClick){return true}if(this.targetElement!==this.getTargetElementFromEventTarget(event.target)||this.touchHasMoved(event)){this.trackingClick=false;this.targetElement=null}return true};FastClick.prototype.findControl=function(labelElement){"use strict";if(labelElement.control!==undefined){return labelElement.control}if(labelElement.htmlFor){return document.getElementById(labelElement.htmlFor)}return labelElement.querySelector("button, input:not([type=hidden]), keygen, meter, output, progress, select, textarea")};FastClick.prototype.onTouchEnd=function(event){"use strict";var forElement,trackingClickStart,targetTagName,scrollParent,touch,targetElement=this.targetElement;if(!this.trackingClick){return true}if(event.timeStamp-this.lastClickTime<200){this.cancelNextClick=true;return true}this.cancelNextClick=false;this.lastClickTime=event.timeStamp;trackingClickStart=this.trackingClickStart;this.trackingClick=false;this.trackingClickStart=0;if(deviceIsIOSWithBadTarget){touch=event.changedTouches[0];targetElement=document.elementFromPoint(touch.pageX-window.pageXOffset,touch.pageY-window.pageYOffset)||targetElement;targetElement.fastClickScrollParent=this.targetElement.fastClickScrollParent}targetTagName=targetElement.tagName.toLowerCase();if(targetTagName==="label"){forElement=this.findControl(targetElement);if(forElement){this.focus(targetElement);if(deviceIsAndroid){return false}targetElement=forElement}}else if(this.needsFocus(targetElement)){if(event.timeStamp-trackingClickStart>100||deviceIsIOS&&window.top!==window&&targetTagName==="input"){this.targetElement=null;return false}this.focus(targetElement);this.sendClick(targetElement,event);if(!deviceIsIOS4||targetTagName!=="select"){this.targetElement=null;event.preventDefault()}return false}if(deviceIsIOS&&!deviceIsIOS4){scrollParent=targetElement.fastClickScrollParent;if(scrollParent&&scrollParent.fastClickLastScrollTop!==scrollParent.scrollTop){return true}}if(!this.needsClick(targetElement)){event.preventDefault();this.sendClick(targetElement,event)}return false};FastClick.prototype.onTouchCancel=function(){"use strict";this.trackingClick=false;this.targetElement=null};FastClick.prototype.onMouse=function(event){"use strict";if(!this.targetElement){return true}if(event.forwardedTouchEvent){return true}if(!event.cancelable){return true}if(!this.needsClick(this.targetElement)||this.cancelNextClick){if(event.stopImmediatePropagation){event.stopImmediatePropagation()}else{event.propagationStopped=true}event.stopPropagation();event.preventDefault();return false}return true};FastClick.prototype.onClick=function(event){"use strict";var permitted;if(this.trackingClick){this.targetElement=null;this.trackingClick=false;return true}if(event.target.type==="submit"&&event.detail===0){return true}permitted=this.onMouse(event);if(!permitted){this.targetElement=null}return permitted};FastClick.prototype.destroy=function(){"use strict";var layer=this.layer;if(deviceIsAndroid){layer.removeEventListener("mouseover",this.onMouse,true);layer.removeEventListener("mousedown",this.onMouse,true);layer.removeEventListener("mouseup",this.onMouse,true)}layer.removeEventListener("click",this.onClick,true);layer.removeEventListener("touchstart",this.onTouchStart,false);layer.removeEventListener("touchmove",this.onTouchMove,false);layer.removeEventListener("touchend",this.onTouchEnd,false);layer.removeEventListener("touchcancel",this.onTouchCancel,false)};FastClick.notNeeded=function(layer){"use strict";var metaViewport;var chromeVersion;if(typeof window.ontouchstart==="undefined"){return true}chromeVersion=+(/Chrome\/([0-9]+)/.exec(navigator.userAgent)||[,0])[1];if(chromeVersion){if(deviceIsAndroid){metaViewport=document.querySelector("meta[name=viewport]");if(metaViewport){if(metaViewport.content.indexOf("user-scalable=no")!==-1){return true}if(chromeVersion>31&&window.innerWidth<=window.screen.width){return true}}}else{return true}}if(layer.style.msTouchAction==="none"){return true}return false};FastClick.attach=function(layer){"use strict";return new FastClick(layer)};if(typeof define!=="undefined"&&define.amd){define(function(){"use strict";return FastClick})}else if(typeof module!=="undefined"&&module.exports){module.exports=FastClick.attach;module.exports.FastClick=FastClick}else{window.FastClick=FastClick}(function(){var e;e=function(){var e,t,n;t=[];e=function(t,r){var i;if(!t){return n()}else if(e.toType(t)==="function"){return e(document).ready(t)}else{i=e.getDOMObject(t,r);return n(i,t)}};n=function(e,r){e=e||t;e.__proto__=n.prototype;e.selector=r||"";return e};e.extend=function(e){Array.prototype.slice.call(arguments,1).forEach(function(t){var n,r;r=[];for(n in t){r.push(e[n]=t[n])}return r});return e};n.prototype=e.fn={};return e}();window.Quo=e;"$$"in window||(window.$$=e)}).call(this);(function(){(function(e){var t,n,r,i,u,a,o,s,c,f,l;t={TYPE:"GET",MIME:"json"};r={script:"text/javascript, application/javascript",json:"application/json",xml:"application/xml, text/xml",html:"text/html",text:"text/plain"};n=0;e.ajaxSettings={type:t.TYPE,async:true,success:{},error:{},context:null,dataType:t.MIME,headers:{},xhr:function(){return new window.XMLHttpRequest},crossDomain:false,timeout:0};e.ajax=function(n){var r,o,f,h;f=e.mix(e.ajaxSettings,n);if(f.type===t.TYPE){f.url+=e.serializeParameters(f.data,"?")}else{f.data=e.serializeParameters(f.data)}if(i(f.url)){return e.jsonp(f)}h=f.xhr();h.onreadystatechange=function(){if(h.readyState===4){clearTimeout(r);return c(h,f)}};h.open(f.type,f.url,f.async);s(h,f);if(f.timeout>0){r=setTimeout(function(){return l(h,f)},f.timeout)}try{h.send(f.data)}catch(d){o=d;h=o;a("Resource not found",h,f)}if(f.async){return h}else{return u(h,f)}};e.jsonp=function(t){var r,i,u,a;if(t.async){i="jsonp"+ ++n;u=document.createElement("script");a={abort:function(){e(u).remove();if(i in window){return window[i]={}}}};r=void 0;window[i]=function(n){clearTimeout(r);e(u).remove();delete window[i];return f(n,a,t)};u.src=t.url.replace(RegExp("=\\?"),"="+i);e("head").append(u);if(t.timeout>0){r=setTimeout(function(){return l(a,t)},t.timeout)}return a}else{return console.error("QuoJS.ajax: Unable to make jsonp synchronous call.")}};e.get=function(t,n,r,i){return e.ajax({url:t,data:n,success:r,dataType:i})};e.post=function(e,t,n,r){return o("POST",e,t,n,r)};e.put=function(e,t,n,r){return o("PUT",e,t,n,r)};e["delete"]=function(e,t,n,r){return o("DELETE",e,t,n,r)};e.json=function(n,r,i){return e.ajax({url:n,data:r,success:i,dataType:t.MIME})};e.serializeParameters=function(e,t){var n,r;if(t==null){t=""}r=t;for(n in e){if(e.hasOwnProperty(n)){if(r!==t){r+="&"}r+=""+encodeURIComponent(n)+"="+encodeURIComponent(e[n])}}if(r===t){return""}else{return r}};c=function(e,t){if(e.status>=200&&e.status<300||e.status===0){if(t.async){f(u(e,t),e,t)}}else{a("QuoJS.ajax: Unsuccesful request",e,t)}};f=function(e,t,n){n.success.call(n.context,e,t)};a=function(e,t,n){n.error.call(n.context,e,t,n)};s=function(e,t){var n;if(t.contentType){t.headers["Content-Type"]=t.contentType}if(t.dataType){t.headers["Accept"]=r[t.dataType]}for(n in t.headers){e.setRequestHeader(n,t.headers[n])}};l=function(e,t){e.onreadystatechange={};e.abort();a("QuoJS.ajax: Timeout exceeded",e,t)};o=function(t,n,r,i,u){return e.ajax({type:t,url:n,data:r,success:i,dataType:u,contentType:"application/x-www-form-urlencoded"})};u=function(e,n){var r,i;i=e.responseText;if(i){if(n.dataType===t.MIME){try{i=JSON.parse(i)}catch(u){r=u;i=r;a("QuoJS.ajax: Parse Error",e,n)}}else{if(n.dataType==="xml"){i=e.responseXML}}}return i};return i=function(e){return RegExp("=\\?").test(e)}})(Quo)}).call(this);(function(){(function(e){var t,n,r,i,u,a,o,s;t=[];i=Object.prototype;r=/^\s*<(\w+|!)[^>]*>/;u=document.createElement("table");a=document.createElement("tr");n={tr:document.createElement("tbody"),tbody:u,thead:u,tfoot:u,td:a,th:a,"*":document.createElement("div")};e.toType=function(e){return i.toString.call(e).match(/\s([a-z|A-Z]+)/)[1].toLowerCase()};e.isOwnProperty=function(e,t){return i.hasOwnProperty.call(e,t)};e.getDOMObject=function(t,n){var i,u,a;i=null;u=[1,9,11];a=e.toType(t);if(a==="array"){i=o(t)}else if(a==="string"&&r.test(t)){i=e.fragment(t.trim(),RegExp.$1);t=null}else if(a==="string"){i=e.query(document,t);if(n){if(i.length===1){i=e.query(i[0],n)}else{i=e.map(function(){return e.query(i,n)})}}}else if(u.indexOf(t.nodeType)>=0||t===window){i=[t];t=null}return i};e.map=function(t,n){var r,i,u,a;a=[];r=void 0;i=void 0;if(e.toType(t)==="array"){r=0;while(r<t.length){u=n(t[r],r);if(u!=null){a.push(u)}r++}}else{for(i in t){u=n(t[i],i);if(u!=null){a.push(u)}}}return s(a)};e.each=function(t,n){var r,i;r=void 0;i=void 0;if(e.toType(t)==="array"){r=0;while(r<t.length){if(n.call(t[r],r,t[r])===false){return t}r++}}else{for(i in t){if(n.call(t[i],i,t[i])===false){return t}}}return t};e.mix=function(){var t,n,r,i,u;r={};t=0;i=arguments.length;while(t<i){n=arguments[t];for(u in n){if(e.isOwnProperty(n,u)&&n[u]!==undefined){r[u]=n[u]}}t++}return r};e.fragment=function(t,r){var i;if(r==null){r="*"}if(!(r in n)){r="*"}i=n[r];i.innerHTML=""+t;return e.each(Array.prototype.slice.call(i.childNodes),function(){return i.removeChild(this)})};e.fn.map=function(t){return e.map(this,function(e,n){return t.call(e,n,e)})};e.fn.instance=function(e){return this.map(function(){return this[e]})};e.fn.filter=function(t){return e([].filter.call(this,function(n){return n.parentNode&&e.query(n.parentNode,t).indexOf(n)>=0}))};e.fn.forEach=t.forEach;e.fn.indexOf=t.indexOf;o=function(e){return e.filter(function(e){return e!==void 0&&e!==null})};return s=function(e){if(e.length>0){return[].concat.apply([],e)}else{return e}}})(Quo)}).call(this);(function(){(function(e){e.fn.attr=function(t,n){if(this.length===0){null}if(e.toType(t)==="string"&&n===void 0){return this[0].getAttribute(t)}else{return this.each(function(){return this.setAttribute(t,n)})}};e.fn.removeAttr=function(e){return this.each(function(){return this.removeAttribute(e)})};e.fn.data=function(e,t){return this.attr("data-"+e,t)};e.fn.removeData=function(e){return this.removeAttr("data-"+e)};e.fn.val=function(t){if(e.toType(t)==="string"){return this.each(function(){return this.value=t})}else{if(this.length>0){return this[0].value}else{return null}}};e.fn.show=function(){return this.style("display","block")};e.fn.hide=function(){return this.style("display","none")};e.fn.height=function(){var e;e=this.offset();return e.height};e.fn.width=function(){var e;e=this.offset();return e.width};e.fn.offset=function(){var e;e=this[0].getBoundingClientRect();return{left:e.left+window.pageXOffset,top:e.top+window.pageYOffset,width:e.width,height:e.height}};return e.fn.remove=function(){return this.each(function(){if(this.parentNode!=null){return this.parentNode.removeChild(this)}})}})(Quo)}).call(this);(function(){(function(e){var t,n,r,i,u,a,o;r=null;t=/WebKit\/([\d.]+)/;n={Android:/(Android)\s+([\d.]+)/,ipad:/(iPad).*OS\s([\d_]+)/,iphone:/(iPhone\sOS)\s([\d_]+)/,Blackberry:/(BlackBerry|BB10|Playbook).*Version\/([\d.]+)/,FirefoxOS:/(Mozilla).*Mobile[^\/]*\/([\d\.]*)/,webOS:/(webOS|hpwOS)[\s\/]([\d.]+)/};e.isMobile=function(){r=r||u();return r.isMobile&&r.os.name!=="firefoxOS"};e.environment=function(){r=r||u();return r};e.isOnline=function(){return navigator.onLine};u=function(){var e,t;t=navigator.userAgent;e={};e.browser=i(t);e.os=a(t);e.isMobile=!!e.os;e.screen=o();return e};i=function(e){var n;n=e.match(t);if(n){return n[0]}else{return e}};a=function(e){var t,r,i;t=null;for(r in n){i=e.match(n[r]);if(i){t={name:r==="iphone"||r==="ipad"?"ios":r,version:i[2].replace("_",".")};break}}return t};return o=function(){return{width:window.innerWidth,height:window.innerHeight}}})(Quo)}).call(this);(function(){(function(e){var t,n,r,i,u,a,o,s,c,f,l,h;t=1;i={};r={preventDefault:"isDefaultPrevented",stopImmediatePropagation:"isImmediatePropagationStopped",stopPropagation:"isPropagationStopped"};n={touchstart:"mousedown",touchmove:"mousemove",touchend:"mouseup",touch:"click",doubletap:"dblclick",orientationchange:"resize"};u=/complete|loaded|interactive/;e.fn.on=function(t,n,r){if(n==="undefined"||e.toType(n)==="function"){return this.bind(t,n)}else{return this.delegate(n,t,r)}};e.fn.off=function(t,n,r){if(n==="undefined"||e.toType(n)==="function"){return this.unbind(t,n)}else{return this.undelegate(n,t,r)}};e.fn.ready=function(t){if(u.test(document.readyState)){return t(e)}else{return e.fn.addEvent(document,"DOMContentLoaded",function(){return t(e)})}};e.Event=function(e,t){var n,r;n=document.createEvent("Events");n.initEvent(e,true,true,null,null,null,null,null,null,null,null,null,null,null,null);if(t){for(r in t){n[r]=t[r]}}return n};e.fn.bind=function(e,t){return this.each(function(){l(this,e,t)})};e.fn.unbind=function(e,t){return this.each(function(){h(this,e,t)})};e.fn.delegate=function(t,n,r){return this.each(function(i,u){l(u,n,r,t,function(n){return function(r){var i,o;o=e(r.target).closest(t,u).get(0);if(o){i=e.extend(a(r),{currentTarget:o,liveFired:u});return n.apply(o,[i].concat([].slice.call(arguments,1)))}}})})};e.fn.undelegate=function(e,t,n){return this.each(function(){h(this,t,n,e)})};e.fn.trigger=function(t,n,r){if(e.toType(t)==="string"){t=e.Event(t,n)}if(r!=null){t.originalEvent=r}return this.each(function(){this.dispatchEvent(t)})};e.fn.addEvent=function(e,t,n){if(e.addEventListener){return e.addEventListener(t,n,false)}else if(e.attachEvent){return e.attachEvent("on"+t,n)}else{return e["on"+t]=n}};e.fn.removeEvent=function(e,t,n){if(e.removeEventListener){return e.removeEventListener(t,n,false)}else if(e.detachEvent){return e.detachEvent("on"+t,n)}else{return e["on"+t]=null}};l=function(t,n,r,u,a){var c,l,h,d;n=s(n);h=f(t);l=i[h]||(i[h]=[]);c=a&&a(r,n);d={event:n,callback:r,selector:u,proxy:o(c,r,t),delegate:c,index:l.length};l.push(d);return e.fn.addEvent(t,d.event,d.proxy)};h=function(t,n,r,u){var a;n=s(n);a=f(t);return c(a,n,r,u).forEach(function(n){delete i[a][n.index];return e.fn.removeEvent(t,n.event,n.proxy)})};f=function(e){return e._id||(e._id=t++)};s=function(t){var r;r=e.isMobile()?t:n[t];return r||t};o=function(e,t,n){var r;t=e||t;r=function(e){var r;r=t.apply(n,[e].concat(e.data));if(r===false){e.preventDefault()}return r};return r};c=function(e,t,n,r){return(i[e]||[]).filter(function(e){return e&&(!t||e.event===t)&&(!n||e.callback===n)&&(!r||e.selector===r)})};return a=function(t){var n;n=e.extend({originalEvent:t},t);e.each(r,function(e,r){n[e]=function(){this[r]=function(){return true};return t[e].apply(t,arguments)};return n[r]=function(){return false}});return n}})(Quo)}).call(this);(function(){(function($$){var CURRENT_TOUCH,EVENT,FIRST_TOUCH,GESTURE,GESTURES,HOLD_DELAY,TAPS,TOUCH_TIMEOUT,_angle,_capturePinch,_captureRotation,_cleanGesture,_distance,_fingersPosition,_getTouches,_hold,_isSwipe,_listenTouches,_onTouchEnd,_onTouchMove,_onTouchStart,_parentIfText,_swipeDirection,_trigger;TAPS=null;EVENT=void 0;GESTURE={};FIRST_TOUCH=[];CURRENT_TOUCH=[];TOUCH_TIMEOUT=void 0;HOLD_DELAY=650;GESTURES=["touch","tap","singleTap","doubleTap","hold","swipe","swiping","swipeLeft","swipeRight","swipeUp","swipeDown","rotate","rotating","rotateLeft","rotateRight","pinch","pinching","pinchIn","pinchOut","drag","dragLeft","dragRight","dragUp","dragDown"];GESTURES.forEach(function(e){$$.fn[e]=function(t){var n;n=e==="touch"?"touchend":e;return $$(document.body).delegate(this.selector,n,t)};return this});$$(document).ready(function(){return _listenTouches()});_listenTouches=function(){var e;e=$$(document.body);e.bind("touchstart",_onTouchStart);e.bind("touchmove",_onTouchMove);e.bind("touchend",_onTouchEnd);return e.bind("touchcancel",_cleanGesture)};_onTouchStart=function(e){var t,n,r,i;EVENT=e;r=Date.now();t=r-(GESTURE.last||r);TOUCH_TIMEOUT&&clearTimeout(TOUCH_TIMEOUT);i=_getTouches(e);n=i.length;FIRST_TOUCH=_fingersPosition(i,n);GESTURE.el=$$(_parentIfText(i[0].target));GESTURE.fingers=n;GESTURE.last=r;if(!GESTURE.taps){GESTURE.taps=0}GESTURE.taps++;if(n===1){if(n>=1){GESTURE.gap=t>0&&t<=250}return setTimeout(_hold,HOLD_DELAY)}else if(n===2){GESTURE.initial_angle=parseInt(_angle(FIRST_TOUCH),10);GESTURE.initial_distance=parseInt(_distance(FIRST_TOUCH),10);GESTURE.angle_difference=0;return GESTURE.distance_difference=0}};_onTouchMove=function(e){var t,n,r;EVENT=e;if(GESTURE.el){r=_getTouches(e);t=r.length;if(t===GESTURE.fingers){CURRENT_TOUCH=_fingersPosition(r,t);n=_isSwipe(e);if(n){GESTURE.prevSwipe=true}if(n||GESTURE.prevSwipe===true){_trigger("swiping")}if(t===2){_captureRotation();_capturePinch();e.preventDefault()}}else{_cleanGesture()}}return true};_isSwipe=function(e){var t,n,r;t=false;if(CURRENT_TOUCH[0]){n=Math.abs(FIRST_TOUCH[0].x-CURRENT_TOUCH[0].x)>30;r=Math.abs(FIRST_TOUCH[0].y-CURRENT_TOUCH[0].y)>30;t=GESTURE.el&&(n||r)}return t};_onTouchEnd=function(e){var t,n,r,i,u;EVENT=e;_trigger("touch");if(GESTURE.fingers===1){if(GESTURE.taps===2&&GESTURE.gap){_trigger("doubleTap");_cleanGesture()}else if(_isSwipe()||GESTURE.prevSwipe){_trigger("swipe");u=_swipeDirection(FIRST_TOUCH[0].x,CURRENT_TOUCH[0].x,FIRST_TOUCH[0].y,CURRENT_TOUCH[0].y);_trigger("swipe"+u);_cleanGesture()}else{_trigger("tap");if(GESTURE.taps===1){TOUCH_TIMEOUT=setTimeout(function(){_trigger("singleTap");return _cleanGesture()},100)}}}else{t=false;if(GESTURE.angle_difference!==0){_trigger("rotate",{angle:GESTURE.angle_difference});i=GESTURE.angle_difference>0?"rotateRight":"rotateLeft";_trigger(i,{angle:GESTURE.angle_difference});t=true}if(GESTURE.distance_difference!==0){_trigger("pinch",{angle:GESTURE.distance_difference});r=GESTURE.distance_difference>0?"pinchOut":"pinchIn";_trigger(r,{distance:GESTURE.distance_difference});t=true}if(!t&&CURRENT_TOUCH[0]){if(Math.abs(FIRST_TOUCH[0].x-CURRENT_TOUCH[0].x)>10||Math.abs(FIRST_TOUCH[0].y-CURRENT_TOUCH[0].y)>10){_trigger("drag");n=_swipeDirection(FIRST_TOUCH[0].x,CURRENT_TOUCH[0].x,FIRST_TOUCH[0].y,CURRENT_TOUCH[0].y);_trigger("drag"+n)}}_cleanGesture()}return EVENT=void 0};_fingersPosition=function(e,t){var n,r;r=[];n=0;e=e[0].targetTouches?e[0].targetTouches:e;while(n<t){r.push({x:e[n].pageX,y:e[n].pageY});n++}return r};_captureRotation=function(){var angle,diff,i,symbol;angle=parseInt(_angle(CURRENT_TOUCH),10);diff=parseInt(GESTURE.initial_angle-angle,10);if(Math.abs(diff)>20||GESTURE.angle_difference!==0){i=0;symbol=GESTURE.angle_difference<0?"-":"+";while(Math.abs(diff-GESTURE.angle_difference)>90&&i++<10){eval("diff "+symbol+"= 180;")}GESTURE.angle_difference=parseInt(diff,10);return _trigger("rotating",{angle:GESTURE.angle_difference})}};_capturePinch=function(){var e,t;t=parseInt(_distance(CURRENT_TOUCH),10);e=GESTURE.initial_distance-t;if(Math.abs(e)>10){GESTURE.distance_difference=e;return _trigger("pinching",{distance:e})}};_trigger=function(e,t){if(GESTURE.el){t=t||{};if(CURRENT_TOUCH[0]){t.iniTouch=GESTURE.fingers>1?FIRST_TOUCH:FIRST_TOUCH[0];t.currentTouch=GESTURE.fingers>1?CURRENT_TOUCH:CURRENT_TOUCH[0]}return GESTURE.el.trigger(e,t,EVENT)}};_cleanGesture=function(e){FIRST_TOUCH=[];CURRENT_TOUCH=[];GESTURE={};return clearTimeout(TOUCH_TIMEOUT)};_angle=function(e){var t,n,r;t=e[0];n=e[1];r=Math.atan((n.y-t.y)*-1/(n.x-t.x))*(180/Math.PI);if(r<0){return r+180}else{return r}};_distance=function(e){var t,n;t=e[0];n=e[1];return Math.sqrt((n.x-t.x)*(n.x-t.x)+(n.y-t.y)*(n.y-t.y))*-1};_getTouches=function(e){if($$.isMobile()){return e.touches}else{return[e]}};_parentIfText=function(e){if("tagName"in e){return e}else{return e.parentNode}};_swipeDirection=function(e,t,n,r){var i,u;i=Math.abs(e-t);u=Math.abs(n-r);if(i>=u){if(e-t>0){return"Left"}else{return"Right"}}else{if(n-r>0){return"Up"}else{return"Down"}}};return _hold=function(){if(GESTURE.last&&Date.now()-GESTURE.last>=HOLD_DELAY){_trigger("hold");return GESTURE.taps=0}}})(Quo)}).call(this);(function(){(function(e){e.fn.text=function(t){if(t||e.toType(t)==="number"){return this.each(function(){return this.textContent=t})}else{return this[0].textContent}};e.fn.html=function(t){var n;n=e.toType(t);if(t||n==="number"||n==="string"){return this.each(function(){var e,r,i,u;if(n==="string"||n==="number"){return this.innerHTML=t}else{this.innerHTML=null;if(n==="array"){u=[];for(r=0,i=t.length;r<i;r++){e=t[r];u.push(this.appendChild(e))}return u}else{return this.appendChild(t)}}})}else{return this[0].innerHTML}};e.fn.append=function(t){var n;n=e.toType(t);return this.each(function(){var e=this;if(n==="string"){return this.insertAdjacentHTML("beforeend",t)}else if(n==="array"){return t.each(function(t,n){return e.appendChild(n)})}else{return this.appendChild(t)}})};e.fn.prepend=function(t){var n;n=e.toType(t);return this.each(function(){var e=this;if(n==="string"){return this.insertAdjacentHTML("afterbegin",t)}else if(n==="array"){return t.each(function(t,n){return e.insertBefore(n,e.firstChild)})}else{return this.insertBefore(t,this.firstChild)}})};e.fn.replaceWith=function(t){var n;n=e.toType(t);this.each(function(){var e=this;if(this.parentNode){if(n==="string"){return this.insertAdjacentHTML("beforeBegin",t)}else if(n==="array"){return t.each(function(t,n){return e.parentNode.insertBefore(n,e)})}else{return this.parentNode.insertBefore(t,this)}}});return this.remove()};return e.fn.empty=function(){return this.each(function(){return this.innerHTML=null})}})(Quo)}).call(this);(function(){(function(e){var t,n,r,i,u,a;r="parentNode";t=/^\.([\w-]+)$/;n=/^#[\w\d-]+$/;i=/^[\w-]+$/;e.query=function(e,r){var u;r=r.trim();if(t.test(r)){u=e.getElementsByClassName(r.replace(".",""))}else if(i.test(r)){u=e.getElementsByTagName(r)}else if(n.test(r)&&e===document){u=e.getElementById(r.replace("#",""));if(!u){u=[]}}else{u=e.querySelectorAll(r)}if(u.nodeType){return[u]}else{return Array.prototype.slice.call(u)}};e.fn.find=function(t){var n;if(this.length===1){n=Quo.query(this[0],t)}else{n=this.map(function(){return Quo.query(this,t)})}return e(n)};e.fn.parent=function(e){var t;t=e?a(this):this.instance(r);return u(t,e)};e.fn.siblings=function(e){var t;t=this.map(function(e,t){return Array.prototype.slice.call(t.parentNode.children).filter(function(e){return e!==t})});return u(t,e)};e.fn.children=function(e){var t;t=this.map(function(){return Array.prototype.slice.call(this.children)});return u(t,e)};e.fn.get=function(e){if(e===undefined){return this}else{return this[e]}};e.fn.first=function(){return e(this[0])};e.fn.last=function(){return e(this[this.length-1])};e.fn.closest=function(t,n){var r,i;i=this[0];r=e(t);if(!r.length){i=null}while(i&&r.indexOf(i)<0){i=i!==n&&i!==document&&i.parentNode
}return e(i)};e.fn.each=function(e){this.forEach(function(t,n){return e.call(t,n,t)});return this};a=function(t){var n;n=[];while(t.length>0){t=e.map(t,function(e){if((e=e.parentNode)&&e!==document&&n.indexOf(e)<0){n.push(e);return e}})}return n};return u=function(t,n){if(n===undefined){return e(t)}else{return e(t).filter(n)}}})(Quo)}).call(this);(function(){(function(e){var t,n,r;t=["-webkit-","-moz-","-ms-","-o-",""];e.fn.addClass=function(e){return this.each(function(){if(!r(e,this.className)){this.className+=" "+e;return this.className=this.className.trim()}})};e.fn.removeClass=function(e){return this.each(function(){if(!e){return this.className=""}else{if(r(e,this.className)){return this.className=this.className.replace(e," ").replace(/\s+/g," ").trim()}}})};e.fn.toggleClass=function(e){return this.each(function(){if(r(e,this.className)){return this.className=this.className.replace(e," ")}else{this.className+=" "+e;return this.className=this.className.trim()}})};e.fn.hasClass=function(e){return r(e,this[0].className)};e.fn.style=function(e,t){if(t){return this.each(function(){return this.style[e]=t})}else{return this[0].style[e]||n(this[0],e)}};e.fn.css=function(e,t){return this.style(e,t)};e.fn.vendor=function(e,n){var r,i,u,a;a=[];for(i=0,u=t.length;i<u;i++){r=t[i];a.push(this.style(""+r+e,n))}return a};r=function(e,t){var n;n=t.split(/\s+/g);return n.indexOf(e)>=0};return n=function(e,t){return document.defaultView.getComputedStyle(e,"")[t]}})(Quo)}).call(this);(function($){$.fn.antiscroll=function(options){return this.each(function(){if($(this).data("antiscroll")){$(this).data("antiscroll").destroy()}$(this).data("antiscroll",new $.Antiscroll(this,options))})};$.Antiscroll=Antiscroll;function Antiscroll(el,opts){this.el=$(el);this.options=opts||{};this.x=false!==this.options.x||this.options.forceHorizontal;this.y=false!==this.options.y||this.options.forceVertical;this.autoHide=false!==this.options.autoHide;this.padding=undefined==this.options.padding?3:this.options.padding;this.inner=this.el.find(".antiscroll-inner");this.inner.css({width:"+="+(this.y?scrollbarSize():0),height:"+="+(this.x?scrollbarSize():0)});this.refresh()}Antiscroll.prototype.refresh=function(){var needHScroll=this.inner.get(0).scrollWidth>this.el.width()+(this.y?scrollbarSize():0),needVScroll=this.inner.get(0).scrollHeight>this.el.height()+(this.x?scrollbarSize():0);if(this.x){if(!this.horizontal&&needHScroll){this.horizontal=new Scrollbar.Horizontal(this)}else if(this.horizontal&&!needHScroll){this.horizontal.destroy();this.horizontal=null}else if(this.horizontal){this.horizontal.update()}}if(this.y){if(!this.vertical&&needVScroll){this.vertical=new Scrollbar.Vertical(this)}else if(this.vertical&&!needVScroll){this.vertical.destroy();this.vertical=null}else if(this.vertical){this.vertical.update()}}};Antiscroll.prototype.destroy=function(){if(this.horizontal){this.horizontal.destroy();this.horizontal=null}if(this.vertical){this.vertical.destroy();this.vertical=null}return this};Antiscroll.prototype.rebuild=function(){this.destroy();this.inner.attr("style","");Antiscroll.call(this,this.el,this.options);return this};function Scrollbar(pane){this.pane=pane;this.pane.el.append(this.el);this.innerEl=this.pane.inner.get(0);this.dragging=false;this.enter=false;this.shown=false;this.pane.el.mouseenter($.proxy(this,"mouseenter"));this.pane.el.mouseleave($.proxy(this,"mouseleave"));this.el.mousedown($.proxy(this,"mousedown"));this.innerPaneScrollListener=$.proxy(this,"scroll");this.pane.inner.scroll(this.innerPaneScrollListener);this.innerPaneMouseWheelListener=$.proxy(this,"mousewheel");this.pane.inner.bind("mousewheel",this.innerPaneMouseWheelListener);var initialDisplay=this.pane.options.initialDisplay;if(initialDisplay!==false){this.show();if(this.pane.autoHide){this.hiding=setTimeout($.proxy(this,"hide"),parseInt(initialDisplay,10)||3e3)}}}Scrollbar.prototype.destroy=function(){this.el.remove();this.pane.inner.unbind("scroll",this.innerPaneScrollListener);this.pane.inner.unbind("mousewheel",this.innerPaneMouseWheelListener);return this};Scrollbar.prototype.mouseenter=function(){this.enter=true;this.show()};Scrollbar.prototype.mouseleave=function(){this.enter=false;if(!this.dragging){if(this.pane.autoHide){this.hide()}}};Scrollbar.prototype.scroll=function(){if(!this.shown){this.show();if(!this.enter&&!this.dragging){if(this.pane.autoHide){this.hiding=setTimeout($.proxy(this,"hide"),1500)}}}this.update()};Scrollbar.prototype.mousedown=function(ev){ev.preventDefault();this.dragging=true;this.startPageY=ev.pageY-parseInt(this.el.css("top"),10);this.startPageX=ev.pageX-parseInt(this.el.css("left"),10);this.el[0].ownerDocument.onselectstart=function(){return false};var pane=this.pane,move=$.proxy(this,"mousemove"),self=this;$(this.el[0].ownerDocument).mousemove(move).mouseup(function(){self.dragging=false;this.onselectstart=null;$(this).unbind("mousemove",move);if(!self.enter){self.hide()}})};Scrollbar.prototype.show=function(duration){if(!this.shown&&this.update()){this.el.addClass("antiscroll-scrollbar-shown");if(this.hiding){clearTimeout(this.hiding);this.hiding=null}this.shown=true}};Scrollbar.prototype.hide=function(){if(this.pane.autoHide!==false&&this.shown){this.el.removeClass("antiscroll-scrollbar-shown");this.shown=false}};Scrollbar.Horizontal=function(pane){this.el=$('<div class="antiscroll-scrollbar antiscroll-scrollbar-horizontal"/>',pane.el);Scrollbar.call(this,pane)};inherits(Scrollbar.Horizontal,Scrollbar);Scrollbar.Horizontal.prototype.update=function(){var paneWidth=this.pane.el.width(),trackWidth=paneWidth-this.pane.padding*2,innerEl=this.pane.inner.get(0);this.el.css("width",trackWidth*paneWidth/innerEl.scrollWidth).css("left",trackWidth*innerEl.scrollLeft/innerEl.scrollWidth);return paneWidth<innerEl.scrollWidth};Scrollbar.Horizontal.prototype.mousemove=function(ev){var trackWidth=this.pane.el.width()-this.pane.padding*2,pos=ev.pageX-this.startPageX,barWidth=this.el.width(),innerEl=this.pane.inner.get(0);var y=Math.min(Math.max(pos,0),trackWidth-barWidth);innerEl.scrollLeft=(innerEl.scrollWidth-this.pane.el.width())*y/(trackWidth-barWidth)};Scrollbar.Horizontal.prototype.mousewheel=function(ev,delta,x,y){if(x<0&&0==this.pane.inner.get(0).scrollLeft||x>0&&this.innerEl.scrollLeft+Math.ceil(this.pane.el.width())==this.innerEl.scrollWidth){ev.preventDefault();return false}};Scrollbar.Vertical=function(pane){this.el=$('<div class="antiscroll-scrollbar antiscroll-scrollbar-vertical"/>',pane.el);Scrollbar.call(this,pane)};inherits(Scrollbar.Vertical,Scrollbar);Scrollbar.Vertical.prototype.update=function(){var paneHeight=this.pane.el.height(),trackHeight=paneHeight-this.pane.padding*2,innerEl=this.innerEl;var scrollbarHeight=trackHeight*paneHeight/innerEl.scrollHeight;scrollbarHeight=scrollbarHeight<20?20:scrollbarHeight;var topPos=trackHeight*innerEl.scrollTop/innerEl.scrollHeight;if(topPos+scrollbarHeight>trackHeight){var diff=topPos+scrollbarHeight-trackHeight;topPos=topPos-diff-3}this.el.css("height",scrollbarHeight).css("top",topPos);return paneHeight<innerEl.scrollHeight};Scrollbar.Vertical.prototype.mousemove=function(ev){var paneHeight=this.pane.el.height(),trackHeight=paneHeight-this.pane.padding*2,pos=ev.pageY-this.startPageY,barHeight=this.el.height(),innerEl=this.innerEl;var y=Math.min(Math.max(pos,0),trackHeight-barHeight);innerEl.scrollTop=(innerEl.scrollHeight-paneHeight)*y/(trackHeight-barHeight)};Scrollbar.Vertical.prototype.mousewheel=function(ev,delta,x,y){if(y>0&&0==this.innerEl.scrollTop||y<0&&this.innerEl.scrollTop+Math.ceil(this.pane.el.height())==this.innerEl.scrollHeight){ev.preventDefault();return false}};function inherits(ctorA,ctorB){function f(){}f.prototype=ctorB.prototype;ctorA.prototype=new f}var size;function scrollbarSize(){if(size===undefined){var div=$('<div class="antiscroll-inner" style="width:50px;height:50px;overflow-y:scroll;'+'position:absolute;top:-200px;left:-200px;"><div style="height:100px;width:100%"/>'+"</div>");$("body").append(div);var w1=$(div).innerWidth();var w2=$("div",div).innerWidth();$(div).remove();size=w1-w2}return size}})(jQuery);(function(factory){if(typeof module==="function"){module.exports=factory(this.jQuery||require("jquery"))}else{this.NProgress=factory(this.jQuery)}})(function($){var NProgress={};NProgress.version="0.1.2";var Settings=NProgress.settings={minimum:.08,easing:"ease",positionUsing:"",speed:200,trickle:true,trickleRate:.02,trickleSpeed:800,showSpinner:true,template:'<div class="bar" role="bar"><div class="peg"></div></div><div class="spinner" role="spinner"><div class="spinner-icon"></div></div>'};NProgress.configure=function(options){$.extend(Settings,options);return this};NProgress.status=null;NProgress.set=function(n){var started=NProgress.isStarted();n=clamp(n,Settings.minimum,1);NProgress.status=n===1?null:n;var $progress=NProgress.render(!started),$bar=$progress.find('[role="bar"]'),speed=Settings.speed,ease=Settings.easing;$progress[0].offsetWidth;$progress.queue(function(next){if(Settings.positionUsing==="")Settings.positionUsing=NProgress.getPositioningCSS();$bar.css(barPositionCSS(n,speed,ease));if(n===1){$progress.css({transition:"none",opacity:1});$progress[0].offsetWidth;setTimeout(function(){$progress.css({transition:"all "+speed+"ms linear",opacity:0});setTimeout(function(){NProgress.remove();next()},speed)},speed)}else{setTimeout(next,speed)}});return this};NProgress.isStarted=function(){return typeof NProgress.status==="number"};NProgress.start=function(){if(!NProgress.status)NProgress.set(0);var work=function(){setTimeout(function(){if(!NProgress.status)return;NProgress.trickle();work()},Settings.trickleSpeed)};if(Settings.trickle)work();return this};NProgress.done=function(force){if(!force&&!NProgress.status)return this;return NProgress.inc(.3+.5*Math.random()).set(1)};NProgress.inc=function(amount){var n=NProgress.status;if(!n){return NProgress.start()}else{if(typeof amount!=="number"){amount=(1-n)*clamp(Math.random()*n,.1,.95)}n=clamp(n+amount,0,.994);return NProgress.set(n)}};NProgress.trickle=function(){return NProgress.inc(Math.random()*Settings.trickleRate)};NProgress.render=function(fromStart){if(NProgress.isRendered())return $("#nprogress");$("html").addClass("nprogress-busy");var $el=$("<div id='nprogress'>").html(Settings.template);var perc=fromStart?"-100":toBarPerc(NProgress.status||0);$el.find('[role="bar"]').css({transition:"all 0 linear",transform:"translate3d("+perc+"%,0,0)"});if(!Settings.showSpinner)$el.find('[role="spinner"]').remove();$el.appendTo("#screens");return $el};NProgress.remove=function(){$("html").removeClass("nprogress-busy");$("#nprogress").remove()};NProgress.isRendered=function(){return $("#nprogress").length>0};NProgress.getPositioningCSS=function(){var bodyStyle=document.body.style;var vendorPrefix="WebkitTransform"in bodyStyle?"Webkit":"MozTransform"in bodyStyle?"Moz":"msTransform"in bodyStyle?"ms":"OTransform"in bodyStyle?"O":"";if(vendorPrefix+"Perspective"in bodyStyle){return"translate3d"}else if(vendorPrefix+"Transform"in bodyStyle){return"translate"}else{return"margin"}};function clamp(n,min,max){if(n<min)return min;if(n>max)return max;return n}function toBarPerc(n){return(-1+n)*100}function barPositionCSS(n,speed,ease){var barCSS;if(Settings.positionUsing==="translate3d"){barCSS={transform:"translate3d("+toBarPerc(n)+"%,0,0)"}}else if(Settings.positionUsing==="translate"){barCSS={transform:"translate("+toBarPerc(n)+"%,0)"}}else{barCSS={"margin-left":toBarPerc(n)+"%"}}barCSS.transition="all "+speed+"ms "+ease;return barCSS}return NProgress});(function(root,factory){if(typeof define==="function"&&define.amd){define([],function(){return root.returnExportsGlobal=factory()})}else if(typeof exports==="object"){module.exports=factory()}else{root["bouncefix"]=factory()}})(this,function(){var domEvent;domEvent=function(){function DOMEvent(el,eventName,handler,context){this.el=el;this.eventName=eventName;this.handler=handler;this.context=context;this.add()}DOMEvent.prototype._handler=function(e,context){var evt={};for(var k in e){evt[k]=e[k]}evt.stopPropagation=function(){if(e.stopPropagation){e.stopPropagation()}else{e.cancelBubble=true}};evt.preventDefault=function(){if(e.preventDefault){e.preventDefault()}else{e.returnValue=false}};this.handler.call(this.context||context,evt)};DOMEvent.prototype.add=function(){var self=this;self.cachedHandler=function(e){self._handler.call(self,e,this)};self.el.addEventListener(self.eventName,self.cachedHandler,false)};DOMEvent.prototype.remove=function(){this.el.removeEventListener(this.eventName,this.cachedHandler)};return DOMEvent}();var utils;utils=function(){var utils={};utils.getTargetedEl=function(el,className){while(true){if(el.classList.contains(className)){break}if(el=el.parentElement){continue}break}return el};utils.isScrollable=function(el){return el.scrollHeight>el.offsetHeight};utils.scrollToEnd=function(el){var curPos=el.scrollTop,height=el.offsetHeight,scroll=el.scrollHeight;if(curPos<=0){el.scrollTop=1}if(curPos+height>=scroll){el.scrollTop=scroll-height-1}};return utils}();var fix;fix=function(DOMEvent,utils){var Fix=function(className){if(!(this instanceof Fix)){return new Fix(className)}if(!className){throw new Error('"className" argument is required')}this.className=className;this.startListener=new DOMEvent(document,"touchstart",this.touchStart,this);this.endListener=new DOMEvent(document,"touchend",this.touchEnd,this)};Fix.prototype.touchStart=function(evt){var el=utils.getTargetedEl(evt.target,this.className);if(el&&utils.isScrollable(el)){return utils.scrollToEnd(el)}if(el&&!this.moveListener){this.moveListener=new DOMEvent(el,"touchmove",this.touchMove,this)}};Fix.prototype.touchMove=function(evt){evt.preventDefault()};Fix.prototype.touchEnd=function(evt){if(this.moveListener){this.moveListener.remove();delete this.moveListener}};Fix.prototype.remove=function(){this.startListener.remove();this.endListener.remove()};return Fix}(domEvent,utils);var bouncefix;bouncefix=function(Fix){var bouncefix={cache:{}};bouncefix.add=function(className){if(!this.cache[className]){this.cache[className]=new Fix(className)}};bouncefix.remove=function(className){if(this.cache[className]){this.cache[className].remove();delete this.cache[className]}};return bouncefix}(fix);return bouncefix});this["MARVELAPP"]=this["MARVELAPP"]||{};this["MARVELAPP"]["templates"]=this["MARVELAPP"]["templates"]||{};this["MARVELAPP"]["templates"]["ADD_TO_HOMESCREEN"]=function(obj){obj||(obj={});var __t,__p="",__e=_.escape,__j=Array.prototype.join;function print(){__p+=__j.call(arguments,"")}with(obj){__p+='<div class="addToHomescreen';if(iPad){__p+=" ipad"}if(android){__p+=" android"}__p+='">\n    <div class="popup">\n        ';if(!android){__p+='<div id="close_wrapper" class="close_wrapper"><div class="close"></div></div>'}__p+="\n        ";if(app_icon!=null){__p+='\n            <div id="app-icon-popover">\n                <div class="icon" style="background-image: url('+((__t=app_icon.url)==null?"":__t)+');"></div>\n            </div>\n        '}else{__p+='\n			<div id="app-icon-popover">\n                <div class="icon" style="background-image: url(../../../static/assets/images/icons/icon_120_'+((__t=random_number)==null?"":__t)+'.png);"></div>\n            </div>\n        '}__p+='\n        <h1>Install this prototype!</h1>\n        <p>You can install this prototype on your homescreen to make it look and feel like a real app. Give it a spin!</p>\n        <div class="bottom">\n            ';if(android){__p+="\n                Just tap <span class=\"up-icon android\"></span> then 'Add to home screen'\n            "}else{__p+="\n                Just tap <span class=\"up-icon\"></span> then 'Add to Home Screen'\n            "}__p+="\n        </div>\n        ";if(android){__p+='<div id="close_wrapper" class="close_wrapper"><div class="close">Close</div></div>'}__p+="\n    </div>\n</div>"}return __p};this["MARVELAPP"]["templates"]["HOTSPOT"]=function(obj){obj||(obj={});var __t,__p="",__e=_.escape,__j=Array.prototype.join;function print(){__p+=__j.call(arguments,"")}with(obj){__p+='<div id="hotspot-'+((__t=id)==null?"":__t)+'"class="hotspot';if(type==projectConstants.TYPE_URL){__p+=" url"}if(type==projectConstants.TYPE_ANCHOR){__p+=" anchor"}if(action!="click"){__p+=" gesture "+((__t=action)==null?"":__t)}__p+='" style="width: '+((__t=width)==null?"":__t)+"%; height: "+((__t=height)==null?"":__t)+"%; top: "+((__t=top)==null?"":__t)+"%; left: "+((__t=left)==null?"":__t)+'%;" data-target="'+((__t=dest_img_fk)==null?"":__t)+'" data-transition="'+((__t=transition)==null?"":__t)+'"';if(type==projectConstants.TYPE_ANCHOR){__p+=' data-anchor="'+((__t=anchor_y_pos)==null?"":__t)+'"'}if(type==projectConstants.TYPE_URL){__p+=' data-url="'+((__t=external_url)==null?"":__t)+'"'}__p+=' data-maintain-scroll="'+((__t=maintain_scroll)==null?"":__t)+'"></div>'}return __p};this["MARVELAPP"]["templates"]["IOS_PROTOTYPE_WRAPPER"]=function(obj){obj||(obj={});var __t,__p="",__e=_.escape,__j=Array.prototype.join;function print(){__p+=__j.call(arguments,"")}with(obj){__p+='<div class="screen';if(mobile){__p+=" mobile"}__p+='">\n	<div id="screens" style="background-color: #'+((__t=prototype_background)==null?"":__t)+'"></div>\n</div>'}return __p};this["MARVELAPP"]["templates"]["PAGE_LOADER"]=function(obj){obj||(obj={});var __t,__p="",__e=_.escape,__j=Array.prototype.join;function print(){__p+=__j.call(arguments,"")}with(obj){__p+='<div id="page-loader">\n    <div class="modal">\n        <div class="modal-inner">\n            ';if(team_icon!=""&&team_icon!=null){__p+='\n            <div class="team-logo" style="background-image: url('+((__t=team_icon)==null?"":__t)+');"></div>\n            '}else if(!is_pro){__p+='\n            <a href="https://marvelapp.com/" target="_blank">\n            <svg class="logo" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" version="1.1" x="0px" y="0px" width="102px" height="32.279px" viewBox="0 0 102 32.279" enable-background="new 0 0 102 32.279" xml:space="preserve"><path d="M101.431 0.723C101.052 0.2 100.5 0 99.9 0c-0.723 0-1.506 0.25-2.35 0.7 c-0.844 0.499-1.816 1.3-2.918 2.401c-0.792 0.792-1.644 1.782-2.556 2.97c-0.913 1.188-1.817 2.479-2.712 3.9 c-0.895 1.394-1.756 2.823-2.582 4.287c-0.826 1.464-1.533 2.866-2.118 4.209c-0.438 0.967-0.805 1.846-1.108 2.6 c-0.061 0.064-0.122 0.122-0.183 0.198l-1.085 1.446c-0.93 1.239-2.023 2.272-3.28 3.099c-1.258 0.826-2.35 1.24-3.28 1.2 c-0.619 0-1.11-0.147-1.472-0.44c-0.362-0.292-0.543-0.731-0.543-1.317c0-0.206 0.026-0.387 0.077-0.542 c0.052-0.155 0.146-0.353 0.284-0.594c0.31 0.1 0.6 0.1 0.8 0.181c0.189 0.1 0.4 0.1 0.7 0.1 c0.999 0 1.98-0.232 2.944-0.697c0.964-0.465 1.816-1.076 2.556-1.833c0.741-0.757 1.343-1.618 1.808-2.583 c0.464-0.964 0.697-1.944 0.697-2.944c0-1.033-0.309-1.876-0.929-2.531c-0.62-0.654-1.429-0.981-2.428-0.981 c-1.206 0-2.437 0.405-3.693 1.214c-1.257 0.809-2.401 1.851-3.434 3.124c-0.705 0.87-1.315 1.808-1.844 2.8 c-0.415 0.216-0.817 0.337-1.205 0.337c-0.173 0-0.345-0.017-0.517-0.052c0.378-0.653 0.671-1.402 0.878-2.246 c0.207-0.843 0.31-1.643 0.31-2.401c0-0.688-0.138-1.257-0.413-1.705c-0.276-0.447-0.654-0.671-1.136-0.671 c-0.448 0-0.887 0.173-1.317 0.517c-0.431 0.345-0.818 0.784-1.162 1.317c-0.344 0.534-0.619 1.154-0.826 1.9 c-0.207 0.706-0.31 1.42-0.31 2.143c0 0.2 0 0.4 0 0.62c0 0.2 0 0.5 0.1 0.878c-0.173 0.413-0.413 0.852-0.723 1.3 c-0.31 0.465-0.706 1.007-1.188 1.627c-0.689 0.896-1.249 1.55-1.679 1.963c-0.431 0.413-0.818 0.62-1.162 0.6 c-0.173 0-0.319-0.077-0.439-0.232c-0.121-0.155-0.181-0.336-0.181-0.542c0-0.378 0.137-0.947 0.413-1.705 c0.276-0.757 0.62-1.515 1.033-2.272l1.343-2.634c0.378-0.688 0.679-1.411 0.903-2.169c0.223-0.757 0.336-1.377 0.336-1.859 c0-0.551-0.173-0.998-0.517-1.343c-0.344-0.344-0.757-0.517-1.239-0.517c-0.482 0-0.887 0.138-1.214 0.4 c-0.327 0.276-0.628 0.775-0.903 1.498c-0.207 0.482-0.413 0.973-0.62 1.472c-0.207 0.5-0.447 0.99-0.723 1.472l-0.402 0.8 c-0.107 0.03-0.214 0.075-0.321 0.137c-0.207 0.121-0.551 0.371-1.033 0.749c-0.586 0.483-1.11 0.861-1.575 1.1 c-0.465 0.276-0.818 0.413-1.059 0.413c-0.345 0-0.517-0.137-0.517-0.413c0-0.207 0.181-0.499 0.542-0.878 c0.361-0.379 0.834-0.792 1.42-1.24c0.62-0.413 1.05-0.783 1.291-1.111c0.241-0.327 0.362-0.697 0.362-1.111 c0-0.413-0.164-0.792-0.491-1.136c-0.327-0.344-0.697-0.517-1.11-0.517c-0.379 0-0.81 0.138-1.291 0.4 c-0.483 0.276-1.206 0.758-2.169 1.446c-1.033 0.793-1.962 1.55-2.789 2.273c-0.826 0.723-1.705 1.619-2.634 2.685l-0.362 0.4 c0.207-0.482 0.517-1.05 0.93-1.705c0.413-0.654 0.86-1.257 1.342-1.808c0.585-0.689 0.956-1.17 1.111-1.446 c0.155-0.275 0.232-0.585 0.232-0.93c0-0.413-0.173-0.775-0.517-1.085c-0.344-0.31-0.757-0.465-1.239-0.465 c-0.723 0-1.429 0.362-2.118 1.085c-0.413 0.413-0.887 1.007-1.42 1.782c-0.534 0.774-1.041 1.575-1.523 2.4 c-0.122 0.206-0.238 0.427-0.358 0.639c-0.285 0.206-0.578 0.509-0.88 0.911c-0.999 1.377-1.833 2.376-2.506 3 c-0.672 0.62-1.265 0.93-1.781 0.93c-0.586 0-0.879-0.276-0.879-0.827c0-0.379 0.155-0.878 0.466-1.498 c0.309-0.62 0.723-1.273 1.239-1.963c0.276-0.31 0.447-0.55 0.517-0.723c0.069-0.172 0.103-0.344 0.103-0.517 c0-0.207-0.052-0.395-0.154-0.568c-0.104-0.172-0.328-0.395-0.672-0.672c0.172-0.447 0.301-0.834 0.388-1.162 c0.085-0.327 0.129-0.697 0.129-1.111c0-1.17-0.344-2.099-1.033-2.789c-0.689-0.688-1.584-1.033-2.686-1.033 c-1.205 0-2.453 0.422-3.744 1.265c-1.291 0.844-2.539 2.075-3.744 3.693c-0.85 1.125-1.552 2.308-2.119 3.5 c-0.171 0.198-0.359 0.443-0.566 0.744c-0.379 0.551-0.818 1.154-1.317 1.808c-0.499 0.655-0.921 1.171-1.265 1.6 c-0.655 0.723-1.188 1.231-1.601 1.523c-0.413 0.293-0.793 0.44-1.136 0.44c-0.448 0-0.671-0.225-0.671-0.672 c0-1.033 1.343-3.306 4.028-6.818c0.585-0.757 0.989-1.35 1.214-1.781c0.224-0.43 0.336-0.852 0.336-1.265 c0-0.55-0.232-1.041-0.697-1.472c-0.464-0.43-0.99-0.646-1.575-0.646c-0.413 0-0.844 0.121-1.291 0.4 c-0.448 0.241-1.016 0.655-1.705 1.24c-0.31 0.276-0.62 0.542-0.93 0.801c-0.31 0.258-0.638 0.56-0.981 0.9 c-0.345 0.345-0.741 0.741-1.188 1.188c-0.448 0.448-0.981 0.999-1.601 1.653l-0.62 0.672l0.413-0.775l1.085-1.963 c0.447-0.792 0.74-1.377 0.878-1.756c0.137-0.378 0.207-0.723 0.207-1.033c0-0.481-0.173-0.886-0.517-1.213 c-0.345-0.327-0.758-0.491-1.24-0.491c-0.379 0-0.8 0.121-1.265 0.362c-0.465 0.241-0.99 0.62-1.575 1.1 c-0.586 0.516-1.265 1.205-2.04 2.066c-0.775 0.861-1.678 1.911-2.711 3.15l0.568-1.136c0.31-0.55 0.568-1.007 0.775-1.369 c0.207-0.362 0.362-0.628 0.465-0.801c0.585-0.929 0.956-1.583 1.111-1.962c0.155-0.378 0.232-0.74 0.232-1.085 c0-0.447-0.164-0.826-0.491-1.136c-0.328-0.31-0.715-0.465-1.162-0.465c-0.413 0-0.793 0.129-1.136 0.4 c-0.345 0.258-0.758 0.697-1.24 1.317c-0.826 1.102-1.661 2.427-2.505 3.977c-0.843 1.55-1.627 3.237-2.35 5.1 C0.637 26.5 0 28.8 0 30.058c0 0.7 0.2 1.2 0.5 1.602c0.345 0.4 0.8 0.6 1.3 0.6 c0.517 0 0.939-0.163 1.265-0.49c0.328-0.328 0.697-0.973 1.111-1.937c0.31-0.723 0.697-1.471 1.162-2.246 c0.465-0.775 0.998-1.541 1.601-2.298c0.602-0.757 1.23-1.489 1.885-2.195c0.654-0.705 1.325-1.334 2.014-1.885 c-0.138 0.276-0.241 0.448-0.31 0.517l-0.981 1.705c-0.207 0.309-0.448 0.748-0.723 1.317c-0.276 0.568-0.5 1.093-0.671 1.6 c-0.276 0.62-0.457 1.111-0.542 1.472c-0.086 0.362-0.129 0.732-0.129 1.111c0 0.6 0.2 1.1 0.5 1.5 c0.362 0.4 0.8 0.6 1.4 0.594c0.517 0 0.947-0.181 1.291-0.542c0.344-0.362 0.843-1.093 1.498-2.195 c0.895-1.653 1.781-3.004 2.66-4.055c0.878-1.05 1.764-1.919 2.66-2.608c-0.138 0.207-0.225 0.345-0.258 0.4 c-0.483 0.689-0.878 1.317-1.188 1.885c-0.31 0.568-0.551 1.102-0.723 1.601c-0.173 0.5-0.302 0.98-0.387 1.4 c-0.086 0.465-0.129 0.956-0.129 1.472c0 1 0.3 1.8 0.9 2.453c0.62 0.6 1.4 1 2.4 1 c1.033 0 2.177-0.396 3.434-1.188c1.123-0.708 2.226-1.679 3.308-2.91c0.159 0.5 0.4 0.9 0.7 1.3 c0.638 0.8 1.4 1.1 2.4 1.137c1.859 0 3.615-1.137 5.269-3.408v0.465c0 0.8 0.3 1.4 0.8 1.9 c0.517 0.5 1.2 0.8 1.9 0.801c1.258 0 2.555-0.451 3.892-1.348c-0.181 0.696-0.278 1.255-0.278 1.7 c0 0.6 0.2 1 0.5 1.317c0.345 0.3 0.8 0.5 1.3 0.49c0.483 0 0.878-0.112 1.188-0.336 c0.31-0.225 0.603-0.612 0.878-1.162l1.136-2.376c0.62-1.273 1.498-2.538 2.634-3.796c1.136-1.257 2.358-2.332 3.667-3.228 c-0.483 0.689-0.723 1.342-0.724 1.964c0 0.6 0.2 1.1 0.7 1.523c0.499 0.4 1.1 0.6 1.9 0.6 c1.028 0 2.118-0.301 3.267-0.893c-0.03 0.096-0.064 0.195-0.091 0.29c-0.292 1.016-0.439 1.92-0.439 2.7 c0 1.1 0.3 2 1 2.763c0.637 0.7 1.4 1.1 2.4 1.111c1.377 0 2.841-0.654 4.39-1.963 c1.55-1.308 3.013-3.116 4.39-5.423c0.378 0.1 0.7 0.2 1 0.285c0.275 0.1 0.6 0.1 0.9 0.1 c0.038 0 0.077-0.005 0.115-0.006c-0.108 0.613-0.165 1.22-0.165 1.822c0 1.6 0.5 2.8 1.4 3.8 c0.948 1 2.2 1.5 3.7 1.472c1.343 0 2.771-0.387 4.287-1.162c1.248-0.639 2.426-1.485 3.535-2.534 c0.149 1 0.5 1.8 1.1 2.456c0.793 0.9 1.8 1.3 3.1 1.291c2.169 0 4.527-1.325 7.076-3.977 c0.517-0.55 1.007-1.127 1.472-1.73c0.464-0.602 0.869-1.179 1.213-1.73c0.344-0.55 0.611-1.058 0.801-1.523 c0.189-0.465 0.284-0.852 0.284-1.162c0-0.379-0.103-0.688-0.31-0.93c-0.207-0.24-0.483-0.362-0.826-0.362 c-0.517 0-1.085 0.379-1.705 1.136l-0.879 1.033c-2.411 3.065-4.218 4.597-5.423 4.597c-0.379 0-0.715-0.155-1.007-0.465 c-0.293-0.31-0.439-0.654-0.439-1.033c0-0.069 0-0.137 0-0.207c0-0.103 0.017-0.189 0.052-0.258 c1.963-1.446 3.675-2.875 5.139-4.286c1.463-1.411 2.848-2.995 4.158-4.752c0.86-1.17 1.634-2.358 2.324-3.564 c0.689-1.205 1.282-2.376 1.782-3.512c0.499-1.136 0.886-2.221 1.162-3.254C101.862 4.3 102 3.4 102 2.6 C102 1.8 101.8 1.2 101.4 0.723z M77.494 18.128c0.705-0.689 1.247-1.033 1.627-1.033c0.344 0 0.5 0.2 0.5 0.6 c0 0.345-0.103 0.689-0.31 1.033c-0.207 0.344-0.473 0.663-0.8 0.955c-0.328 0.293-0.689 0.525-1.085 0.7 c-0.396 0.173-0.784 0.258-1.162 0.258c-0.139 0-0.25-0.008-0.336-0.026c-0.086-0.017-0.199-0.043-0.336-0.077 C76.159 19.6 76.8 18.8 77.5 18.128z M34.989 19.315c-0.328 0.62-0.697 1.136-1.111 1.55l-0.825 0.9 c-0.172 0.173-0.259 0.362-0.259 0.568c0 0.1 0.1 0.3 0.2 0.568c-0.173 0.173-0.276 0.293-0.309 0.4 c-0.586 0.723-1.068 1.223-1.446 1.498c-0.379 0.276-0.758 0.414-1.136 0.414c-0.517 0-0.775-0.293-0.775-0.879 c0-0.482 0.181-1.153 0.542-2.014c0.362-0.86 0.817-1.686 1.369-2.479c0.585-0.826 1.196-1.489 1.833-1.988 c0.636-0.499 1.179-0.749 1.627-0.749c0.55 0 0.8 0.3 0.8 0.826C35.48 18.2 35.3 18.7 35 19.315z M97.636 6.9 c-0.225 0.568-0.517 1.223-0.878 1.963c-0.362 0.741-0.784 1.516-1.265 2.324c-0.483 0.809-0.999 1.593-1.55 2.4 c-0.826 1.205-1.652 2.272-2.479 3.202c-0.826 0.929-1.79 1.911-2.892 2.944c0.137-0.344 0.275-0.688 0.413-1.033 c0.137-0.344 0.3-0.705 0.49-1.085c0.189-0.378 0.413-0.817 0.672-1.317c0.258-0.499 0.576-1.093 0.956-1.782 c0.619-1.17 1.102-2.066 1.446-2.685s0.705-1.222 1.085-1.808c0.93-1.55 1.738-2.745 2.428-3.589 c0.688-0.843 1.205-1.265 1.55-1.265c0.24 0 0.4 0.2 0.4 0.465C97.972 5.9 97.9 6.3 97.6 6.895z"/></svg>\n            </a>\n            '}__p+='\n\n            <div class="loader">\n                <div class="inner"></div>\n            </div>\n        </div>\n    </div>'}return __p};this["MARVELAPP"]["templates"]["PASSWORD_BOX"]=function(obj){obj||(obj={});var __t,__p="",__e=_.escape,__j=Array.prototype.join;function print(){__p+=__j.call(arguments,"")}with(obj){__p+='<div id="password-protected">\n    <div class="inner">\n        ';if(team_icon!=""&&team_icon!=null){__p+='\n            <div class="team-logo" style="background-image: url('+((__t=team_icon)==null?"":__t)+');"></div>\n        '}else if(!is_pro){__p+='\n            <a class="powered" href="http://marvelapp.com/">\n        		<svg class="logo" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" version="1.1" x="0px" y="0px" width="102px" height="32.279px" viewBox="0 0 102 32.279" enable-background="new 0 0 102 32.279" xml:space="preserve"><path d="M101.431 0.723C101.052 0.2 100.5 0 99.9 0c-0.723 0-1.506 0.25-2.35 0.7 c-0.844 0.499-1.816 1.3-2.918 2.401c-0.792 0.792-1.644 1.782-2.556 2.97c-0.913 1.188-1.817 2.479-2.712 3.9 c-0.895 1.394-1.756 2.823-2.582 4.287c-0.826 1.464-1.533 2.866-2.118 4.209c-0.438 0.967-0.805 1.846-1.108 2.6 c-0.061 0.064-0.122 0.122-0.183 0.198l-1.085 1.446c-0.93 1.239-2.023 2.272-3.28 3.099c-1.258 0.826-2.35 1.24-3.28 1.2 c-0.619 0-1.11-0.147-1.472-0.44c-0.362-0.292-0.543-0.731-0.543-1.317c0-0.206 0.026-0.387 0.077-0.542 c0.052-0.155 0.146-0.353 0.284-0.594c0.31 0.1 0.6 0.1 0.8 0.181c0.189 0.1 0.4 0.1 0.7 0.1 c0.999 0 1.98-0.232 2.944-0.697c0.964-0.465 1.816-1.076 2.556-1.833c0.741-0.757 1.343-1.618 1.808-2.583 c0.464-0.964 0.697-1.944 0.697-2.944c0-1.033-0.309-1.876-0.929-2.531c-0.62-0.654-1.429-0.981-2.428-0.981 c-1.206 0-2.437 0.405-3.693 1.214c-1.257 0.809-2.401 1.851-3.434 3.124c-0.705 0.87-1.315 1.808-1.844 2.8 c-0.415 0.216-0.817 0.337-1.205 0.337c-0.173 0-0.345-0.017-0.517-0.052c0.378-0.653 0.671-1.402 0.878-2.246 c0.207-0.843 0.31-1.643 0.31-2.401c0-0.688-0.138-1.257-0.413-1.705c-0.276-0.447-0.654-0.671-1.136-0.671 c-0.448 0-0.887 0.173-1.317 0.517c-0.431 0.345-0.818 0.784-1.162 1.317c-0.344 0.534-0.619 1.154-0.826 1.9 c-0.207 0.706-0.31 1.42-0.31 2.143c0 0.2 0 0.4 0 0.62c0 0.2 0 0.5 0.1 0.878c-0.173 0.413-0.413 0.852-0.723 1.3 c-0.31 0.465-0.706 1.007-1.188 1.627c-0.689 0.896-1.249 1.55-1.679 1.963c-0.431 0.413-0.818 0.62-1.162 0.6 c-0.173 0-0.319-0.077-0.439-0.232c-0.121-0.155-0.181-0.336-0.181-0.542c0-0.378 0.137-0.947 0.413-1.705 c0.276-0.757 0.62-1.515 1.033-2.272l1.343-2.634c0.378-0.688 0.679-1.411 0.903-2.169c0.223-0.757 0.336-1.377 0.336-1.859 c0-0.551-0.173-0.998-0.517-1.343c-0.344-0.344-0.757-0.517-1.239-0.517c-0.482 0-0.887 0.138-1.214 0.4 c-0.327 0.276-0.628 0.775-0.903 1.498c-0.207 0.482-0.413 0.973-0.62 1.472c-0.207 0.5-0.447 0.99-0.723 1.472l-0.402 0.8 c-0.107 0.03-0.214 0.075-0.321 0.137c-0.207 0.121-0.551 0.371-1.033 0.749c-0.586 0.483-1.11 0.861-1.575 1.1 c-0.465 0.276-0.818 0.413-1.059 0.413c-0.345 0-0.517-0.137-0.517-0.413c0-0.207 0.181-0.499 0.542-0.878 c0.361-0.379 0.834-0.792 1.42-1.24c0.62-0.413 1.05-0.783 1.291-1.111c0.241-0.327 0.362-0.697 0.362-1.111 c0-0.413-0.164-0.792-0.491-1.136c-0.327-0.344-0.697-0.517-1.11-0.517c-0.379 0-0.81 0.138-1.291 0.4 c-0.483 0.276-1.206 0.758-2.169 1.446c-1.033 0.793-1.962 1.55-2.789 2.273c-0.826 0.723-1.705 1.619-2.634 2.685l-0.362 0.4 c0.207-0.482 0.517-1.05 0.93-1.705c0.413-0.654 0.86-1.257 1.342-1.808c0.585-0.689 0.956-1.17 1.111-1.446 c0.155-0.275 0.232-0.585 0.232-0.93c0-0.413-0.173-0.775-0.517-1.085c-0.344-0.31-0.757-0.465-1.239-0.465 c-0.723 0-1.429 0.362-2.118 1.085c-0.413 0.413-0.887 1.007-1.42 1.782c-0.534 0.774-1.041 1.575-1.523 2.4 c-0.122 0.206-0.238 0.427-0.358 0.639c-0.285 0.206-0.578 0.509-0.88 0.911c-0.999 1.377-1.833 2.376-2.506 3 c-0.672 0.62-1.265 0.93-1.781 0.93c-0.586 0-0.879-0.276-0.879-0.827c0-0.379 0.155-0.878 0.466-1.498 c0.309-0.62 0.723-1.273 1.239-1.963c0.276-0.31 0.447-0.55 0.517-0.723c0.069-0.172 0.103-0.344 0.103-0.517 c0-0.207-0.052-0.395-0.154-0.568c-0.104-0.172-0.328-0.395-0.672-0.672c0.172-0.447 0.301-0.834 0.388-1.162 c0.085-0.327 0.129-0.697 0.129-1.111c0-1.17-0.344-2.099-1.033-2.789c-0.689-0.688-1.584-1.033-2.686-1.033 c-1.205 0-2.453 0.422-3.744 1.265c-1.291 0.844-2.539 2.075-3.744 3.693c-0.85 1.125-1.552 2.308-2.119 3.5 c-0.171 0.198-0.359 0.443-0.566 0.744c-0.379 0.551-0.818 1.154-1.317 1.808c-0.499 0.655-0.921 1.171-1.265 1.6 c-0.655 0.723-1.188 1.231-1.601 1.523c-0.413 0.293-0.793 0.44-1.136 0.44c-0.448 0-0.671-0.225-0.671-0.672 c0-1.033 1.343-3.306 4.028-6.818c0.585-0.757 0.989-1.35 1.214-1.781c0.224-0.43 0.336-0.852 0.336-1.265 c0-0.55-0.232-1.041-0.697-1.472c-0.464-0.43-0.99-0.646-1.575-0.646c-0.413 0-0.844 0.121-1.291 0.4 c-0.448 0.241-1.016 0.655-1.705 1.24c-0.31 0.276-0.62 0.542-0.93 0.801c-0.31 0.258-0.638 0.56-0.981 0.9 c-0.345 0.345-0.741 0.741-1.188 1.188c-0.448 0.448-0.981 0.999-1.601 1.653l-0.62 0.672l0.413-0.775l1.085-1.963 c0.447-0.792 0.74-1.377 0.878-1.756c0.137-0.378 0.207-0.723 0.207-1.033c0-0.481-0.173-0.886-0.517-1.213 c-0.345-0.327-0.758-0.491-1.24-0.491c-0.379 0-0.8 0.121-1.265 0.362c-0.465 0.241-0.99 0.62-1.575 1.1 c-0.586 0.516-1.265 1.205-2.04 2.066c-0.775 0.861-1.678 1.911-2.711 3.15l0.568-1.136c0.31-0.55 0.568-1.007 0.775-1.369 c0.207-0.362 0.362-0.628 0.465-0.801c0.585-0.929 0.956-1.583 1.111-1.962c0.155-0.378 0.232-0.74 0.232-1.085 c0-0.447-0.164-0.826-0.491-1.136c-0.328-0.31-0.715-0.465-1.162-0.465c-0.413 0-0.793 0.129-1.136 0.4 c-0.345 0.258-0.758 0.697-1.24 1.317c-0.826 1.102-1.661 2.427-2.505 3.977c-0.843 1.55-1.627 3.237-2.35 5.1 C0.637 26.5 0 28.8 0 30.058c0 0.7 0.2 1.2 0.5 1.602c0.345 0.4 0.8 0.6 1.3 0.6 c0.517 0 0.939-0.163 1.265-0.49c0.328-0.328 0.697-0.973 1.111-1.937c0.31-0.723 0.697-1.471 1.162-2.246 c0.465-0.775 0.998-1.541 1.601-2.298c0.602-0.757 1.23-1.489 1.885-2.195c0.654-0.705 1.325-1.334 2.014-1.885 c-0.138 0.276-0.241 0.448-0.31 0.517l-0.981 1.705c-0.207 0.309-0.448 0.748-0.723 1.317c-0.276 0.568-0.5 1.093-0.671 1.6 c-0.276 0.62-0.457 1.111-0.542 1.472c-0.086 0.362-0.129 0.732-0.129 1.111c0 0.6 0.2 1.1 0.5 1.5 c0.362 0.4 0.8 0.6 1.4 0.594c0.517 0 0.947-0.181 1.291-0.542c0.344-0.362 0.843-1.093 1.498-2.195 c0.895-1.653 1.781-3.004 2.66-4.055c0.878-1.05 1.764-1.919 2.66-2.608c-0.138 0.207-0.225 0.345-0.258 0.4 c-0.483 0.689-0.878 1.317-1.188 1.885c-0.31 0.568-0.551 1.102-0.723 1.601c-0.173 0.5-0.302 0.98-0.387 1.4 c-0.086 0.465-0.129 0.956-0.129 1.472c0 1 0.3 1.8 0.9 2.453c0.62 0.6 1.4 1 2.4 1 c1.033 0 2.177-0.396 3.434-1.188c1.123-0.708 2.226-1.679 3.308-2.91c0.159 0.5 0.4 0.9 0.7 1.3 c0.638 0.8 1.4 1.1 2.4 1.137c1.859 0 3.615-1.137 5.269-3.408v0.465c0 0.8 0.3 1.4 0.8 1.9 c0.517 0.5 1.2 0.8 1.9 0.801c1.258 0 2.555-0.451 3.892-1.348c-0.181 0.696-0.278 1.255-0.278 1.7 c0 0.6 0.2 1 0.5 1.317c0.345 0.3 0.8 0.5 1.3 0.49c0.483 0 0.878-0.112 1.188-0.336 c0.31-0.225 0.603-0.612 0.878-1.162l1.136-2.376c0.62-1.273 1.498-2.538 2.634-3.796c1.136-1.257 2.358-2.332 3.667-3.228 c-0.483 0.689-0.723 1.342-0.724 1.964c0 0.6 0.2 1.1 0.7 1.523c0.499 0.4 1.1 0.6 1.9 0.6 c1.028 0 2.118-0.301 3.267-0.893c-0.03 0.096-0.064 0.195-0.091 0.29c-0.292 1.016-0.439 1.92-0.439 2.7 c0 1.1 0.3 2 1 2.763c0.637 0.7 1.4 1.1 2.4 1.111c1.377 0 2.841-0.654 4.39-1.963 c1.55-1.308 3.013-3.116 4.39-5.423c0.378 0.1 0.7 0.2 1 0.285c0.275 0.1 0.6 0.1 0.9 0.1 c0.038 0 0.077-0.005 0.115-0.006c-0.108 0.613-0.165 1.22-0.165 1.822c0 1.6 0.5 2.8 1.4 3.8 c0.948 1 2.2 1.5 3.7 1.472c1.343 0 2.771-0.387 4.287-1.162c1.248-0.639 2.426-1.485 3.535-2.534 c0.149 1 0.5 1.8 1.1 2.456c0.793 0.9 1.8 1.3 3.1 1.291c2.169 0 4.527-1.325 7.076-3.977 c0.517-0.55 1.007-1.127 1.472-1.73c0.464-0.602 0.869-1.179 1.213-1.73c0.344-0.55 0.611-1.058 0.801-1.523 c0.189-0.465 0.284-0.852 0.284-1.162c0-0.379-0.103-0.688-0.31-0.93c-0.207-0.24-0.483-0.362-0.826-0.362 c-0.517 0-1.085 0.379-1.705 1.136l-0.879 1.033c-2.411 3.065-4.218 4.597-5.423 4.597c-0.379 0-0.715-0.155-1.007-0.465 c-0.293-0.31-0.439-0.654-0.439-1.033c0-0.069 0-0.137 0-0.207c0-0.103 0.017-0.189 0.052-0.258 c1.963-1.446 3.675-2.875 5.139-4.286c1.463-1.411 2.848-2.995 4.158-4.752c0.86-1.17 1.634-2.358 2.324-3.564 c0.689-1.205 1.282-2.376 1.782-3.512c0.499-1.136 0.886-2.221 1.162-3.254C101.862 4.3 102 3.4 102 2.6 C102 1.8 101.8 1.2 101.4 0.723z M77.494 18.128c0.705-0.689 1.247-1.033 1.627-1.033c0.344 0 0.5 0.2 0.5 0.6 c0 0.345-0.103 0.689-0.31 1.033c-0.207 0.344-0.473 0.663-0.8 0.955c-0.328 0.293-0.689 0.525-1.085 0.7 c-0.396 0.173-0.784 0.258-1.162 0.258c-0.139 0-0.25-0.008-0.336-0.026c-0.086-0.017-0.199-0.043-0.336-0.077 C76.159 19.6 76.8 18.8 77.5 18.128z M34.989 19.315c-0.328 0.62-0.697 1.136-1.111 1.55l-0.825 0.9 c-0.172 0.173-0.259 0.362-0.259 0.568c0 0.1 0.1 0.3 0.2 0.568c-0.173 0.173-0.276 0.293-0.309 0.4 c-0.586 0.723-1.068 1.223-1.446 1.498c-0.379 0.276-0.758 0.414-1.136 0.414c-0.517 0-0.775-0.293-0.775-0.879 c0-0.482 0.181-1.153 0.542-2.014c0.362-0.86 0.817-1.686 1.369-2.479c0.585-0.826 1.196-1.489 1.833-1.988 c0.636-0.499 1.179-0.749 1.627-0.749c0.55 0 0.8 0.3 0.8 0.826C35.48 18.2 35.3 18.7 35 19.315z M97.636 6.9 c-0.225 0.568-0.517 1.223-0.878 1.963c-0.362 0.741-0.784 1.516-1.265 2.324c-0.483 0.809-0.999 1.593-1.55 2.4 c-0.826 1.205-1.652 2.272-2.479 3.202c-0.826 0.929-1.79 1.911-2.892 2.944c0.137-0.344 0.275-0.688 0.413-1.033 c0.137-0.344 0.3-0.705 0.49-1.085c0.189-0.378 0.413-0.817 0.672-1.317c0.258-0.499 0.576-1.093 0.956-1.782 c0.619-1.17 1.102-2.066 1.446-2.685s0.705-1.222 1.085-1.808c0.93-1.55 1.738-2.745 2.428-3.589 c0.688-0.843 1.205-1.265 1.55-1.265c0.24 0 0.4 0.2 0.4 0.465C97.972 5.9 97.9 6.3 97.6 6.895z"/></svg>\n    	</a>\n        '
}__p+='\n        <div id="password-box">\n            <h1>This prototype is password protected</h1>\n            Enter password to view\n            <div method="POST" id="password-form">\n                <div class="field">\n                    <div class="icon-lock"></div>\n                    <input class="" id="password" name="password" type="password" class="password-field" value="">\n                </div>\n                <button id="submit" type="submit">Submit</button>\n            </div>\n            <div id="success">\n                <div class="icon-checkmark"></div>\n            </div>\n        </div>\n    </div>\n</div>'}return __p};this["MARVELAPP"]["templates"]["PROTOTYPE_WRAPPER"]=function(obj){obj||(obj={});var __t,__p="",__e=_.escape,__j=Array.prototype.join;function print(){__p+=__j.call(arguments,"")}with(obj){__p+='<div id="content-wrapper" class="cf"';if(!embed){__p+=' style="background-color: #'+((__t=background)==null?"":__t)+';"'}__p+='>\n	<div id="content"';if(collapsed){__p+=' class="collapsed"'}__p+='>\n        <div class="inner-content" id="device">\n			<div class="marvel-device '+((__t=frame)==null?"":__t)+" "+((__t=colour)==null?"":__t)+" "+((__t=orientation)==null?"":__t)+'"\n			';if(embed&&(frame=="web-frame"||frame=="desktop-view")){__p+=' style="width: '+((__t=images[1].width)==null?"":__t)+"px; height: "+((__t=images[1].height)==null?"":__t)+'px;"'}__p+='>\n				<div class="top-bar"></div>\n				<div class="sleep"></div>\n				<div class="volume"></div>\n				<div class="camera"></div>\n				<div class="sensor"></div>\n				<div class="speaker"></div>\n				<div class="screen">\n					<div id="screens" style="background-color: #'+((__t=prototype_background)==null?"":__t)+'"></div>\n				</div>\n				<div class="home"></div>\n				<div class="bottom-bar"></div>\n			</div>\n			';if(!is_pro){__p+='\n			<a href="https://marvelapp.com/" target="_parent" id="powered-by">Powered by Marvel</a>\n			'}__p+="\n		</div>\n	</div>\n</div>"}return __p};this["MARVELAPP"]["templates"]["ROTATE_DEVICE"]=function(obj){obj||(obj={});var __t,__p="",__e=_.escape;with(obj){__p+='<div class="rotateDevice hidden">\n    <div class="table">\n        <div class="cell">\n            <div class="inner">\n                <div class="icon"></div>\n                <h4>Rotate your device</h4>\n            </div>\n        </div>\n    </div>\n</div>'}return __p};this["MARVELAPP"]["templates"]["SCREEN"]=function(obj){obj||(obj={});var __t,__p="",__e=_.escape,__j=Array.prototype.join;function print(){__p+=__j.call(arguments,"")}with(obj){__p+='<div id="'+((__t=id)==null?"":__t)+'" class="screen-wrap';if(firstImage){__p+=" active"}__p+='" style="background-color: #'+((__t=background)==null?"":__t)+';">\n\n	<div class="loading';if(white){__p+=" white"}__p+='" style="background: #'+((__t=background)==null?"":__t)+';">\n		<div class="modal">\n			<div class="modal-inner">\n				<div id="spinner_'+((__t=id)==null?"":__t)+'"></div>		\n			</div>\n		</div>\n	</div>\n\n	';if(trim_status=="1"&&mobile&&status_type!="0"&&homescreen){__p+='\n		<div class="status" style="background-color: rgba('+((__t=status_pixel_colour)==null?"":__t)+');"></div>\n	'}__p+="\n\n	";if(fixedHeader!=""&&fixedHeaderURL!=""){__p+='\n	<div class="fixed-header';if(mobile&&trim_status=="1"){__p+=" trimmed"}__p+='" style="max-width: '+((__t=width)==null?"":__t)+"px; background-image: url("+((__t=fixedHeaderURL)==null?"":__t)+");"+((__t=disable_resizing_scale)==null?"":__t)+'"></div>\n	'}__p+='\n	<div class="box-wrap antiscroll-wrap">\n		<div class="box">\n			';if(top_pixel_colour!=null&&mobile){__p+='\n			<div class="topBg" style="background-color: rgba('+((__t=top_pixel_colour)==null?"":__t)+"); max-width: "+((__t=width)==null?"":__t)+'px;"></div>\n			'}__p+="\n			";if(bottom_pixel_colour!=null&&mobile){__p+='\n			<div class="bottomBg" style="background-color: rgba('+((__t=bottom_pixel_colour)==null?"":__t)+"); max-width: "+((__t=width)==null?"":__t)+'px;"></div>\n			'}__p+='\n			<div class="antiscroll-inner';if(!iOS7){__p+=" touch"}__p+='" style="width: 100%;">\n				<div class="box-inner';if(disable_resizing=="1"){__p+=" disable-resize"}__p+='">\n					<div class="image cf" style="max-width: '+((__t=width)==null?"":__t)+"px;"+((__t=disable_resizing_scale)==null?"":__t)+'">\n						<img data="'+((__t=id)==null?"":__t)+'" src="">\n					</div>\n				</div>\n			</div>\n		</div>\n	</div>\n	';if(fixedFooter!=""&&fixedFooterURL!=""){__p+='\n	<div class="fixed-footer" style="max-width: '+((__t=width)==null?"":__t)+"px; background-image: url("+((__t=fixedFooterURL)==null?"":__t)+");"+((__t=disable_resizing_scale)==null?"":__t)+'"></div>\n	'}__p+="\n</div>"}return __p};this["MARVELAPP"]["templates"]["SIDEBAR"]=function(obj){obj||(obj={});var __t,__p="",__e=_.escape,__j=Array.prototype.join;function print(){__p+=__j.call(arguments,"")}with(obj){__p+='<div class="close icon-cross"></div>\n<div class="title">\n    ';if(app_icon!=null){__p+='\n        <div class="app-icon" style="background-image: url('+((__t=app_icon.url)==null?"":__t)+');"></div>\n    '}__p+="\n	<h1>"+((__t=name)==null?"":__t)+"</h1>\n	";if(!initial){__p+='\n	<div class="name">'+((__t=_.escape(first_name).replace(/%(..)/g,"&#x$1;"))==null?"":__t)+'</div>\n	<div class="screen-info">\n        <div class="current">'+((__t=first_index)==null?"":__t)+'</div> / <div class="total">'+((__t=num_images)==null?"":__t)+'</div>\n    </div>\n	<div class="description">'+__e(first_description)+"</div>\n	"}__p+='\n</div>\n<div class="controls">\n	<div class="prev">Previous</div>\n	<div class="home">Home</div>\n	<div class="next">Next</div>\n	<!-- <div class="share">Share</div> -->\n</div>\n';if(team_icon!=""&&team_icon!=null){__p+='\n	<div class="team-logo" style="background-image: url('+((__t=team_icon)==null?"":__t)+');"></div>\n'}else if(!is_pro){__p+='\n	<a class="powered" target="_blank" href="https://marvelapp.com/">Create Your Free Prototype</a>\n'}__p+="\n</a>\n"}return __p};function ProjectConstants(){this.QUEUE_IMG_STATUS_UPLOAD_START=1;this.QUEUE_IMG_STATUS_UPLOAD_PROCESSING=2;this.QUEUE_IMG_STATUS_UPLOAD_EXT_PROCESSING=3;this.QUEUE_IMG_STATUS_PROCESSING_PSD=4;this.QUEUE_IMG_STATUS_UPLOAD_FINISHED=5;this.QUEUE_IMG_STATUS_HAS_CHANGED=6;this.QUEUE_IMG_STATUS_UPLOAD_PROCESSING_NEW=7;this.QUEUE_IMG_STATUS_UPLOAD_ERROR_FINAL=-2;this.QUEUE_IMG_STATUS_UPLOAD_ERROR_CMYK=-3;this.REGISTERED=1;this.NOT_REGISTERED=2;this.USER_STATE_INACTIVE=0;this.NOTIFY_TYPE_OK="success";this.NOTIFY_TYPE_ERROR="error";this.NOTIFY_TYPE_WARN="warning";this.NOTIFY_TYPE_NEWS="information";this.VERSION_NO=9914;this.DISPLAY_VERSION=false;this.SYNC_STATE_NOT_RUNNING=0;this.SYNC_STATE_RUNNING=1;this.SYNC_STATE_RUNNING_IN_QUEUE=2;this.SYNC_STATE_FINISHED_NOTIFY=3;this.SYNC_STATE_FINISHED=4;this.SYNC_STATE_ERROR_WARNING=-1;this.MSG_SYNCING_DROPBOX_ACCOUNT="We're syncing your account with Dropbox. This may take a few minutes.";this.MSG_SYNCING_FINISHED_DROPBOX_ACCOUNT="We have completed syncing your Dropbox account, you can now sync in real time!";this.MSG_INVALID_FILE_TYPES="We're currently syncing your files, however we've left out some (yet) unsupported file types.";this.MSG_INVALID_IMAGE_ICON="The icon file you have chosen is not a supported image. Please use a PSD or PNG";this.MSG_INVALID_IMAGE_ICON_SIZE="The icon file size is not valid, please choose a file 114x114 pixels in size";this.MSG_SELECT_DEST_IMAGE="You have not selected an image to link to. Please select an image and click save.";this.MSG_INVALID_PSD_TYPE="Sorry we're having problems with one or more of your PSDs please hit the mail icon above to contact support.";this.MSG_INVALID_FILENAME="You've selected an image with an unacceptable filename.";this.HOTSPOT_DELETED=3;this.HOTSPOT_DETACHED=2;this.HOTSPOT_ACTIVE=1;this.PROJECT_PROP_DISABLE_FRAME="ui-prj-disable-frame";this.PROJECT_PROP_SHOW_HINTS="ui-prj-show-hints";this.PROJECT_PROP_DISABLE_SWIPE="ui-prj-disable-swipe";this.PROJECT_PROP_CENTER_IMAGE="ui-prj-center-image";this.PROJECT_PROP_STATUS_BAR="ui-prj-status-bar";this.PROJECT_PROP_FRAME="ui-prj-frame";this.PROJECT_PROP_FRAME_COLOUR="ui-prj-frame-colour";this.PROJECT_PROP_NON_RESPONSIVE="ui-prj-responsive";this.PROJECT_PROP_RETINA_SCALE="ui-prj-retina-scale";this.PROJECT_PROP_REMOVE_STATUS="ui-prj-remove-status";this.PROJECT_PROP_ORIENTATION="ui-prj-orientation";this.PROJECT_PROP_THUMBNAIL_WIDTH="ui-prj-thumbnail-width";this.PROJECT_PROP_BACKGROUND_HEX="ui-prj-background-hex";this.PROJECT_PROP_PROTOTYPE_BACKGROUND_HEX="ui-prj-prototype-background-hex";this.PROP_STATUS_BLACK="0";this.PROP_STATUS_BLACK_CLEAR="1";this.PROP_STATUS_BLACK_WHITE_CLEAR="2";this.ORIENTATION_LANDSCAPE="landscape";this.ORIENTATION_PORTRAIT="portrait";this.FRAME_DESKTOP="desktop-view";this.SUBSCRIPTION_ACTIVE=1;this.SUBSCRIPTION_INACTIVE=0;this.SUBSCRIPTION_CANCELLED=2;this.SUBSCRIPTION_IS_TRIAL=3;this.ARCHIVE_STATUS_READY=0;this.ARCHIVE_STATUS_WORKING=1;this.ARCHIVE_STATUS_FAILED=-1;this.SUB_TYPE_MONTHLY_EARLY=1;this.SUB_TYPE_MONTHLY_FULL=2;this.SUB_TYPE_YEARLY_EARLY=3;this.SUB_TYPE_YEARLY_MONTHLY_FULL=4;this.PRICE_SUB_EARLY_MONTH=500;this.PRICE_SUB_EARLY_YEARLY=4800;this.PAYMENT_TYPE_NONE=0;this.PAYMENT_TYPE_PROCESSING=1;this.PAYMENT_TYPE_INVALIDATED=2;this.ALL_USER_PROPS={ui_new_feature:"ui-new-feature",ui_pro_notify:"ui-pro-notify"};this.TYPE_STANDARD=1;this.TYPE_FIXED_HORIZONTAL=2;this.TYPE_FIXED_VERTICAL=3;this.TYPE_BACK=4;this.TYPE_URL=5;this.TYPE_ANCHOR=6;this.TYPE_POSITION_LEFT=1;this.TYPE_POSITION_RIGHT=2;this.TYPE_POSITION_TOP=3;this.TYPE_POSITION_BOTTOM=4;this.DEVICE_TYPES={IPADMINI:{stringValue:"ipad",width:768,height:1024},IPADAIR:{stringValue:"ipad",width:1536,height:2048},IPHONE3G:{stringValue:"iphone4s",width:320,height:480},IPHONE4S:{stringValue:"iphone4s",width:640,height:960},IPHONE5S:{stringValue:"iphone5",width:640,height:1136},IPHONE6:{stringValue:"iphone6",width:750,height:1334},IPHONE6PLUS:{stringValue:"iphone6plus",width:1080,height:1920},IPHONE6PLUSNATIVE:{stringValue:"iphone6plus",width:1242,height:2208}}}projectConstants=new ProjectConstants;projectHotspots={};function ProjectController(){this.getUser=function(callbackMethod){$.getJSON("/api/user/",{},function(data){callbackMethod(false,"",data)}).success(function(){}).error(function(e){callbackMethod(true,"",{});try{showNotificationMessage(projectConstants.NOTIFY_TYPE_ERROR,"Error retrieving user: there was a problem contacting the server.")}catch(ex){}}).complete(function(){console.log("Completed get user service call")})};this.numUsers=function(callbackMethod){$.getJSON("/api/users/count/",{},function(data){console.log(data);callbackMethod(false,"",data)}).success(function(){}).error(function(e){callbackMethod(true,"",{});try{showNotificationMessage(projectConstants.NOTIFY_TYPE_ERROR,"Error retrieving user: there was a problem contacting the server.")}catch(ex){}}).complete(function(){console.log("Completed get user service call")})};this.numActiveUsers=function(type,callbackMethod){$.getJSON("/api/users/count/active/"+type+"/",{},function(data){console.log(data);callbackMethod(false,"",data)}).success(function(){}).error(function(e){callbackMethod(true,"",{});try{showNotificationMessage(projectConstants.NOTIFY_TYPE_ERROR,"Error retrieving user: there was a problem contacting the server.")}catch(ex){}}).complete(function(){console.log("Completed get user service call")})};this.numContent=function(callbackMethod){$.getJSON("/api/content/count/",{},function(data){console.log(data);callbackMethod(false,"",data)}).success(function(){}).error(function(e){callbackMethod(true,"",{});try{showNotificationMessage(projectConstants.NOTIFY_TYPE_ERROR,"Error retrieving user: there was a problem contacting the server.")}catch(ex){}}).complete(function(){console.log("Completed get user service call")})};this.numProject=function(callbackMethod){$.getJSON("/api/project/count/",{},function(data){console.log(data);callbackMethod(false,"",data)}).success(function(){}).error(function(e){callbackMethod(true,"",{});try{showNotificationMessage(projectConstants.NOTIFY_TYPE_ERROR,"Error retrieving user: there was a problem contacting the server.")}catch(ex){}}).complete(function(){console.log("Completed get user service call")})};this.deleteUser=function(callbackMethod){$.ajax({url:"/api/user/",type:"DELETE",success:function(data,e){callbackMethod(false,"",data)},error:function(e,f){callbackMethod(true,"",{},projectConstants.NOTIFY_TYPE_ERROR);showNotificationMessage(projectConstants.NOTIFY_TYPE_ERROR,"Error retrieving user: there was a problem contacting the server.")}})};this.editUser=function(userObj,callbackMethod){console.log("Editing user ");console.log(userObj);$.ajax({url:"/api/user/",type:"PUT",data:userObj,success:function(data,e){console.log("User returned is ");console.log(data);callbackMethod(false,"",data)},error:function(e,f){callbackMethod(true,"",{},projectConstants.NOTIFY_TYPE_ERROR);try{showNotificationMessage(projectConstants.NOTIFY_TYPE_ERROR,"Error retrieving user: there was a problem contacting the server.")}catch(ex){}}})};this.getProject=function(projectId,callbackSetMethod){$.getJSON("/api/project/"+projectId+"/",{},function(data){callbackSetMethod(false,"",data)}).success(function(){}).error(function(e){console.log("Error could not retrieve project");console.log(e);callbackSetMethod(true,"Error could not retrieve project",{});try{showNotificationMessage(projectConstants.NOTIFY_TYPE_ERROR,"Error retrieving user: there was a problem contacting the server.")}catch(ex){}}).complete(function(){})};this.getProjectSequence=function(projectId,callbackMethod){$.ajax({url:"/api/project/sequence/"+projectId+"/",type:"GET",success:function(data,e){callbackMethod(data)},error:function(e,f){callbackMethod(true,"",{},projectConstants.NOTIFY_TYPE_ERROR)}})};this.sendProjectSequence=function(project,options){$.ajax({url:"/api/project/sequence/"+project.id+"/",type:"PUT",dataType:"json",contentType:"application/json",data:JSON.stringify({images:project.sequencedImageIds()}),success:function(data,e){if(options.success){options.success(data,e)}var sequence_delta=data.sequence_delta;var version=data.version;project.set("sequence_delta",sequence_delta);project.set("version",version);if(Object.size(project.get("images"))>=1){project.set("project_image",project.get("images")[1].thumbnail)}MARVELAPP.models.projects.get("project_collection").set([project],{remove:false});if(typeof MARVELAPP.Router.currentView.projectThumbnailsView!=="undefined"){MARVELAPP.Router.currentView.projectThumbnailsView.enableSortable()}},error:function(e,f){if(options.error){options.error(e,f)}}})};this.getPrototypeProject=function(projectId,callbackSetMethod){function getParameterByName(name){name=name.replace(/[\[]/,"\\[").replace(/[\]]/,"\\]");var regex=new RegExp("[\\?&]"+name+"=([^&#]*)"),results=regex.exec(location.search);return results==null?"":decodeURIComponent(results[1].replace(/\+/g," "))}var xf=getParameterByName("xf");var xf_param="";if(typeof xf!=="undefined"){xf_param="?xf="+xf}$.getJSON("/api/prototype/"+projectId+"/"+xf_param,{},function(data){callbackSetMethod(false,"",data)}).success(function(){}).error(function(e){console.log("Error could not retrieve project");console.log(e);callbackSetMethod(true,"Error could not retrieve project",{});try{showNotificationMessage(projectConstants.NOTIFY_TYPE_ERROR,"Error retrieving user: there was a problem contacting the server.")}catch(ex){}}).complete(function(){})};this.getAllProjects=function(callbackMethod){console.log("Calling get project ");$.getJSON("/api/project/all/",{},function(data){try{callbackMethod(data)}catch(err){try{showNotificationMessage(projectConstants.NOTIFY_TYPE_ERROR,"Error retrieving projects: "+err)}catch(ex){}}}).success(function(){}).error(function(e){console.log("Error could not retrieve projects");console.log(e);callbackMethod(true,"Error could not retrieve projects",{},projectConstants.NOTIFY_TYPE_ERROR);try{showNotificationMessage(projectConstants.NOTIFY_TYPE_ERROR,"Error retrieving projects: there was a problem contacting the server.")}catch(ex){}}).complete(function(){})};this.createProject=function(projectName,password,callbackMethod){$.ajax({url:"/api/project/create/"+projectName+"/",type:"POST",data:{password:password},success:function(data,e){callbackMethod(false,"",data)},error:function(e,f){callbackMethod(true,"",{},projectConstants.NOTIFY_TYPE_ERROR);try{showNotificationMessage(projectConstants.NOTIFY_TYPE_ERROR,"Error creating project: there was a problem contacting the server.")}catch(ex){}}})};this.deleteProject=function deleteProject(project_id,callbackMethod){$.ajax({url:"/api/project/"+project_id+"/",type:"DELETE",success:function(data,e){callbackMethod(false,"",project_id)},error:function(e,f){callbackMethod(true,"",{},projectConstants.NOTIFY_TYPE_ERROR);try{showNotificationMessage(projectConstants.NOTIFY_TYPE_ERROR,"Error deleting project: there was a problem contacting the server.")}catch(ex){}}})};this.duplicateProject=function(project_id,callbackMethod){console.log("Duplicating project: "+project_id);$.ajax({url:"/api/project/clone/"+project_id+"/",type:"POST",dataType:"json",success:function(data,e){callbackMethod(false,"Project duplicated",data)}})};this.editProject=function(project,callback_method){console.log("Editing the project");console.log(project);$.ajax({url:"/api/project/"+project.id+"/",type:"PUT",dataType:"json",contentType:"application/json",data:JSON.stringify(project.attributes),success:function(data,e){if(callback_method!=undefined){callback_method(project)}},error:function(e,f){try{showNotificationMessage(projectConstants.NOTIFY_TYPE_ERROR,"Error editing the project: there was a problem contacting the server.")}catch(ex){}}})};this.getHotspots=function(imageId,project_id,callbackMethod){$.getJSON("/api/hotspot/all/"+project_id+"/"+imageId+"/",{},function(data){try{var dataRetrieved=data;var sorted_data={};$.each(dataRetrieved,function(key,value){sorted_data[value.id]=value});projectHotspots[imageId]=sorted_data;try{callbackMethod()}catch(err2){}}catch(err){console.log(err);try{showNotificationMessage(projectConstants.NOTIFY_TYPE_ERROR,"Error getting hotspot")}catch(ex){}}}).success(function(){}).error(function(e){try{showNotificationMessage(projectConstants.NOTIFY_TYPE_ERROR,"Error getting hotspot: there was a problem contacting the server.")}catch(ex){}}).complete(function(){})};this.addHotspot=function(hotspotObj,imageObj,projectId){hotspotObj["img_owner_fk"]=imageObj.id;$.ajax({url:"/api/hotspot/"+projectId+"/",type:"POST",data:JSON.stringify(hotspotObj),success:function(data,e){var hotspotObj=data;if(typeof projectHotspots[hotspotObj.img_owner_fk]==="undefined"){projectHotspots[hotspotObj.img_owner_fk]={}}var existing_hotspot=projectHotspots[hotspotObj.img_owner_fk][hotspotObj["id"]];if(typeof existing_hotspot==="undefined"){existing_hotspot=projectHotspots[hotspotObj.img_owner_fk][hotspotObj["uuid"]]}if(typeof existing_hotspot==="undefined"){existing_hotspot=hotspotObj}else{existing_hotspot.id=hotspotObj.id}delete projectHotspots[hotspotObj.img_owner_fk][hotspotObj["uuid"]];delete projectHotspots[hotspotObj.img_owner_fk][hotspotObj["id"]];projectHotspots[hotspotObj.img_owner_fk][hotspotObj["id"]]=existing_hotspot;if(typeof highlightedHotspot!="undefined"){if(highlightedHotspot.uuid==hotspotObj.uuid){if(hasHotspotChanged(highlightedHotspot,hotspotObj)==true){setHighlightedHotspotId(existing_hotspot.id);projectHotspots[hotspotObj.img_owner_fk][hotspotObj["id"]]=highlightedHotspot}else{setHighlightedHotspot(existing_hotspot)}}}previous_hotspots[hotspotObj.id]=existing_hotspot;MARVELAPP.models.current_project.set("hotspots_delta",hotspotObj.project_hotspot_delta);MARVELAPP.models.current_project.addHotspotForImageIfNew(existing_hotspot,hotspotObj.img_owner_fk);setIsHotspotSaving(false,hotspotObj.id);_.each(_.keys(projectHotspots),function(imageId){_.each(_.keys(projectHotspots[imageId]),function(hotspotId){if(parseInt(imageId,10)!==parseInt(projectHotspots[imageId][hotspotId].img_owner_fk,10)){delete projectHotspots[imageId][hotspotId]}})})},error:function(e,f){setIsHotspotSaving(false,hotspotObj.id);try{showNotificationMessage(projectConstants.NOTIFY_TYPE_ERROR,"Error adding the hotspot: there was a problem contacting the server.")}catch(ex){}jcrop_api.enable()},complete:function(e,f){console.log("Hotspot has been saved")}})};this.addDuplicateHotspot=function(hotspotObj,imageObj,projectId,callback_method,destImgId){hotspotObj["img_owner_fk"]=imageObj.id;setIsHotspotSaving(true,hotspotObj.id);$.ajax({url:"/api/hotspot/duplicate/"+projectId+"/",type:"POST",data:JSON.stringify(hotspotObj),success:function(data,e){var hotspotObj=data;MARVELAPP.models.current_project.set("hotspots_delta",hotspotObj.project_hotspot_delta);if(typeof highlightedHotspot!=="undefined"){if(highlightedHotspot.uuid==hotspotObj.uuid){highlightedHotspot.id=hotspotObj.id}}callback_method(hotspotObj);$(".duplicate-button").removeClass("wait-state");$("#duplicate-modal").removeClass("activated");setIsHotspotSaving(false,hotspotObj.id)},error:function(e,f){$(".duplicate-button").removeClass("wait-state");$("#duplicate-modal").removeClass("activated");setIsHotspotSaving(false,hotspotObj.id);try{showNotificationMessage(projectConstants.NOTIFY_TYPE_ERROR,"Error adding the hotspot: there was a problem contacting the server.")}catch(ex){}},complete:function(e,f){}})};this.deleteHotspot=function(hotspotObj,projectId,imageObj,setIsDeletingHotspot){console.log("Deleting hotspot ");console.log(hotspotObj);var hotspot_id=hotspotObj.id;$.ajax({url:"/api/hotspot/"+projectId+"/"+hotspotObj.id+"/",type:"DELETE",data:hotspotObj,success:function(data,e){console.log("Returned hotspot object is");delete projectHotspots[hotspotObj.img_owner_fk][hotspotObj.id];$("#hotspot_"+hotspotObj.id).remove();if(typeof imageObj!=="undefined"){refreshHotspotObjects(imageObj)}if(typeof setIsDeletingHotspot!=="undefined"){setIsDeletingHotspot(false)}},error:function(e,f){setIsDeletingHotspot(false);try{showNotificationMessage(projectConstants.NOTIFY_TYPE_ERROR,"Error deleting the hotspot: there was a problem contacting the server.")}catch(ex){}}})};this.deleteDuplicateHotspot=function(hotspotObj,projectId,imageObj,setIsDeletingHotspot,callback_method){if(imageObj!=undefined){image_path=imageObj.id+"/"}else{image_path=""}$.ajax({url:"/api/hotspot/duplicate/"+projectId+"/"+hotspotObj.id+"/"+image_path,type:"DELETE",data:hotspotObj,success:function(data,e){setIsDeletingHotspot(false);console.log(data);hotspotObj=data;$("#hotspot_"+hotspotObj.id).remove();callback_method(hotspotObj,imageObj)},error:function(e,f){setIsDeletingHotspot(false);try{showNotificationMessage(projectConstants.NOTIFY_TYPE_ERROR,"Error deleting the hotspot: there was a problem contacting the server.")}catch(ex){}}})};this.numUploadImagesInQueue=0;this.isNumUploadLocked=false;this.getUploadImagesInQueue=function(){return this.numUploadImagesInQueue};this.addUploadImageToQueue=function(){if(this.isNumUploadLocked==false){this.isNumUploadLocked=true;this.numUploadImagesInQueue=this.numUploadImagesInQueue+1;this.isNumUploadLocked=false}else{this.addUploadImageToQueue()}};this.removeUploadImageFromQueue=function(){if(this.isNumUploadLocked==false){this.isNumUploadLocked=true;this.numUploadImagesInQueue=this.numUploadImagesInQueue-1;if(this.numUploadImagesInQueue==0){}this.isNumUploadLocked=false}else{this.removeUploadImageFromQueue()}};this.numDeleteImagesInQueue=0;this.isDeleteImageQueueLocked=false;this.getDeleteImagesInQueue=function(){return this.numDeleteImagesInQueue};this.addDeleteImageToQueue=function(){if(this.isDeleteImageQueueLocked==false){this.isDeleteImageQueueLocked=true;this.numDeleteImagesInQueue=this.numDeleteImagesInQueue+1;this.isDeleteImageQueueLocked=false}else{this.addDeleteImageToQueue()}};this.removeDeleteImageFromQueue=function(){if(this.isDeleteImageQueueLocked==false){this.isDeleteImageQueueLocked=true;this.numDeleteImagesInQueue=this.numDeleteImagesInQueue-1;if(this.numDeleteImagesInQueue==0){}this.isDeleteImageQueueLocked=false}else{this.removeDeleteImageFromQueue()}};this.addImageObject=function(projectId,theImage,callbackMethod){if(theImage.id==""){theImage.id="0";try{mixpanel.track("Adding new image")}catch(e){}}else{mixpanel.track("Updating image")}$.ajax({url:"/api/content/"+theImage.id+"/"+projectId+"/",type:"POST",data:theImage,success:function(data,e){callbackMethod(false,"",data)},error:function(e,f){callbackMethod(true,"",{},projectConstants.NOTIFY_TYPE_ERROR);try{showNotificationMessage(projectConstants.NOTIFY_TYPE_ERROR,"Error adding the image: there was a problem contacting the server.")}catch(ex){}}})};this.editImageMetaData=function(projectId,theImage,callbackMethod){$.ajax({url:"/api/content/meta/"+projectId+"/",type:"POST",data:theImage,success:function(data,e){if(callbackMethod){callbackMethod(false,"",data)}},error:function(e,f){callbackMethod(true,"",{},projectConstants.NOTIFY_TYPE_ERROR);try{showNotificationMessage(projectConstants.NOTIFY_TYPE_ERROR,"Error adding the image: there was a problem contacting the server.")}catch(ex){}}})};this.getImageObject=function(projectId,theImage,callbackMethod){$.getJSON("/api/content/"+theImage.id+"/"+projectId+"/",{},function(data){try{if(data!=undefined){callbackMethod(false,"",data)}}catch(err){console.log(err);try{showNotificationMessage(projectConstants.NOTIFY_TYPE_ERROR,"Error getting image info, (3) - "+err)}catch(ex){}callbackMethod(true,"",theImage)}}).success().error(function(err){try{showNotificationMessage(projectConstants.NOTIFY_TYPE_ERROR,"Error getting image info: there was a problem contacting the server, retrying.")}catch(ex){}callbackMethod(true,"",theImage)}).complete()};this.deleteProjectImage=function(projectId,theImage,callbackMethod){projectController=this;$.ajax({url:"/api/content/"+theImage.id+"/"+projectId+"/",type:"DELETE",data:theImage,success:function(data,e){projectController.removeDeleteImageFromQueue();callbackMethod(false,"",theImage)},error:function(e,f){projectController.removeDeleteImageFromQueue();callbackMethod(true,"",theImage,projectConstants.NOTIFY_TYPE_ERROR);try{showNotificationMessage(projectConstants.NOTIFY_TYPE_ERROR,"Error deleting the image: there was a "+"problem contacting the server.")}catch(ex){}}})};this.deleteProjectImages=function(projectId,images,callbackMethod){projectController=this;$.ajax({url:"/api/content/delete/all/"+projectId+"/",type:"DELETE",data:JSON.stringify(images),success:function(data,e){callbackMethod(false,"",images)},error:function(e,f){callbackMethod(true,"",theImage,projectConstants.NOTIFY_TYPE_ERROR);try{showNotificationMessage(projectConstants.NOTIFY_TYPE_ERROR,"Error deleting the images: "+"there was a problem contacting the server.")}catch(ex){}}})};this.sendProjectEmail=function(projectId,email,project_url,callbackMethod){console.log("Sending email for "+projectId+" with  "+email);$.ajax({url:"/api/project/email/"+projectId+"/?email="+email+"",type:"POST",success:function(data,e){callbackMethod(false,"",data)},error:function(e,f){var responseJson=$.parseJSON(e.responseText);callbackMethod(true,responseJson.message,projectConstants.NOTIFY_TYPE_ERROR);try{showNotificationMessage(projectConstants.NOTIFY_TYPE_ERROR,responseJson.message+": there was a problem contacting the server.")}catch(ex){}}})};this.sendProjectSms=function(projectId,msisdn,project_url,callbackMethod){console.log("Sending sms for "+projectId+" with  "+msisdn);msisdn=msisdn.replace("+","");$.ajax({url:"/api/project/sms/"+projectId+"/"+msisdn+"/",type:"POST",success:function(data,e){callbackMethod(false,"",data)},error:function(e,f){var responseJson=$.parseJSON(e.responseText);callbackMethod(true,responseJson.message,projectConstants.NOTIFY_TYPE_ERROR);try{showNotificationMessage(projectConstants.NOTIFY_TYPE_ERROR,responseJson.message+": there was a problem contacting the server.")}catch(ex){}}})};this.sendDownloadEmail=function(archiveId,email,project_url,callbackMethod){console.log("Sending email for "+archiveId+" with  "+email);$.ajax({url:"/api/archive/email/"+archiveId+"/"+email+"/",type:"POST",success:function(data,e){callbackMethod(false,"",data)},error:function(e,f){var responseJson=$.parseJSON(e.responseText);callbackMethod(true,responseJson.message,projectConstants.NOTIFY_TYPE_ERROR);try{showNotificationMessage(projectConstants.NOTIFY_TYPE_ERROR,responseJson.message+": there was a problem contacting the server.")}catch(ex){}}})};this.sendDownloadSms=function(archiveId,msisdn,project_url,callbackMethod){console.log("Sending sms for "+archiveId+" with  "+msisdn);msisdn=msisdn.replace("+","");$.ajax({url:"/api/prototype/send/sms/"+archiveId+"/"+msisdn+"/",type:"POST",success:function(data,e){callbackMethod(false,"",data)},error:function(e,f){var responseJson=$.parseJSON(e.responseText);callbackMethod(true,responseJson.message,projectConstants.NOTIFY_TYPE_ERROR);try{showNotificationMessage(projectConstants.NOTIFY_TYPE_ERROR,responseJson.message+": there was a problem contacting the server.")}catch(ex){}}})};this.sendDownloadEmail=function(archiveId,msisdn,project_url,callbackMethod){msisdn=msisdn.replace("+","");$.ajax({url:"/api/prototype/send/email/"+archiveId+"/"+msisdn+"/",type:"POST",success:function(data,e){callbackMethod(false,"",data)},error:function(e,f){var responseJson=$.parseJSON(e.responseText);callbackMethod(true,responseJson.message,projectConstants.NOTIFY_TYPE_ERROR);try{showNotificationMessage(projectConstants.NOTIFY_TYPE_ERROR,responseJson.message+": there was a problem contacting the server.")}catch(ex){}}})};this.editProperty=function(property,callbackMethod){$.ajax({url:"/api/properties/",type:"POST",data:property,success:function(data,e){callbackMethod(false,"",data)},error:function(e,f){callbackMethod(true,"",{},projectConstants.NOTIFY_TYPE_ERROR)}})};this.editProjectProperty=function(project_id,property,callbackMethod){$.ajax({url:"/api/project/property/"+project_id+"/",type:"POST",data:property,success:function(data,e){callbackMethod(false,"",data);MARVELAPP.models.current_project.setProperty(data);MARVELAPP.models.current_project.trigger("change:properties")},error:function(e,f){callbackMethod(true,"",{},projectConstants.NOTIFY_TYPE_ERROR)}})};this.subscribeUser=function(token,plan_id,interval,quantity,callback){console.log("Adding subscription to plan",plan_id,interval,token);$.ajax({url:"/api/stripe/subscribe/",type:"POST",data:{token:token,plan_id:plan_id,interval:interval,quantity:quantity},success:function(data,e){callback(false,"",data)},error:function(e,f){callback(true,"",e,projectConstants.NOTIFY_TYPE_ERROR)}})};this.verifyPassword=function(password,project_encoding,callbackMethod){$.ajax({url:"/api/project/verify/"+project_encoding+"/",type:"POST",data:{password:password},success:function(data,e){callbackMethod(false,"",data)},error:function(e,f){callbackMethod(true,"",{},projectConstants.NOTIFY_TYPE_ERROR)}})};this.unsubscribeUser=function(callbackMethod){$.ajax({url:"/api/stripe/subscribe/",type:"DELETE",success:function(data,e){callbackMethod(false,"",data)},error:function(e,f){callbackMethod(true,"",{},projectConstants.NOTIFY_TYPE_ERROR);try{showNotificationMessage(projectConstants.NOTIFY_TYPE_ERROR,"Error unsubscribing from Marvel. Please contact support help@marvelapp.com")}catch(ex){}}})};var is_polling=false;this.pollContent=function(project,callbackMethod){if(project!=undefined){if(project.id==undefined){callbackMethod(true,"",project);return}}else{callbackMethod(true,"",project);return}$.ajax({url:"/api/content/poll/"+project.id+"/",type:"POST",data:{cursor:project.cursor},success:function(data,e){callbackMethod(false,"",data)},error:function(e,f){callbackMethod(true,"",{},projectConstants.NOTIFY_TYPE_ERROR)}})};this.generatePrototype=function(projectId,callbackMethod,type,description){var call_url="/api/prototype/build/"+projectId+"/";if(type==MARVELAPP.constants.prototype.ARCHIVE_TYPE_DOWNLOAD){call_url="/api/prototype/zip/"+projectId+"/"}$.ajax({url:call_url,type:"POST",data:{type:type,description:description},success:function(data,e){callbackMethod(false,"",data)
},error:function(e,f){response_data={response:e.responseJSON,type:type,status:e.status};console.log(e,f);if(e.status==400&&e.responseJSON.message=="You are already building an app of this type"){callbackMethod(true,e.responseJSON.message,response_data,projectConstants.NOTIFY_TYPE_ERROR)}else if(e.status==423){callbackMethod(true,e.responseJSON.message,response_data,projectConstants.NOTIFY_TYPE_ERROR)}else{callbackMethod(true,"Uh oh! Problem generating file",{},projectConstants.NOTIFY_TYPE_ERROR)}}})};this.getDownload=function(projectId,archive_id,callbackMethod){$.ajax({url:"/api/prototype/archive/"+projectId+"/"+archive_id+"/",type:"GET",success:function(data,e){callbackMethod(false,"",data)},error:function(e,f){callbackMethod(true,"",{},projectConstants.NOTIFY_TYPE_ERROR)}})};this.getLayerScreens=function(content_id,callbackMethod){$.ajax({url:"/api/secret-sauce/sketch/"+content_id+"/sync/",type:"GET",success:function(data,e){console.log("Sauce content sync success")},error:function(e,f){callbackMethod(true,"",{},projectConstants.NOTIFY_TYPE_ERROR)}})};this.exportLayerScreens=function(content_id,project_id,export_layers,callbackMethod){var data={export_layers:export_layers,fonts:MARVELAPP.models.required_fonts};var url="/api/content/screens/"+content_id+"/"+project_id+"/";console.log("Content screens URL:");console.log(url);MARVELAPP.models.required_fonts=[];$.ajax({url:url,type:"POST",data:JSON.stringify(data),success:function(data,e){callbackMethod(false,"",data)},error:function(e,f){callbackMethod(true,"",{},projectConstants.NOTIFY_TYPE_ERROR)}})};this.pollProjectContent=function(updateCallback){var projectCursor=MARVELAPP.models.current_project.get("cursor");if(!projectCursor||!projectCursor.length){projectCursor="init"}var project_poll_data={id:MARVELAPP.models.current_project.id,cursor:projectCursor,hotspots_delta:MARVELAPP.models.current_project.get("hotspots_delta"),sequence_delta:MARVELAPP.models.current_project.get("sequence_delta"),backoff:"10",content:[],project_version:MARVELAPP.models.current_project.get("version")};MARVELAPP.models.poll_project=new MARVELAPP.ProjectDeltaModel;MARVELAPP.models.poll_project.set(project_poll_data);var options={delay:MARVELAPP.constants.projects.POLL_DELTA_TIMING,delayed:true,continueOnError:true};if(typeof MARVELAPP.pollers.project_delta_poller!=="undefined"){MARVELAPP.pollers.project_delta_poller.stop()}MARVELAPP.pollers.project_delta_poller=Backbone.Poller.get(MARVELAPP.models.poll_project,options);MARVELAPP.pollers.project_delta_poller.on("success",_.bind(function(model,response){updateCallback(model,response)},this));MARVELAPP.pollers.project_delta_poller.on("complete",function(model){});MARVELAPP.pollers.project_delta_poller.on("error",function(model){});MARVELAPP.pollers.project_delta_poller.start()}}function VPController(){this.getProject=function(projectId,callbackSetMethod){$.getJSON("/project/getproject",{pid:projectId},function(data){try{if(data["responseCode"]=="200"){projData=data["data"];callbackSetMethod(projData);console.log("Data returned is ");console.log(projData)}else if(data["responseCode"]=="401"){showNotificationMessage(projectConstants.NOTIFY_TYPE_ERROR,"Error retrieving project: "+data["message"])}else{showNotificationMessage(projectConstants.NOTIFY_TYPE_ERROR,"Error retrieving project: "+data["message"])}}catch(err){showNotificationMessage(projectConstants.NOTIFY_TYPE_ERROR,"Error retrieving project: "+err)}})}}MARVELAPP.PrototypeRouter=Backbone.Router.extend({url:null,routes:{"*screen":"screen"},initialize:function(){var root=window.location.pathname;this.startHistory(root);this.listenTo(Backbone,"page-transition",this.animate)},startHistory:function(_root){Backbone.history.start({silent:true,hashChange:true,root:_root})},screen:function(screen_){var target_screen=screen_;var found=false;for(id in prototype.model.attributes.images){if(prototype.model.attributes.images[id].id==target_screen){found=true;break}}if(target_screen==null)target_screen=prototype.model.attributes.images[1].id;if(!found){target_screen=prototype.model.attributes.images[1].id;if(history.pushState){history.pushState(null,null,"#"+target_screen)}else{location.hash="#"+target_screen}}var back_transition="none";for(id in transition_history){if(current_screen==transition_history[id].target&&target_screen==transition_history[id].source){if(!window.chrome)back_transition=transition_history[id].transition;transition_history.remove(id)}}var reverse=true;prototype.handleTransition(current_screen,target_screen,back_transition,reverse)},animate:function(currentScreen,targetScreen,transition){setTimeout(function(){Backbone.history.navigate(targetScreen,{trigger:false})},prototype.getTiming(transition));var a={url:window.location.href,source:currentScreen,target:targetScreen,transition:transition};transition_history.unshift(a)}});MARVELAPP.ProjectsCollection=Backbone.Collection.extend({initialize:function(){this.listenTo(this,"add",_.bind(this.addingModel,this));this.listenTo(this,"reset",_.bind(this.resetModel,this))},resetModel:function(collection,response,options){},addingModel:function(collection,response,options){},getModelByContentOwner:function(project_id){return this.findWhere({id:project_id})},getModelById:function(project_name){return this.findWhere({id:project_name})},getModelByImageId:function(team_fk){return this.where({team_fk:team_fk})},getModelByOwner:function(owner_fk){return this.where({owner_fk:owner_fk})},comparators:{id:function(project){return Number(project.get("id"))},reverse_id:function(project){return-Number(project.get("id"))},name:function(project){return project.get("name")},date:function(project){return Date.createFromMysql(project.get("created_on")).getTime()}}});MARVELAPP.MemberCollection=Backbone.Collection.extend({initialize:function(){this.listenTo(this,"add",_.bind(this.addingModel,this));this.listenTo(this,"reset",_.bind(this.resetModel,this))},resetModel:function(collection,response,options){},addingModel:function(collection,response,options){},getMemberById:function(user_id){return this.findWhere({id:user_id})},comparators:{id:function(member){return Number(member.get("id"))},reverse_id:function(member){return-Number(member.get("id"))},name:function(member){return member.get("username")}}});MARVELAPP.ProjectsCollection=Backbone.Collection.extend({initialize:function(){this.listenTo(this,"add",_.bind(this.addingModel,this));this.listenTo(this,"reset",_.bind(this.resetModel,this))},resetModel:function(collection,response,options){},addingModel:function(collection,response,options){},getModelByProjectId:function(project_id){return this.findWhere({id:project_id})},getModelByName:function(project_name){return this.findWhere({id:project_name})},getModelByTeamFk:function(team_fk){return this.where({team_fk:team_fk})},getModelByOwner:function(owner_fk){return this.where({owner_fk:owner_fk})},comparators:{id:function(project){return Number(project.get("id"))},reverse_id:function(project){return-Number(project.get("id"))},name:function(project){return project.get("name")},date:function(project){return Date.createFromMysql(project.get("created_on")).getTime()}}});MARVELAPP.TeamsCollection=Backbone.Collection.extend({initialize:function(){this.listenTo(this,"add",_.bind(this.addingModel,this));this.listenTo(this,"reset",_.bind(this.resetModel,this))},resetModel:function(collection,response,options){},addingModel:function(collection,response,options){},getModelByTeamId:function(teamId){return this.findWhere({id:teamId})},getModelByInviteAcceptedOrOwner:function(){return this.filter(function(model){return model.attributes.invite_state===MARVELAPP.constants.invite.TEAM_MEMBER_STATE_ACCEPTED||model.attributes.role===MARVELAPP.constants.role.ROLE_OWNER})},getInvitesNotDeclined:function(){return this.where({invite_state:MARVELAPP.constants.invite.TEAM_MEMBER_STATE_INVITED})}});MARVELAPP.HotspotModel=Backbone.Model.extend({url:"/api/hotspot/",defaults:{id:"",uuid:"",x:"",y:"",x2:"",y2:"",dest_img_fk:"",img_owner_fk:"",transition:"",action:"",owner_hotspot:"",status:"",images:"",type:"",location:"",url:"",external_url:"",delta_check:"",project_hotspot_delta:""},fetchHotspot:function(id){if(typeof id=="undefined"){id=this.get("id")}this.fetch({url:this.url+""+id+"/",success:_.bind(this.success,this),error:_.bind(this.error,this)})},error:function(model,response,options){showNotificationMessage(projectConstants.NOTIFY_TYPE_WARN,MARVELAPP.messages.PROJECT_NOT_FOUND)},success:function(model,response,options){this.set(response)},initialize:function(){this.listenTo(this,"sync",_.bind(this.runningSync,this))},isIncompleteHotspot:function(){if(!this.get("type")||this.get("type")===""){return true}if(this.get("type")===1&&this.get("img_owner_fk")&&this.get("dest_img_fk")){if(this.get("owner_hotspot")){return false}if(parseInt(this.get("img_owner_fk"),10)===parseInt(this.get("dest_img_fk"),10)){return true}}return false},parse:function(data){},runningSync:function(model,response){if(typeof model!=="undefined"&&typeof response.id!=="undefined"){if(model.id==response.id){this.set(response)}}}});MARVELAPP.InviteModel=Backbone.Model.extend({url:"/api/team/invite/",defaults:{team_id:undefined,invitee:undefined,inviter:undefined,state:MARVELAPP.constants.invite.TEAM_MEMBER_STATE_INVITED,email:undefined,is_gifted:false,is_coupon:false,is_allowance:false},initialize:function(){this.listenTo(this,"sync",_.bind(this.runningSync,this))},runningSync:function(){console.log("RUNNING: Teams sync")}});MARVELAPP.MemberModel=Backbone.Model.extend({url:function(){return this.get("url")},defaults:{id:"",username:"",email:"",created_on:"",role:"Team Member",invite_state:"Invited",gifted_owner:null,is_gifted:null,user_team_count:0}});MARVELAPP.ModalModel=Backbone.Model.extend({defaults:{topHeading:MARVELAPP.constants.modal.TOP_HEADER,contentHeading:MARVELAPP.constants.modal.CONTENT_HEADER,buttonText:MARVELAPP.constants.modal.BUTTON_TEXT,buttonColor:MARVELAPP.constants.modal.BUTTON_COLOR,secondaryLink:"",size:MARVELAPP.constants.modal.SIZE,modalClass:""}});MARVELAPP.ProjectDeltaModel=Backbone.Model.extend({url:function(){return"/api/content/poll/"+this.get("id")+"/"+this.currentCursor()+"/"},defaults:{id:null,cursor:null,hotspots_delta:null,sequence_delta:null,backoff:"10",content:[],project_version:0},error:function(model,response,options){},success:function(model,response,options){this.set(response)},currentCursor:function(){var cursor=this.attributes.cursor;if(cursor==""||cursor==null||typeof cursor==="undefined"){cursor=null}return cursor},initialize:function(){this.listenTo(this,"sync",_.bind(this.runningSync,this))},parse:function(data){},runningSync:function(model,response){if(model.id==response.id){this.set(response)}}});MARVELAPP.ProjectModel=Backbone.Model.extend({url:"/api/project/",defaults:{name:""},fetchProject:function(id){if(typeof id=="undefined"){id=this.get("id")}console.log("fetching project");this.fetch({url:this.url+""+id+"/",success:_.bind(this.success,this),error:_.bind(this.error,this)})},error:function(model,response,options){showNotificationMessage(projectConstants.NOTIFY_TYPE_WARN,MARVELAPP.messages.PROJECT_NOT_FOUND)},success:function(model,response,options){this.set(response)},initialize:function(){this.listenTo(this,"sync",_.bind(this.runningSync,this))},parse:function(data){},addImage:function(image,sequenceNumber){if(!image.md5){image.md5=md5(image.name)}if(typeof image.is_new==="undefined"){if(!this.getImageByName(image.name)){image.is_new=true}else{image.is_new=false;sequenceNumber=this.getSequenceNumberOfImage(image)}}if(typeof sequenceNumber==="undefined"){sequenceNumber=this.getNextSequenceNumber()}image.seq=sequenceNumber;this.get("images")[sequenceNumber]=image;this.trigger("change:images")},updateStatusByUuid:function(uuid,status){var existingImage=this.getImageForUUID(uuid);console.log("updateStatusByUuid:",existingImage,uuid,status);if(typeof existingImage!="undefined"){var sequenceNumber=existingImage.seq;this.get("images")[sequenceNumber].status=status;this.trigger("change:images")}},updateImage:function(image,sequenceNumber){var existingImage=this.getImageForId(image.id)||this.getImageByName(image.name);if(existingImage){existingImage.status=image.status;existingImage.uuid=image.uuid;existingImage.seq=sequenceNumber}},replaceImageWithDropboxImage:function(newImage,imageId){var file_extension=newImage.name.split(".").pop();var existingImage=this.getImageForId(imageId);if(typeof existingImage==="undefined"){existingImage=this.getImageByName(newImage.name)}var directory=getDirectory(newImage.link,newImage.name);existingImage.name=newImage.name;if(file_extension==="psd"){existingImage.thumbnail=newImage.thumbnails["640x480"];existingImage.thumbnail.url=newImage.thumbnails["640x480"]}else{existingImage.url=newImage.src||newImage.link}try{existingImage.thumbnail=newImage.thumbnails["640x480"]}catch(e){}existingImage.direct_url=newImage.link;existingImage.directory=directory;existingImage.md5=md5(existingImage.name);existingImage.status=2;if(!newImage.size){newImage.size=0}existingImage.size=newImage.size;existingImage.is_dropbox=true;existingImage.mime_type=ext_to_mimes[file_extension.toLowerCase()];existingImage.seq=this.getSequenceForImageId(existingImage.id);this.addImage(existingImage,existingImage.seq);return existingImage},removeImage:function(sequenceNumber){delete this.get("images")[sequenceNumber];this.trigger("change:images")},deleteImageFromProject:function(imageToDelete,projectHotspots){for(var id in this.get("images")){var imageObject=this.get("images")[id];if(imageToDelete.id==imageObject.id){this.removeImage(id);delete projectHotspots[id];for(var imageId in projectHotspots){var hotspots=projectHotspots[imageId];for(var hotspotId in hotspots){var hotspot=hotspots[hotspotId];if(hotspot.dest_img_fk==imageToDelete.id){delete projectHotspots[imageId][hotspotId]}}}return}}},addHotspotForImageIfNew:function(hotspotToAdd,imageId){var image=this.getImageForId(imageId);if(!image.hotspots){image.hotspots=[]}if(!_.find(image.hotspots,function(hotspot){return hotspotToAdd.uuid===hotspot.uuid})){image.hotspots.push(hotspotToAdd)}},removeHotspotForImage:function(hotspotToRemove,imageId){var image=this.getImageForId(imageId);image.hotspots=_.filter(image.hotspots,function(hotspot){return hotspotToRemove.uuid!==hotspot.uuid})},sortImagesByIds:function(imageIds){var newImagesObject={};_.each(imageIds,_.bind(function(id,index){newImagesObject[index+1]=this.getImageForId(id)},this));this.set("images",newImagesObject)},sequencedImageIds:function(){var sequencedImageIds={};_.each(this.get("images"),_.bind(function(image,index){sequencedImageIds[index+1]=image.id},this));return sequencedImageIds},getSequenceNumberOfImage:function(imageToFind){var num;_.each(this.get("images"),function(image,sequenceNumber){if(image.id&&image.id===imageToFind.id||image.name===imageToFind.name){num=sequenceNumber}});return num},getPropertyForName:function(name){var property=_.find(this.get("properties"),function(property){if(name===property.name){return property}});return property||{}},setProperty:function(data){_.each(this.get("properties"),_.bind(function(property,idx){if(property.id==data.id){this.get("properties")[idx]=data}},this))},numberOfScreens:function(){var numScreens=0;_.each(this.get("images"),_.bind(function(image,index){if(typeof image!=="undefined"){if(!image.is_app_icon){numScreens=numScreens+1}}else{delete this.get("images")[index]}},this));return numScreens},numberOfImages:function(){return Object.size(this.get("images"))},totalContentSize:function(){var totalSize=0;_.each(this.get("images"),_.bind(function(image,index){totalSize=totalSize+parseInt(image.size)},this));return totalSize},getNextSequenceNumber:function(isLocked){isLocked=isLocked||false;var sequenceNumber=0;if(isLocked===false){isLocked=true;sequenceNumber=Object.size(this.get("images"))+1;isLocked=false;return sequenceNumber}else{return this.getNextSequenceNumber(isLocked)}},getSequenceForImageId:function(imageId){var sequenceNumber;_.each(this.get("images"),_.bind(function(image,index){if(image.id==imageId){sequenceNumber=index}},this));return sequenceNumber},getImageForId:function(id){return _.find(this.get("images"),_.bind(function(image,index){if(parseInt(image.id,10)===parseInt(id,10)){return true}else if(md5(image.name||"")===id){return true}return false},this))},getImageForUUID:function(uuid){return _.find(this.get("images"),_.bind(function(image,index){if(image.uuid==uuid){return true}return false},this))},getImageByName:function(name){return _.find(this.get("images"),_.bind(function(image,index){return image.name==name||md5(image.name)===name},this))},firstImageDimensions:function(overrideWidth,overrideHeight){var sequence;var dimensions={width:0,height:0};for(sequence in this.get("images")){if(this.get("images")[sequence].width){dimensions.width=this.get("images")[sequence].width;dimensions.height=this.get("images")[sequence].height;break}}if(!dimensions.width||!dimensions.height){if(_.isNumber(overrideWidth)||_.isNumber(overrideHeight)){dimensions.width=overrideWidth;dimensions.height=overrideHeight}}return dimensions},firstImageRatio:function(overrideWidth,overrideHeight){var firstImageDimensions=this.firstImageDimensions(overrideWidth,overrideHeight);return firstImageDimensions.width/firstImageDimensions.height},probableDevice:function(){var dimensions=this.firstImageDimensions();var deviceTypes=projectConstants.DEVICE_TYPES;var iDevices=[deviceTypes.IPADMINI,deviceTypes.IPADAIR,deviceTypes.IPHONE4S,deviceTypes.IPHONE3G,deviceTypes.IPHONE5S,deviceTypes.IPHONE6,deviceTypes.IPHONE6PLUS,deviceTypes.IPHONE6PLUSNATIVE];var i;var matchesDimensionsEitherWay=function(dimensionsToTest,predicate){var matches=false;if(dimensionsToTest.width===predicate.width){matches=true}else if(dimensionsToTest.width===predicate.height){matches=true}return matches};for(i=iDevices.length-1;i>=0;i-=1){if(matchesDimensionsEitherWay(dimensions,iDevices[i])){return iDevices[i].stringValue}}},probableOrientation:function(){var detectedDevice=!!this.probableDevice();var dimensions=this.firstImageDimensions();if(this.numberOfScreens()===0||!detectedDevice||dimensions.width===0&&dimensions.height===0){return}if(!detectedDevice){return projectConstants.ORIENTATION_PORTRAIT}if(dimensions.width>dimensions.height){return"landscape"}return"portrait"},isIPhoneSized:function(overrideWidth,overrideHeight){var firstImageDimensions=this.firstImageDimensions(overrideWidth,overrideHeight);var firstImageRatio=this.firstImageRatio(overrideWidth,overrideHeight);if(!firstImageDimensions.width||!firstImageDimensions.height){return false}if(firstImageDimensions.width===640||firstImageDimensions.width==320||firstImageDimensions.width===750||firstImageDimensions.width===1242){return true}else if(_.isNumber(firstImageRatio)&&(firstImageRatio<750/1334||firstImageRatio>2/3)){return false}return true},getThumbnailWidth:function(overrideWidth,overrideHeight){var projectConstants=new ProjectConstants;var thumbnailWidth=220;var savedWidth=this.getPropertyForName(projectConstants.PROJECT_PROP_THUMBNAIL_WIDTH);if(+savedWidth.value&&_.isNumber(+savedWidth.value)){return+savedWidth.value}var firstImageDimensions=this.firstImageDimensions(overrideWidth,overrideHeight);var firstImageRatio=this.firstImageRatio(overrideWidth,overrideHeight);if(firstImageDimensions.width===640||firstImageDimensions.width==320){thumbnailWidth=220}else if(_.isNumber(firstImageRatio)&&(firstImageRatio<750/1334||firstImageRatio>2/3)){thumbnailWidth=260}return thumbnailWidth},runningSync:function(model,response){if(typeof response!=="undefined"){if(typeof model!=="undefined"&&typeof response.id!=="undefined"){if(model.id==response.id){this.set(response)}}}}});MARVELAPP.ProjectsModel=Backbone.Model.extend({first_run:false,identifier:undefined,collection:undefined,url:"/api/project/all/",url_team:"/api/project/team/",defaults:{project_collection:new MARVELAPP.ProjectsCollection},fetch_projects_for_team:function(url,team_model){this.fetch({url:this[url]+""+team_model.id+"/",team_model:team_model,success:_.bind(this.success,this),error:_.bind(this.error,this)})},fetch_all_projects:function(){this.fetch({url:this.url,success:_.bind(this.success,this),error:_.bind(this.error,this)})},error:function(model,response,options){},success:function(model,response,options){var update=false;if(typeof MARVELAPP.models.projects!="undefined"){if(MARVELAPP.models.projects.get("project_collection").length>0){update=true;var remove_models=[];_.each(MARVELAPP.models.projects.get("project_collection").models,_.bind(function(existing_model){var model_found=false;_.each(response,_.bind(function(responseModel){var project_model=new MARVELAPP.ProjectModel(responseModel);if(project_model.id==existing_model.id){model_found=true}}));if(model_found==false){remove_models.push(existing_model)}}));for(var idx in remove_models){var existing_model=remove_models[idx];MARVELAPP.models.projects.get("project_collection").remove(existing_model)}}}var tmp_collection=[];_.each(response,_.bind(function(responseModel){var project_model=new MARVELAPP.ProjectModel(responseModel);if(update==true){var existing_model=MARVELAPP.models.projects.get("project_collection").getModelByProjectId(project_model.id);if(typeof existing_model!=="undefined"){var current_project_id=undefined;if(typeof MARVELAPP.models.current_project!=="undefined"){current_project_id=MARVELAPP.models.current_project.id}if((existing_model.get("version")!=project_model.get("version")||existing_model.get("sequence_delta")!=project_model.get("sequence_delta"))&&current_project_id!=project_model.id){tmp_collection.push(project_model)}}else{tmp_collection.push(project_model)}}else{tmp_collection.push(project_model)}},this));if(typeof options.poll==="undefined"){options.poll=false}if(tmp_collection.length==0&&MARVELAPP.models.projects.get("project_collection").length==0){MARVELAPP.models.projects.get("project_collection").reset()}else{if(tmp_collection.length!=0){MARVELAPP.models.projects.get("project_collection").set(tmp_collection,{remove:false})}}if(this.first_run==false){var options={delay:MARVELAPP.constants.team.POLL_TIMING,delayed:true,continueOnError:true};if(typeof MARVELAPP.pollers.project_poller!=="undefined"){MARVELAPP.pollers.project_poller.stop()}MARVELAPP.pollers.project_poller=Backbone.Poller.get(MARVELAPP.models.projects,options);MARVELAPP.pollers.project_poller.on("success",_.bind(function(model,response){this.success(model,response,{poll:true})},this));MARVELAPP.pollers.project_poller.on("complete",function(model){});MARVELAPP.pollers.project_poller.on("error",function(model){});MARVELAPP.pollers.project_poller.start();this.first_run=true}}});MARVELAPP.SubscriptionModel=Backbone.Model.extend({url:"/api/stripe/subscribe/",defaults:{name:""},fetchSubscription:function(id){this.fetch({url:this.url+""+id+"/",success:_.bind(this.success,this),error:_.bind(this.error,this)})},error:function(model,response,options){showNotificationMessage(projectConstants.NOTIFY_TYPE_WARN,MARVELAPP.messages.PROJECT_NOT_FOUND)},success:function(model,response,options){this.set(response)},initialize:function(){this.listenTo(this,"sync",_.bind(this.runningSync,this))},parse:function(data){},runningSync:function(){console.log("RUNNING: subscription sync")}});MARVELAPP.TeamModel=Backbone.Model.extend({url:"/api/team/",defaults:{name:MARVELAPP.constants.team.DEFAULT_TEAM_NAME,icon_url:MARVELAPP.constants.team.DEFAULT_TEAM_ICON_URL,users:[]},fetchTeam:function(id){this.fetch({url:this.url+""+id+"/",async:false,success:_.bind(this.success,this),error:_.bind(this.error,this)})},error:function(model,response,options){showNotificationMessage(projectConstants.NOTIFY_TYPE_WARN,MARVELAPP.messages.TEAM_NOT_FOUND)},success:function(model,response,options){this.set(response)},initialize:function(){this.listenTo(this,"sync",_.bind(this.runningSync,this))},get_owner:function(){var return_owner={};_.each(this.get("users"),function(member){if(typeof member!=="undefined"){if(typeof member.attributes!=="undefined"){member=member.attributes}if(member.role==MARVELAPP.constants.role.ROLE_OWNER){this.owner=member;return_owner=member;return member}}});return return_owner},get_owner_name:function(){var owner=this.get_owner();if(typeof owner!=="undefined"){if(typeof owner.attributes!=="undefined"){return owner.attributes.username}else{return owner.username}}else{""}},get_member:function(member_id){var models=this.get("users").models;if(typeof models==="undefined"){models=this.get("users")}var return_member=undefined;for(i in models){var member=models[i];if(typeof member!=="undefined"){if(typeof member.attributes!=="undefined"){member=member.attributes}if(member.id==member_id){return_member=member;break}}}return return_member},parse:function(data){var collection=new MARVELAPP.MemberCollection;if(data.users&&data.users.length>0){_.each(data.users,_.bind(function(user){collection.add(new MARVELAPP.MemberModel(user))},this))}if(data.icon_url==null){if(typeof this.get("icon_url")==="undefined"||this.get("icon_url")==null){data.icon_url=MARVELAPP.constants.team.DEFAULT_TEAM_ICON_URL}else{data.icon_url=this.get("icon_url")}}data.users=collection;return data},runningSync:function(model,response,options){this.set(response)}});MARVELAPP.TeamsModel=Backbone.Model.extend({first_run:false,urlOwned:"/api/teams/owned/",urlBelonging:"/api/teams/belonging/",urlInvited:"/api/teams/invited/",urlAll:"/api/teams/all/",url:"/api/teams/all/",defaults:{categoryAll:new MARVELAPP.TeamsCollection,categoryOwned:new MARVELAPP.TeamsCollection,categoryBelonging:new MARVELAPP.TeamsCollection,categoryInvited:new MARVELAPP.TeamsCollection},fetchCategory:function(url,identifier){this.fetch({url:this[url],identifier:identifier,success:_.bind(this.success,this),error:_.bind(this.error,this)})},error:function(model,response,options){console.log("Error retrieving team details")},success:function(model,response,options){if(response.length==0){if(MARVELAPP.models.teams.get("categoryAll").length>0){MARVELAPP.models.teams.get("categoryAll").reset();MARVELAPP.models.teams.get("categoryInvited").reset();MARVELAPP.models.teams.get("categoryOwned").reset();MARVELAPP.models.teams.get("categoryBelonging").reset()}}else{this.manage_collections(response)}},manage_collections:function(response){try{var is_existing=false;if(typeof response==="undefined"){response=MARVELAPP.models.teams.get("categoryAll");response=response.models;is_existing=true}else{if(typeof MARVELAPP.models.teams!="undefined"){if(MARVELAPP.models.teams.get("categoryAll").length>0){var remove_models=[];_.each(MARVELAPP.models.teams.get("categoryAll").models,_.bind(function(existing_model){var model_found=false;_.each(response,_.bind(function(responseModel){var team_model=new MARVELAPP.TeamModel(responseModel);if(team_model.id==existing_model.id){model_found=true}}));if(model_found==false){remove_models.push(existing_model)}}));for(var idx in remove_models){var existing_model=remove_models[idx];MARVELAPP.models.teams.get("categoryInvited").remove(existing_model.id);MARVELAPP.models.teams.get("categoryAll").remove(existing_model.id);MARVELAPP.models.teams.get("categoryOwned").remove(existing_model.id);MARVELAPP.models.teams.get("categoryBelonging").remove(existing_model.id)}}}}if(response.length==0){this.run_team_poller();return}var tmp_collection=new MARVELAPP.TeamsCollection;_.each(response,_.bind(function(responseModel){var model=new MARVELAPP.TeamModel;model.set(model.parse(responseModel));var update=true;var existing_model=undefined;if(is_existing==true){model=responseModel}else{existing_model=MARVELAPP.models.teams.get("categoryAll").getModelByTeamId(model.id);if(typeof existing_model!=="undefined"){if(existing_model.get("version")==model.get("version")){update=false}}}if(update==true){if(model.get("invite_state")===null||model.get("owner_fk")==MARVELAPP.models.current_user.id){if(typeof existing_model!=="undefined"){MARVELAPP.models.teams.get("categoryOwned").set([model],{remove:false})}else{MARVELAPP.models.teams.get("categoryOwned").add(model)}}else if(model.get("invite_state")==MARVELAPP.constants.invite.TEAM_MEMBER_STATE_ACCEPTED){if(typeof existing_model!=="undefined"){MARVELAPP.models.teams.get("categoryBelonging").set([model],{remove:false})}else{MARVELAPP.models.teams.get("categoryBelonging").add(model)}}else{if(typeof existing_model!=="undefined"){MARVELAPP.models.teams.get("categoryInvited").set([model],{remove:false})}else{MARVELAPP.models.teams.get("categoryInvited").add(model)}}tmp_collection.add(model)}},this));if(tmp_collection.length>0){MARVELAPP.models.teams.set("categoryAll",tmp_collection,{remove:false})}}catch(e){console.log(e)}this.run_team_poller()},run_team_poller:function(){if(MARVELAPP.pollers.team_first_run==false){var options={delay:MARVELAPP.constants.team.POLL_TIMING,continueOnError:true};try{MARVELAPP.pollers.team_poller.stop()}catch(ex){}MARVELAPP.pollers.team_poller=undefined;MARVELAPP.pollers.team_poller=Backbone.Poller.get(MARVELAPP.models.teams,options);MARVELAPP.pollers.team_poller.on("success",_.bind(function(model,response){this.success(model,response,{poll:true})},this));MARVELAPP.pollers.team_poller.on("complete",function(model){});MARVELAPP.pollers.team_poller.on("error",function(model){});MARVELAPP.pollers.team_poller.start();MARVELAPP.pollers.team_first_run=true}}});MARVELAPP.UserModel=Backbone.Model.extend({url:"/api/user/",is_fetching:false,fetch_user:function(async){if(this.is_fetching==false){this.is_fetching=true;if(typeof async==="undefined"){async=false}this.fetch({async:async,success:_.bind(this.success,this),error:_.bind(this.error,this)})}},error:function(){this.is_fetching=false},success:function(model,response){this.set(response);this.subscribed=this.is_subscribed();this.is_fetching=false},is_subscribed:function(){var subscription=this.get("subscription");if(subscription!=null||subscription!=undefined){if(subscription.is_subscribed){return true}}return false},get_paid_included_user:function(){var all_users=this.get("subscription").included_users;var returned_users=[];_.each(all_users,_.bind(function(user){if(user.is_coupon==false){returned_users.push(user)}},this));return returned_users},countTeamInvites:function(){var num_invites=0;var teams=this.attributes.teams;if(teams&&teams.length>0){_.each(teams.models,_.bind(function(team){if(team.get("invite_state")==MARVELAPP.constants.invite.TEAM_MEMBER_STATE_INVITED){num_invites=num_invites+1}},this))}return num_invites},parse:function(data){MARVELAPP.models.teams=new MARVELAPP.TeamsModel;var collection=new MARVELAPP.TeamsCollection;if(data.teams&&data.teams.length>0){_.each(data.teams,_.bind(function(team){var team_model=new MARVELAPP.TeamModel(team);team_model.set(team_model.parse(team));collection.add(team_model)},this))}data.teams=collection;MARVELAPP.models.teams.set("categoryAll",collection);MARVELAPP.models.teams.manage_collections();return data},isUpgrade:function(plan){var current_price=this.attributes.subscription.plan.price_yearly;return plan.price_yearly>current_price},getAllowance:function(name){return _.findWhere(this.get("subscription").allowances,{name:name})},hasAllowance:function(name){var allowance=this.getAllowance(name);if(allowance===undefined){return false}else if(allowance.is_unlimited){return true}else{return allowance.quantity>allowance.quantity_used}}});MARVELAPP.PrototypeView=Backbone.View.extend({el:"#prototype",transitionTimings:{0:{name:"pushleft",duration:500},1:{name:"pushright",duration:500},2:{name:"flip",duration:400},3:{name:"fade",duration:400},4:{name:"slide",duration:400},5:{name:"slide-left",duration:400},6:{name:"slideup",duration:550},7:{name:"slidedown",duration:550},8:{name:"pop",duration:500},9:{name:"turn",duration:650},10:{name:"flow",duration:1200},11:{name:"slidefade",duration:400}},pusher:null,batches:[],hovers:[],events:{"click .hotspot":"clickHotspot","click #screens":"flashHotspots","click .home":"goHome","touchstart .gesture":"blockScrolling","touchend .gesture":"unblockScrolling","click .addToHomescreen .close":"hideHomescreen"},initialize:function(options,id){options=options||{};
this.model=new MARVELAPP.ProjectModel(options);for(i in this.model.attributes.images){this.batches.push(this.model.attributes.images[i])}this.screenViews=[];this.listenTo(this.model,"change",this.render);this.render();$(document).bind("keyup",this.handleKeys);if(offline==false){try{this.handlePusherCalls()}catch(ex){console.log("Issue with pusher connection",ex)}}},render:function(){var attributes=this.model.attributes;attributes.disable_sidebar=getProjectPropertyForName(attributes,projectConstants.PROJECT_PROP_DISABLE_FRAME);var duplicate_hotspots=[];for(image in attributes.images){for(hdx in attributes.images[image].hotspots){var hotspot=attributes.images[image].hotspots[hdx];if(typeof hotspot.images!=="undefined"){if(hotspot.images.length!=0){duplicate_hotspots.push(hotspot)}}}}if(duplicate_hotspots.length!=0){for(id in duplicate_hotspots){for(hid in duplicate_hotspots[id].images){for(image in attributes.images){if(attributes.images[image].id==duplicate_hotspots[id].images[hid]){if(attributes.images[image].id!=duplicate_hotspots[id].img_owner_fk){var length=attributes.images[image].hotspots.length;attributes.images[image].hotspots[length]=duplicate_hotspots[id]}}}}}}var initial_fragment=Backbone.history.getFragment();attributes.first_image=attributes.images[1].id;var found=false;if(initial_fragment!=""){for(id in attributes.images){if(attributes.images[id].id==initial_fragment){found=true;break}}if(found)attributes.first_image=initial_fragment}if(!mobile&&attributes.disable_sidebar!=1&&!embed){attributes.initial=false;this.sidebar=new MARVELAPP.SidebarView(attributes)}NProgress.start();NProgress.configure({showSpinner:false,parent:"#screens"});NProgress.inc(.1);for(id in attributes.images){var image_object=attributes.images[id];if(image_object.id==attributes.first_image){var firstImage=true;current_screen=attributes.first_image}else{var firstImage=false}var screenView=new MARVELAPP.ScreenView({image_object:image_object,firstImage:firstImage});this.addScreen(screenView)}var hidden_sidebar=$.cookie("homescreen");if(mobile&&!homescreen&&hidden_sidebar!="1"&&offline==false&&iosapp==0){$(".screen").append(MARVELAPP.templates.ADD_TO_HOMESCREEN(attributes))}if(mobile){$(".screen").append(MARVELAPP.templates.ROTATE_DEVICE());attributes.orientation=getProjectPropertyForName(attributes,projectConstants.PROJECT_PROP_ORIENTATION);this.checkOrientation(attributes.orientation);$(window).on("orientationchange",_.bind(function(event){Backbone.trigger("antiscroll-trigger");this.checkOrientation(attributes.orientation)},this))}this.callAntiscroll();this.handleGestures();return this},checkOrientation:function(orientation){console.log(window.orientation);if(orientation=="landscape"&&window.orientation==0){$(".rotateDevice").removeClass("hidden")}else if(orientation=="portrait"&&window.orientation!=0){$(".rotateDevice").removeClass("hidden");if(window.orientation>0){$(".rotateDevice .icon").addClass("flip")}else{$(".rotateDevice .icon").removeClass("flip")}}else{$(".rotateDevice").addClass("hidden")}},addScreen:function(screenView){this.screenViews.push(screenView);this.$("#screens").append(screenView.render())},runPreloader:function(){var batches=this.batches;var start=0;var num_batches=3;var maxIndex=batches.length;var amountDownloaded=0;var count=0;if(num_batches>batches.length){num_batches=batches.length}var current_batch_end=num_batches;function preload_image(image_object,fn){var tmp=new Image,self=this;if(fn)tmp.onload=function(e){fn.call(self,image_object.id,image_object.url,100,1)};if(fn)tmp.onerror=function(e){fn.call(self,image_object.id,image_object.url,100,1)};tmp.src=image_object.url}function loadBatch(batch_start,batch_end){for(var z=batch_start;z<=batch_end;z++){if(typeof batches[z]!=="undefined"){if(batches[z].url!=undefined){var id=batches[z].id;preload_image(batches[z],function(image_id,image_src,perc,done){if(done){count++;amountDownloaded++;var totalPercent=100;if(current_screen==image_id){NProgress.set(0);NProgress.set(totalPercent)}$("#"+image_id+" img").attr("src",image_src);$("#"+image_id+" .loading").fadeOut(300)}else if(done==-1){count++;amountDownloaded++}var done=false;if(count==0||batches.length==1){perc=40;$("#page-loader .inner").css("width","45%");if(batches.length==1){done=true}}else if(count==1||batches.length==2){$("#page-loader .inner").css("width","66.66%");if(batches.length==2){done=true}}else if(count>=2||batches.length==3){$("#page-loader .inner").css("width","100%");done=true}if(done){if(firstAntiscrollRun==false||current_screen==image_id){prototype.callAntiscroll();setTimeout(function(){$(".active .antiscroll-inner").css("-webkit-overflow-scrolling","touch");$("#page-loader").fadeOut(100)},200);firstAntiscrollRun=true}}if(count>=current_batch_end&&count!=maxIndex){var next_batches=current_batch_end+num_batches;var start_batches=current_batch_end+1;if(next_batches>=maxIndex){next_batches=maxIndex}loadBatch(start_batches,next_batches);current_batch_end=next_batches}})}}}}loadBatch(start,current_batch_end)},updateScreen:function(imageObject,useImage){for(sidx=0;sidx<this.screenViews.length;sidx++){var screenView=this.screenViews[sidx];if(screenView.image_object.id==imageObject.id){screenView.image_object=imageObject;screenView.render(true,useImage);$("#"+imageObject.id+" img").attr("src",imageObject.url);$("#"+imageObject.id+" .loading").fadeOut(300);break}}},getScreenView:function(screenID){for(sidx=0;sidx<this.screenViews.length;sidx++){var screenView=this.screenViews[sidx];if(screenView.image_object.id==screenID){return screenView;break}}},callAntiscroll:function(){if(!mobile){$(".antiscroll-wrap").antiscroll();$(".antiscroll-inner").width("100%")}},beenClicked:false,clickHotspot:function(e){this.beenClicked=true;var target_screen=$(e.currentTarget).attr("data-target");var transition=$(e.currentTarget).attr("data-transition");var maintain_scroll=$(e.currentTarget).attr("data-maintain-scroll");if(maintain_scroll=="true"){maintain_scroll=true}else{maintain_scroll=false}var anchor=$(e.currentTarget).hasClass("anchor");var gesture=$(e.currentTarget).hasClass("gesture");if(!mobile&&gesture)gesture=false;var url=$(e.currentTarget).hasClass("url");if(anchor){if(!gesture)this.handleAnchor($(e.currentTarget).attr("data-anchor"))}else if(url){if(!gesture)this.handleURL($(e.currentTarget).attr("data-url"))}else if(!gesture&&touchStartID!=null){this.handleTransition(current_screen,target_screen,transition,false,maintain_scroll)}},handleTransition:function(currentScreen,targetScreen,transition,reverse,maintainScroll){console.log("Handle transition",currentScreen,targetScreen,transition,reverse,maintainScroll);$(document).unbind("mousemove");$(".screen-wrap").removeClass("hover-active");this.hovers=[];if(maintainScroll==undefined)maintainScroll=false;if(transition=="back"){if(transition_history.length!=0){if(typeof Ti!=="undefined"){this.goBack();return}else{window.history.back()}}return}if(!reverse)Backbone.trigger("page-transition",currentScreen,targetScreen,transition);if(!transitioning){if(currentScreen==targetScreen){return}else{var image_url=$("#"+targetScreen+" img").attr("src");if(typeof image_url==="undefined"){console.log("No destination image found ",image_url);return}transitioning=true;if(iOS7&&transition=="none")transition="zero";if(!reverse){$("#"+targetScreen).addClass(transition+" in active");$("#"+currentScreen).addClass(transition+" out")}else{$("#"+targetScreen).addClass(transition+" in active reverse");$("#"+currentScreen).addClass(transition+" out reverse")}if(transition=="flip")$("#screens").addClass("viewport-flip");if(transition=="turn")$("#screens").addClass("viewport-turn");if(!mobile)$(".antiscroll-wrap").antiscroll();Backbone.trigger("antiscroll-trigger");try{var image_type=image_url.indexOf(".gif")>-1;var image_url2=$("#"+currentScreen+" img").attr("src");var image_type2=image_url2.indexOf(".gif")>-1;if(maintainScroll==true){var scroll=$("#"+currentScreen+" .antiscroll-inner").scrollTop();$("#"+targetScreen+" .antiscroll-inner").scrollTop(scroll)}setTimeout(function(){$("#"+targetScreen).removeClass().addClass("screen-wrap active");$("#"+currentScreen).removeClass().addClass("screen-wrap");$("#screens").removeClass("viewport-flip viewport-turn");if(image_type2)$("#"+currentScreen+" img").attr("src",image_url2);transitioning=false;if(iOS7){$(".antiscroll-inner").css("-webkit-overflow-scrolling","auto");$(".active .antiscroll-inner").css("-webkit-overflow-scrolling","touch")}},this.getTiming(transition));previous_screen=current_screen;current_screen=targetScreen;try{if(!mobile)this.sidebar.updateSequence($("#"+current_screen).index()+1)}catch(ex){}}catch(ex){console.log("Problem navigating screens");transitioning=false}}}},handleAnchor:function(y_pos){var a=$("#"+current_screen+" .box-inner").height()+$("#"+current_screen+" .fixed-footer").height();var b=a*(y_pos/100);$("#"+current_screen+" .antiscroll-inner").scrollTop(b)},handleURL:function(url){if(offline==true){if(typeof Ti!=="undefined"){Ti.App.fireEvent("openLink",{linkUrl:url})}else{window.location.href=url}}else{window.location.href=url}},getTiming:function(transition){var timing=500;for(id in this.transitionTimings){if(this.transitionTimings[id].name==transition){timing=this.transitionTimings[id].duration}}if(transition=="none")timing=50;return timing},goHome:function(){var next_screen=$(".screen-wrap").eq(0).attr("id");prototype.handleTransition(current_screen,next_screen,"none",false)},goBack:function(transition){var go_transition="none";if(transition!=undefined)go_transition=transition;var max_index=$(".screen-wrap").length;var current_index=$("#"+current_screen).index()+1;if(current_index-1==0){var next_screen=$(".screen-wrap").eq(max_index-1).attr("id")}else{var next_screen=$(".screen-wrap").eq(current_index-2).attr("id")}this.handleTransition(current_screen,next_screen,go_transition,false)},goForward:function(transition){var go_transition="none";if(transition!=undefined)go_transition=transition;var max_index=$(".screen-wrap").length;var current_index=$("#"+current_screen).index()+1;if(current_index+1>max_index){var next_screen=$(".screen-wrap").eq(0).attr("id")}else{var next_screen=$(".screen-wrap").eq(current_index).attr("id")}this.handleTransition(current_screen,next_screen,go_transition,false)},flashHotspots:function(e){var disable=getProjectPropertyForName(this.model.attributes,projectConstants.PROJECT_PROP_SHOW_HINTS);if(disable!=1){if(!$(e.target).is(".hotspot")){var time=300;$(".hotspot").addClass("flash");setTimeout(function(){$(".hotspot").removeClass("flash")},time)}}},handleKeys:function(event){var code=event.keyCode||event.which;switch(code){case 37:prototype.goBack();break;case 39:prototype.goForward();break;case 72:prototype.goHome();break}},handleGestures:function(){var that=this;var disable_swipe=getProjectPropertyForName(this.model.attributes,projectConstants.PROJECT_PROP_DISABLE_SWIPE);if(mobile){$$(".screen-wrap").swipeRight(function(e){if(disable_swipe!="1")that.goBack("slide-left")});$$(".screen-wrap").swipeLeft(function(e){if(disable_swipe!="1")that.goForward("slide")})}$("body").on({mouseenter:function(e){if(!transitioning){var parentScreen=$(e.currentTarget).closest(".screen-wrap").attr("id");var hoverScreen=$(e.currentTarget).attr("data-target");var hotspotID=$(e.currentTarget).attr("id");$("#"+hoverScreen).addClass("hover-active");var scroll=$("#"+parentScreen+" .antiscroll-inner").scrollTop();$("#"+hoverScreen+" .antiscroll-inner").scrollTop(scroll);Backbone.trigger("antiscroll-trigger");var boundaries=$(e.currentTarget).offset();boundaries.top=boundaries.top;boundaries.right=boundaries.left+$(e.currentTarget).outerWidth();boundaries.bottom=boundaries.top+$(e.currentTarget).outerHeight();boundaries.screen=hoverScreen;that.hovers.push(boundaries);$(document).bind("mousemove",function(e){if(that.hovers.length==0)return;var boundaries=that.hovers[that.hovers.length-1];if(e.pageY>=boundaries.top&&e.pageY<=boundaries.bottom&&e.pageX>=boundaries.left&&e.pageX<=boundaries.right){}else{var targetScroll=$("#"+boundaries.screen+" .antiscroll-inner").scrollTop();$("#"+parentScreen+" .antiscroll-inner").scrollTop(targetScroll);$("#"+boundaries.screen).removeClass("hover-active");that.hovers.pop()}})}}},".hover");$$(".swiperight").swipeRight(function(e){that.handleGesture(e)});$$(".swipeleft").swipeLeft(function(e){that.handleGesture(e)});$$(".swipeup").swipeUp(function(e){that.handleGesture(e)});$$(".swipedown").swipeDown(function(e){that.handleGesture(e)});$$(".pinch").pinchIn(function(e){that.handleGesture(e)});$$(".pinchout").pinchOut(function(e){that.handleGesture(e)});$$(".doubletap").doubleTap(function(e){that.handleGesture(e)})},handleGesture:function(e){var anchor=$(e.currentTarget).hasClass("anchor");var url=$(e.currentTarget).hasClass("url");var maintain_scroll=$(e.currentTarget).attr("data-maintain-scroll");if(maintain_scroll=="true"){maintain_scroll=true}else{maintain_scroll=false}if(url){that.handleURL($(e.currentTarget).attr("data-url"))}else if(anchor){that.handleAnchor($(e.currentTarget).attr("data-anchor"))}else{var target_screen=$(e.currentTarget).attr("data-target");var transition=$(e.currentTarget).attr("data-transition");this.handleTransition(current_screen,target_screen,transition,false,maintain_scroll)}},blockScrolling:function(){$(document).bind("touchmove",function(e){e.preventDefault()})},unblockScrolling:function(){$(document).unbind("touchmove")},hideHomescreen:function(){var cookie_path=window.location.pathname;$(".addToHomescreen").hide();$.cookie("homescreen","1",{path:""+cookie_path})},handlePusherCalls:function(){Pusher.log=function(message){};pusher=new Pusher("70744d379f87a37df68a",{encrypted:true});pusher.connection.bind("error",function(err){console.log("Issue connecting to pusher.",err)});var prototype_channel=pusher.subscribe(MARVELAPP.settings.PUSHER.PROTOTYPE_CHANNEL_PREFIX+project_object.id);prototype_channel.bind(MARVELAPP.constants.pusher.EVENT_IMAGE,_.bind(function(data){var content=data.content.object;var sequence=this.model.getSequenceForImageId(content.id);if(content.status==projectConstants.QUEUE_IMG_STATUS_UPLOAD_FINISHED){this.model.addImage(content,sequence);this.updateScreen(content,false)}},this));prototype_channel.bind(MARVELAPP.constants.pusher.EVENT_HOTSPOT,_.bind(function(data){var hotspot=data.content.object;var parentScreen=this.getScreenView(hotspot.img_owner_fk);var image_object=this.model.getImageForId(hotspot.img_owner_fk);var found=false;for(id in image_object.hotspots){if(image_object.hotspots[id].id==hotspot.id){found=true;break}}if(hotspot.status==projectConstants.HOTSPOT_DELETED){$("#hotspot-"+hotspot.id).remove();for(id in this.model.attributes.images){if(this.model.attributes.images[id].id==hotspot.img_owner_fk){for(hid in this.model.attributes.images[id].hotspots){if(this.model.attributes.images[id].hotspots[hid].id==hotspot.id){this.model.attributes.images[id].hotspots.remove(hid);break}}}}}else{if(found){for(id in this.model.attributes.images){if(this.model.attributes.images[id].id==hotspot.img_owner_fk){for(hid in this.model.attributes.images[id].hotspots){if(this.model.attributes.images[id].hotspots[hid].id==hotspot.id){this.model.attributes.images[id].hotspots[hid]=hotspot;break}}}}if(hotspot.type==2||hotspot.type==3){for(id in parentScreen.image_object.hotspots){if(parentScreen.image_object.hotspots[id].id==hotspot.id){parentScreen.image_object.hotspots[id]=hotspot;this.updateScreen(parentScreen.image_object,true);break}}}else{$("#hotspot-"+hotspot.id).remove();parentScreen.renderHotspot(hotspot)}}else{parentScreen.renderHotspot(hotspot);for(id in this.model.attributes.images){if(this.model.attributes.images[id].id==hotspot.img_owner_fk){this.model.attributes.images[id].hotspots.push(hotspot);break}}}}},this))}});MARVELAPP.ScreenView=Backbone.View.extend({image_object:null,firstImage:null,screenID:null,settings:null,el:"#screens",initialize:function(options){options=options||{};this.image_object=options.image_object;this.firstImage=options.firstImage},render:function(rerender,useImage){if(rerender==undefined)rerender=false;_this=this;var image_object=this.image_object;var attributes=image_object;attributes.firstImage=this.firstImage;screenID=attributes.id;attributes.fixedHeader="";attributes.fixedHeaderURL="";attributes.fixedFooter="";attributes.fixedFooterURL="";attributes.retina_scale=getProjectPropertyForName(project_object,projectConstants.PROJECT_PROP_RETINA_SCALE);if(attributes.retina_scale=="1"){attributes.retina_scale=true;if(!rerender)attributes.width=attributes.width/2}else{attributes.retina_scale=false}$.each(image_object.hotspots,function(hotspot){if(image_object.hotspots[hotspot].type==projectConstants.TYPE_FIXED_HORIZONTAL){if(image_object.hotspots[hotspot].location==projectConstants.TYPE_POSITION_TOP){attributes.fixedHeader=image_object.hotspots[hotspot].y;if(image_object.hotspots[hotspot].url==""||image_object.hotspots[hotspot].url==null||useImage){attributes.fixedHeaderURL=image_object.url}else{attributes.fixedHeaderURL=image_object.hotspots[hotspot].url}if(attributes.retina_scale)attributes.fixedHeader=attributes.fixedHeader/2}else{attributes.fixedFooter=image_object.height-image_object.hotspots[hotspot].y;if(image_object.hotspots[hotspot].url==""||image_object.hotspots[hotspot].url==null||useImage){attributes.fixedFooterURL=image_object.url}else{attributes.fixedFooterURL=image_object.hotspots[hotspot].url}if(attributes.retina_scale)attributes.fixedFooter=attributes.fixedFooter/2}}});attributes.background=attributes.prototype_background=getProjectPropertyForName(project_object,projectConstants.PROJECT_PROP_PROTOTYPE_BACKGROUND_HEX);var white=false;var rgb=parseInt(attributes.background,16);var r=rgb>>16&255;var g=rgb>>8&255;var b=rgb>>0&255;var luma=.213*(r/255)+.715*(g/255)+.072*(b/255);if(luma<.5)white=true;attributes.white=white;attributes.trim_status=getProjectPropertyForName(project_object,projectConstants.PROJECT_PROP_REMOVE_STATUS);attributes.status_type=getProjectPropertyForName(project_object,projectConstants.PROJECT_PROP_STATUS_BAR);if(offline==1&&mobile)attributes.trim_status="0";globalStatusType=attributes.status_type;globalTrimStatus=attributes.trim_status;attributes.disable_resizing=getProjectPropertyForName(project_object,projectConstants.PROJECT_PROP_NON_RESPONSIVE);attributes.disable_resizing_scale="";if(attributes.disable_resizing=="1"){var frame=getProjectPropertyForName(project_object,projectConstants.PROJECT_PROP_FRAME);var disable_sidebar=getProjectPropertyForName(project_object,projectConstants.PROJECT_PROP_DISABLE_FRAME);if(disable_sidebar=="1"||frame=="web-frame"||frame=="desktop-view"){attributes.disable_resizing_scale=" min-width: "+attributes.width+"px;"}}if(!rerender){this.$el.append(MARVELAPP.templates.SCREEN(attributes))}else{if($("#"+image_object.id).hasClass("active"))attributes.firstImage=true;$("#"+image_object.id).replaceWith(MARVELAPP.templates.SCREEN(attributes))}if(attributes.trim_status=="1"){var trim=true}else{var trim=false}_this.calculateFixedAreas(attributes.fixedHeader,attributes.fixedFooter,attributes.id,attributes.width,trim);this.listenTo(Backbone,"antiscroll-trigger",function(){_this.calculateFixedAreas(attributes.fixedHeader,attributes.fixedFooter,attributes.id,attributes.width,trim)});$("#"+image_object.id+" .fixed-header").unbind("touchstart");$("#"+image_object.id+" .fixed-header").bind("touchstart",function(e){if(iOS)e.preventDefault()});$("#"+image_object.id+" .fixed-footer").unbind("touchstart");$("#"+image_object.id+" .fixed-footer").bind("touchstart",function(e){if(iOS)e.preventDefault()});if(!mobile){if(rerender)$(window).off("resize");$(window).resize(function(){_this.calculateFixedAreas(attributes.fixedHeader,attributes.fixedFooter,attributes.id,attributes.width,false)})}this.settings=attributes;$.each(image_object.hotspots,function(hotspot){_this.renderHotspot(image_object.hotspots[hotspot])});var opts={lines:11,length:8,width:2,radius:8,corners:1,rotate:0,direction:1,color:white?"#FFF":"#000",speed:1,trail:60,shadow:false,hwaccel:false,className:"spinner",zIndex:2e9,top:"50%",left:"50%"};var target=document.getElementById("spinner_"+attributes.id);var spinner=new Spinner(opts).spin(target);return this.$el},renderHotspot:function(hotspot_object){hotspot_object.inside_header=false;hotspot_object.inside_footer=false;hotspot_object.duplicate=false;if(hotspot_object.images.length!=0){hotspot_object.duplicate=true}if(this.settings.fixedHeader!=""){if(this.settings.fixedFooter!=""){hotspot_object.top=(hotspot_object.y-this.settings.fixedHeader)*100/(this.image_object.height-this.settings.fixedHeader-this.settings.fixedFooter);if(this.settings.retina_scale){hotspot_object.top=(hotspot_object.y-this.settings.fixedHeader*2)*100/(this.image_object.height-this.settings.fixedHeader*2-this.settings.fixedFooter*2)}}else{hotspot_object.top=(hotspot_object.y-this.settings.fixedHeader)*100/(this.image_object.height-this.settings.fixedHeader);if(this.settings.retina_scale){hotspot_object.top=(hotspot_object.y-this.settings.fixedHeader*2)*100/(this.image_object.height-this.settings.fixedHeader*2)}}}else{if(this.settings.fixedFooter!=""){if(this.settings.trim_status=="1"&&mobile){hotspot_object.top=(hotspot_object.y-40)*100/(this.image_object.height-40-this.settings.fixedFooter);if(this.settings.retina_scale){hotspot_object.top=(hotspot_object.y-40)*100/(this.image_object.height-40-this.settings.fixedFooter*2)}}else{hotspot_object.top=hotspot_object.y*100/(this.image_object.height-this.settings.fixedFooter);if(this.settings.retina_scale){hotspot_object.top=hotspot_object.y*100/(this.image_object.height-this.settings.fixedFooter*2)}}}else{if(this.settings.trim_status=="1"&&mobile){hotspot_object.top=(hotspot_object.y-40)*100/(this.image_object.height-40)}else{hotspot_object.top=hotspot_object.y*100/this.image_object.height}}}if(hotspot_object.y<this.settings.fixedHeader&&this.settings.fixedHeader!=""){hotspot_object.inside_header=true;if(this.settings.trim_status=="1"&&mobile){hotspot_object.height=(hotspot_object.y2-hotspot_object.y)*100/(this.settings.fixedHeader-40);hotspot_object.top=(hotspot_object.y-40)*100/(this.settings.fixedHeader-40)}else{hotspot_object.height=(hotspot_object.y2-hotspot_object.y)*100/this.settings.fixedHeader;hotspot_object.top=hotspot_object.y*100/this.settings.fixedHeader}if(this.settings.retina_scale){hotspot_object.height=hotspot_object.height/2;hotspot_object.top=hotspot_object.top/2}}else if(hotspot_object.y2>this.image_object.height-this.settings.fixedFooter&&this.settings.fixedFooter!=""){hotspot_object.inside_footer=true;hotspot_object.height=(hotspot_object.y2-hotspot_object.y)*100/this.settings.fixedFooter;hotspot_object.top=-(this.image_object.height-this.settings.fixedFooter-hotspot_object.y)*100/this.settings.fixedFooter;if(this.settings.retina_scale){hotspot_object.height=hotspot_object.height/2;hotspot_object.top=-(this.image_object.height-this.settings.fixedFooter*2-hotspot_object.y)*100/(this.settings.fixedFooter*2)}}else{if(this.settings.fixedHeader!=""){if(this.settings.fixedFooter!=""){hotspot_object.height=(hotspot_object.y2-hotspot_object.y)*100/(this.image_object.height-this.settings.fixedFooter-this.settings.fixedHeader)}else{hotspot_object.height=(hotspot_object.y2-hotspot_object.y)*100/(this.image_object.height-this.settings.fixedHeader)}}else{if(this.settings.fixedFooter!=""){hotspot_object.height=(hotspot_object.y2-hotspot_object.y)*100/(this.image_object.height-this.settings.fixedFooter)}else{hotspot_object.height=(hotspot_object.y2-hotspot_object.y)*100/this.image_object.height}}}hotspot_object.width=(hotspot_object.x2-hotspot_object.x)*100/this.image_object.width;hotspot_object.left=hotspot_object.x*100/this.image_object.width;if(this.settings.retina_scale){hotspot_object.width=hotspot_object.width/2;hotspot_object.left=hotspot_object.left/2}if(hotspot_object.anchor_y_pos!=null){var anchor_offset=0;if(this.settings.trim_status=="1"&&mobile)anchor_offset=-40;if(this.settings.fixedHeader!=""){if(this.settings.trim_status=="1"&&mobile){anchor_offset=anchor_offset-this.settings.fixedHeader+40}else{anchor_offset=anchor_offset-this.settings.fixedHeader}}hotspot_object.anchor_y_pos=(hotspot_object.anchor_y_pos+anchor_offset)*100/(this.image_object.height+anchor_offset)}if(hotspot_object.type!=projectConstants.TYPE_FIXED_HORIZONTAL&&hotspot_object.type!=projectConstants.TYPE_FIXED_VERTICAL){if(hotspot_object.inside_header){$("#"+this.settings.id+" .fixed-header").append(MARVELAPP.templates.HOTSPOT(hotspot_object))}else if(hotspot_object.inside_footer){$("#"+this.settings.id+" .fixed-footer").append(MARVELAPP.templates.HOTSPOT(hotspot_object))}else{$("#"+this.settings.id+" .image").append(MARVELAPP.templates.HOTSPOT(hotspot_object))}}},calculateFixedAreas:function(fixedHeader,fixedFooter,id,width,trim){if($("#"+id).hasClass("active")||$("#"+id).hasClass("hover-active")){var status_type=getProjectPropertyForName(project_object,projectConstants.PROJECT_PROP_STATUS_BAR);var status_offset=0;if(mobile){if(status_type!="0"){if(homescreen){if(trim)status_offset=20}else{status_offset=0}}else{status_offset=0}}var headerHeight=0;var footerHeight=0;var containerWidth=$("#"+id+" .image").width();var prototypeWidth=$("#"+id+" .antiscroll-wrap").width();if(!mobile){var leftPosition=Math.round((prototypeWidth-containerWidth)/2);$("#"+id+" .image").css("left",leftPosition);$("#"+id+" .fixed-header").css("left",leftPosition);$("#"+id+" .fixed-footer").css("left",leftPosition)}if(fixedHeader!=""){headerHeight=fixedHeader*containerWidth/width;if(!mobile)headerHeight=Math.floor(headerHeight);if(trim&&mobile)headerHeight=headerHeight-20;$("#"+id+" .fixed-header").height(headerHeight)}if(fixedFooter!=""){footerHeight=fixedFooter*containerWidth/width;if(!mobile)footerHeight=Math.floor(footerHeight);$("#"+id+" .fixed-footer").height(footerHeight)}$("#"+id+" .antiscroll-wrap").height($("#screens").height()-headerHeight-footerHeight-status_offset);$("#"+id+" .antiscroll-inner").height($("#screens").height()-headerHeight-footerHeight-status_offset);$("#"+id+" .antiscroll-inner").width("100%");var image_margin=-headerHeight;if(trim&&mobile)image_margin=image_margin-20;if(fixedHeader==""){if(trim&&mobile)image_margin=-20}$("#"+id+" .antiscroll-inner img").css("margin-top",image_margin+"px");$("#"+id+" .antiscroll-inner img").css("margin-bottom",-footerHeight+"px")}}});MARVELAPP.SidebarView=Backbone.View.extend({el:"#sidebar",events:{"click .home":"returnHome","click .prev":"goBack","click .next":"goForward","click .close":"toggleSidebar",click:"toggleSidebar"},initialize:function(options){options=options||{};this.model=options;this.render()},render:function(){var attributes=this.model;attributes.first_name=attributes.images[1].name;attributes.first_description=attributes.images[1].description;attributes.first_index=1;for(image in attributes.images){var image_object=attributes.images[image];if(image_object.id==attributes.first_image){attributes.first_description=replaceURLWithHTMLLinks(image_object.description);attributes.first_name=image_object.name;attributes.first_index=image}}if(typeof attributes.initial=="undefined"){attributes.initial==true}this.$el.html(MARVELAPP.templates.SIDEBAR(attributes));return this},updateSequence:function(index){this.$el.find(".current").html(index);this.$el.find(".name").html(_.escape(this.model.images[index].name).replace(/%(..)/g,"&#x$1;"));var description=_.escape(this.model.images[index].description);if(description!=null){this.$el.find(".description").html(replaceURLWithHTMLLinks(description))}else{this.$el.find(".description").html("")}},returnHome:function(){prototype.goHome()},goBack:function(){prototype.goBack()},goForward:function(){prototype.goForward()},toggleSidebar:function(e){var cookie=$.cookie("sidebar");if(cookie=="0"||typeof cookie==="undefined"){if($(e.target).is(".close")){$.cookie("sidebar","1");$("#sidebar").addClass("collapsed");$("#content").addClass("collapsed")}}else{if(!$(e.target).is(".close")){$.cookie("sidebar","0");$("#sidebar").removeClass("collapsed");$("#content").removeClass("collapsed")}}setTimeout(function(){Backbone.trigger("antiscroll-trigger")},250)}});var project_object=undefined;var current_screen=undefined;var transitioning=false;var projectController=new ProjectController;var projectConstants=new ProjectConstants;var prototype={};var previous_screen=null;var iOS=navigator.userAgent.match(/(iPad|iPhone|iPod)/g)?true:false;var iOS7=navigator.userAgent.match(/(iPad|iPhone);.*CPU.*OS 7_\d/i)?true:false;var android=navigator.userAgent.toLowerCase().indexOf("android")>-1;var mobile=false;var firstAntiscrollRun=false;(function(a){if(/(android|bb\d+|meego).+mobile|avantgo|bada\/|blackberry|blazer|compal|elaine|fennec|hiptop|iemobile|ip(hone|od)|iris|kindle|lge |maemo|midp|mmp|mobile.+firefox|netfront|opera m(ob|in)i|palm( os)?|phone|p(ixi|re)\/|plucker|pocket|psp|series(4|6)0|symbian|treo|up\.(browser|link)|vodafone|wap|windows (ce|phone)|xda|xiino/i.test(a)||/1207|6310|6590|3gso|4thp|50[1-6]i|770s|802s|a wa|abac|ac(er|oo|s\-)|ai(ko|rn)|al(av|ca|co)|amoi|an(ex|ny|yw)|aptu|ar(ch|go)|as(te|us)|attw|au(di|\-m|r |s )|avan|be(ck|ll|nq)|bi(lb|rd)|bl(ac|az)|br(e|v)w|bumb|bw\-(n|u)|c55\/|capi|ccwa|cdm\-|cell|chtm|cldc|cmd\-|co(mp|nd)|craw|da(it|ll|ng)|dbte|dc\-s|devi|dica|dmob|do(c|p)o|ds(12|\-d)|el(49|ai)|em(l2|ul)|er(ic|k0)|esl8|ez([4-7]0|os|wa|ze)|fetc|fly(\-|_)|g1 u|g560|gene|gf\-5|g\-mo|go(\.w|od)|gr(ad|un)|haie|hcit|hd\-(m|p|t)|hei\-|hi(pt|ta)|hp( i|ip)|hs\-c|ht(c(\-| |_|a|g|p|s|t)|tp)|hu(aw|tc)|i\-(20|go|ma)|i230|iac( |\-|\/)|ibro|idea|ig01|ikom|im1k|inno|ipaq|iris|ja(t|v)a|jbro|jemu|jigs|kddi|keji|kgt( |\/)|klon|kpt |kwc\-|kyo(c|k)|le(no|xi)|lg( g|\/(k|l|u)|50|54|\-[a-w])|libw|lynx|m1\-w|m3ga|m50\/|ma(te|ui|xo)|mc(01|21|ca)|m\-cr|me(rc|ri)|mi(o8|oa|ts)|mmef|mo(01|02|bi|de|do|t(\-| |o|v)|zz)|mt(50|p1|v )|mwbp|mywa|n10[0-2]|n20[2-3]|n30(0|2)|n50(0|2|5)|n7(0(0|1)|10)|ne((c|m)\-|on|tf|wf|wg|wt)|nok(6|i)|nzph|o2im|op(ti|wv)|oran|owg1|p800|pan(a|d|t)|pdxg|pg(13|\-([1-8]|c))|phil|pire|pl(ay|uc)|pn\-2|po(ck|rt|se)|prox|psio|pt\-g|qa\-a|qc(07|12|21|32|60|\-[2-7]|i\-)|qtek|r380|r600|raks|rim9|ro(ve|zo)|s55\/|sa(ge|ma|mm|ms|ny|va)|sc(01|h\-|oo|p\-)|sdk\/|se(c(\-|0|1)|47|mc|nd|ri)|sgh\-|shar|sie(\-|m)|sk\-0|sl(45|id)|sm(al|ar|b3|it|t5)|so(ft|ny)|sp(01|h\-|v\-|v )|sy(01|mb)|t2(18|50)|t6(00|10|18)|ta(gt|lk)|tcl\-|tdg\-|tel(i|m)|tim\-|t\-mo|to(pl|sh)|ts(70|m\-|m3|m5)|tx\-9|up(\.b|g1|si)|utst|v400|v750|veri|vi(rg|te)|vk(40|5[0-3]|\-v)|vm40|voda|vulc|vx(52|53|60|61|70|80|81|83|85|98)|w3c(\-| )|webc|whit|wi(g |nc|nw)|wmlb|wonu|x700|yas\-|your|zeto|zte\-/i.test(a.substr(0,4)))mobile=true})(navigator.userAgent||navigator.vendor||window.opera);var iPad=navigator.userAgent.match(/(iPad)/g)?true:false;if(iPad)mobile=true;var transition_history=[];var homescreen=window.navigator.standalone;var embed=false;var globalStatusType=null,globalTrimStatus=null;if(window.location.href.indexOf("?emb=1")>-1)embed=true;var startTopScroll;var startTime;var touchStartID;function createPrototype(is_error,message,returnedProjectObject){if(project_data.images[1].width==0){$("body").html("");project_data.images[1].width=returnedProjectObject.images[1].width;setupPrototype(returnedProjectObject);return}if(is_error!=true)project_object=returnedProjectObject;MARVELAPP.settings=settings;if(MARVELAPP.settings.APP_SENTRY_DSN){Raven.config(MARVELAPP.settings.APP_SENTRY_DSN).install()}MARVELAPP.models.teams=new MARVELAPP.TeamsModel;new MARVELAPP.PrototypeRouter;var endTime=new Date;var timeDiff=endTime-startTime;console.log("Response time: "+timeDiff+"ms");prototype=new MARVELAPP.PrototypeView(project_object);prototype.runPreloader()}var perc;function run_load_bar(){setTimeout(function(){perc=perc+1;if(perc<40){$("#page-loader .inner").css("width",perc+"%");run_load_bar()}},500)}$(document).ready(function(){FastClick.attach(document.body);startTime=new Date;setupPrototype(project_data);$(window).resize(function(){checkOddPixel($(window).width())
});if(iOS){$(document).bind("touchstart",function(e){var id=$(e.target).closest(".screen-wrap").attr("id");prototype.unblockScrolling();touchStartID=id;var screenHeight=$("#"+id+" img").height();if(globalStatusType=="0"&&globalTrimStatus=="1"&&offline!=1)screenHeight=screenHeight-20;if(Math.abs($(window).height()-screenHeight)<4){if(homescreen||offline==1)prototype.blockScrolling()}else{startTopScroll=$("#"+id+" .antiscroll-inner").scrollTop();scrollHeight=$("#"+id+" .antiscroll-inner").prop("scrollHeight")-$("#"+id+" .antiscroll-inner").height();if(startTopScroll==0){$("#"+id+" .antiscroll-inner").scrollTop(1)}if(startTopScroll==scrollHeight){$("#"+id+" .antiscroll-inner").scrollTop(scrollHeight-1)}startTopScroll=$("#"+id+" .antiscroll-inner").scrollTop()}});$(document).bind("touchend",function(e){var id=$(e.target).closest(".screen-wrap").attr("id");var screenHeight=$("#"+id+" img").height();if(globalStatusType=="0"&&globalTrimStatus=="1"&&offline!=1)screenHeight=screenHeight-20;if(Math.abs($(window).height()-screenHeight)<4){if(homescreen||offline==1)prototype.unblockScrolling()}else{var endScroll=$("#"+id+" .antiscroll-inner").scrollTop();if(startTopScroll==endScroll){if($(e.target).is(".hotspot")){$(e.target).click()}else{prototype.flashHotspots(e)}prototype.beenClicked=false}}touchStartID=null})}else{touchStartID=0}});function setupPrototype(data){attributes=data;var cookie=$.cookie("sidebar");attributes.collapsed=cookie==="1"?true:false;attributes.orientation=getProjectPropertyForName(attributes,projectConstants.PROJECT_PROP_ORIENTATION);attributes.background=getProjectPropertyForName(attributes,projectConstants.PROJECT_PROP_BACKGROUND_HEX);attributes.disable_sidebar=getProjectPropertyForName(attributes,projectConstants.PROJECT_PROP_DISABLE_FRAME);attributes.prototype_background=getProjectPropertyForName(attributes,projectConstants.PROJECT_PROP_PROTOTYPE_BACKGROUND_HEX);attributes.random_number=random_number;if(mobile)$("body").css("background","#"+attributes.prototype_background);if(embed)$("body").addClass("embedded");attributes.frame=getProjectPropertyForName(attributes,projectConstants.PROJECT_PROP_FRAME);attributes.colour=getProjectPropertyForName(attributes,projectConstants.PROJECT_PROP_FRAME_COLOUR);if(attributes.frame=="desktop-view"||attributes.frame=="web-frame"&&embed){if(attributes.images[1].width==320||attributes.images[1].width==640){attributes.frame="iphone5-frame";attributes.colour="black"}else if(attributes.images[1].width==750){attributes.frame="iphone6-frame";attributes.colour="white"}else if(attributes.images[1].width==1242){attributes.frame="iphone6plus-frame";attributes.colour="white"}}if(attributes.frame==""||typeof attributes.frame==="undefined"){attributes.frame="web-frame"}if(!mobile){if(attributes.disable_sidebar==1){$("#prototype").append(MARVELAPP.templates.IOS_PROTOTYPE_WRAPPER(attributes))}else{if(!embed){if(attributes.collapsed){$("#prototype").append("<div id='sidebar' class='collapsed'></div>")}else{$("#prototype").append("<div id='sidebar'></div>")}attributes.initial=true;prototype.sidebar=new MARVELAPP.SidebarView(attributes)}$("#prototype").append(MARVELAPP.templates.PROTOTYPE_WRAPPER(attributes))}}else{$("#prototype").append(MARVELAPP.templates.IOS_PROTOTYPE_WRAPPER(attributes))}checkOddPixel($(window).width());$(".screen").append(MARVELAPP.templates.PAGE_LOADER(attributes));if(!offline){setTimeout(function(){$("#page-loader .inner").css("width","15%")},500);run_load_bar(15);projectController.getPrototypeProject(project_id,createPrototype)}else{homescreen=true;createPrototype(false,"",prototype_data)}}function getProjectPropertyForName(selectedProjectObject,name){for(id in selectedProjectObject.properties){var property=selectedProjectObject.properties[id];if(name==property.name){return property.value}}}function checkOddPixel(width){if(!mobile){if(width%2){$("body").addClass("odd")}else{$("body").removeClass("odd")}}}function replaceURLWithHTMLLinks(text){var exp=/(\b(https?|ftp|file):\/\/[-A-Z0-9+&@#\/%?=~_|!:,.;]*[-A-Z0-9+&@#\/%=~_|])/gi;if(text!=null){return text.replace(exp,'<a target="_blank" href="$1">$1</a>')}else{return""}}Array.prototype.remove=function(from,to){var rest=this.slice((to||from)+1||this.length);this.length=from<0?this.length+from:from;return this.push.apply(this,rest)};Array.prototype.chunk=function(chunkSize){var array=this;return[].concat.apply([],array.map(function(elem,i){return i%chunkSize?[]:[array.slice(i,i+chunkSize)]}))};var linkClicked=false;var backDetected=false;var previousFragment=null;!function(a,b){"object"==typeof exports?module.exports=b():"function"==typeof define&&define.amd?define(b):a.Spinner=b()}(this,function(){"use strict";function a(a,b){var c,d=document.createElement(a||"div");for(c in b)d[c]=b[c];return d}function b(a){for(var b=1,c=arguments.length;c>b;b++)a.appendChild(arguments[b]);return a}function c(a,b,c,d){var e=["opacity",b,~~(100*a),c,d].join("-"),f=.01+c/d*100,g=Math.max(1-(1-a)/b*(100-f),a),h=j.substring(0,j.indexOf("Animation")).toLowerCase(),i=h&&"-"+h+"-"||"";return l[e]||(m.insertRule("@"+i+"keyframes "+e+"{0%{opacity:"+g+"}"+f+"%{opacity:"+a+"}"+(f+.01)+"%{opacity:1}"+(f+b)%100+"%{opacity:"+a+"}100%{opacity:"+g+"}}",m.cssRules.length),l[e]=1),e}function d(a,b){var c,d,e=a.style;for(b=b.charAt(0).toUpperCase()+b.slice(1),d=0;d<k.length;d++)if(c=k[d]+b,void 0!==e[c])return c;return void 0!==e[b]?b:void 0}function e(a,b){for(var c in b)a.style[d(a,c)||c]=b[c];return a}function f(a){for(var b=1;b<arguments.length;b++){var c=arguments[b];for(var d in c)void 0===a[d]&&(a[d]=c[d])}return a}function g(a,b){return"string"==typeof a?a:a[b%a.length]}function h(a){this.opts=f(a||{},h.defaults,n)}function i(){function c(b,c){return a("<"+b+' xmlns="urn:schemas-microsoft.com:vml" class="spin-vml">',c)}m.addRule(".spin-vml","behavior:url(#default#VML)"),h.prototype.lines=function(a,d){function f(){return e(c("group",{coordsize:k+" "+k,coordorigin:-j+" "+-j}),{width:k,height:k})}function h(a,h,i){b(m,b(e(f(),{rotation:360/d.lines*a+"deg",left:~~h}),b(e(c("roundrect",{arcsize:d.corners}),{width:j,height:d.width,left:d.radius,top:-d.width>>1,filter:i}),c("fill",{color:g(d.color,a),opacity:d.opacity}),c("stroke",{opacity:0}))))}var i,j=d.length+d.width,k=2*j,l=2*-(d.width+d.length)+"px",m=e(f(),{position:"absolute",top:l,left:l});if(d.shadow)for(i=1;i<=d.lines;i++)h(i,-2,"progid:DXImageTransform.Microsoft.Blur(pixelradius=2,makeshadow=1,shadowopacity=.3)");for(i=1;i<=d.lines;i++)h(i);return b(a,m)},h.prototype.opacity=function(a,b,c,d){var e=a.firstChild;d=d.shadow&&d.lines||0,e&&b+d<e.childNodes.length&&(e=e.childNodes[b+d],e=e&&e.firstChild,e=e&&e.firstChild,e&&(e.opacity=c))}}var j,k=["webkit","Moz","ms","O"],l={},m=function(){var c=a("style",{type:"text/css"});return b(document.getElementsByTagName("head")[0],c),c.sheet||c.styleSheet}(),n={lines:12,length:7,width:5,radius:10,rotate:0,corners:1,color:"#000",direction:1,speed:1,trail:100,opacity:.25,fps:20,zIndex:2e9,className:"spinner",top:"50%",left:"50%",position:"absolute"};h.defaults={},f(h.prototype,{spin:function(b){this.stop();{var c=this,d=c.opts,f=c.el=e(a(0,{className:d.className}),{position:d.position,width:0,zIndex:d.zIndex});d.radius+d.length+d.width}if(e(f,{left:d.left,top:d.top}),b&&b.insertBefore(f,b.firstChild||null),f.setAttribute("role","progressbar"),c.lines(f,c.opts),!j){var g,h=0,i=(d.lines-1)*(1-d.direction)/2,k=d.fps,l=k/d.speed,m=(1-d.opacity)/(l*d.trail/100),n=l/d.lines;!function o(){h++;for(var a=0;a<d.lines;a++)g=Math.max(1-(h+(d.lines-a)*n)%l*m,d.opacity),c.opacity(f,a*d.direction+i,g,d);c.timeout=c.el&&setTimeout(o,~~(1e3/k))}()}return c},stop:function(){var a=this.el;return a&&(clearTimeout(this.timeout),a.parentNode&&a.parentNode.removeChild(a),this.el=void 0),this},lines:function(d,f){function h(b,c){return e(a(),{position:"absolute",width:f.length+f.width+"px",height:f.width+"px",background:b,boxShadow:c,transformOrigin:"left",transform:"rotate("+~~(360/f.lines*k+f.rotate)+"deg) translate("+f.radius+"px,0)",borderRadius:(f.corners*f.width>>1)+"px"})}for(var i,k=0,l=(f.lines-1)*(1-f.direction)/2;k<f.lines;k++)i=e(a(),{position:"absolute",top:1+~(f.width/2)+"px",transform:f.hwaccel?"translate3d(0,0,0)":"",opacity:f.opacity,animation:j&&c(f.opacity,f.trail,l+k*f.direction,f.lines)+" "+1/f.speed+"s linear infinite"}),f.shadow&&b(i,e(h("#000","0 0 4px #000"),{top:"2px"})),b(d,b(i,h(g(f.color,k),"0 0 1px rgba(0,0,0,.1)")));return d},opacity:function(a,b,c){b<a.childNodes.length&&(a.childNodes[b].style.opacity=c)}});var o=e(a("group"),{behavior:"url(#default#VML)"});return!d(o,"transform")&&o.adj?i():j=d(o,"animation"),h});(function(i,s,o,g,r,a,m){i["GoogleAnalyticsObject"]=r;i[r]=i[r]||function(){(i[r].q=i[r].q||[]).push(arguments)},i[r].l=1*new Date;a=s.createElement(o),m=s.getElementsByTagName(o)[0];a.async=1;a.src=g;m.parentNode.insertBefore(a,m)})(window,document,"script","//www.google-analytics.com/analytics.js","ga");ga("create","UA-38711157-1","auto");ga("send","pageview","prototype-view");(function(){function b(a,d){(null===a||void 0===a)&&b.warn("Warning","You must pass your app key when you instantiate Pusher.");d=d||{};var c=this;this.key=a;this.config=b.Util.extend(b.getGlobalConfig(),d.cluster?b.getClusterConfig(d.cluster):{},d);this.channels=new b.Channels;this.global_emitter=new b.EventsDispatcher;this.sessionID=Math.floor(1e9*Math.random());this.timeline=new b.Timeline(this.key,this.sessionID,{cluster:this.config.cluster,features:b.Util.getClientFeatures(),params:this.config.timelineParams||{},limit:50,level:b.Timeline.INFO,version:b.VERSION});this.config.disableStats||(this.timelineSender=new b.TimelineSender(this.timeline,{host:this.config.statsHost,path:"/timeline/v2/jsonp"}));this.connection=new b.ConnectionManager(this.key,b.Util.extend({getStrategy:function(a){a=b.Util.extend({},c.config,a);return b.StrategyBuilder.build(b.getDefaultStrategy(a),a)},timeline:this.timeline,activityTimeout:this.config.activity_timeout,pongTimeout:this.config.pong_timeout,unavailableTimeout:this.config.unavailable_timeout},this.config,{encrypted:this.isEncrypted()}));this.connection.bind("connected",function(){c.subscribeAll();c.timelineSender&&c.timelineSender.send(c.connection.isEncrypted())});this.connection.bind("message",function(a){var d=0===a.event.indexOf("pusher_internal:");if(a.channel){var b=c.channel(a.channel);b&&b.handleEvent(a.event,a.data)}d||c.global_emitter.emit(a.event,a.data)});this.connection.bind("disconnected",function(){c.channels.disconnect()});this.connection.bind("error",function(a){b.warn("Error",a)});b.instances.push(this);this.timeline.info({instances:b.instances.length});b.isReady&&c.connect()}var c=b.prototype;b.instances=[];b.isReady=!1;b.debug=function(){b.log&&b.log(b.Util.stringify.apply(this,arguments))};b.warn=function(){var a=b.Util.stringify.apply(this,arguments);window.console&&(window.console.warn?window.console.warn(a):window.console.log&&window.console.log(a));b.log&&b.log(a)};b.ready=function(){b.isReady=!0;for(var a=0,d=b.instances.length;a<d;a++)b.instances[a].connect()};c.channel=function(a){return this.channels.find(a)};c.allChannels=function(){return this.channels.all()};c.connect=function(){this.connection.connect();if(this.timelineSender&&!this.timelineSenderTimer){var a=this.connection.isEncrypted(),d=this.timelineSender;this.timelineSenderTimer=new b.PeriodicTimer(6e4,function(){d.send(a)})}};c.disconnect=function(){this.connection.disconnect();this.timelineSenderTimer&&(this.timelineSenderTimer.ensureAborted(),this.timelineSenderTimer=null)};c.bind=function(a,d){this.global_emitter.bind(a,d);return this};c.bind_all=function(a){this.global_emitter.bind_all(a);return this};c.subscribeAll=function(){for(var a in this.channels.channels)this.channels.channels.hasOwnProperty(a)&&this.subscribe(a)};c.subscribe=function(a){a=this.channels.add(a,this);"connected"===this.connection.state&&a.subscribe();return a};c.unsubscribe=function(a){a=this.channels.remove(a);"connected"===this.connection.state&&a.unsubscribe()};c.send_event=function(a,d,b){return this.connection.send_event(a,d,b)};c.isEncrypted=function(){return"https:"===b.Util.getDocument().location.protocol?!0:Boolean(this.config.encrypted)};b.HTTP={};this.Pusher=b}).call(this);(function(){function b(a){window.clearTimeout(a)}function c(a){window.clearInterval(a)}function a(a,d,b,c){var k=this;this.clear=d;this.timer=a(function(){null!==k.timer&&(k.timer=c(k.timer))},b)}var d=a.prototype;d.isRunning=function(){return null!==this.timer};d.ensureAborted=function(){this.timer&&(this.clear(this.timer),this.timer=null)};Pusher.Timer=function(d,c){return new a(setTimeout,b,d,function(a){c();return null})};Pusher.PeriodicTimer=function(d,b){return new a(setInterval,c,d,function(a){b();return a})}}).call(this);(function(){Pusher.Util={now:function(){return Date.now?Date.now():(new Date).valueOf()},defer:function(b){return new Pusher.Timer(0,b)},extend:function(b){for(var c=1;c<arguments.length;c++){var a=arguments[c],d;for(d in a)b[d]=a[d]&&a[d].constructor&&a[d].constructor===Object?Pusher.Util.extend(b[d]||{},a[d]):a[d]}return b},stringify:function(){for(var b=["Pusher"],c=0;c<arguments.length;c++)"string"===typeof arguments[c]?b.push(arguments[c]):void 0===window.JSON?b.push(arguments[c].toString()):b.push(JSON.stringify(arguments[c]));return b.join(" : ")},arrayIndexOf:function(b,c){var a=Array.prototype.indexOf;if(null===b)return-1;if(a&&b.indexOf===a)return b.indexOf(c);for(var a=0,d=b.length;a<d;a++)if(b[a]===c)return a;return-1},objectApply:function(b,c){for(var a in b)Object.prototype.hasOwnProperty.call(b,a)&&c(b[a],a,b)},keys:function(b){var c=[];Pusher.Util.objectApply(b,function(a,d){c.push(d)});return c},values:function(b){var c=[];Pusher.Util.objectApply(b,function(a){c.push(a)});return c},apply:function(b,c,a){for(var d=0;d<b.length;d++)c.call(a||window,b[d],d,b)},map:function(b,c){for(var a=[],d=0;d<b.length;d++)a.push(c(b[d],d,b,a));return a},mapObject:function(b,c){var a={};Pusher.Util.objectApply(b,function(d,b){a[b]=c(d)});return a},filter:function(b,c){c=c||function(a){return!!a};for(var a=[],d=0;d<b.length;d++)c(b[d],d,b,a)&&a.push(b[d]);return a},filterObject:function(b,c){var a={};Pusher.Util.objectApply(b,function(d,h){if(c&&c(d,h,b,a)||Boolean(d))a[h]=d});return a},flatten:function(b){var c=[];Pusher.Util.objectApply(b,function(a,d){c.push([d,a])});return c},any:function(b,c){for(var a=0;a<b.length;a++)if(c(b[a],a,b))return!0;return!1},all:function(b,c){for(var a=0;a<b.length;a++)if(!c(b[a],a,b))return!1;return!0},method:function(b){var c=Array.prototype.slice.call(arguments,1);return function(a){return a[b].apply(a,c.concat(arguments))}},getWindow:function(){return window},getDocument:function(){return document},getNavigator:function(){return navigator},getLocalStorage:function(){try{return window.localStorage}catch(b){}},getClientFeatures:function(){return Pusher.Util.keys(Pusher.Util.filterObject({ws:Pusher.WSTransport,flash:Pusher.FlashTransport},function(b){return b.isSupported({})}))},addWindowListener:function(b,c){var a=Pusher.Util.getWindow();void 0!==a.addEventListener?a.addEventListener(b,c,!1):a.attachEvent("on"+b,c)},removeWindowListener:function(b,c){var a=Pusher.Util.getWindow();void 0!==a.addEventListener?a.removeEventListener(b,c,!1):a.detachEvent("on"+b,c)},isXHRSupported:function(){var b=window.XMLHttpRequest;return Boolean(b)&&void 0!==(new b).withCredentials},isXDRSupported:function(b){b=b?"https:":"http:";var c=Pusher.Util.getDocument().location.protocol;return Boolean(window.XDomainRequest)&&c===b}}}).call(this);(function(){Pusher.VERSION="2.2.4";Pusher.PROTOCOL=7;Pusher.host="ws.pusherapp.com";Pusher.ws_port=80;Pusher.wss_port=443;Pusher.sockjs_host="sockjs.pusher.com";Pusher.sockjs_http_port=80;Pusher.sockjs_https_port=443;Pusher.sockjs_path="/pusher";Pusher.stats_host="stats.pusher.com";Pusher.channel_auth_endpoint="/pusher/auth";Pusher.channel_auth_transport="ajax";Pusher.activity_timeout=12e4;Pusher.pong_timeout=3e4;Pusher.unavailable_timeout=1e4;Pusher.cdn_http="http://js.pusher.com/";Pusher.cdn_https="https://js.pusher.com/";Pusher.dependency_suffix=".min";Pusher.getDefaultStrategy=function(b){return[[":def","ws_options",{hostUnencrypted:b.wsHost+":"+b.wsPort,hostEncrypted:b.wsHost+":"+b.wssPort}],[":def","wss_options",[":extend",":ws_options",{encrypted:!0}]],[":def","sockjs_options",{hostUnencrypted:b.httpHost+":"+b.httpPort,hostEncrypted:b.httpHost+":"+b.httpsPort,httpPath:b.httpPath}],[":def","timeouts",{loop:!0,timeout:15e3,timeoutLimit:6e4}],[":def","ws_manager",[":transport_manager",{lives:2,minPingDelay:1e4,maxPingDelay:b.activity_timeout}]],[":def","streaming_manager",[":transport_manager",{lives:2,minPingDelay:1e4,maxPingDelay:b.activity_timeout}]],[":def_transport","ws","ws",3,":ws_options",":ws_manager"],[":def_transport","wss","ws",3,":wss_options",":ws_manager"],[":def_transport","flash","flash",2,":ws_options",":ws_manager"],[":def_transport","sockjs","sockjs",1,":sockjs_options"],[":def_transport","xhr_streaming","xhr_streaming",1,":sockjs_options",":streaming_manager"],[":def_transport","xdr_streaming","xdr_streaming",1,":sockjs_options",":streaming_manager"],[":def_transport","xhr_polling","xhr_polling",1,":sockjs_options"],[":def_transport","xdr_polling","xdr_polling",1,":sockjs_options"],[":def","ws_loop",[":sequential",":timeouts",":ws"]],[":def","wss_loop",[":sequential",":timeouts",":wss"]],[":def","flash_loop",[":sequential",":timeouts",":flash"]],[":def","sockjs_loop",[":sequential",":timeouts",":sockjs"]],[":def","streaming_loop",[":sequential",":timeouts",[":if",[":is_supported",":xhr_streaming"],":xhr_streaming",":xdr_streaming"]]],[":def","polling_loop",[":sequential",":timeouts",[":if",[":is_supported",":xhr_polling"],":xhr_polling",":xdr_polling"]]],[":def","http_loop",[":if",[":is_supported",":streaming_loop"],[":best_connected_ever",":streaming_loop",[":delayed",4e3,[":polling_loop"]]],[":polling_loop"]]],[":def","http_fallback_loop",[":if",[":is_supported",":http_loop"],[":http_loop"],[":sockjs_loop"]]],[":def","strategy",[":cached",18e5,[":first_connected",[":if",[":is_supported",":ws"],b.encrypted?[":best_connected_ever",":ws_loop",[":delayed",2e3,[":http_fallback_loop"]]]:[":best_connected_ever",":ws_loop",[":delayed",2e3,[":wss_loop"]],[":delayed",5e3,[":http_fallback_loop"]]],[":if",[":is_supported",":flash"],[":best_connected_ever",":flash_loop",[":delayed",2e3,[":http_fallback_loop"]]],[":http_fallback_loop"]]]]]]]}}).call(this);(function(){Pusher.getGlobalConfig=function(){return{wsHost:Pusher.host,wsPort:Pusher.ws_port,wssPort:Pusher.wss_port,httpHost:Pusher.sockjs_host,httpPort:Pusher.sockjs_http_port,httpsPort:Pusher.sockjs_https_port,httpPath:Pusher.sockjs_path,statsHost:Pusher.stats_host,authEndpoint:Pusher.channel_auth_endpoint,authTransport:Pusher.channel_auth_transport,activity_timeout:Pusher.activity_timeout,pong_timeout:Pusher.pong_timeout,unavailable_timeout:Pusher.unavailable_timeout}};Pusher.getClusterConfig=function(b){return{wsHost:"ws-"+b+".pusher.com",httpHost:"sockjs-"+b+".pusher.com"}}}).call(this);(function(){function b(b){var a=function(a){Error.call(this,a);this.name=b};Pusher.Util.extend(a.prototype,Error.prototype);return a}Pusher.Errors={BadEventName:b("BadEventName"),RequestTimedOut:b("RequestTimedOut"),TransportPriorityTooLow:b("TransportPriorityTooLow"),TransportClosed:b("TransportClosed"),UnsupportedTransport:b("UnsupportedTransport"),UnsupportedStrategy:b("UnsupportedStrategy")}}).call(this);(function(){function b(a){this.callbacks=new c;this.global_callbacks=[];this.failThrough=a}function c(){this._callbacks={}}var a=b.prototype;a.bind=function(a,b,c){this.callbacks.add(a,b,c);return this};a.bind_all=function(a){this.global_callbacks.push(a);return this};a.unbind=function(a,b,c){this.callbacks.remove(a,b,c);return this};a.unbind_all=function(a,b){this.callbacks.remove(a,b);return this};a.emit=function(a,b){var c;for(c=0;c<this.global_callbacks.length;c++)this.global_callbacks[c](a,b);var e=this.callbacks.get(a);if(e&&0<e.length)for(c=0;c<e.length;c++)e[c].fn.call(e[c].context||window,b);else this.failThrough&&this.failThrough(a,b);return this};c.prototype.get=function(a){return this._callbacks["_"+a]};c.prototype.add=function(a,b,c){a="_"+a;this._callbacks[a]=this._callbacks[a]||[];this._callbacks[a].push({fn:b,context:c})};c.prototype.remove=function(a,b,c){!a&&!b&&!c?this._callbacks={}:(a=a?["_"+a]:Pusher.Util.keys(this._callbacks),b||c?Pusher.Util.apply(a,function(a){this._callbacks[a]=Pusher.Util.filter(this._callbacks[a]||[],function(a){return b&&b!==a.fn||c&&c!==a.context});0===this._callbacks[a].length&&delete this._callbacks[a]},this):Pusher.Util.apply(a,function(a){delete this._callbacks[a]},this))};Pusher.EventsDispatcher=b}).call(this);(function(){function b(a,d){this.lastId=0;this.prefix=a;this.name=d}var c=b.prototype;c.create=function(a){this.lastId++;var d=this.lastId,b=this.prefix+d,c=this.name+"["+d+"]",e=!1,f=function(){e||(a.apply(null,arguments),e=!0)};this[d]=f;return{number:d,id:b,name:c,callback:f}};c.remove=function(a){delete this[a.number]};Pusher.ScriptReceiverFactory=b;Pusher.ScriptReceivers=new b("_pusher_script_","Pusher.ScriptReceivers")}).call(this);(function(){function b(a){this.src=a}var c=b.prototype;c.send=function(a){var d=this,b="Error loading "+d.src;d.script=document.createElement("script");d.script.id=a.id;d.script.src=d.src;d.script.type="text/javascript";d.script.charset="UTF-8";d.script.addEventListener?(d.script.onerror=function(){a.callback(b)},d.script.onload=function(){a.callback(null)}):d.script.onreadystatechange=function(){("loaded"===d.script.readyState||"complete"===d.script.readyState)&&a.callback(null)};void 0===d.script.async&&document.attachEvent&&/opera/i.test(navigator.userAgent)?(d.errorScript=document.createElement("script"),d.errorScript.id=a.id+"_error",d.errorScript.text=a.name+"('"+b+"');",d.script.async=d.errorScript.async=!1):d.script.async=!0;var c=document.getElementsByTagName("head")[0];c.insertBefore(d.script,c.firstChild);d.errorScript&&c.insertBefore(d.errorScript,d.script.nextSibling)};c.cleanup=function(){this.script&&(this.script.onload=this.script.onerror=null,this.script.onreadystatechange=null);this.script&&this.script.parentNode&&this.script.parentNode.removeChild(this.script);this.errorScript&&this.errorScript.parentNode&&this.errorScript.parentNode.removeChild(this.errorScript);this.errorScript=this.script=null};Pusher.ScriptRequest=b}).call(this);(function(){function b(a){this.options=a;this.receivers=a.receivers||Pusher.ScriptReceivers;this.loading={}}var c=b.prototype;c.load=function(a,d,b){var c=this;if(c.loading[a]&&0<c.loading[a].length)c.loading[a].push(b);else{c.loading[a]=[b];var e=new Pusher.ScriptRequest(c.getPath(a,d)),f=c.receivers.create(function(d){c.receivers.remove(f);if(c.loading[a]){var b=c.loading[a];delete c.loading[a];for(var h=function(a){a||e.cleanup()},m=0;m<b.length;m++)b[m](d,h)}});e.send(f)}};c.getRoot=function(a){var d=Pusher.Util.getDocument().location.protocol;return(a&&a.encrypted||"https:"===d?this.options.cdn_https:this.options.cdn_http).replace(/\/*$/,"")+"/"+this.options.version};c.getPath=function(a,d){return this.getRoot(d)+"/"+a+this.options.suffix+".js"};Pusher.DependencyLoader=b}).call(this);(function(){function b(){Pusher.ready()}function c(a){document.body?a():setTimeout(function(){c(a)},0)}function a(){c(b)}Pusher.DependenciesReceivers=new Pusher.ScriptReceiverFactory("_pusher_dependencies","Pusher.DependenciesReceivers");Pusher.Dependencies=new Pusher.DependencyLoader({cdn_http:Pusher.cdn_http,cdn_https:Pusher.cdn_https,version:Pusher.VERSION,suffix:Pusher.dependency_suffix,receivers:Pusher.DependenciesReceivers});window.JSON?a():Pusher.Dependencies.load("json2",{},a)})();(function(){for(var b=String.fromCharCode,c=0;64>c;c++)"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/".charAt(c);var a=function(a){var d=a.charCodeAt(0);return 128>d?a:2048>d?b(192|d>>>6)+b(128|d&63):b(224|d>>>12&15)+b(128|d>>>6&63)+b(128|d&63)},d=function(a){var d=[0,2,1][a.length%3];a=a.charCodeAt(0)<<16|(1<a.length?a.charCodeAt(1):0)<<8|(2<a.length?a.charCodeAt(2):0);return["ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/".charAt(a>>>18),"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/".charAt(a>>>12&63),2<=d?"=":"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/".charAt(a>>>6&63),1<=d?"=":"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/".charAt(a&63)].join("")},h=window.btoa||function(a){return a.replace(/[\s\S]{1,3}/g,d)};Pusher.Base64={encode:function(d){return h(d.replace(/[^\x00-\x7F]/g,a))}}}).call(this);(function(){function b(a,b){this.url=a;this.data=b}function c(a){return Pusher.Util.mapObject(a,function(a){"object"===typeof a&&(a=JSON.stringify(a));return encodeURIComponent(Pusher.Base64.encode(a.toString()))})}var a=b.prototype;a.send=function(a){if(!this.request){var b=Pusher.Util.filterObject(this.data,function(a){return void 0!==a}),b=Pusher.Util.map(Pusher.Util.flatten(c(b)),Pusher.Util.method("join","=")).join("&");this.request=new Pusher.ScriptRequest(this.url+"/"+a.number+"?"+b);this.request.send(a)}};a.cleanup=function(){this.request&&this.request.cleanup()};Pusher.JSONPRequest=b}).call(this);(function(){function b(a,d,b){this.key=a;this.session=d;this.events=[];this.options=b||{};this.uniqueID=this.sent=0}var c=b.prototype;b.ERROR=3;b.INFO=6;b.DEBUG=7;c.log=function(a,d){a<=this.options.level&&(this.events.push(Pusher.Util.extend({},d,{timestamp:Pusher.Util.now()})),this.options.limit&&this.events.length>this.options.limit&&this.events.shift())};c.error=function(a){this.log(b.ERROR,a)};c.info=function(a){this.log(b.INFO,a)};c.debug=function(a){this.log(b.DEBUG,a)};c.isEmpty=function(){return 0===this.events.length};c.send=function(a,d){var b=this,c=Pusher.Util.extend({session:b.session,bundle:b.sent+1,key:b.key,lib:"js",version:b.options.version,cluster:b.options.cluster,features:b.options.features,timeline:b.events},b.options.params);b.events=[];a(c,function(a,c){a||b.sent++;d&&d(a,c)});return!0};c.generateUniqueID=function(){this.uniqueID++;return this.uniqueID};Pusher.Timeline=b}).call(this);(function(){function b(b,a){this.timeline=b;this.options=a||{}}b.prototype.send=function(b,a){var d=this;d.timeline.isEmpty()||d.timeline.send(function(a,g){var e=new Pusher.JSONPRequest("http"+(b?"s":"")+"://"+(d.host||d.options.host)+d.options.path,a),f=Pusher.ScriptReceivers.create(function(a,b){Pusher.ScriptReceivers.remove(f);e.cleanup();b&&b.host&&(d.host=b.host);g&&g(a,b)});e.send(f)},a)};Pusher.TimelineSender=b}).call(this);(function(){function b(a){this.strategies=a}function c(a,b,c){var h=Pusher.Util.map(a,function(a,d,h,g){return a.connect(b,c(d,g))});return{abort:function(){Pusher.Util.apply(h,d)},forceMinPriority:function(a){Pusher.Util.apply(h,function(b){b.forceMinPriority(a)})}}}function a(a){return Pusher.Util.all(a,function(a){return Boolean(a.error)})}function d(a){!a.error&&!a.aborted&&(a.abort(),a.aborted=!0)}var h=b.prototype;h.isSupported=function(){return Pusher.Util.any(this.strategies,Pusher.Util.method("isSupported"))};h.connect=function(b,d){return c(this.strategies,b,function(b,c){return function(h,g){(c[b].error=h)?a(c)&&d(!0):(Pusher.Util.apply(c,function(a){a.forceMinPriority(g.transport.priority)}),d(null,g))}})};Pusher.BestConnectedEverStrategy=b}).call(this);(function(){function b(a,b,d){this.strategy=a;this.transports=b;this.ttl=d.ttl||18e5;this.encrypted=d.encrypted;this.timeline=d.timeline}function c(a){return"pusherTransport"+(a?"Encrypted":"Unencrypted")}function a(a){var b=Pusher.Util.getLocalStorage();if(b)try{var h=b[c(a)];if(h)return JSON.parse(h)}catch(k){d(a)}return null}function d(a){var b=Pusher.Util.getLocalStorage();if(b)try{delete b[c(a)]}catch(d){}}var h=b.prototype;h.isSupported=function(){return this.strategy.isSupported()};h.connect=function(b,h){var f=this.encrypted,k=a(f),l=[this.strategy];if(k&&k.timestamp+this.ttl>=Pusher.Util.now()){var n=this.transports[k.transport];n&&(this.timeline.info({cached:!0,transport:k.transport,latency:k.latency}),l.push(new Pusher.SequentialStrategy([n],{timeout:2*k.latency+1e3,failFast:!0})))}var m=Pusher.Util.now(),p=l.pop().connect(b,function s(a,k){if(a)d(f),0<l.length?(m=Pusher.Util.now(),p=l.pop().connect(b,s)):h(a);else{var n=k.transport.name,t=Pusher.Util.now()-m,r=Pusher.Util.getLocalStorage();if(r)try{r[c(f)]=JSON.stringify({timestamp:Pusher.Util.now(),transport:n,latency:t})}catch(u){}h(null,k)}});return{abort:function(){p.abort()},forceMinPriority:function(a){b=a;p&&p.forceMinPriority(a)}}};Pusher.CachedStrategy=b}).call(this);(function(){function b(a,b){this.strategy=a;this.options={delay:b.delay}}var c=b.prototype;c.isSupported=function(){return this.strategy.isSupported()};c.connect=function(a,b){var c=this.strategy,g,e=new Pusher.Timer(this.options.delay,function(){g=c.connect(a,b)});return{abort:function(){e.ensureAborted();g&&g.abort()},forceMinPriority:function(b){a=b;g&&g.forceMinPriority(b)}}};Pusher.DelayedStrategy=b}).call(this);(function(){function b(a){this.strategy=a}var c=b.prototype;c.isSupported=function(){return this.strategy.isSupported()};c.connect=function(a,b){var c=this.strategy.connect(a,function(a,e){e&&c.abort();b(a,e)});return c};Pusher.FirstConnectedStrategy=b}).call(this);(function(){function b(a,b,c){this.test=a;this.trueBranch=b;this.falseBranch=c}var c=b.prototype;c.isSupported=function(){return(this.test()?this.trueBranch:this.falseBranch).isSupported()};c.connect=function(a,b){return(this.test()?this.trueBranch:this.falseBranch).connect(a,b)};Pusher.IfStrategy=b}).call(this);(function(){function b(a,b){this.strategies=a;this.loop=Boolean(b.loop);this.failFast=Boolean(b.failFast);this.timeout=b.timeout;this.timeoutLimit=b.timeoutLimit}var c=b.prototype;c.isSupported=function(){return Pusher.Util.any(this.strategies,Pusher.Util.method("isSupported"))};c.connect=function(a,b){var c=this,g=this.strategies,e=0,f=this.timeout,k=null,l=function(n,m){m?b(null,m):(e+=1,c.loop&&(e%=g.length),e<g.length?(f&&(f*=2,c.timeoutLimit&&(f=Math.min(f,c.timeoutLimit))),k=c.tryStrategy(g[e],a,{timeout:f,failFast:c.failFast},l)):b(!0))},k=this.tryStrategy(g[e],a,{timeout:f,failFast:this.failFast},l);return{abort:function(){k.abort()},forceMinPriority:function(b){a=b;k&&k.forceMinPriority(b)}}};c.tryStrategy=function(a,b,c,g){var e=null,f=null;0<c.timeout&&(e=new Pusher.Timer(c.timeout,function(){f.abort();g(!0)}));f=a.connect(b,function(a,b){if(!a||!e||!e.isRunning()||c.failFast)e&&e.ensureAborted(),g(a,b)});return{abort:function(){e&&e.ensureAborted();f.abort()},forceMinPriority:function(a){f.forceMinPriority(a)}}};Pusher.SequentialStrategy=b}).call(this);(function(){function b(a,b,c,e){this.name=a;this.priority=b;this.transport=c;this.options=e||{}}function c(a,b){Pusher.Util.defer(function(){b(a)});return{abort:function(){},forceMinPriority:function(){}}}var a=b.prototype;a.isSupported=function(){return this.transport.isSupported({encrypted:this.options.encrypted})};a.connect=function(a,b){if(this.isSupported()){if(this.priority<a)return c(new Pusher.Errors.TransportPriorityTooLow,b)}else return c(new Pusher.Errors.UnsupportedStrategy,b);var g=this,e=!1,f=this.transport.createConnection(this.name,this.priority,this.options.key,this.options),k=null,l=function(){f.unbind("initialized",l);f.connect()},n=function(){k=new Pusher.Handshake(f,function(a){e=!0;q();b(null,a)})},m=function(a){q();b(a)},p=function(){q();b(new Pusher.Errors.TransportClosed(f))},q=function(){f.unbind("initialized",l);f.unbind("open",n);f.unbind("error",m);f.unbind("closed",p)};f.bind("initialized",l);f.bind("open",n);f.bind("error",m);f.bind("closed",p);f.initialize();return{abort:function(){e||(q(),k?k.close():f.close())},forceMinPriority:function(a){e||g.priority<a&&(k?k.close():f.close())}}};Pusher.TransportStrategy=b
}).call(this);(function(){function b(a,b,c){return a+(b.encrypted?"s":"")+"://"+(b.encrypted?b.hostEncrypted:b.hostUnencrypted)+c}function c(a,b){return"/app/"+a+("?protocol="+Pusher.PROTOCOL+"&client=js&version="+Pusher.VERSION+(b?"&"+b:""))}Pusher.URLSchemes={ws:{getInitial:function(a,d){return b("ws",d,c(a,"flash=false"))}},flash:{getInitial:function(a,d){return b("ws",d,c(a,"flash=true"))}},sockjs:{getInitial:function(a,c){return b("http",c,c.httpPath||"/pusher","")},getPath:function(a,b){return c(a)}},http:{getInitial:function(a,d){var h=(d.httpPath||"/pusher")+c(a);return b("http",d,h)}}}}).call(this);(function(){function b(a,b,c,g,e){Pusher.EventsDispatcher.call(this);this.hooks=a;this.name=b;this.priority=c;this.key=g;this.options=e;this.state="new";this.timeline=e.timeline;this.activityTimeout=e.activityTimeout;this.id=this.timeline.generateUniqueID()}var c=b.prototype;Pusher.Util.extend(c,Pusher.EventsDispatcher.prototype);c.handlesActivityChecks=function(){return Boolean(this.hooks.handlesActivityChecks)};c.supportsPing=function(){return Boolean(this.hooks.supportsPing)};c.initialize=function(){var a=this;a.timeline.info(a.buildTimelineMessage({transport:a.name+(a.options.encrypted?"s":"")}));a.hooks.beforeInitialize&&a.hooks.beforeInitialize.call(a);if(a.hooks.isInitialized())a.changeState("initialized");else if(a.hooks.file)a.changeState("initializing"),Pusher.Dependencies.load(a.hooks.file,{encrypted:a.options.encrypted},function(b,c){if(a.hooks.isInitialized())a.changeState("initialized"),c(!0);else{if(b)a.onError(b);a.onClose();c(!1)}});else a.onClose()};c.connect=function(){var a=this;if(a.socket||"initialized"!==a.state)return!1;var b=a.hooks.urls.getInitial(a.key,a.options);try{a.socket=a.hooks.getSocket(b,a.options)}catch(c){return Pusher.Util.defer(function(){a.onError(c);a.changeState("closed")}),!1}a.bindListeners();Pusher.debug("Connecting",{transport:a.name,url:b});a.changeState("connecting");return!0};c.close=function(){return this.socket?(this.socket.close(),!0):!1};c.send=function(a){var b=this;return"open"===b.state?(Pusher.Util.defer(function(){b.socket&&b.socket.send(a)}),!0):!1};c.ping=function(){"open"===this.state&&this.supportsPing()&&this.socket.ping()};c.onOpen=function(){this.hooks.beforeOpen&&this.hooks.beforeOpen(this.socket,this.hooks.urls.getPath(this.key,this.options));this.changeState("open");this.socket.onopen=void 0};c.onError=function(a){this.emit("error",{type:"WebSocketError",error:a});this.timeline.error(this.buildTimelineMessage({error:a.toString()}))};c.onClose=function(a){a?this.changeState("closed",{code:a.code,reason:a.reason,wasClean:a.wasClean}):this.changeState("closed");this.unbindListeners();this.socket=void 0};c.onMessage=function(a){this.emit("message",a)};c.onActivity=function(){this.emit("activity")};c.bindListeners=function(){var a=this;a.socket.onopen=function(){a.onOpen()};a.socket.onerror=function(b){a.onError(b)};a.socket.onclose=function(b){a.onClose(b)};a.socket.onmessage=function(b){a.onMessage(b)};a.supportsPing()&&(a.socket.onactivity=function(){a.onActivity()})};c.unbindListeners=function(){this.socket&&(this.socket.onopen=void 0,this.socket.onerror=void 0,this.socket.onclose=void 0,this.socket.onmessage=void 0,this.supportsPing()&&(this.socket.onactivity=void 0))};c.changeState=function(a,b){this.state=a;this.timeline.info(this.buildTimelineMessage({state:a,params:b}));this.emit(a,b)};c.buildTimelineMessage=function(a){return Pusher.Util.extend({cid:this.id},a)};Pusher.TransportConnection=b}).call(this);(function(){function b(a){this.hooks=a}var c=b.prototype;c.isSupported=function(a){return this.hooks.isSupported(a)};c.createConnection=function(a,b,c,g){return new Pusher.TransportConnection(this.hooks,a,b,c,g)};Pusher.Transport=b}).call(this);(function(){Pusher.WSTransport=new Pusher.Transport({urls:Pusher.URLSchemes.ws,handlesActivityChecks:!1,supportsPing:!1,isInitialized:function(){return Boolean(window.WebSocket||window.MozWebSocket)},isSupported:function(){return Boolean(window.WebSocket||window.MozWebSocket)},getSocket:function(a){return new(window.WebSocket||window.MozWebSocket)(a)}});Pusher.FlashTransport=new Pusher.Transport({file:"flashfallback",urls:Pusher.URLSchemes.flash,handlesActivityChecks:!1,supportsPing:!1,isSupported:function(){try{return Boolean(new ActiveXObject("ShockwaveFlash.ShockwaveFlash"))}catch(a){try{var b=Pusher.Util.getNavigator();return Boolean(b&&b.mimeTypes&&void 0!==b.mimeTypes["application/x-shockwave-flash"])}catch(c){return!1}}},beforeInitialize:function(){void 0===window.WEB_SOCKET_SUPPRESS_CROSS_DOMAIN_SWF_ERROR&&(window.WEB_SOCKET_SUPPRESS_CROSS_DOMAIN_SWF_ERROR=!0);window.WEB_SOCKET_SWF_LOCATION=Pusher.Dependencies.getRoot({encrypted:this.options.encrypted})+"/WebSocketMain.swf"},isInitialized:function(){return void 0!==window.FlashWebSocket},getSocket:function(a){return new FlashWebSocket(a)}});Pusher.SockJSTransport=new Pusher.Transport({file:"sockjs",urls:Pusher.URLSchemes.sockjs,handlesActivityChecks:!0,supportsPing:!1,isSupported:function(){return!0},isInitialized:function(){return void 0!==window.SockJS},getSocket:function(a,b){return new SockJS(a,null,{js_path:Pusher.Dependencies.getPath("sockjs",{encrypted:b.encrypted}),ignore_null_origin:b.ignoreNullOrigin})},beforeOpen:function(a,b){a.send(JSON.stringify({path:b}))}});var b={urls:Pusher.URLSchemes.http,handlesActivityChecks:!1,supportsPing:!0,isInitialized:function(){return Boolean(Pusher.HTTP.Socket)}},c=Pusher.Util.extend({getSocket:function(a){return Pusher.HTTP.getStreamingSocket(a)}},b),b=Pusher.Util.extend({getSocket:function(a){return Pusher.HTTP.getPollingSocket(a)}},b),a={file:"xhr",isSupported:Pusher.Util.isXHRSupported},d={file:"xdr",isSupported:function(a){return Pusher.Util.isXDRSupported(a.encrypted)}};Pusher.XHRStreamingTransport=new Pusher.Transport(Pusher.Util.extend({},c,a));Pusher.XDRStreamingTransport=new Pusher.Transport(Pusher.Util.extend({},c,d));Pusher.XHRPollingTransport=new Pusher.Transport(Pusher.Util.extend({},b,a));Pusher.XDRPollingTransport=new Pusher.Transport(Pusher.Util.extend({},b,d))}).call(this);(function(){function b(a,b,c){this.manager=a;this.transport=b;this.minPingDelay=c.minPingDelay;this.maxPingDelay=c.maxPingDelay;this.pingDelay=void 0}var c=b.prototype;c.createConnection=function(a,b,c,g){var e=this;g=Pusher.Util.extend({},g,{activityTimeout:e.pingDelay});var f=e.transport.createConnection(a,b,c,g),k=null,l=function(){f.unbind("open",l);f.bind("closed",n);k=Pusher.Util.now()},n=function(a){f.unbind("closed",n);1002===a.code||1003===a.code?e.manager.reportDeath():!a.wasClean&&k&&(a=Pusher.Util.now()-k,a<2*e.maxPingDelay&&(e.manager.reportDeath(),e.pingDelay=Math.max(a/2,e.minPingDelay)))};f.bind("open",l);return f};c.isSupported=function(a){return this.manager.isAlive()&&this.transport.isSupported(a)};Pusher.AssistantToTheTransportManager=b}).call(this);(function(){function b(a){this.options=a||{};this.livesLeft=this.options.lives||Infinity}var c=b.prototype;c.getAssistant=function(a){return new Pusher.AssistantToTheTransportManager(this,a,{minPingDelay:this.options.minPingDelay,maxPingDelay:this.options.maxPingDelay})};c.isAlive=function(){return 0<this.livesLeft};c.reportDeath=function(){this.livesLeft-=1};Pusher.TransportManager=b}).call(this);(function(){function b(a){return function(b){return[a.apply(this,arguments),b]}}function c(a,b){if(0===a.length)return[[],b];var h=d(a[0],b),e=c(a.slice(1),h[1]);return[[h[0]].concat(e[0]),e[1]]}function a(a,b){if("string"===typeof a[0]&&":"===a[0].charAt(0)){var h=b[a[0].slice(1)];if(1<a.length){if("function"!==typeof h)throw"Calling non-function "+a[0];var e=[Pusher.Util.extend({},b)].concat(Pusher.Util.map(a.slice(1),function(a){return d(a,Pusher.Util.extend({},b))[0]}));return h.apply(this,e)}return[h,b]}return c(a,b)}function d(b,c){if("string"===typeof b){var d;if("string"===typeof b&&":"===b.charAt(0)){d=c[b.slice(1)];if(void 0===d)throw"Undefined symbol "+b;d=[d,c]}else d=[b,c];return d}return"object"===typeof b&&b instanceof Array&&0<b.length?a(b,c):[b,c]}var h={ws:Pusher.WSTransport,flash:Pusher.FlashTransport,sockjs:Pusher.SockJSTransport,xhr_streaming:Pusher.XHRStreamingTransport,xdr_streaming:Pusher.XDRStreamingTransport,xhr_polling:Pusher.XHRPollingTransport,xdr_polling:Pusher.XDRPollingTransport},g={isSupported:function(){return!1},connect:function(a,b){var c=Pusher.Util.defer(function(){b(new Pusher.Errors.UnsupportedStrategy)});return{abort:function(){c.ensureAborted()},forceMinPriority:function(){}}}},e={extend:function(a,b,c){return[Pusher.Util.extend({},b,c),a]},def:function(a,b,c){if(void 0!==a[b])throw"Redefining symbol "+b;a[b]=c;return[void 0,a]},def_transport:function(a,b,c,d,e,p){var q=h[c];if(!q)throw new Pusher.Errors.UnsupportedTransport(c);c=(!a.enabledTransports||-1!==Pusher.Util.arrayIndexOf(a.enabledTransports,b))&&(!a.disabledTransports||-1===Pusher.Util.arrayIndexOf(a.disabledTransports,b))&&("flash"!==b||!0!==a.disableFlash)?new Pusher.TransportStrategy(b,d,p?p.getAssistant(q):q,Pusher.Util.extend({key:a.key,encrypted:a.encrypted,timeline:a.timeline,ignoreNullOrigin:a.ignoreNullOrigin},e)):g;d=a.def(a,b,c)[1];d.transports=a.transports||{};d.transports[b]=c;return[void 0,d]},transport_manager:b(function(a,b){return new Pusher.TransportManager(b)}),sequential:b(function(a,b){var c=Array.prototype.slice.call(arguments,2);return new Pusher.SequentialStrategy(c,b)}),cached:b(function(a,b,c){return new Pusher.CachedStrategy(c,a.transports,{ttl:b,timeline:a.timeline,encrypted:a.encrypted})}),first_connected:b(function(a,b){return new Pusher.FirstConnectedStrategy(b)}),best_connected_ever:b(function(){var a=Array.prototype.slice.call(arguments,1);return new Pusher.BestConnectedEverStrategy(a)}),delayed:b(function(a,b,c){return new Pusher.DelayedStrategy(c,{delay:b})}),"if":b(function(a,b,c,d){return new Pusher.IfStrategy(b,c,d)}),is_supported:b(function(a,b){return function(){return b.isSupported()}})};Pusher.StrategyBuilder={build:function(a,b){var c=Pusher.Util.extend({},e,b);return d(a,c)[1].strategy}}}).call(this);(function(){Pusher.Protocol={decodeMessage:function(b){try{var c=JSON.parse(b.data);if("string"===typeof c.data)try{c.data=JSON.parse(c.data)}catch(a){if(!(a instanceof SyntaxError))throw a}return c}catch(d){throw{type:"MessageParseError",error:d,data:b.data}}},encodeMessage:function(b){return JSON.stringify(b)},processHandshake:function(b){b=this.decodeMessage(b);if("pusher:connection_established"===b.event){if(!b.data.activity_timeout)throw"No activity timeout specified in handshake";return{action:"connected",id:b.data.socket_id,activityTimeout:1e3*b.data.activity_timeout}}if("pusher:error"===b.event)return{action:this.getCloseAction(b.data),error:this.getCloseError(b.data)};throw"Invalid handshake"},getCloseAction:function(b){return 4e3>b.code?1002<=b.code&&1004>=b.code?"backoff":null:4e3===b.code?"ssl_only":4100>b.code?"refused":4200>b.code?"backoff":4300>b.code?"retry":"refused"},getCloseError:function(b){return 1e3!==b.code&&1001!==b.code?{type:"PusherError",data:{code:b.code,message:b.reason||b.message}}:null}}}).call(this);(function(){function b(a,b){Pusher.EventsDispatcher.call(this);this.id=a;this.transport=b;this.activityTimeout=b.activityTimeout;this.bindListeners()}var c=b.prototype;Pusher.Util.extend(c,Pusher.EventsDispatcher.prototype);c.handlesActivityChecks=function(){return this.transport.handlesActivityChecks()};c.send=function(a){return this.transport.send(a)};c.send_event=function(a,b,c){a={event:a,data:b};c&&(a.channel=c);Pusher.debug("Event sent",a);return this.send(Pusher.Protocol.encodeMessage(a))};c.ping=function(){this.transport.supportsPing()?this.transport.ping():this.send_event("pusher:ping",{})};c.close=function(){this.transport.close()};c.bindListeners=function(){var a=this,b={message:function(b){var c;try{c=Pusher.Protocol.decodeMessage(b)}catch(d){a.emit("error",{type:"MessageParseError",error:d,data:b.data})}if(void 0!==c){Pusher.debug("Event recd",c);switch(c.event){case"pusher:error":a.emit("error",{type:"PusherError",data:c.data});break;case"pusher:ping":a.emit("ping");break;case"pusher:pong":a.emit("pong")}a.emit("message",c)}},activity:function(){a.emit("activity")},error:function(b){a.emit("error",{type:"WebSocketError",error:b})},closed:function(b){c();b&&b.code&&a.handleCloseEvent(b);a.transport=null;a.emit("closed")}},c=function(){Pusher.Util.objectApply(b,function(b,c){a.transport.unbind(c,b)})};Pusher.Util.objectApply(b,function(b,c){a.transport.bind(c,b)})};c.handleCloseEvent=function(a){var b=Pusher.Protocol.getCloseAction(a);(a=Pusher.Protocol.getCloseError(a))&&this.emit("error",a);b&&this.emit(b)};Pusher.Connection=b}).call(this);(function(){function b(a,b){this.transport=a;this.callback=b;this.bindListeners()}var c=b.prototype;c.close=function(){this.unbindListeners();this.transport.close()};c.bindListeners=function(){var a=this;a.onMessage=function(b){a.unbindListeners();try{var c=Pusher.Protocol.processHandshake(b);"connected"===c.action?a.finish("connected",{connection:new Pusher.Connection(c.id,a.transport),activityTimeout:c.activityTimeout}):(a.finish(c.action,{error:c.error}),a.transport.close())}catch(g){a.finish("error",{error:g}),a.transport.close()}};a.onClosed=function(b){a.unbindListeners();var c=Pusher.Protocol.getCloseAction(b)||"backoff";b=Pusher.Protocol.getCloseError(b);a.finish(c,{error:b})};a.transport.bind("message",a.onMessage);a.transport.bind("closed",a.onClosed)};c.unbindListeners=function(){this.transport.unbind("message",this.onMessage);this.transport.unbind("closed",this.onClosed)};c.finish=function(a,b){this.callback(Pusher.Util.extend({transport:this.transport,action:a},b))};Pusher.Handshake=b}).call(this);(function(){function b(a,b){Pusher.EventsDispatcher.call(this);this.key=a;this.options=b||{};this.state="initialized";this.connection=null;this.encrypted=!!b.encrypted;this.timeline=this.options.timeline;this.connectionCallbacks=this.buildConnectionCallbacks();this.errorCallbacks=this.buildErrorCallbacks();this.handshakeCallbacks=this.buildHandshakeCallbacks(this.errorCallbacks);var c=this;Pusher.Network.bind("online",function(){c.timeline.info({netinfo:"online"});("connecting"===c.state||"unavailable"===c.state)&&c.retryIn(0)});Pusher.Network.bind("offline",function(){c.timeline.info({netinfo:"offline"});c.connection&&c.sendActivityCheck()});this.updateStrategy()}var c=b.prototype;Pusher.Util.extend(c,Pusher.EventsDispatcher.prototype);c.connect=function(){!this.connection&&!this.runner&&(this.strategy.isSupported()?(this.updateState("connecting"),this.startConnecting(),this.setUnavailableTimer()):this.updateState("failed"))};c.send=function(a){return this.connection?this.connection.send(a):!1};c.send_event=function(a,b,c){return this.connection?this.connection.send_event(a,b,c):!1};c.disconnect=function(){this.disconnectInternally();this.updateState("disconnected")};c.isEncrypted=function(){return this.encrypted};c.startConnecting=function(){var a=this,b=function(c,g){c?a.runner=a.strategy.connect(0,b):"error"===g.action?(a.emit("error",{type:"HandshakeError",error:g.error}),a.timeline.error({handshakeError:g.error})):(a.abortConnecting(),a.handshakeCallbacks[g.action](g))};a.runner=a.strategy.connect(0,b)};c.abortConnecting=function(){this.runner&&(this.runner.abort(),this.runner=null)};c.disconnectInternally=function(){this.abortConnecting();this.clearRetryTimer();this.clearUnavailableTimer();this.connection&&this.abandonConnection().close()};c.updateStrategy=function(){this.strategy=this.options.getStrategy({key:this.key,timeline:this.timeline,encrypted:this.encrypted})};c.retryIn=function(a){var b=this;b.timeline.info({action:"retry",delay:a});0<a&&b.emit("connecting_in",Math.round(a/1e3));b.retryTimer=new Pusher.Timer(a||0,function(){b.disconnectInternally();b.connect()})};c.clearRetryTimer=function(){this.retryTimer&&(this.retryTimer.ensureAborted(),this.retryTimer=null)};c.setUnavailableTimer=function(){var a=this;a.unavailableTimer=new Pusher.Timer(a.options.unavailableTimeout,function(){a.updateState("unavailable")})};c.clearUnavailableTimer=function(){this.unavailableTimer&&this.unavailableTimer.ensureAborted()};c.sendActivityCheck=function(){var a=this;a.stopActivityCheck();a.connection.ping();a.activityTimer=new Pusher.Timer(a.options.pongTimeout,function(){a.timeline.error({pong_timed_out:a.options.pongTimeout});a.retryIn(0)})};c.resetActivityCheck=function(){var a=this;a.stopActivityCheck();a.connection.handlesActivityChecks()||(a.activityTimer=new Pusher.Timer(a.activityTimeout,function(){a.sendActivityCheck()}))};c.stopActivityCheck=function(){this.activityTimer&&this.activityTimer.ensureAborted()};c.buildConnectionCallbacks=function(){var a=this;return{message:function(b){a.resetActivityCheck();a.emit("message",b)},ping:function(){a.send_event("pusher:pong",{})},activity:function(){a.resetActivityCheck()},error:function(b){a.emit("error",{type:"WebSocketError",error:b})},closed:function(){a.abandonConnection();a.shouldRetry()&&a.retryIn(1e3)}}};c.buildHandshakeCallbacks=function(a){var b=this;return Pusher.Util.extend({},a,{connected:function(a){b.activityTimeout=Math.min(b.options.activityTimeout,a.activityTimeout,a.connection.activityTimeout||Infinity);b.clearUnavailableTimer();b.setConnection(a.connection);b.socket_id=b.connection.id;b.updateState("connected",{socket_id:b.socket_id})}})};c.buildErrorCallbacks=function(){function a(a){return function(c){c.error&&b.emit("error",{type:"WebSocketError",error:c.error});a(c)}}var b=this;return{ssl_only:a(function(){b.encrypted=!0;b.updateStrategy();b.retryIn(0)}),refused:a(function(){b.disconnect()}),backoff:a(function(){b.retryIn(1e3)}),retry:a(function(){b.retryIn(0)})}};c.setConnection=function(a){this.connection=a;for(var b in this.connectionCallbacks)this.connection.bind(b,this.connectionCallbacks[b]);this.resetActivityCheck()};c.abandonConnection=function(){if(this.connection){this.stopActivityCheck();for(var a in this.connectionCallbacks)this.connection.unbind(a,this.connectionCallbacks[a]);a=this.connection;this.connection=null;return a}};c.updateState=function(a,b){var c=this.state;this.state=a;c!==a&&(Pusher.debug("State changed",c+" -> "+a),this.timeline.info({state:a,params:b}),this.emit("state_change",{previous:c,current:a}),this.emit(a,b))};c.shouldRetry=function(){return"connecting"===this.state||"connected"===this.state};Pusher.ConnectionManager=b}).call(this);(function(){function b(){Pusher.EventsDispatcher.call(this);var b=this;void 0!==window.addEventListener&&(window.addEventListener("online",function(){b.emit("online")},!1),window.addEventListener("offline",function(){b.emit("offline")},!1))}Pusher.Util.extend(b.prototype,Pusher.EventsDispatcher.prototype);b.prototype.isOnline=function(){return void 0===window.navigator.onLine?!0:window.navigator.onLine};Pusher.NetInfo=b;Pusher.Network=new b}).call(this);(function(){function b(){this.reset()}var c=b.prototype;c.get=function(a){return Object.prototype.hasOwnProperty.call(this.members,a)?{id:a,info:this.members[a]}:null};c.each=function(a){var b=this;Pusher.Util.objectApply(b.members,function(c,g){a(b.get(g))})};c.setMyID=function(a){this.myID=a};c.onSubscription=function(a){this.members=a.presence.hash;this.count=a.presence.count;this.me=this.get(this.myID)};c.addMember=function(a){null===this.get(a.user_id)&&this.count++;this.members[a.user_id]=a.user_info;return this.get(a.user_id)};c.removeMember=function(a){var b=this.get(a.user_id);b&&(delete this.members[a.user_id],this.count--);return b};c.reset=function(){this.members={};this.count=0;this.me=this.myID=null};Pusher.Members=b}).call(this);(function(){function b(a,b){Pusher.EventsDispatcher.call(this,function(b,c){Pusher.debug("No callbacks on "+a+" for "+b)});this.name=a;this.pusher=b;this.subscribed=!1}var c=b.prototype;Pusher.Util.extend(c,Pusher.EventsDispatcher.prototype);c.authorize=function(a,b){return b(!1,{})};c.trigger=function(a,b){if(0!==a.indexOf("client-"))throw new Pusher.Errors.BadEventName("Event '"+a+"' does not start with 'client-'");return this.pusher.send_event(a,b,this.name)};c.disconnect=function(){this.subscribed=!1};c.handleEvent=function(a,b){0===a.indexOf("pusher_internal:")?"pusher_internal:subscription_succeeded"===a&&(this.subscribed=!0,this.emit("pusher:subscription_succeeded",b)):this.emit(a,b)};c.subscribe=function(){var a=this;a.authorize(a.pusher.connection.socket_id,function(b,c){b?a.handleEvent("pusher:subscription_error",c):a.pusher.send_event("pusher:subscribe",{auth:c.auth,channel_data:c.channel_data,channel:a.name})})};c.unsubscribe=function(){this.pusher.send_event("pusher:unsubscribe",{channel:this.name})};Pusher.Channel=b}).call(this);(function(){function b(a,b){Pusher.Channel.call(this,a,b)}var c=b.prototype;Pusher.Util.extend(c,Pusher.Channel.prototype);c.authorize=function(a,b){return new Pusher.Channel.Authorizer(this,this.pusher.config).authorize(a,b)};Pusher.PrivateChannel=b}).call(this);(function(){function b(a,b){Pusher.PrivateChannel.call(this,a,b);this.members=new Pusher.Members}var c=b.prototype;Pusher.Util.extend(c,Pusher.PrivateChannel.prototype);c.authorize=function(a,b){var c=this;Pusher.PrivateChannel.prototype.authorize.call(c,a,function(a,e){if(!a){if(void 0===e.channel_data){Pusher.warn("Invalid auth response for channel '"+c.name+"', expected 'channel_data' field");b("Invalid auth response");return}var f=JSON.parse(e.channel_data);c.members.setMyID(f.user_id)}b(a,e)})};c.handleEvent=function(a,b){switch(a){case"pusher_internal:subscription_succeeded":this.members.onSubscription(b);this.subscribed=!0;this.emit("pusher:subscription_succeeded",this.members);break;case"pusher_internal:member_added":var c=this.members.addMember(b);this.emit("pusher:member_added",c);break;case"pusher_internal:member_removed":(c=this.members.removeMember(b))&&this.emit("pusher:member_removed",c);break;default:Pusher.PrivateChannel.prototype.handleEvent.call(this,a,b)}};c.disconnect=function(){this.members.reset();Pusher.PrivateChannel.prototype.disconnect.call(this)};Pusher.PresenceChannel=b}).call(this);(function(){function b(){this.channels={}}var c=b.prototype;c.add=function(a,b){if(!this.channels[a]){var c=this.channels,g;g=0===a.indexOf("private-")?new Pusher.PrivateChannel(a,b):0===a.indexOf("presence-")?new Pusher.PresenceChannel(a,b):new Pusher.Channel(a,b);c[a]=g}return this.channels[a]};c.all=function(a){return Pusher.Util.values(this.channels)};c.find=function(a){return this.channels[a]};c.remove=function(a){var b=this.channels[a];delete this.channels[a];return b};c.disconnect=function(){Pusher.Util.objectApply(this.channels,function(a){a.disconnect()})};Pusher.Channels=b}).call(this);(function(){Pusher.Channel.Authorizer=function(b,a){this.channel=b;this.type=a.authTransport;this.options=a;this.authOptions=(a||{}).auth||{}};Pusher.Channel.Authorizer.prototype={composeQuery:function(b){b="socket_id="+encodeURIComponent(b)+"&channel_name="+encodeURIComponent(this.channel.name);for(var a in this.authOptions.params)b+="&"+encodeURIComponent(a)+"="+encodeURIComponent(this.authOptions.params[a]);return b},authorize:function(b,a){return Pusher.authorizers[this.type].call(this,b,a)}};var b=1;Pusher.auth_callbacks={};Pusher.authorizers={ajax:function(b,a){var d;d=Pusher.XHR?new Pusher.XHR:window.XMLHttpRequest?new window.XMLHttpRequest:new ActiveXObject("Microsoft.XMLHTTP");d.open("POST",this.options.authEndpoint,!0);d.setRequestHeader("Content-Type","application/x-www-form-urlencoded");for(var h in this.authOptions.headers)d.setRequestHeader(h,this.authOptions.headers[h]);d.onreadystatechange=function(){if(4===d.readyState)if(200===d.status){var b,c=!1;try{b=JSON.parse(d.responseText),c=!0}catch(f){a(!0,"JSON returned from webapp was invalid, yet status code was 200. Data was: "+d.responseText)}c&&a(!1,b)}else Pusher.warn("Couldn't get auth info from your webapp",d.status),a(!0,d.status)};d.send(this.composeQuery(b));return d},jsonp:function(c,a){void 0!==this.authOptions.headers&&Pusher.warn("Warn","To send headers with the auth request, you must use AJAX, rather than JSONP.");var d=b.toString();b++;var h=Pusher.Util.getDocument(),g=h.createElement("script");Pusher.auth_callbacks[d]=function(b){a(!1,b)};g.src=this.options.authEndpoint+"?callback="+encodeURIComponent("Pusher.auth_callbacks['"+d+"']")+"&"+this.composeQuery(c);d=h.getElementsByTagName("head")[0]||h.documentElement;d.insertBefore(g,d.firstChild)}}}).call(this);
//# sourceMappingURL=js/app-prototype.map